%
% Motion Segmentation Toolbox (2010).
% Laget av Stian Fuglesang Olsen.
%
% ----Generering av bevegelsesbilder og motiongram----
%
%   framesIn              - Her leses bilder (frames) fra nsket mappe inn i Matlab.
%   videoIn               - Video leses inn i Matlab. 
%   motiongram            - Lage motiongram ved  sette sammen "gjennomsnittskolonnene" fra alle
%   mImage                - Generering av bevegelsesbilder (eng: motion image).
%   mediaOut              - Lagre bevegelsesbilder eller motiongram til disk.
%
%
% ----Behandling av bevegelsesbilder----
%
%   mImageIn              - Her leses bevegelsesbilder (eng: motion image) inn i Matlab.
%   centroid_mImage       - Beregne sentroiden til bevegelsesbilder (eng: motion image). 
%   mImage_variables      - Her kan standardavvik til sentroidene og QoM for bevegelsesbilder finnes.
%   segm_mImage           - Her klassifiseres segmenter til  inneholde FM eller ikke ut i fra
%   viewResultSegm        - Segmenter funnet av segm_mImage markeres p QoM-plot eller i motiongram. 
%   lagTestsett           - Lage testsett.
%   lagTreningssett       - Her kan det lages treningsett med og uten FM.
%   LDA                   - Klassifisere segmenter via LDA.
%   segm_LDA              - Omgjr resultatene fra LDA til relevante segmenter.
%   viewResultLDA         - Segmenter funnet av segm_LDA markeres p QoM-plot eller i motiongram. 
%
%
% ----Behandling av motiongram----
%
%   motiongramIn          - Lese inn bilde (motiongram) som skal brukes i analyse.
%   QoM_motiongram        - Regne ut bevegelsesmengden (QoM) til motiongram.
%   Qmean_motiomgram      - Lager en "glattet" versjon av QoM (gjennomsnitt). 
%   centroid_motiomgram   - Beregne sentroiden til motiongram.
%   stdQoM_motiongram     - Finner standardavviket til deler av QoM for motiongram.
%   r_param_est_motionvar - Estimere parametre for variable hentet ut av motiongram.
%
%
% ----Behandling av sensordata----
%
%   rekursiv_param_est    - Her kan man rekursivt estimere modellparametre
%   auto_segment          - Automatisk segmentering av signal fra estimerte parametre.
%   funk_segm             - SEGMENT funksjonen benyttes her som et alternativ til RARX.
%   reprod                - I denne filen kan et forhnds definert resultat enkelt reproduseres. 
%
%
% ----Hjelpefunksjoner----
%
%   centroid              - Funksjon som regner ut sentroiden til et bilde.
%   areashade             - Funksjon som farger omrdet mellom en kurve og en spesifisert verdi.
%   intersections         - Funksjon som bergener posisjonen hvor to kurver krysser hverandre.
%   hline                 - Funksjon som lager en horisontal linje for en spesifisert verdi.
%   vline                 - Funksjon som lager en vertikal linje for en spesifisert verdi.
%   sec2ms                - Konverterer antall sekunder til en minutt-sekund string.
%   segmentplot           - Plotter aktuelt signal med segmenteringslinjer.
%
%
% ----Diverse----
%
%   figurSensordata       - Plot av sensorsignaler for normale og unormale tilfeller.
%   Plot                  - Diverse plot.
%   analyse               - Diverse forhndsanalyse av aktuell data. Sjekker for "randomness".
%
% ----SLUTT P FIL-----