function [thhat,lamhat,Epsi]=adfilterx(z,nnn,adg,adm,fflam,decfactor,P0)

% adfilterx turbo version of adfilter using simulink
%
% function [thhat,lamhat,Epsi]=adfilter(z,nnn,adg,adm,fflam,decfactor)
%
  
if nargin<6; decfactor=[]; end;
if nargin<5; fflam=[]; end;
if nargin<3; adg=1; end;

if isempty(decfactor); decfactor=1; end;
if isempty(fflam); fflam=1; end;

mtype=modeltype(nnn);
[N,nz]=size(z);

if mtype>4;   % State space model

else        % Regression model
  if nargin<7; 
    P=1000000;
  else
    P=P0;
  end

  if nargin<4; 
    if adg<=1 & adg>0.1;
      adm='RLS'; 
    elseif adg<0.1;
      adm='LMS'; 
    else
      adm='WLS'; 
    end;
  end
  
  z=z(1:N/decfactor,:);
  y=z(:,1);
  u=z(:,2);
  t=(1:N)';
  U=[t u];
  Y=[t y];
  global alarm gt threc

  ff=1; R1=0; L=0;
  if strcmp(adm,'RLS')
    ff=adg; 
    if ff>1|ff<0; ff=0.98; disp('ff changed to 0.98'); end
    sim('rlssim',[1 N])
    epsi=zeros(N,1);
    lamhat=zeros(N,1);
  elseif strcmp(adm,'LMS') | strcmp(adm,'NLMS')
    mu=adg;
  elseif strcmp(adm,'WLS')
    L=adg;
    if L<1; L=10; disp('L changed to 10'); end
  elseif strcmp(adm,'KF')
    R1=adg;
    if size(R1,1)==1;
      R1=R1*eye(d);
    end;
  else
    disp('Not a valid method adm')
    disp('adm set to RLS with adg=0.98!')
    ff=0.98;
    adm='RLS';
  end;




end;


