void inv(int_T dim,real_T *matrix)
{
  int_T i,j,k;
  real_T sigma;

  /*calculate the UD-factorization of matrix*/
  for (j=dim; j>0; j--)
    {
      for (i=j; i>0; i--)
	{
	  sigma = matrix[(j-1)*dim+i-1];
	  for (k=j+1; k<dim+1; k++)
	    sigma = sigma-matrix[(k-1)*dim+i-1]*matrix[(k-1)*dim+k-1]*matrix[(k-1)*dim+j-1];
	  if (i==j)
	    matrix[(j-1)*dim+j-1] = sigma;
	  else
	    matrix[(j-1)*dim+i-1] = sigma/(matrix[(j-1)*dim+j-1]);
	}
    }
  
  
  /*invert U*/
  for (i=dim-1; i>0; i--)
    for (j=dim; j>i; j--)
      {
	matrix[(j-1)*dim+i-1] = -matrix[(j-1)*dim+i-1];
	for (k=i+1; k<j; k++)
	  matrix[(j-1)*dim+i-1] = matrix[(j-1)*dim+i-1] - matrix[(k-1)*dim+i-1]*matrix[(k-1)*dim+j-1];
      }
  
  
  /*invert D*/
  for (i=1; i<dim+1; i++)
    matrix[(i-1)*dim+i-1] = 1/(matrix[(i-1)*dim+i-1]);
  
  /*recombine matrix=inv(U')*inv(D)*inv(U)*/
  for (i=dim; i>0; i--)
    {
      for (j=1; j<i; j++)
	matrix[(j-1)*dim+i-1] = matrix[(i-1)*dim+j-1]*matrix[(j-1)*dim+j-1];
      for (j=dim; j>i-1; j--)
	{
	  if (i<j)
	    matrix[(j-1)*dim+i-1] = matrix[(j-1)*dim+i-1]*matrix[(i-1)*dim+i-1];
	  for (k=1; k<i; k++)
	    matrix[(j-1)*dim+i-1] = matrix[(j-1)*dim+i-1]+matrix[(j-1)*dim+k-1]*matrix[(k-1)*dim+i-1];
	  matrix[(i-1)*dim+j-1] = matrix[(j-1)*dim+i-1];
	}
    }
}
