void kalman(real_T *den,real_T *A,real_T *B,real_T *C,real_T *D,real_T *R1,real_T *R2,real_T *P,real_T *th,real_T *eps,real_T lambda,SimStruct *S,int_T nstates)
{
  int_T i;
  real_T *temp1 = mxCalloc(nstates*nstates,8);
  real_T *temp2 = mxCalloc(nstates*nstates,8);
  real_T *temp3 = mxCalloc(nstates*nstates,8);
  real_T *K = mxCalloc(nstates*nstates,8);
  InputRealPtrsType y = ssGetInputPortRealSignalPtrs(S,1);
  InputRealPtrsType u = ssGetInputPortRealSignalPtrs(S,0);
  int_T nu = ssGetInputPortWidth(S,0);
  int_T ny = ssGetInputPortWidth(S,1);


  /*calculate den = lambda*R2+C*P*C'*/
  temp1 = transpose(C,ny,nstates,temp1);
  temp2 = matrixmult(P,nstates,nstates,temp1,ny,temp2);
  temp1 = matrixmult(C,ny,nstates,temp2,ny,temp1);
  for (i=0; i<ny*ny; i++)
    den[i] = lambda*R2[i]+temp1[i];
  
  inv(ny,den);
  
  
  /*calculate epsilon*/
  temp1 = matrixmult(C,ny,nstates,th,1,temp1);
  for (i=0; i<nu;i++)
    temp3[i] = *u[i];
  temp2 = matrixmult(D,ny,nu,temp3,1,temp2);
  for (i=0; i<ny ;i++)
    eps[i] = *y[i] - temp1[i] - temp2[i];
  
  /*calculate K*/
  temp2 = matrixmult(P,nstates,nstates,transpose(C,ny,nstates,temp3),ny,temp2);
  K = matrixmult(temp2,nstates,ny,den,ny,K);
  
  /*update th*/
  temp2 = matrixmult(K,nstates,ny,eps,1,temp2);
  for (i=0; i<nstates; i++)
    temp2[i] = th[i]+temp2[i];
  th = matrixmult(A,nstates,nstates,temp2,1,th);
  for (i=0; i<nu; i++)
    temp3[i] = *u[i];
  temp1 = matrixmult(B,nstates,nu,temp3,1,temp1);
  for (i=0; i<nstates; i++)
    th[i] = th[i]+temp1[i];
  
  /*update P*/
  temp2 = matrixmult(K,nstates,ny,C,nstates,temp2);
  temp1 = matrixmult(temp2,nstates,nstates,P,nstates,temp1);
  for (i=0; i<nstates*nstates; i++)
    temp1[i] = P[i] - temp1[i];
  temp2 = matrixmult(A,nstates,nstates,temp1,nstates,temp2);
  temp1 = matrixmult(temp2,nstates,nstates,transpose(A,nstates,nstates,temp3),nstates,temp1);
  for (i=0; i<nstates*nstates; i++)
    P[i] = temp1[i] + lambda*R1[i];
  temp1 = transpose(P,nstates,nstates,temp1);
  for (i=0; i<nstates*nstates; i++)
    P[i] = 0.5*(P[i]+temp1[i]);
  
}
