real_T *matrixmult(real_T *factor1,int_T row1,int_T col1,real_T *factor2,int_T col2,real_T* pr)
{
  real_T *prod=pr;
  int_T i,j,k;
  for (i = 0; i<row1; i++)
    {
      for (j = 0; j < col2; j++)
	{
	  prod[j*row1+i]=0;
	  for (k = 0; k < col1; k++)
	    {
	      prod[j*row1+i]=prod[j*row1+i]+factor1[k*row1+i]*factor2[j*col1+k];
	    }
	}
    }
  return prod;
}


real_T *transpose(real_T *matrix,int_T row,int_T col,real_T *tr)
{
  real_T *trans=tr;
  int_T i,j;
  for (i=0; i<row; i++)
    {
      for (j=0; j<col; j++)
	{
	  trans[i*col+j] = matrix[j*row+i];
      }
    }
  return trans;
}


real_T det(real_T *matrix,int_T dim)
{
  real_T *U=mxCalloc(dim*dim,sizeof(real_T));
  real_T dum;
  int_T i,j,k;

  for (i=0;i<dim*dim;i++)
    U[i]=matrix[i];

  for (i=1; i<=dim;i++)
    for (j=i+1; j<=dim; j++)
      {
	dum = U[(i-1)*dim+j-1]/U[(i-1)*dim+j-2];
	for (k=i+1;k<=dim;k++)
	  U[(k-1)*dim+j-1]=U[(k-1)*dim+j-1]-dum*U[(k-1)*dim+j-2];
      }
  
  dum=1;
  for (i=0;i<dim;i++)
    dum=dum*U[i*dim+i];

  return dum;
}
