int_T modeltype(real_T *nnn,int_T nrow,int_T ncol)
{
  int_T mtype;

  if ((nnn[0] == 0) && (ncol == 1))
    mtype = 0;                        /*only noise*/
  else if (nnn[0] == -1)
    mtype = 1;                       /*unknown mean model*/
  else if (nnn[0] == -2)
    mtype = 2;                        /*regression model*/
  else if (nnn[0] == -5)
    mtype = 5;                       /*state space*/
  else if ((ncol == 1) && (nrow == 1))
    mtype = 3;                       /*AR*/
  else if ((nrow == 1) && (ncol == 3))
    mtype = 4;                       /*ARX*/
  return mtype;
}


int_T numberofstates(real_T *nnn,int_T mtype,const char *filename)
{
  int_T nstates,i;
  mxArray *rhs[4],*lhs[1];

  if (mtype == 0)
    nstates = 1;
  else if (mtype == 1)
    nstates = 1;
  else if (mtype == 2)
    nstates = 1;
  else if (mtype == 3)
    nstates = nnn[0];
  else if (mtype == 4)
    nstates = nnn[0] + nnn[1];
  else if (mtype == 5)
    {
      for (i=0;i<4;i++)
	rhs[i]=mxCreateDoubleMatrix(1,1,mxREAL);
      lhs[0]=mxCreateDoubleMatrix(1,6,mxREAL);
      for (i=0;i<4;i++)
	{
	  mxGetPr(rhs[i])[0]=0;
	}
      mexCallMATLAB(1,lhs,4,rhs,filename);
      nstates = mxGetPr(lhs[0])[0];
    }
  return nstates;
}



int_T initstates(int_T M,real_T *nnn,int_T nstates,int_T mtype,SimStruct *S,const char* filename)
{
  int_T tstart = 2;
  real_T *dstates = ssGetRealDiscStates(S);
  real_T *rwork = ssGetRWork(S);
  int_T ny,nu,i,j,k;
  real_T *x0,*P0,*n,*temp;
  int_T tempn;
  mxArray *rhs[4],*lhs[6];

  if (mtype < 5)
    {
      for (i=0; i<M*nstates+M*nstates*nstates; i++)
	dstates[i] = 0;           
      for (j=0; j<M; j++)
	{
	  for (i=M*nstates+j*nstates*nstates; i<M*nstates+(j+1)*nstates*nstates; i=i+nstates+1)
	    dstates[i] = 1000000000/*lambda*/;                     /*initialize P*/
	}
      for (i=0; i<ssGetNumRWork(S); i++)
	rwork[i] = 0;
    }

  else if (mtype == 5)
    {
      ny = ssGetInputPortWidth(S,1);
      nu = ssGetInputPortWidth(S,0);
      
      for (i=0;i<4;i++)
	rhs[i]=mxCreateDoubleMatrix(1,1,mxREAL);
      lhs[0]=mxCreateDoubleMatrix(1,6,mxREAL);
      lhs[1]=mxCreateDoubleMatrix(nstates,1,mxREAL);
      lhs[2]=mxCreateDoubleMatrix(nstates,nstates,mxREAL);
      for (i=0;i<4;i++)
	mxGetPr(rhs[i])[0]=0;
      mexCallMATLAB(3,lhs,4,rhs,filename);
      n=mxGetPr(lhs[0]);
      x0=mxGetPr(lhs[1]);
      P0=mxGetPr(lhs[2]);
      for (k=0; k<M; k++)
	{
	  for (i = 0;i < nstates;i++)
	    dstates[k*nstates+i] = x0[i];                /*initialize th*/
	  
	  for (j = 0;j < nstates*nstates;j++)                   /*initialize P*/
	    dstates[k*nstates*nstates+nstates*M+j] = P0[j]/*lambda*/;
	}
      /*for easy access of the state-space matrices*/
      /*rhs[0]=mxCreateDoubleMatrix(1,1,mxREAL);
	rhs[1]=mxCreateDoubleMatrix(nstates,1,mxREAL);
	rhs[2]=mxCreateDoubleMatrix(n[1]+n[3]+n[4]+1,1,mxREAL);
	rhs[3]=mxCreateDoubleMatrix(1,1,mxREAL);
	lhs[0]=mxCreateDoubleMatrix(nstates,nstates,mxREAL);
	lhs[1]=mxCreateDoubleMatrix(nstates,n[1],mxREAL);
	lhs[2]=mxCreateDoubleMatrix(nstates,n[2],mxREAL);
	lhs[3]=mxCreateDoubleMatrix(nstates,n[3],mxREAL);
	lhs[4]=mxCreateDoubleMatrix(nstates,n[4],mxREAL);
	lhs[5]=mxCreateDoubleMatrix(nstates,nstates,mxREAL);
	mxGetPr(rhs[0])[0]=0;
	for (i=0;i<nstates;i++)
	mxGetPr(rhs[1])[i]=x0[i];
	for (i=0;i<n[1]+n[2]+n[4]+1;i++)
	mxGetPr(rhs[2])[i]=0;
	mxGetPr(rhs[3])[0]=5; 
	mexCallMATLAB(5,lhs,4,rhs,filename); 

      temp=mxGetPr(lhs[0]);                    
      for (i = 0; i < nstates*nstates; i++)                                                    
	rwork[i] = temp[i];

      temp=mxGetPr(lhs[1]);                   
      for (i = 0; i < n[1]*nstates; i++)                                                             
	rwork[nstates*nstates+i]=temp[i];

      temp=mxGetPr(lhs[2]);                   
      tempn=nstates*(nstates+n[1]);
      for (i = 0; i < nstates*n[2]; i++)                                                    
	rwork[tempn+i] = temp[i];

      temp=mxGetPr(lhs[3]);                   
      tempn=nstates*(nstates+n[1]+n[2]);
      for (i = 0; i < nstates*n[3]; i++)                                                    
	rwork[tempn+i] = temp[i];

      temp=mxGetPr(lhs[4]);                   
      tempn=nstates*(nstates+n[1]+n[2]+n[3]);
      for (i = 0; i < nstates*n[4]; i++)                                                    
	rwork[tempn+i] = temp[i];

      temp=mxGetPr(lhs[5]);                   
      tempn=nstates*(nstates+n[1]+n[2]+n[3]+n[4]);
      for (i = 0; i < nstates*nstates; i++)                                                    
	rwork[tempn+i] = temp[i];

      lhs[0]=mxCreateDoubleMatrix(n[5],nstates,mxREAL);
      lhs[1]=mxCreateDoubleMatrix(n[5],n[1],mxREAL);
      lhs[2]=mxCreateDoubleMatrix(n[5],n[4],mxREAL);
      lhs[3]=mxCreateDoubleMatrix(n[5],n[5],mxREAL);
      mxGetPr(rhs[3])[0]=6;
      mexCallMATLAB(4,lhs,4,rhs,filename);

      temp=mxGetPr(lhs[1]);                   
      tempn=nstates*(nstates+n[1]+n[2]+n[3]+n[4]+nstates);
      for (i = 0; i < n[5]*nstates; i++)                                                    
	rwork[tempn+i] = temp[i];

      temp=mxGetPr(lhs[2]);                   
      tempn=nstates*(nstates+n[1]+n[2]+n[3]+n[4]+n[5]+nstates);
      for (i = 0; i < n[5]*n[1]; i++)                                                    
	rwork[tempn+i] = temp[i];

      temp=mxGetPr(lhs[3]);                   
      tempn=nstates*(nstates+n[1]+n[2]+n[3]+n[4]+n[5]+nstates)+n[1]*n[5];
      for (i = 0; i < n[5]*n[4]; i++)                                                    
	rwork[tempn+i] = temp[i];

      temp=mxGetPr(lhs[2]);                   
      tempn=nstates*(nstates+n[1]+n[2]+n[3]+n[4]+n[5]+nstates)+(n[1]+n[4])*n[5];
      for (i = 0; i < n[5]*n[5]; i++)                                                     
	rwork[tempn+i] = temp[i];*/


    }

  if (mtype == 2)
    tstart = nstates + 1;

  else if (mtype == 3)
    tstart = nstates + 1;

  else if (mtype == 4)
    if (nnn[0]+1 > nnn[1]+nnn[2])
      tstart = nnn[0]+1;
    else
      tstart = nnn[1]+nnn[2];

  return tstart;
}
