void rls(real_T *phi,real_T *th,real_T *P,real_T *eps,real_T lambda,int_T nstates,SimStruct *S)
{ 
  int_T i,j;
  real_T *temp1 = mxCalloc(nstates*nstates,sizeof(real_T));
  real_T *temp2 = mxCalloc(nstates*nstates,sizeof(real_T));
  real_T *temp3 = mxCalloc(nstates*nstates,sizeof(real_T));
  real_T *K = mxCalloc(nstates*nstates,sizeof(real_T));
  InputRealPtrsType y = ssGetInputPortRealSignalPtrs(S,1);
  int_T ny = ssGetInputPortWidth(S,1);


  /*update epsilon*/
  temp2 = matrixmult(transpose(phi,nstates,1,temp3),1,nstates,th,1,temp2);
  for (i=0; i<ny; i++)
    eps[i] = *y[i] - temp2[i];
  
  /*update P*/
  for (i=0; i<ny; i++)
    {
      temp3 = matrixmult((phi+i*nstates),1,nstates,P,nstates,temp3);
      temp1 = matrixmult(temp3,nstates,1,temp3,nstates,temp1);
      temp2 = matrixmult((phi+i*nstates),1,nstates,temp3,1,temp2);
      for (j=0; j<nstates*nstates; j++)
	P[j] = P[j] - temp1[j]/(lambda+temp2[0]);
      temp1 = transpose(P,nstates,nstates,temp1);
      for (j=0; j<nstates*nstates; j++)
	P[j] = 0.5*(P[j] + temp1[j]);
    }
  for (i=0; i<nstates*nstates; i++)
    P[i] = P[i]/lambda;


  /*calculate K*/
  K = matrixmult(P,nstates,nstates,phi,ny,K);

  /*calculate th*/
  temp1 = matrixmult(K,nstates,ny,eps,1,temp1);
  for (i=0; i<nstates; i++)
    th[i] = th[i] + temp1[i];
}
