function cddisp(text,p,arg1)
% p='header' over block scheme
% p='help' upper right corner
% p='demo' upper right corner
% p='ex' 
% p='all' all screen
% p=Tag
% Text = string with text and controls. Available controls:
% \n newline
% \c center text
% \b bold face
% \d demi
% \t thin normal width)
% \r rm (normal font)
% \i italic
% \o oblique
% \s small
% \l large
% \h huge
% \5 tab
% \R highlight background
% \W transparant background

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $
  
if nargin<2; p='cddisp'; end

%------------------- Initiate all uicontrol options --------------------------------

winsize(1)=400; % needed for centerline

grey=0.7*[1 1 1]; 
smallfont=8;
largefont=10;
hugefont=20;
smallcolstep=6;
largecolstep=9;
hugecolstep=20;
smallrowstep=20;
largerowstep=34;
hugerowstep=50;
rowstep=[smallrowstep largerowstep hugerowstep];
boldfactor=1.05;

       
  [n,m]=size(text);
  rowlength=100;
  ind=find(text=='\');
  ind=[0 ind length(text)];
  text=[text 'e'];  %end
  outtext=[];
  colpos(1)=1; rowpos(1)=1; row(1)=1; fontsize(1)=1; width(1)=1; font(1)=1;
  color(1)=1;
  colstep=smallcolstep;
  %rowstep=smallrowstep;
  rowsize(1)=1;
  n=length(ind);
  for i=2:n;
     outtext=str2mat(outtext,text(ind(i-1)+2:ind(i)-1));
     if ind(i)-ind(i-1)>rowlength
     end
     if text(ind(i)+1)=='n'  % newline
        row(i)=row(i-1)+1;
        rowsize(row(i))=1;  
        %rowpos(row(i))=rowpos(row(i-1))+rowstep;
        colpos(i)=1;
        colstep=smallcolstep;
        fontsize(i)=1;
        width(i)=1;
        font(i)=1;
        color(i)=1;   
    elseif text(ind(i)+1)=='c'  % center line
        row(i)=row(i-1);
        %rowpos(row(i))=max([ rowpos(row(i-1))+smallrowstep rowpos(row(i))]);
        %rowsize(row(i))=1;  
        colpos(i)=(winsize(1)-colstep*(ind(i+1)-ind(i)-1))*0.35;
        fontsize(i)=fontsize(i-1);
        width(i)=width(i-1);
        font(i)=font(i-1);
        color(i)=color(i-1);   
    elseif text(ind(i)+1)=='s'  % small
        row(i)=row(i-1);
        %rowpos(row(i))=max([ rowpos(row(i-1))+smallrowstep rowpos(row(i))]);
        rowsize(row(i))=1;  
        colpos(i)=colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        colstep=smallcolstep;
        %rowstep=max([smallrowstep rowstep]);
        fontsize(i)=1;
        width(i)=width(i-1);
        font(i)=font(i-1);
        color(i)=color(i-1);   
    elseif text(ind(i)+1)=='l'  % large
        row(i)=row(i-1);
        rowsize(row(i))=2;
        %rowpos(row(i))=max([ rowpos(row(i-1))+largerowstep/2 rowpos(row(i))]);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        colstep=largecolstep;
        %rowstep=max([largerowstep rowstep]);
        fontsize(i)=2;
        width(i)=width(i-1);
        font(i)=font(i-1);
        color(i)=color(i-1);   
   elseif text(ind(i)+1)=='h'  % huge
        row(i)=row(i-1);
        rowsize(row(i))=3;  
        rowsize(row(i))=4;  % new
        %rowpos(row(i))=max([ rowpos(row(i-1))+hugerowstep/2 rowpos(row(i))]);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        colstep=hugecolstep;
        %rowstep=hugerowstep;
        fontsize(i)=3;
        width(i)=width(i-1);
        font(i)=font(i-1);
        color(i)=color(i-1);   
    elseif text(ind(i)+1)=='t'  % thin
        row(i)=row(i-1);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        fontsize(i)=fontsize(i-1);
        width(i)=1;
        font(i)=font(i-1);
        color(i)=color(i-1);   
    elseif text(ind(i)+1)=='b'  % boldface
        row(i)=row(i-1);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        colstep=colstep*boldfactor;
        fontsize(i)=fontsize(i-1);
        width(i)=2;
        font(i)=font(i-1);
        color(i)=color(i-1);   
   elseif text(ind(i)+1)=='d'  % demi
        row(i)=row(i-1);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        fontsize(i)=fontsize(i-1);
        width(i)=3;
        font(i)=font(i-1);
        color(i)=color(i-1);   
   elseif text(ind(i)+1)=='r'  % rm (normal font)
        row(i)=row(i-1);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        fontsize(i)=fontsize(i-1);
        width(i)=width(i-1);
        font(i)=1;
        color(i)=color(i-1);   
   elseif text(ind(i)+1)=='i'  % italic
        row(i)=row(i-1);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        fontsize(i)=fontsize(i-1);
        colstep=colstep*boldfactor;
        width(i)=width(i-1);
        font(i)=2;
        color(i)=color(i-1);   
   elseif text(ind(i)+1)=='o'  % oblique
        row(i)=row(i-1);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        fontsize(i)=fontsize(i-1);
        width(i)=width(i-1);
        font(i)=3;
        color(i)=color(i-1);   
   elseif text(ind(i)+1)=='R'  % red
        row(i)=row(i-1);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        fontsize(i)=fontsize(i-1);
        width(i)=width(i-1);
        font(i)=font(i-1);
        color(i)=2;   
   elseif text(ind(i)+1)=='W'  % normal background
        row(i)=row(i-1);
        colpos(i)= colpos(i-1)+colstep*(ind(i)-ind(i-1)-1);
        fontsize(i)=fontsize(i-1);
        width(i)=width(i-1);
        font(i)=font(i-1);
        color(i)=1;   
    elseif text(ind(i)+1)=='5'  % tab 5
        row(i)=row(i-1);
        colpos(i)=colpos(i-1)+20;
        fontsize(i)=fontsize(i-1);
        width(i)=width(i-1);
        font(i)=font(i-1);   
        color(i)=color(i-1);   
    else
        row(i)=row(i-1);
        colpos(i)=colpos(i-1);
        fontsize(i)=fontsize(i-1);
        width(i)=width(i-1);
        font(i)=font(i-1);   
        color(i)=color(i-1);   
    end
  end
  outtext(1,:)=[];
  rowpos(1)=rowstep(rowsize(1));
  %n,row,rowstep,rowsize
  for i=2:row(n-1);
    rowpos(i)=rowpos(i-1)+0.5*( rowstep(rowsize(i))+rowstep(rowsize(i-1)) );
  end
  
  %----------------- Setup the window ------------------------------
  
  screen=get(0,'ScreenSize');
  screen=screen(3:4);

  if strcmp(p,'header')
    h=findobj('Tag',p(1:2));
    if ~isempty(h);
      figure(h); clf
    else
      figure; 
    end;

     winsize=[screen(1) 110];
     pos=[10 winsize(2) winsize(1)-20 40];
     set(gcf,...
        'Position',[0 screen(2)-0-winsize(2) winsize],...
      'NumberTitle','off',...
      'Name','Help');
     handle=findobj('Tag','block');
     uicontrol(gcf,'Style','Frame',...
      'Units','pixels',...
      'Position',[0 0 winsize],...
	   'BackGroundColor',grey);
     blockpos=[0 (screen(2)-365)/screen(2) 700/screen(1) 200/screen(2)];
     global figpos
     figpos(2,:)=blockpos;
     if ~isempty(handle)
        set(handle,...
           'Position',blockpos)
     end
  elseif strcmp(p,'all')
     h=findobj('Tag',p(1:2));
     if ~isempty(h);
       figure(h); clf
     else
       figure; 
     end;

     winsize=screen-[0 50];
     pos=[10 winsize(2) winsize(1)-20 40];
     set(gcf,...
        'Position',[0 30 winsize],...
      'NumberTitle','off',...
      'Name','GUI presentation');
     uicontrol(gcf,'Style','Frame',...
      'Units','pixels',...
      'Position',[0 0 winsize],...
      'BackGroundColor',grey);
   
   elseif strcmp(p(1:2),'ex')
     if strcmp(p,'exu') % up
        h=findobj(gcf,'Tag','pos');
        figpos=get(h,'UserData');
        text=get(gcf,'UserData');
        pos=figpos(1,:)-[0 80 0 0];
        winsize=figpos(2,1:2);
     elseif strcmp(p,'exd') % down
        h=findobj(gcf,'Tag','pos');
        figpos=get(h,'UserData');
        text=get(gcf,'UserData');
        pos=figpos(1,:)+[0 80 0 0];
        winsize=figpos(2,1:2);
     else
        winsize=[screen(1) 180];
        pos=[10 winsize(2) winsize(1)-20 40];
        cddispfig=[screen(1)-winsize(1) screen(2)-30-winsize(2) winsize];
        handle=findobj('Tag','block');
        blockpos=[0 (screen(2)-460)/screen(2) 700/screen(1) 200/screen(2)];
        global figpos
        figpos(2,:)=blockpos;
        if ~isempty(handle)
          set(handle,...
             'Position',blockpos)
        end
     end
     h=findobj('Tag',p(1:2));
     if ~isempty(h);
       figure(h); clf
     else
       figure; 
       set(gcf,'Position',cddispfig,...
        'NumberTitle','off',...
        'Name','Example');
     end;
     set(gcf,'UserData',text)
 
     uicontrol(gcf,'Style','Frame',...
        'Units','pixels',...
        'Tag','pos',...
        'UserData',[pos; winsize 0 0],...
      'Position',[0 0 winsize],...
      'BackGroundColor',grey);
   
  elseif  strcmp(p(1:2),'he')  % help
     h=findobj('Tag',p(1:2));
     winsize=[450 rowpos(length(rowpos))+100];
     pos=[10,winsize(2)-40,winsize(1)-20,40];
     framepos=[5,50,winsize(1)-10,winsize(2)-55];
     cddispfig=[(screen-winsize-[0 30]) winsize];
     if ~isempty(h);
       figure(h); clf
     else
       figure; 
     end;
     set(gcf,'Position',cddispfig,...
        'NumberTitle','off',...
        'Name','Help');
     uicontrol(gcf,'Style','Frame',...
        'Units','pixels',...
      'Position',framepos,...
     'BackGroundColor',grey);
  elseif  strcmp(p(1:2),'de')  % demo
     h=findobj('Tag',p(1:2));
     winsize=[400 400];
     pos=[10,winsize(2)-40,winsize(1)-20,40];
     framepos=[5,50,winsize(1)-10,winsize(2)-55];
     cddispfig=[(screen-winsize-[0 30]) winsize];
     if ~isempty(h);
       figure(h); clf
     else
       figure; 
     end;
     set(gcf,'Position',cddispfig,...
        'NumberTitle','off',...
        'Name','Demo');
     uicontrol(gcf,'Style','Frame',...
      'Units','pixels',...
      'Position',framepos,...
     'IntegerHandle','off',...
     'BackGroundColor',darkgrey);
end
     
  set(gcf,'Tag',p(1:2),...
         'MenuBar','none');
      
%-------- Print text by uicontrols --------------------------
  
  
  % row,col,fontsize,width,outtext,size(outtext)
% [num2str([row' colpos' fontsize' width']),outtext]
for i=1:size(outtext,1);
        textstring=outtext(i,:);
        ind=find(textstring~=' ');
        if ~isempty(ind)
           textstring(ind(length(ind))+1:size(textstring,2))=[];
        end
        if fontsize(i)==1;
           s=smallfont; 
           s=largefont; 
        elseif fontsize(i)==2;
           s=largefont; 
           s=hugefont; 
        elseif fontsize(i)==3;
           s=hugefont; 
        end
        if width(i)==1;  % light, normal, demi, bold
           w='normal';
        elseif width(i)==2;
           w='bold';
        elseif width(i)==3;
           w='demi';
        end
        if font(i)==1;  %  %normal, italic, oblique 
           f='normal';
        elseif font(i)==2;
           f='italic';
        elseif font(i)==3;
           f='oblique';
        end
        if color(i)==1;
           c=grey;
        elseif color(i)==2;
           c=0.8*[1 1 1];
        end
        
        % HorizontalAlignment: [ left | {center} | right ]
                  h=uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
                'FontWeight',w,...
                'FontAngle',f,...
                'FontSize',s,...
             'HorizontalAlignment','left',...
             'Position',pos+[colpos(i) -rowpos(row(i)) 0 0],...
             'String',textstring,...
             'Tag',num2str(i),...
 	          'BackGroundColor',c);
     end;
    % set(h)      
    
    if strcmp(p,'demo');      
      uicontrol(gcf,'Style','PushButton',...
               'Units','pixels',...
               'Position',[80 10 70 30],...
	       'String','Forward',...
	       'CallBack','guidemo(''next'')',...
	       'Tag','next',...
	       'BackGroundColor','w');

  uicontrol(gcf,'Style','PushButton',...
               'Units','pixels',...
               'Position',[165 10 70 30],...
	       'String','Back',...
	       'CallBack','guidemo(''back'')',...
	       'Tag','back',...
	       'BackGroundColor','w');

	 uicontrol(gcf,'Style','PushButton',...
               'Units','pixels',...
               'Position',[250 10 70 30],...
	       'String','Close',...
	       'CallBack','close(gcf)',...
	       'BackGroundColor','w');
    end
    
    if strcmp(p,'help');      
    uicontrol(gcf,'Style','PushButton',...
               'Units','pixels',...
               'Position',[winsize(1)/2-30 10 70 30],...
	       'String','Close',...
	       'CallBack','close(gcf)',...
	       'BackGroundColor',grey);
    end   
    if  strcmp(p(1:2),'ex');      
    uicontrol(gcf,'Style','PushButton',...
               'Units','pixels',...
               'Position',[winsize(1)-60 winsize(2)/4-10 50 20],...
	       'String','Close',...
	       'CallBack','close(gcf)',...
	       'BackGroundColor',grey);
    uicontrol(gcf,'Style','PushButton',...
               'Units','pixels',...
               'Position',[winsize(1)-60 winsize(2)/2-10 50 20],...
	       'String','Down',...
	       'CallBack',['cddisp('' '',''exd'')'],...
	       'BackGroundColor',grey);
    uicontrol(gcf,'Style','PushButton',...
               'Units','pixels',...
               'Position',[winsize(1)-60 winsize(2)*3/4-10 50 20],...
	       'String','Up',...
	       'CallBack',['cddisp('' '',''exu'')'],...
	       'BackGroundColor',grey);
%  uicontrol(gcf,'Style','Slider',...
%               'Units','pixels',...
%               'Position',[winsize(1)-30 0 winsize(1)-30 winsize(2)],...
%	       'Value',ypos/120,...
%	       'CallBack',['cddisp(',text,',',p,',',num2str(ypos),')'],...
%	       'BackGroundColor','w');

end
