function handle=cdfigure(n,np)


% Adaptive figure
%
% handle=cdfigure(n)
%
% cdfigure works as figure, with the difference that 
% non-overlapping windows are created in a 3x3 pattern,
% starting at the upper right corner going downwards.
% E.g., cdfigure(5) creates a figure window in the middle
% of the screen, and cdfigure(7) at the upper left corner.
% 
% Old syntax:  handle=cdfigure(n,np)

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $

if nargin<2; np=n-1; end;

s=get(0,'ScreenSize');
w=s(3)/3-10;
h=s(4)/3-60;
W=s(3)/3;
H=s(4)/3;
for i=np+1:n;
  handle(i-np)=figure;
  set(handle(i-np),'Position',[s(3)+10-ceil(i/3)*W s(4)+10-(1+rem(i-1,3))*H w h]);
end
