function h=chi2(d,alpha);

% ERFCHI2 computes the threshold for chi-2 distribution
%
% function h=chi2(d,alpha);
%
% d    = degrees of freedom
% alpha= confidence level

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $

xmax=d+5*sqrt(2*d);   % mean plus 5 standard deviations
xstep=xmax/1000;
x=xstep:xstep:xmax;
f=x.^(d/2-1).*exp(-x/2) / 2^(d/2) / gamma(d/2);
F=cumsum(f)/sum(f);
ind=find(F>alpha);
h=x(ind(1));
