echo on
clc

%         EEG examination
%        =================
%
% The first data set is measured from human ocdipital area. Before t_b the lights
% are on in test room and the test person is looking at something
% interesting. The neurons are processing information in visual cortex,
% and only noise is seen in measurements. When lights are turned off,
% the visual cortex has nothing to do. The neuron clusters start 10 Hz
% periodical "rest rythm". The delay between t_b and the actual time
% when the rhythm starts varies strongly. It is believed that the delay
% correlates with e.g. Alzheimer decease, and methods for estimating the
% delay would be useful in for example medicin tests.
%
% We load the signal, segment it with respect to changes in an AR model.

load eeg_human
[threc,jhat,ths]=detectM(Y(:,1),4);

h1=cdfigure(1);
segplot(Y(:,1),jhat)
title('EEG signal on a human when lights turned on at time 387')
jhat
t_b

% The delay to reaction for this man is 45 samples.

pause

% The second data set is an EEG signal from a rat.
% The problem for evaluation here is that no one can say anything about the true times. 
% The "rat people" want to classify the signal to "spindles" and "back
% ground". Currently they are using narrow band filter and they have
% some treshold for output power of that. That method gives
%
% sp_time=[1096 1543 1887 2265 2980 3455 3832 39341]
%
% but here the signal is constrained to two classes. 
% The assumption here being that
% the transition is not abrupt in this signal, but merely smooth.

load eeg_rat
h2=cdfigure(2,1);
plot(y)
title('EEG signal on a rat')
pause
[th,lam,epsi]=adfilter(y,0,.97);
[jtime,jtype,ths,lams]=multihyp(y,0,300,[0 1 0]);
plot([lam lams'])
pause
close([h1 h2])
