
clc
clg
echo on

randn('seed',2)
u=randn(100,1);
e=randn(100,1);

%             UNKNOWN MEAN MODEL

% The signal consists of an unknown mean in white noise
nnn=-1;
jumptimes=[40 70];
TH=[0 1 2];
y=simchange(0.1*e,nnn,jumptimes,TH);
z=y;
[threc,jhat,thseg,dum,dum,Alfa]=detectM(z,nnn);jhat

h1=cdfigure(1);
segplot(y,jhat)
title('Signal and estimated change times')

h2=cdfigure(2);
plot([y thseg'])
title('Signal and estimated mean')

h3=cdfigure(3,2);
plot(Alfa)
axis([0 100 0 10])
title('Negative log likelihood for each model')
% Note that it takes about 6 samples before one model becomes the best
pause

% The one and two model approaches give comparable results:
% The normalized sample mean (1) as distance measure and
% the CUSUM detector [2 5 1] as stopping rule gives:
[threc,jhat,thseg,gt1,ta]=detect1(z,nnn,1,[2 5 1],0.01);jhat

% The normalized squared sample mean (2) as distance measure and
% the CUSUM detector [1 10 5] as stopping rule gives:
[threc,jhat,thseg,gt2,ta]=detect1(z,nnn,2,[1 10 5],0.01);jhat

% Brandt's GLR (1) as distance measure and
% the CUSUM detector as stopping rule gives:
[threc,jhat,thseg,gt3,ta]=detect2(z,nnn,1,[1 3 0.3],10,-1);jhat

% The divergence test (2) as distance measure and
% the CUSUM detector as stopping rule gives:
[threc,jhat,thseg,gt4,ta]=detect2(z,nnn,2,[1 3 0.3],10,-1);jhat

h4=cdfigure(4,3);
plot([gt1(:,:) 0.1*gt2(:,1) gt3(:,1) gt4(:,1)])
% Note the different thresholds that are required !
% This makes the design a bit difficult

pause
close([h1 h2 h3 h4])
echo off             
