clc
echo on
randn('seed',2)
u=randn(100,1);

%             STATE SPACE MODELS
%

%[a,b,c,d]=tf2ss([0 1 1],[1 1 1]);
A=[1 1;0 1]; B=[0.5;1]; C=[1 0]; D=0; R1=.01*eye(2); R2=0.1; P0=1*eye(2);

Q=0.01*eye(2);
R=0.01;
P0=1*eye(2);
nnn=ss2nnn(A,B,C,D,Q,R,P0);
jumptime=50;
TH=[10; 20];
[y,X]=simchange([u],nnn,jumptime,TH);
[Xhat,lamhat,epsi]=adfilter([y u],nnn);

h1=cdfigure(1);
plot(epsi)
pause

% Test the MLR function
[jhat,lr]=mlr([y u],nnn);jhat
h2=cdfigure(2,1);
plot(lr)
pause

% Test the GLR function
[Xhatglr,jumphat,ta,lr,numat,mu]=glr([y u],nnn,10,6e4);
disp([jumphat])
disp([nuhat])
h3=cdfigure(3,2);
plot(lr)
h4=cdfigure(4,3);
leg1=plot(X(1,:),':'), hold on
leg2=plot(Xhat(1,:),'--')
leg3=plot(Xhatglr(1,:),'-'), hold off
legend([leg2 leg2 leg3],'True states','Kalman filtered states','GLR filtered states',2);
h5=cdfigure(5,4);
leg1=plot(X(2,:),':'), hold on
leg2=plot(Xhat(2,:),'--')
leg3=plot(Xhatglr(2,:),'-'), hold off
legend([leg2 leg2 leg3],'True states','Kalman filtered states','GLR filtered states',2);
pause

close([h1 h2 h3 h4 h5])

echo off             
