% demo_speechseg

echo on
clc
clg

%      ANALYSIS OF SPEECH DATA
%      =======================
%
% This speech data was recorded inside a car with fs=8 kHz.
% It has been analysed by Regine Andre-Obrecht (1988) and her
% results are also published in Basseville and Nikiforov (1993).
% The first data batch contains low-frequency noise from the car
% and the other is a prefiltered version.

load speech
h1=cdfigure(1);
subplot(211)
plot(fig1120)
title('Noisy speech signal')
subplot(212)
plot(fig1118)
title('Filtered speech signal')
pause

% The signals are segmented by using the segm-command using a second order AR model with
% unknown and changing noise variance:

% This takes a couple of minutes....

 [jh1118,ths1118,lam1118]=detectM(fig1118,2);
 [jh1120,ths1120,lam1120]=detectM(fig1120,2);


% We can now illustrate the achieved segmentation on the signal:

subplot(211)
hold on
dum=axis;
plot([jh1120 jh1120]',[dum(3)*ones(size(jh1120)) dum(4)*ones(size(jh1120))]','-')
pause
subplot(212)
hold on
dum=axis;
plot([jh1118 jh1118]',[dum(3)*ones(size(jh1118)) dum(4)*ones(size(jh1118))]','-')
pause
close(h1)
