function demodetect(arg)

echo on

if nargin<1; arg='main'; end

if strcmp(arg,'main')

  header='Demonstration of the Detection ToolBox';
  labels=str2mat('Detection functions (overview)','Data models and methods (overview)',...
		 'Change point estimation','Design of CUSUM test',...
		 'Asymptotic power','Recursive implementation','Applications');

  callbacks=str2mat('demo_methods','demodetect(''models'')',...
  'demo_cpe','demo_cusum','demo_aspower','demodetect(''rec'')','demodetect(''applications'')');

  choices('demo DetectTB',header,labels,callbacks)
end

if strcmp(arg,'models')
  header='Data models and detection methods';
  labels=str2mat('Unknown mean model               ','AR model','ARX model','State space model');
  callbacks=str2mat('demo_models1','demo_models2','demo_models3','demo_models4');
  choices('demo models',header,labels,callbacks)
end

if strcmp(arg,'rec')
  header='Recursive implementations';
  labels=str2mat('Onemodel             ','Twomodel','GLR');
  callbacks=str2mat('demo_rec1','demo_rec3','demo_rec2');
  choices('demo recursive',header,labels,callbacks)
end

if strcmp(arg,'applications')
  header='Applications';
  labels=str2mat('Variance and parameter change in a communication problem','Variance change in an altitude sensor','Speech segmentation','Spectrogram','Path segmentation','Belching sheep','Skid detection','Fuel consumption filter','EEG','Equalization','Target tracking');
  callbacks=str2mat('demo_digcom','demo_altdata','demo_speechseg', ...
		    'demo_specgram','demo_carpath','demo_sheep','demo_fricest');
  callbacks=stre2mat(callbacks,'demo_fuel','demo_eeg','demodetect(''equalization'')','demodetect(''tracking'')');
  choices('application demo',header,labels,callbacks);
end

if strcmp(arg,'equalization')
header='Equalization';
labels=str2mat('Viterbi: equalization of SISO real channel',...
'Blindeq1: Time-invariant SISO, real channel.',...
'BlindeqM: Time-invariant SISO, real channel.',...
'BlindeqM: Time-varying SISO, real channel',...
'BlindeqM: Time invariant SIMO, real channel',...
'BlindeqM: Time-varying SIMO, real channel',...
'BlindeqM: Time invariant MIMO, real channel',...
'BlindeqM: Time-varying SISO, complex channel');

callbacks=str2mat('demodigcomarg=0; demo_equalization',...
   'demodigcomarg=1; demo_equalization',...
   'demodigcomarg=2; demo_equalization',...
   'demodigcomarg=3; demo_equalization',...
   'demodigcomarg=4; demo_equalization',...
   'demodigcomarg=5; demo_equalization',...
   'demodigcomarg=6; demo_equalization',...
   'demodigcomarg=7; demo_equalization');
choices('demo digcom',header,labels,callbacks)

end

if strcmp(arg,'tracking')
header='Tracking';
labels=str2mat('1 ',...
'2',...
'3');

callbacks=str2mat('demotrackingarg=0; demo_tracking',...
   'demotrackingarg=1; demo_tracking',...
   'demotrackingarg=2; demo_tracking',...
   'demotrackingarg=3; demo_tracking',...
   'demotrackingarg=4; demo_tracking',...
   'demotrackingarg=5; demo_tracking',...
   'demotrackingarg=6; demo_tracking',...
   'demotrackingarg=7; demo_tracking');
choices('demo tracking',header,labels,callbacks)

end
