function y=fastfilter(b,a,u);

% Fast implementation of filter
%
% y=fastfilter(b,a,u);
%
% Utilizes that y=h*u=ifft(fft(h).*fft(u)) (*=convolution)
% which gives considerable speedup for long u sequences
%
% See also fastfiltfilt

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $


N=length(u);
n=ceil(log(N)/log(2));
h=dimpulse(b,a,min([N,1000]));
hz=[h;zeros(2^n-length(h),1)];
uz=[u;zeros(2^n-length(u),1)];
yz=real(ifft(fft(uz).*fft(hz)));
y=yz(1:N);






