function y=fastfiltfilt(b,a,u);

% Fast implementation of filtfilt
%
% y=fastfiltfilt(b,a,u);
%
% Utilizes that y=h*u=ifft(fft(h).*fft(u)) (*=convolution)
% which gives considerable speedup for long u sequences
%
% See also fastfilter

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $

% y=filtfilt(b,a,u); return  % Standard matlab

N=length(u);
n=ceil(log(N)/log(2));
h=dimpulse(b,a,min([N,1000]));
hz=[h;zeros(2^n-length(h),1)];
uz=[u;zeros(2^n-length(u),1)];
Hz=fft(hz);
Uz=fft(uz);
yz=(ifft(Uz.*Hz.*conj(Hz)));
y=real(yz(1:N));





