function guiex(action,arg1,arg2)

% Exercises for the GUI guidetect

coldata=[0.95 1 0.95];

if strcmp(action,'1')
   
text=['\l\b\cEXERCISE 1\n\n',...
      '\bADAPTIVE FILTERING \n',...
      '\bFundamental example: \o  change in the mean in random variable \n',...
      'After a model-based filter is applied to data, all adaptive filter\n',...
      'and change detection problems boil down to the one of tracking and \n',...
      'detecting abrupt changes in the statistical properties of (scalar) \nrandom variables.\n',...
      'This is the motivation for starting with this case, and you will here \n',...
      'discover the main functions in the toolbox listed below. \n',...
      'In the next exercises, you will apply the same methodology to more \n',...
      'complex signals. These exercises are much looser formulated than this \n',...
      'one, and only the general information about the signal is provided. \n',...
      'To get everything correctly setup, choose \n\R Utilities/Examples/Mean change: one jump\Win the menu! \n',...
      'More challenging is perhaps \RMean change: several jumps\W. \n',...
      '\n',...
      '\ba. How to simulate signals: \o built-in simulator, simulink \n',...
      'Linear systems with abrupt changes are most conveniently simulated \n',...
      'with the built in simulator. Click on \R Data Generation \W \nto get the setup window. \n',...
      'You can here check the default settings, which you can change at any time.\n ',...
      'Now, start the simulation by pressing the block\R Simulation \W \nin the block scheme.\n ',...
      'You can plot the simulated signal by pressing the signal \Ry \W. \n',...
      'An alternative to simulate signals is to write your own m-file. \n',...
      '',...
      '\bb. Adaptive filter design: \o tuning, Monte Carlo, auto-tuning  \n',...
      'The default here is to use an adaptive filter. Click on\R Filter Design \W\n',...
      'to confirm that the default is RLS with forgetting factor 0.98. \n',...
      'That is, the estimated mean is \o th = sum{k=1}{t} 0.98^(t-k) y(k) \r\n',...
      'Press the block \R Adaptive Filter \W and look at the resulting estimate\n',...
      'by pressing the signal\R th.\W \n',...
      'You can experiment with tuning the forgetting factor and choosing other \n',...
      'adaptive algorithms. Here you might want to open the \R Adaptive Tool \W\n',...
      'which gives you a possibility to save the settings and results in a table.\n',...
      'For each filter design you want to save, press \R Table \W in this window. \n',...
      'The different figures are measures on performance. \n',...
      'To get a more reliable result, repeat the experiment in a Monte Carlo \n',...
      'simulation by pressing \n\R MC \W (choose e.g. 10 iterations). \n',...
      'The adaptation gain can be automatically optimized \n',...
      'by pressing \R Auto-Tuning \W (choose only 1 iteration to save time).\n',...
      ];
      
end

if strcmp(action,'2')
   
text=['\n\l\b\cEXERCISE 2\n\n',...
      '\bCHANGE DETECTION \n',...
      '\bFundamental example: \o  change in the mean in random variable \n',...
      '\ba. Simulation:\t To simulate the signal, repeat exercise 1.a \n',...
      '\bb. Concepts of change detection: \o test statistic, threshold \n',...
      'The basic idea in this approach is to take the residual \n',...
      '(also called prediction error or innovation), lowpass filtering \n',...
      'it and then comparing the result to a threshold. \n',...
      'First, change the structure by clicking at \R Filter Structure \W and then \n',...
      'choosing \R one-model   \W. Press the \R Residual Generator \W \nor \R Change Detector \W.\n ',...
      'Study the lowpass filtered residual by clicking the signal \R g \W. \n',...
      'This signal crosses the red threshold level and we get an alarm and \n',...
      'the filter gain is increased, which is the reason for the improved \n',...
      'parameter tracking. You may here want to save the result to the \n\R Table \W in the Adaptive Tool. \n',...
      'A fundamental property in change detection is \o alarm time \r. In the \n',...
      '\R Change Tool \W you can start a \R Monte Carlo Simulation \W. \n',...
      'When it is finished, you get all kind of statistics presented, and you can \n',...
      'save the change detection performance in another \R Table \W. \n',...
      '\bc. Advanced change detectors: \o two-filter approach, filter banks \n',...
      'Check the different available detectors by opening \R Filter Structure \W\n ',...
      'and then choosing \R Two-model   \W and \R Multi-model \W, respectively.\n',...
      'In the two-model approach one slow and one fast filter are competing, and \n',...
      'if the fast filter performs the best, an alarm is generated. The design is \n',...
      'similar to the one-model approach.\n',...
      'The idea with filter banks is that each filter is based on a specific guess \n',...
      'about the change time, and the detector just checks which one performs best. \n',...
      'Check the block diagram, and apply the detector if you want to. ',...
  ];


end


if strcmp(action,'3')
   
text=['\n\l\b\cEXERCISE 3\n\n',...
      '\bSimulation examples:   \o  AR, ARX and State Space models \n',...
      'Exercise 1 gives a general overview of the functionality of the toolbox, \napplied ',...
      'to a simple but fundamental example of a change in the mean. \n',...
      'Here we will illustrate how more realistic data models are transformed back \nto ',...
      'the fundamental example by means of an \o adaptive filter. \n',...
      'The available models are listed below: \n\n',...
      '\bAR model.  \t An auto-regressive time series \n',...
      '\5\o y(t) = -a1 y(t-1) - a2 y(t-2) + e(t) \r\n',...
      'with 100 data is simulated with an abrupt parameter change at time 50.\n ',...
      'The parameters are  \o th=[a1, a2]=[1.6, 0.64]\r before the change and \n',...
      '\oth=[0.4, 0.04]\r after the change. These values correspond to a double \n',...
      'pole in 0.8 before and 0.2 after the change, respectively. \n',...
      'Check the simulation setup in \R Data Generation \W. ',...
      '\nCheck the filter settings in \R Filter Model \W (AR(2)).  \n',...
      'Apply first a linear adaptive filter (without change detector), by clicking\n ',...
      'on the blocks. \nThen tune the design parameters in the filter using ',...
      'the \RAdaptive Tool\W\nand save the results to a table.\n ',...
      'Choose one of the change detectors, tune the parameters and use\n',...
      '\RAdaptive Tool \W and \R Change Tool \W to evaluate and automate the design. \n\n',...
      '\bARX model.   \t The simplest model for a dynamic system is an ARX model. \nIn this ',...
      'example it is given on the form \n',...
      '\5\o y(t) + a1 y(t-1) + a2 y(t-2) = b1 u(t-1) + b2 u(t-2) + e(t) \r. \n ',...
      'The parameters \oth=[a1, a2, b1, b2]\r are \oth=[1.6, 0.64, 1, 1]\r \nbefore ',...
      'the change and  \oth=[0.4, 0.04, 1, 1]\r after the change, respectively. \n',...
      'See the AR example above for tips what to do. \n\n',...
      '\bState space model.    \t ',...
      'The state space model is a sampled double \nintegrator (a random force acting on an object)\n',...
      '\5\o x(t+1) = [1  1; 0  1] x(t) + [0.5; 1] v(t) \n ',...
      '\5\o   y(t) = [1  0] x(t) + e(t) \n',...
      '100 data are simulated with an abrupt change at time 50 corresponding \nto a state jump ',...
      'by \oth=[5; 10]\r. The change can be interpreted as a force \n',...
      'of size 10 acting on the the object at time 50. The parameter(s) are  \n',...
      'in this case the abrupt state change(s). \n',...
      'Check how well the state change and states  \n',...
      'themselves can be tracked by an adaptive filter with and without change \ndetection, respectively. \n',...
      'See the AR example above for tips what to do. ',...
   ];

end

if strcmp(action,'4')
   
text=['\n\l\b\cEXERCISE 4\n\n',...
      '\bExamples with real data.\n',...
      'Exercise 1 gives a general overview of the functionality of the toolbox, \n',...
      'applied to a simple but fundamental example of a change in the mean. \n',...
      'Here we will illustrate how to apply these functions to real data.\n',...
      'The advice is to start by running one of the application demos, where \n',...
      'background material is explained, and some filters are demonstrated.\n',...
      'These filters can however be improved on by hand tuning or using \n',...
      'the design tools, and there is as always with real data no true answer\n',...
      'nor a final solution. The best filter is an open question.',...
];

end


cddisp(text,'help');
