function guihelp(action,arg1,arg2)

coldata=[0.95 1 0.95];
disp(['help action: ',action])


if strcmp(action,'block')
  
   text=['\l\b\c  ABOUT THE FRONTEND \n\n',...
         'The frontend focuses on the block diagram. Data are\n',...
         'generated, loaded from file or simulated, by pushing\n',...
         'first block. The filter or detector is started by pushing\n',...
         'one of the following blocks.\n\n',...
         'Signals in the block diagram can be plotted either by pushing \n',...
         'these or by opening the \b Plot Tool \t, where other signals\n',...
         'are also available.\n ',...
         'The upper right \i pop-up menu \r chooses \n',...
         'the structure of the block diagram. That is, if \n',...
         'an adaptive filter or a change detector is to be used. \n\n',...
         'The design parameters of the filter/detector are set \n',...
         'in a window opened by pushing \b Design parameters. \n\n',...
         'The text boxes shows information about CPU use and warnings \n',...
         'or progresses, respectively. \n',...
         'The design tools are: \n',...
         '\5\bAdaptive Tool.  \t For designing adaptive filters. It computes \n',...
         '\5certain performance norms, makes Monte Carlo simulations, \n',...
         '\5creates summary tables and auto-tunes the design parameters. \n',...
         '\5\bChange Tool.  \t For designing change detectors. It computes \n',...
         '\5certain performance norms, makes Monte Carlo simulations, \n',...
         '\5creates summary tables and auto-tunes the design parameters. \n',...
         'Under the menu utilities, there is a number of options for getting \n',...
         'acquainted with the toolbox, like simulation examples, data files \n',...
         'and excercises. The menu demo gives illustrative demonstrations. ',...
         ];

end

if strcmp(action,'datagenreal')

  text=['\l\b\c IMPORT DATA \n\n',...
        'You can load data from matlab. In the \R Data Generator \W,\n',...
        'choose \R Data from file \W, type the file name and\n',...
        'press the block now called \R Load Data \W. \n\n',...
        'There are a number of real data available. These are most \n',...
    'easily accessed from the \R Applications \W menu,\n',...
    'which also sets up default models and methods.\n\n',...
 'Do \R helpdetect(''z'') \W for a definition of the data format.\n'];
  
end;

if strcmp(action,'datagensim')

  
  text=['\l\b\c SIMULATED DATA \n\n',...
    'The most convenient way to get data to play around with is\n',...
    'to simulate them yourself. One advantage is that you know\n',...
    'where the changes are and which model to use. Another one is\n',...
    'that you can test your design with Monte Carlo simulations.\n',...
    ' \n',...
    'Press \R Data Generator \W and choose \R Simulated Data \W\n',...
    'to setup a simulation. You need to specify a model and the\n',...
    'following parameters:\n',...
    '\5\bNumber of data  \t in the simulation.\n',...
    '\5\bChange times  \t as a vector. Leave empty or write [] if no changes.\n',...
    '\5\bParameter vectors  \t between the changes defined as \n',...
    '\5\o    TH=[th0 th1 th2... thn].\n',...
    '\5Remember there is one more segment than number of change times. \n',...
    '\5The parameter vectors are organized as column vectors.\n',...
    '\5\bNoise variance(s)  \t in each segment. Scalar value means constant.\n',...
    '\5The input is either taken from workspace in matlab as a \n',...
    'specified global variable or simulated as white noise.\n',...
    ' \n',...
    'Push the block \R Simulation \W to start the simulation.\n'];
  
end;

if strcmp(action,'detmod')

  
  text=['\l\b\c FILTER MODEL  \n\n',...
    'The detection model is used to generate residuals via a matched\n',...
    'filter. For all but state space models a recursive least squares\n',...
    'filter is applied under a certain hypothesis of jumps. The filter is\n',...
    'restarted when the detection algorithm signals for an alarm. For\n',...
    'state space models a Kalman filter is applied to the data.'];

end;
    
if strcmp(action,'detmet0')

  
  text=['\l\b\c ADAPTIVE FILTER  \n\n',...
        '\bParametric models. \n',...
        'The adaptive filter implements the recursion:\n',...
        '\5\o th(t+1) = th(t) + K(t) e(t)\n',...
        '\5\o     e(t) = y(t) - phi(t)''th(t-1)\n',...
        'The gain \o K(t) \r is determined by the method which can be:\n',...
        '\5\b RLS \t with forgetting factor \o lambda \n',...
        '\5\b LMS  \t with step size \o mu \n',...
        '\5\b NLMS  \t with step size \o mu  \n',...
        '\5\b WLS  \t (windowed LS) with sliding window size \o L  \n',...
        '\5\b KF  \t with parameter noise covariance \o R1 \r or \o r1 I \n',...
        'The parametric model can be one of mean change, linear\n',...
        'regression, AR and ARX models.\n',...
        '\b State space models.\n',...
        'Only the Kalman filter makes sense for state space models.\n\n',...
        'See also \R help cdfilter \W for more details.\n',...
         ];
  
end;

if strcmp(action,'detmet1')

  
  text=['\l\b\c ONE-MODEL DETECTION \n',...
    'In the one-model approach only one filter is applied to data,\n',...
    'under a no jump assumption. The detector is essentially a\n',...
    '\i whiteness test on the residuals \r. The whiteness test looks for\n',...
    'abrupt changes in the \i mean \r or the \i square \r of the residuals.\n',...
    'The \b CUSUM, GMA   \t or the \b Bayes \t \i stopping rule \r\n',...
    'decides when the change is significant. \n',...
    'Design parameters are \i threshold and forgetting.\n\n',...
    'See also \R help detect1 \W for more details.\n',...
];
  
end;

if strcmp(action,'detmet2')

  text=['\l\b\c TWO-MODEL DETECTION  \n',...
        'In the two-model approach, \i one slow and one fast filter\n',...
        'are run in parallel.\n',...
    'One is matched to no jump and the other one to the hypothesis\n',...
    'of a jump \o L \r samples ago. \i Distance measures \r for comparing the\n',...
    'models are either \i the mean, the GLR or the divergence.\n',...
    'Stopping rules are one of \b CUSUM, GMA \t and \b Bayes.\n',...
    'Design parameters are the size of the \i sliding window L, the threshold h\n',...
    'and the \i forgetting lam/gamma \r in the stopping rule.\n\n',...
    'See also \R help detect2 \W for more details.\n',...
    
];
  
end;

if strcmp(action,'detmetsegm')

  
  text=['\l\b\c FILTER BANK DETECTION  \n',...
    'In the multi-model approach a number of \i filters are run in parallel,\n',...
    'each one matched to a certain hypothesis about the change time history.\n',...
    'A search scheme decides which hypothesis to investigate.\n',...
    'There are four possible loss function for comparing the filters:\n',...
    'MAP with and without known noise variance, MDL/BIC and AIC.\n',...
    'There are several design parameters in the search scheme,\n',...
    'but the default settings usually work very well.\n\n',...
    'See also \R help segm \W for more details.\n',...  
];
  
end;

if strcmp(action,'detmetglr')
  
  text=['\l\b\c THE GLR TEST  \n',...
    'Computes the log likelihood ratios of a jump at time k versus no jump\n',... 
    'according to the formulas in Willsky and Jones (1976). \n',...
 ];
  
end;

if strcmp(action,'detmetmlr')
  
  text=['\l\b\c THE MLR TEST  \n\n',...
  'Computes the log likelihood ratios of a jump at time k versus no jump \n',...
  'according to formulas given in AC-41, no 1.',...
  '\n',...
 ];
  
end;

if strcmp(action,'plottool')

  
  text=['\l\b\c PLOT TOOL  \n\n',...
    'There are the following types of validation plots:\n',...
    '\b1. Data Preview. \t The signal is plotted and the there is\n',...
    'a possibility to \b Zoom \t parts of the data for the analysis.\n',...
    '\b2. Data Segmentation.   \t The signal is plotted and the estimated\n',...
    'change times are marked with vertical bars.\n',...
    '\b3. Test statistics. \t The quantity computed in the stopping rule\n',...
    '   is plotted. This is useful for choosing threshold and forgetting.\n',...
    '\b4. User specified. \t Simply write your own script or m-file.\n',...
    '   Syntax: \b fcn(z,threc,thseg,th0,jhat,simjhat) .\n',...
    '\b5. Parameter comparison.   \t The estimated parameters, or for state\n',...
    '   space models the state estimate, are plotted.\n',...
    '   If the data are simulated, the true values are shown as well.\n',...
    '\b6. RMS error. \t The root mean square error of the parameter or\n',...
    '   state estimate. Useful when tuning using simulated data.'];
end;

if strcmp(action,'MC')

  
  text=['\l\b\c MONTE CARLO SIMULATIONS  \n',...
    'Monte Carlo simulations are very useful for validating a design.\n',...
    'This is equivalent to pushing the ''Sim'' and ''Start detection'' \n',...
    'buttons a number of times in a row, but now all results are stored\n',...
    'and certain statistics are computed and plotted.\n',...
    ' \n',...
    'Histograms on delay for detection, alarm times and false alarms\n',...
    'are shown. The mean time for detection, mean time between  false\n',...
    'alarms and and other results are printed out.',...
      ' \n',...
      'These statistics can be save in a table for comparision with\n',...
      'other methods.\n',...
      ' \n',...
      'There is also a quite useful feature of auto-tuning of the\n',...
      'threshold in the change detector. See separate help on this.'];
  
end;

if strcmp(action,'MCtable')
  
  text=['\l\b\c DETECTION TABLE  \n',...
      'Table with results from Monte Carlo simulations\n',...
      ' \n',...
      'Table information:\n',...
      '  Method:     Used change detector with design parameters\n',...
      '  Nsim:       number of Monte Carlo simulations\n',...
      '  Nr det:     total number of detections\n',...
      '  E(ta):      mean delay for detection (ta alarm time)\n',...
      '  alpha:      false alarm rate (type I error)\n',...
      '  beta:       missed detection rate (type II error)\n',...
      ' \n',...
      'Note that only the ten last experiments are shown and  \n',...
      'are recoverable. The Latex table shows them all. \n',...
      ' \n',...
      'This window can only be exited by the quit button.\n',...
      'That is, if you resume your session you can update\n',...
      'the table whenever you want to.'];
end;

  
if strcmp(action,'MCautotuning')
  
  text=['\l\b\c AUTO-TUNING OF DETECTORS  \n',...
      'Do as follows:\n',...
      ' \n',...
      '1. Simulate data without abrupt changes.\n',...
      '2. Run a change detector using explicit threshold\n',...
      '   and set the threshold large so no false alarms\n',...
      '   are received\n',...
      '3. The auto-tuning function computes the threshold\n',...
      '   that gives a pre-specified false alarm rate in\n',...
      '   some different ways. Use the optimzed parametric\n',...
      '   threshold suggestion, especially when the FAR is\n',...
      '   small compared to the number of data.'];
end

if strcmp(action,'zoom')

  
  text=['\l\b\c ZOOM  \n',...
    'Here you can zoom a segment of the data.\n',...
    'By moving the sliders, the vertical bars in the data\n',...
    'window move and when pushing the ''OK'' button the\n',...
    'rest of the data are discarded.'];
  
end;

if strcmp(action,'adaptivetool')

  
  text=['\l\b\c ADAPTIVE TOOL  \n\n',...
    'The Tracking Design Tool has two functions for designing an\n',...
    'adaptive filter or change detector: \n',...
    ' \n',...
    '1. It computes several norms for comparing different filters\n',...
    'and change detectors with each others. Successful designs \n',...
    'can be saved to a table by pushing ''Table''.\n',...
    ' \n',...
    '2. Autotuning. By pushing ''Optimize'' the design parameter(s)\n',...
    'of the current method is optimized with respect to one of the \n',...
    'norms (just select one of them). The globally optimal method \n',...
    'is then found by including the local optima in the table and \n',...
    'selecting the method that performs best.\n',...
    ' \n',...
    'Possible norms are: \n',...
    '1. Loss funtions (V), i.e. the sum of squared prediction errors. \n',...
    '2. MDL, a measure of the number of bits required to store the signal.\n',...
    '3. RMS Parameter Error (PE), the root mean square of the parameter error.\n',...
    'These norms can be computed for the recursive parameter estimate \n',...
    'or the smoothed estimate (only available for change detectors). \n',...
    'The parameter error is only available for simulated data.\n',...
    'N.A. as a norm simply means Not Available.' ];
  
end;

if strcmp(action,'designtable');
  
  text=['\l\b\c ADAPTATION TABLE  \n',...
    'The Design Table summarizes and compares the result from \n',...
    'the Adaptive Design Tool. The columns of the table contain\n',...
    'algorithm, design parameters and the available norms.',...
      ' \n',...
      'Table information:\n',...
      '  Method:     Used adaptive algorithm with design parameters\n',...
      '  V(seg):     \n',...
      '  MDL(seg):   See help on Adaptive tool  \n',...
      '  PE(seg):    See help on Adaptive tool  \n',...
      '  V(rec):     See help on Adaptive tool  \n',...
      '  MDL(rec):   See help on Adaptive tool  \n',...
      '  PE(rec):    See help on Adaptive tool  \n',...
      ' \n',...
      'Pushing the button recovers the complete state of \n',...
      'the experiment and updates the plots. \n',...
      'Note that only the ten last experiments are shown and  \n',...
      'are recoverable. The Latex table shows them all. \n',...
      ' \n',...
      'This window can only be exited by the quit button.\n',...
      'That is, if you resume your session you can update\n',...
      'the table whenever you want to.'];
  
end;

if strcmp(action,'simsetup')

  
  text=['\l\b\c SIMULATION SETUP  \n',...
    'In the Simulation Setup you can setup parameters for  \n',...
    'simulating a piecewise constant linear regression or  \n',...
    'a state space model with abrupt changes.  \n',...
    '  \n',...
    'The ''Number of data'' is an integer.\n',...
    '''Change times'' is a vector of integers.\n',...
    'The matrix ''Parameter vectors'' contains one more column\n',...
    '  than number of change times and each column contains the \n',...
    '  parameter vector in the corresponding segment, alternatively\n',...
    '  the state change at the corresponding change time.\n',...
    '''Noise variances'' is a vector with one more element than the\n',...
    '  the number of change times. A scalar implies constant noise.\n',...
    'An input to a system is loaded from the file simu.mat if it exists, \n',...
    '  otherwise white noise is generated.\n',...
    '  '];
  
end;

if strcmp(action,'design')

  
  text=['\l\b\c FILTER DESIGN  \n',...
    'Here you setup the parameters in the adaptive filters\n',...
    'and change detectors. The parameters are divided in discrete ones,\n',...
    'where there are a finite number of choices, and continouos ones.\n',...
    'Do help on the respective method for more information on the \n',...
    'design parameters.\n',...
    'The adaptive filter is a LS estimator between the estimated change times.\n',...
    'That is, LMS and RLS cannot be used. The design parameters are \n',...
    'the usual ones for CUSUM and GMA, (threshold h and drift nu or forgetting lambda \n).',...
    'The measurement noise variance is critical for change detection. \n\n',...
    'For more info, see matlab help on\n',...
    '\b detect1\t for the one-model approach\n',...
    '\b detect2\t for the two-model approach\n',...
    '\b detectM\t for the segm approach\n',...
    '\b glr\t for the GLR approach\n',...
    '\b mlr\t for the MLR approach\n'];
end;

if strcmp(action,'detector')

  
  text=['\l\b\c Change detection filter structure\n\n',...
    'For more info, see matlab help on\n',...
    '\b detect1\t for the one-model approach\n',...
    '\b detect2\t for the two-model approach\n',...
    '\b detectM\t for the segm approach\n',...
    '\b glr\t for the GLR approach\n',...
    '\b mlr\t for the MLR approach\n'];
end;

if strcmp(action,'simulink')

  
  text=['\l\b\c SIMULINK  \n',...
    'Save the current adaptive filter/change detector as a simulink block.\n',...
    'This generates an S-function that load the design parameters and \n',...
    'calls the corresponding toolbox function using the S-function syntax.\n',...
    'You can open a Simulink window by selecting ''Simulink basic'' for\n',...
    'instance to see how it works.'];
  
end;


if strcmp(action,'simulink')

  
  text=['\l\b\c  ABOUT THE FRONTEND \n',...
    'This is the simulink interface to the toolbox.\n',...
    'Here you can simulate exactly as in the main window,\n',...
    'but the important difference is that the recursive\n',...
    'implementations are used instead.\n',...
    '\n',...
    'You can incorporate simulation models from Simulink,\n',...
    'and even get the corresponding (extended) Kalman filter\n',...
    'from it directly.\n',...
    '\n',...
    'After a successful design the filters and detectors\n',...
    'can be saved as S-function to be used in Simulink.\n',...
    '\n',...
    'The plot tools from the main window are still active\n',...
    'in these simulations.\n',...
    'By clicking the boxes themself, a simulation is started\n',...
    'just as clicking "Load"/"Simulate" and "Start".\n',...
    'Only the clicked block and the ones to the right are\n',...
    'simulated.  '];
  
end;

if strcmp(action,'model')

  
  text=['\l\b\c FILTER MODEL  \n',...
    'Here you choose the model structure for the filter in\n',...
    'the residual generator.'];
  
end;

if strcmp(action,'example')

  
  text=['\l\b\cEXAMPLES  \n\n',...
        'There are a number of examples to illustrate how to simulate\n  ',...
        'models in the following filter models:\n',...   
        '\5\b Mean Change. \n',...
        '\5\b AR. \n',...
        '\5\b ARX. \n',...
        '\5\b State Space. \n',...
        'After choosing an example from the menu, you can press the\n',...
        'blocks and signals and start the examination immediately.\n',...
        'Good, but not optimal, design parameters are set automatically. \n',...
        'Different filter structures and design tools can be tested\n',...
        'without the need for tiresome model specification and tuning.\n',...
  ];
  
end;

if strcmp(action,'exercise')

  
  text=['\l\b\cEXERCISES  \n\n',...
        'There are a number of guided exercises to become aquainted\n  ',...
        'with the toolbox:\n',...   
     '\5\b1. Learning the basics \t In a fundamental simulation example, \n',...
        '\5most of the features of the toolbox are illustrated. \n',...
        '\5\b2. Simulated data. \t This is based on the examples.\n',...
        '\5\b3. Real data. \t This is based on the application demos.\n',...
  ];
  
end;

if strcmp(action,'data')

  
  text=['\l\b\cREAL DATA\n\n',...
        'A number of real data files is available. \n ',...
        'After choosing a file from the menu, you can press the\n',...
        'blocks and signals and start the examination immediately.\n',...
        'Good, but not optimal, design parameters are set automatically. \n',...
        'Different filter structures and design tools can be tested\n',...
        'without the need for tiresome model specification and tuning.\n',...
        ];  
end; 

if strcmp(action,'method')

  
  text=['\l\b\cMETHODS\n\n',...
        'The number of possible combinations of design parameters is huge.\n  ',...
        'They all give different change detectors of which only a fraction \n',...
        'has been proposed in literature. Therefore, a number of named methods \n',...
        'can be directly accesed from this menu. Choose a name that sounds \n',...
        'familiar and then check the \b Detection Setup. \t \n',...
  ];
  
end;

if strcmp(action,'guirec')

   text=['\l\b\cGUI RECORDING\n\n',...
         'Record all subroutine calls to the GUI.\n',...
         'These can be put in a script-file that can be run\n',...
         'when the GUI is open.\n\n',...
         'BUGS: Currently many calls are done twice. This affects\n',...
         'the speed. Some editing is probably also required. ',...
  ];
  
end;

if strcmp(action,'exM1')
  text=['\l\b\c Mean change model  \n\n',...
	'Simulate an abruptly changing constant signal with additive noise. \n',...
	'The signal contains one jump in the middle of the data sequence. \n',...
	'Default settings for all filters and detectors are loaded. \n',...
	' \n',...
	'\b1.\t Push \bSimulation\t and Filter blocks and check the signal boxes.\n',...
	'\b2.\t Try out different filter structures. \n',...
	'\b3.\t Start the \bAdaptive Tool\t and save simulations in the table. \n',...
	'    Use Monte Carlo Simulations for more reliable statistics.\n',...
	'\b4.\t Start the \bChange Tool\t and compare different detectors. \n',...
	'    Save simulations in the table. \n',...
  ];
end;

if strcmp(action,'exM2')
  text=['\l\b\c Mean change model  \n\n',...
	'Simulate an abruptly changing constant signal with additive noise. \n',...
	'The signal contains three jumps of increasing size.. \n',...
	'The first one is barely visible and hard to find. \n',...
	'Default settings for all filters and detectors are loaded. \n',...
	' \n',...
	'\b1.\t Push \bSimulation\t and Filter blocks and check the signal boxes.\n',...
	'\b2.\t Try out different filter structures. \n',...
	'\b3.\t Start the \bAdaptive Tool\t and save simulations in the table. \n',...
	'    Use Monte Carlo Simulations for more reliable statistics.\n',...
	'\b4.\t Start the \bChange Tool\t and compare different detectors. \n',...
	'    Save simulations in the table. \n',...
  ];
end;

if strcmp(action,'exar')
  text=['\l\b\c AR model \n\n',...
	'Simulate an \bAR(2)\t model with abruptly changing parameters. \n',...
	'The parameters contain one abrupt change. \n',...
	'Default settings for all filters and detectors are loaded. \n',...
	' \n',...
	'\b1.\t Push \bSimulation\t and Filter blocks and check the signal boxes.\n',...
	'\b2.\t Try out different filter structures. \n',...
	'\b3.\t Start the \bAdaptive Tool\t and save simulations in the table. \n',...
	'    Use Monte Carlo Simulations for more reliable statistics.\n',...
	'\b4.\t Start the \bChange Tool\t and compare different detectors. \n',...
	'    Save simulations in the table. \n',...
  ];
end;

if strcmp(action,'exarx')
  text=['\l\b\c ARX model \n\n',...
	'Simulate an \bARX(2,2,1)\t model with abruptly changing parameters. \n',...
	'The parameters contain one abrupt change. \n',...
	'Default settings for all filters and detectors are loaded. \n',...
	' \n',...
	'\b1.\t Push \bSimulation\t and Filter blocks and check the signal boxes.\n',...
	'\b2.\t Try out different filter structures. \n',...
	'\b3.\t Start the \bAdaptive Tool\t and save simulations in the table. \n',...
	'    Use Monte Carlo Simulations for more reliable statistics.\n',...
	'\b4.\t Start the \bChange Tool\t and compare different detectors. \n',...
	'    Save simulations in the table. \n',...
  ];
end;

if strcmp(action,'exss')
  text=['\l\b\c State space model \n\n',...
  ];
end;

if strcmp(action,'fuel')
  text=['\l\b\c Fuel consumption \n\n',...
 'Surveillance problems consist in monitoring levels, flows,\n',...
'temparatures and so on in industrial processes. In many cases,\n',...
'the level itself is measured but noise corrupted, and one is\n',...
'interested in getting an accurate value while at the same time\n',...
'being able to track slow and fast variations. In this example,\n',...
'a fuel consumption signal taken from a Volvo 850 GLT will be\n',...
'examined. '];
end;

if strcmp(action,'fricest ')
  text=['\l\b\c Friction estimation  \n\n',...
      'This application illustrates the need of a combined adaptive filter\n',...
'and change detector. The task is to estimate the friction between\n',...
'tire and road on-line in a car. We have a model involving two \n',...
'measurements:\n',...
' \n',...
'\o    s(t) = mu(t) theta(1,t) + theta(2,t) + e(t) \n',...
' \n',...
'Here s(t) is the so called wheel slip and mu(t) a normalized traction force.\n\n',...
'The model assumption is that these are related by an \n',...
'affine transformation and that the slope theta(1,t) is \n',...
'proportional to the friction. The other parameter is changing \n',...
'rather slowly compared to theta(1,t). '];
end;

if strcmp(action,'path')
  text=['\l\b\c Path segmentation  \n\n',...
  ];
end;

if strcmp(action,'speech')
  text=['\l\b\c Speech segmentation  \n\n',...
  ];
end;

if strcmp(action,'tracking')
  text=['\l\b\c Target tracking \n\n',...
  ];
end;

if strcmp(action,'dcmotor')
  text=['\l\b\c DC motor \n\n',...
  ];
end;

if strcmp(action,'eeg ')
  text=['\l\b\c EEG signal  \n\n',...
  ];
end;

if strcmp(action,'altdata')
  text=['\l\b\c Baro altitude data \n\n',...
  ];
end;


if strcmp(action,' ')

  text=['\l\b\c  \n\n',...
  ];
  
end;


cddisp(text,'help');
