function hypplot(Xn,jump);

% Illustrates the local search of hypotheses in detectM
%
% hypplot(Xn,jump);

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $

[N,M]=size(Xn);

plot(0)
hold on
c='bgrcm';
%c='kkkkk';
for i=1:floor(log2(M)/4)+1;
  c=[c,c,c,c];
end
sep=0.5/M;
for i=1:M;
  ind=find(diff(abs(Xn(:,i)))<0);
  ind=[0;ind;N];
  for j=1:length(ind)-1;
    plot(ind(j)+1:ind(j+1),...
         abs(Xn(ind(j)+1:ind(j+1),i))+ones(ind(j+1)-ind(j),1)*i*sep,...
         [c(i),'-']);
  end
  maxind=find(Xn(:,i)<0);
  plot(maxind,abs(Xn(maxind,i))+ones(length(maxind),1)*i*sep,[c(i),'o'])
end
if nargin>1;
  dum=axis;
  plot([jump jump]',[dum(3)*ones(size(jump)) dum(4)*ones(size(jump))]','r-')
end
hold off
xlabel('Time [sample]')
ylabel('Number of change points')


