function labmotor

% Adaptive filtering and change detection benchmark data
%
% LABMOTOR
%
% Measurements from a feedback controlled labmotor
% The controller and approximate motor model is described in
% nnnlabmotor. 
% The data yi,ri are from four different cases:
% 1. Nominal model
% 2. Disturbances (physically holding the shaft)
% 3. Model change (pole change)
% 4. Both disturbance and pole change

  help labmotor
  
  load  labmotor
  t=(0:0.01:25)';

  plot(t,y1+0.6,t,y2+0.2,t,y3-0.6,t,y4-0.2)
  hold on
  plot(t,r1+0.6,t,r2+0.2,t,r3-0.6,t,r4-0.2)
  hold off
  h1=xlabel('Time [s]');
  h2=ylabel('Output y');
%  axis([0 25 -1 1])

  h3=legend(...
      'Case 1: Steady state',...
      'Case 2: Disturbances',...
      'Case 3: System changes',...
      'Case 4: Dist. and system change' );
  set([h1 h2 h3],'FontSize',14)