function lecture(arg)

% Demos from lectures
% ML2   likelihood for gaussian variables
% ML3   forgetting likelihood for gaussian variables with abrupt change
% cusum 
% localsearch
% optimalsearch
% globalsearch
% totalsearch
% mcmcsearch
% mcmcpath
% 11a, 11b faultdetect with DC motor and aircraft
% ex5.1 steepest descent
% ex5.2 Newton-Raphson 
% ex5.3 Newton-Raphson with local minimum
% ex5.4 ARMA estimation 
% ex5.5 AR estimation
% ex5.6 Chirp time-frequency analysis

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $


if strcmp(arg,'cusum')
  randn('seed',0);
  y=randn(40,1)+[zeros(20,1);ones(20,1)];
  gt=0;
  h=10;
  nu=0;
  khat=[]; ta=[]; GT=[];
  for t=1:length(y);
    gt=gt+y(t)-nu/2;
    GT=[GT gt];
    if gt<0; gt=0; khattmp=t; end;
    if gt>h; gt=0; ta=[ta t]; khat=[khat khattmp]; end;
  end
  cdfigure(1)
  segplot(GT,ta)
  title(['Alarm times for CUSUM for h = ',num2str(h),' and nu = ',num2str(nu)])
%  print -depsc /home/rt/fredrik/detect/book/figures/cusum1.eps

  pause
  gt=0;
  nu=1;
  h=5;
  khat=[]; ta=[]; GT=[];
  for t=1:length(y);
    gt=gt+y(t)-nu/2;
    if gt<0; gt=0; khattmp=t; end;
    if gt>h; gt=0; ta=[ta t]; khat=[khat khattmp]; end;
    GT=[GT gt];
  end
  cdfigure(2,1)
  segplot(GT,ta)
  title(['Alarm times for CUSUM for h = ',num2str(h),' and nu = ',num2str(nu)])
 % print -depsc /home/rt/fredrik/detect/book/figures/cusum2.eps

  pause
  cdfigure(3,2)
  segplot(GT,khat)
  title(['khat for CUSUM for h = ',num2str(h),' and nu = ',num2str(nu)])
 % print -depsc /home/rt/fredrik/detect/book/figures/cusum3.eps
end



if strcmp(arg,'ML2')
randn('seed',2)
x=(0:0.1:4)';
lam=0.1:0.1:3;
y=randn(40,1)+2;
p=ones(length(x),length(lam));
figure
for i=1:length(y);
%  for k=1:length(x);
%    for l=1:length(lam);
%      p1(k,l)=1./sqrt(2*pi*lam(l))*exp(-0.5*(x(k)-y(i)).^2/lam(l));
%    end
%  end
  p1=(( ones(size(x)))*(1./sqrt(2*pi*lam)).*( exp(-0.5*(x-y(i)).^2*(1./lam))));
  p=p.*p1;
  p=p/sum(sum(p));
  mesh(lam,x,p)
  ylabel('\theta')
  xlabel('R')
  drawnow
  title(['N = ',num2str(i)])
  axis([0 3 0 4 0 0.04])
  pause(1/i)
  [dum,ind]=max(sum(p));
  lamhat(i)=lam(ind);
  [dum,ind]=max(sum(p'));
  thhat(i)=x(ind);
end
[dum,ind1]=max(p);
[dum,ind2]=max(dum);
jointthhat=lam(ind1(ind2))
jointlamhat=lam(ind2)
thhat(length(thhat))
lamhat(length(lamhat))
cdfigure(1);
mesh(lam,x,p)
  ylabel('\theta')
  xlabel('R')

%print -depsc /home/rt/fredrik/detect/book/figures/ml1.eps

pause
cdfigure(2,1)
plot(lam,sum(p))
title('Marginal distribution for R')
%print -depsc /home/rt/fredrik/detect/book/figures/ml2.eps
cdfigure(3,2)
plot(x,sum(p'))
title('Marginal distribution for \theta')


pause

cdfigure(4,3)
plot(thhat)
title('ML estimate of \theta as a function of time')
cdfigure(5,4)
plot(lamhat)
title('ML estimate of R as a function of time')

%a=axis;
%hold on, plot([1 1],[0 a(4)],'--'), hold off
%title('l1')


end


if strcmp(arg,'ML3')
ff=0.95;
randn('seed',2)
x=(0:0.1:4)';
lam=0.1:0.1:3;
y=randn(40,1)+[ones(20,1);3*ones(20,1)];
p=ones(length(x),length(lam));
figure;
for i=1:length(y);
%  for k=1:length(x);
%    for l=1:length(lam);
%      p1(k,l)=1./sqrt(2*pi*lam(l))*exp(-0.5*(x(k)-y(i)).^2/lam(l));
%    end
%  end
  p1=(( ones(size(x)))*(1./sqrt(2*pi*lam)).*( exp(-0.5*(x-y(i)).^2*(1./lam))));
  p=p.^ff.*p1;
  p=p/sum(sum(p));
  mesh(lam,x,p)
  ylabel('\theta')
  xlabel('R')
  drawnow
  title(['N = ',num2str(i)])
  axis([0 3 0 4 0 0.01])
  pause(1/i)
  [dum,ind]=max(sum(p));
  lamhat(i)=lam(ind);
  [dum,ind]=max(sum(p'));
  thhat(i)=x(ind);
end
cdfigure(1);
mesh(lam,x,p)
  ylabel('\theta')
  xlabel('R')

pause
cdfigure(2,1)
plot(lam,sum(p))
title('Marginal distribution for R')
cdfigure(3,2)
plot(x,sum(p'))
title('Marginal distribution for \theta')

pause

cdfigure(4,3)
plot(thhat)
title('ML estimate of \theta as a function of time')
cdfigure(5,4)
plot(lamhat)
title('ML estimate of R as a function of time')

%a=axis;
%hold on, plot([1 1],[0 a(4)],'--'), hold off
%title('l1')


end

if strcmp(arg,'globalsearch')
N1=100;
N2=10;
N3=0;
N=N1+N2+N3;
k=1:N1;
V1=N2*(N1+N3-k)./(N-k)+log(k)+log(N-k);
k1=k;
k=N1:N1+N2-1;
V2=N1*(k-N1)./k+N3*(N1+N2-k)./(N-k)+log(k)+log(N-k);
k2=k;
k=N1+N2:N1+N2+N3-1;
V3=N2*(k-N2)./(k)+log(k)+log(N-k);
k3=k;
figure(1)
subplot(211)
plot([k1 k2 k3],[zeros(size(k1)) ones(size(k2)) zeros(size(k3))])
axis([0 110 -1 2])
title('Signal')
subplot(212)
plot(k1,V1, '-k',k2,V2,'-k',k3,V3,'-k')
title('Likelihood for k=1:N')
xlabel('Jump time')
axis([0 110 5 20])
text(60,17,'p(k^n=1:N)')

disp('If k is initialized around zero, a search algorithm')
disp('will fail to converge')
pause
disp(' ')
disp('Another example.....')

N1=100;
N2=10;
N3=100;
N=N1+N2+N3;
k0=1:N-1; 
V0=N2*(N1+N3)/(N)*ones(size(k0))+log(N);
k=1:N1;
V1=N2*(N1+N3-k)./(N-k)+log(k)+log(N-k);
k1=k;
k=N1:N1+N2;
V2=N1*(k-N1)./k+N3*(N1+N2-k)./(N-k)+log(k)+log(N-k);
k2=k;
k=N1+N2:N1+N2+N3-1;
V3=N2*(k-N2)./(k)+log(k)+log(N-k);
k3=k;
figure(2)
subplot(211)
plot([k1 k2 k3],[zeros(size(k1)) ones(size(k2)) zeros(size(k3))])
title('Signal')
axis([0 210 -1 2])
subplot(212)
plot(k1,V1,k2,V2,k3,V3,k0,V0)
Vopt=(log(N1)+log(N2)+log(N3))*ones(size(k0));
plot(k1,V1,'r',k2,V2,'r',k3,V3,'r',k0,V0,k0,Vopt)
title('Marginalized likelihood for k=[], k=0:N and k^n=(100,110)')
xlabel('Jump time')
axis([0 210 10 20])
text(160,12,'p(k^n=(100,110))')

text(160,15.5,'p(k^n=[ ])')
text(160,19,'p(k^n=1:N)')
 
disp(' ')
disp('No search scheme based on a local derivative could find')
disp('the global minima from an arbitrary initialization')
pause
figure(3)
disp(' ')
disp('Another example: ')
disp('Assume exponential noise distribution but noiseless measurements')
N=20;
y=0+[zeros(N/2-1,1);1;-1;zeros(N/2-1,1)];
subplot(111)
plot(y)
axis([0 N -2 2])
l1=likelihood(y,[],[],2);
for k=1:N-1;
  l2(k,:)=likelihood(y(1:k),[],[],2)+likelihood(y(k+1:N),[],[],2);
end
%subplot(212)
%plot([1 N],[l1(:,1);l1(:,1)],1:N-1,l2(:,1))

end

if strcmp(arg,'totalsearch')
   randn('seed',1)
   N=15;
   y=simchange(randn(N,1),-1,[N/3 2*N/3],[1 4 8]);
   plot(y),pause
   for i=1:N;
      for j=1:N;
         V(i,j)=lossfun(y,-1,[1 1],0.5,[i j]);
      end
   end
   l=exp(-2*V);
   l=l./max(max(l));
   figure(1)
   mesh(l)
end

if strcmp(arg,'mcmcsearch')
   randn('seed',3)
   disp('   y=simchange(randn(15,1),-1,[5 10],[1 4 8]);')
   y=simchange(randn(15,1),-1,[5 10],[1 4 8]);
   figure(1)
   plot(y)
   pause
   disp('   kn=mcmc(y,-1,[1 1],0.5,[2 40 0],[1 1 1]); ')
   kn=mcmc(y,-1,[1 1],0.5,[2 40 0],[1 1 1]);
   pause
   disp('   kn=mcmc(y,-1,[1 1],0.5,[2 200 0],[0 1 1],[5 10]);')
   kn=mcmc(y,-1,[1 1],0.5,[2 200 0],[0 1 1],[5 10]);
end

if strcmp(arg,'mcmcpath')
   randn('seed',1)
   disp('   load carpath ')
   load carpath
   disp('   [jhat,thseg]=detectM(z,-2,[1 0.05],0.5); ')
   [jhat,thseg]=detectM(z,-2,[1 0.05],0.5);
   jhat
   disp('   kn=mcmc(z,-2,[1 0.05],0.5,[7 5 5],[1 1 1],jhat); ')
   kn=mcmc(z,-2,[1 0.05],0.5,[7 5 5],[1 1 1],jhat);
end

if strcmp(arg,'tracking4')
  randn('state',0);
  rand('state',1);
  close all
  N=50;
  lam=0;
  u=zeros(N,1);
  e=randn(N,2);
  th0=[-0.05;...
       +0.05;...
       0.075;...
       -0.075]';   
  jumps=[15 18 35 38];
  nnn='nnnplane5';
  [y,x0]=simchange(u,nnn,jumps,th0,lam);
  yn=y+300*e;
  cdfigure(1);
  radarplot(yn,x0)
  title('Measurements')

disp('N=50;')
disp('lam=0;')
disp('u=zeros(N,1);')
disp('e=randn(N,2);')
disp('th0=[-0.05;...')
disp('     +0.05;...')
disp('      0.075;...')
disp('     -0.075]'';   ')
disp('jumps=[15 18 35 38];')
disp('nnn=''nnnplane5'';')
disp('[y,x0]=simchange(u,nnn,jumps,th0,lam);')
disp('yn=y+300*e;')
disp('cdfigure(1);')
disp('radarplot(yn,x0)')
pause

  nnn='nnnplane4';

disp('nnn=''nnnplane4'';')
disp('[xhat1,lamhat,Epsi]=adfilter(yn,nnn,1);')
  [xhat1,lamhat,Epsi]=adfilter(yn,nnn,1);
  figure(10)
  radarplot(y,xhat1)
  title('Kalman filter')
pause

%  [xhat2,yhat]=cdkalman(yn,nnn,10,1);
%  cdfigure(3,2);
%  radarplot(y,xhat2)

disp('  [jhat2,xseg,GT,ta,xhat2]=detect1(yn,nnn,1,[2 3 1],1);')
disp('  plot(GT)')

  [jhat2,xseg,GT,ta,xhat2]=detect1(yn,nnn,1,[2 3 1],1);
  figure
  segplot(GT,jhat2)
pause

  figure(12)
disp('[jhat4mc,jhat4,xhat4]=gibbs(yn,nnn,[1 1],0.1,[2 20 0],[1 0 0]);')
  [jhat4mc,jhat4,xhat4]=gibbs(yn,nnn,[1 1],0.1,[2 20 0],[1 0 0]);
pause
  figure(13)
disp('  [jhat4mc,jhat4,xhat4]=gibbs(yn,nnn,[1 1],0.1,[5 20 0],[1 0 0]);')
  [jhat4mc,jhat4,xhat4]=gibbs(yn,nnn,[1 1],0.1,[5 20 0],[1 0 0]);
pause

  figure(11)
  radarplot(y,xhat2)
  title('Gibbs-Metropolis')

disp('  [jhat3,xseg,lamseg,xhat3,Alfa,Xn]=detectM(yn,nnn,[1 1],0.1,[10 7 0]);')
  [jhat3,xseg,lamseg,xhat3,Alfa,Xn]=detectM(yn,nnn,[1 1],0.1,[10 7 0]);

e=yn-y;
e1=xhat1([1 3],:)'-x0([1 3],:)';
e2=xhat2([1 3],:)'-x0([1 3],:)';
e3=xhat3([1 3],:)'-x0([1 3],:)';
e4=xhat4([1 3],:)'-x0([1 3],:)';
disp(['Measurement RMSE:  ',num2str(sqrt(sum(diag(e'*e))/N))]);
disp(['adfilter RMSE:     ',num2str(sqrt(sum(diag(e1'*e1))/N))]);
disp(['detect1  RMSE:     ',num2str(sqrt(sum(diag(e2'*e2))/N)),' and jump time(s): ',cdnum2str(jhat2)]);
disp(['detectM  RMSE:     ',num2str(sqrt(sum(diag(e3'*e3))/N)),' and jump time(s): ',cdnum2str(jhat3)]);
disp(['gibbs    RMSE:     ',num2str(sqrt(sum(diag(e4'*e4))/N)),' and jump time(s): ',cdnum2str(jhat4)]);
pause
  cdfigure(1);
  plot([e e1 e2 e3 e4])
  cdfigure(2,1);
  plot([x0(2,:)' xhat1(2,:)' xhat2(2,:)' xhat3(2,:)' xhat4(2,:)'])

end

if strcmp(arg,'glr')
  randn('state',2);
  rand('state',0);
  close all
  nnn='nnnkin';
  N=100;
  jumps=50;
  TH=80;
  Lam=1;
  [y,x0]=simchange(zeros(N,1),nnn,jumps,TH,Lam);
  [xhat1,lamhat1,epsi1]=adfilter(y,nnn);

%  h1=cdfigure(1);
%  subplot(211),plot([xhat1(1,:)' x0(1,:)'])
%  subplot(212),plot([xhat1(2,:)' x0(2,:)'])
%  pause

% Test the GLR function
[jumphat,ta,lr,Xhatglr,nuhat,mu]=glr([y],nnn,1,10,5e-3);
disp(['Alarm time:',num2str(ta)])
disp(['khat = ',num2str(jumphat)])
disp(['nuhat = ',cdnum2str(nuhat)])
h3=cdfigure(1);
plot(lr)

h4=cdfigure(2,1);
leg1=plot(x0(1,:),':'); hold on
leg2=plot(xhat1(1,:),'--');
leg3=plot(Xhatglr(1,:),'-'); hold off
legend([leg1 leg2 leg3],'True position','Kalman filtered position','GLR filtered position',2 );
h5=cdfigure(3,2);
leg1=plot(x0(2,:),':'); hold on
leg2=plot(xhat1(2,:),'--');
leg3=plot(Xhatglr(2,:),'-'); hold off
legend([leg1 leg2 leg3],'True velocity','Kalman filtered velocity','GLR filtered velocity',2);


end

if strcmp(arg,'11a')
disp('DC motor')
disp('Fault model:  angle or angular faults')
disp('No disturbance')
close all
more on
nnn='nnnDCm1';
N=80;
f1=[1;0];
f2=[0;1];
TH=[f1 -f1 f2 -f2];
jumps=[3*N/8 4*N/8 5*N/8 6*N/8];
u=randn(N,1);
d=[zeros(N/8,1); randn(N/8,1); zeros(6*N/8,1)];
[y,x0]=simchange([u d],nnn,jumps,TH,1);
figure
plot(y), 
title('Simulated output')
pause

L=2;
z=[y u];
[r,Ordo,Hu,Hd,Hf,Null]=faultdetect(z,nnn,L);
[A,Bu,Bv,Bd,Bf,Q]=feval(nnn,0,0,0,5)
pause
[C,Du,Df,R]=feval(nnn,0,0,0,6)
pause
Ordo,Hu,Hd,Hf,Null
pause

subplot(211)
plot(r)
axis([0 N -1 2])
title(['Unstructured residuals for L = ',num2str(L)])

F=eye(2);
R=eye(2);
[r,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,R,F);
w=T*Null
subplot(212)
plot(r)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L)])
pause

L=3;
r1=faultdetect(z,nnn,L);
[r2,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,R,F);
w=T*Null
subplot(211)
plot(r1)
axis([0 N -1 2])
title(['Unstructured residuals for L = ',num2str(L)])
subplot(212)
plot(r2)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L)])
pause

L=4;
r1=faultdetect(z,nnn,L);
[r2,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,R,F);
w=T*Null
subplot(211)
plot(r1)
axis([0 N -1 2])
title(['Unstructured residuals for L = ',num2str(L)])
subplot(212)
plot(r2)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L)])
pause

disp('Fault model:  actuator or angular sensor offset')
disp('No disturbance')
F=eye(2);
R=eye(2);

nnn='nnnDCm2';
[y,x0]=simchange([u d],nnn,jumps,TH,1);

L=2;
z=[y u];
[r1,Ordo,Hu,Hd,Hf,Null]=faultdetect(z,nnn,L);
[r2,Ordo,Hu,Hd,Hf,Null]=faultdetect(z,nnn,L,R,F);
subplot(211)
plot(r1)
title(['Unstructured residuals for L = ',num2str(L)])
subplot(212)
plot(r2)
title(['Structured residuals for L = ',num2str(L)])
Ordo,Hf,Null,NullHf=Null*Hf
pause

L=3;
z=[y u];
[r1,Ordo,Hu,Hd,Hf,Null]=faultdetect(z,nnn,L);
[r2,Ordo,Hu,Hd,Hf,Null]=faultdetect(z,nnn,L,R,F);
subplot(211)
plot(r1)
title(['Unstructured residuals for L = ',num2str(L)])
subplot(212)
plot(r2)
title(['Structured residuals for L = ',num2str(L)])
Hf,Null,NullHf=Null*Hf,rank(NullHf)
end


if strcmp(arg,'11b')
close all
more on
nnn='nnnaircraft';
N=80;
f1=[1;0;0;0;0;0];
f2=[0;0;0;0;0;1];
TH=[f1 -f1 f2 -f2];
jumps=[1*N/8 3*N/8 4*N/8 6*N/8];
u=randn(N,3);
e=randn(N,3);
d=[zeros(N/8,1); randn(N/8,1); zeros(6*N/8,1)];
[y0,x0]=simchange([u d],nnn,jumps,TH,1);
y=y0+0*e;
figure
plot(y), 
title('Measurements')
pause

L=5;
z=[y u];
[r,Ordo,Hu,Hd,Hf,Null]=faultdetect(z,nnn,L);
[A,Bu,Bv,Bd,Bf,Q]=feval(nnn,0,0,0,5)
poles=eig(A)
pause
[C,Du,Df,R]=feval(nnn,0,0,0,6)
pause
Ordo,Hu,Hd,Hf,Null
pause

figure
subplot(311)
plot(r)
axis([0 N -1 2])
title(['Unstructured residuals for L = ',num2str(L)])

Fstruc=[f1 f2];
Rstruc=eye(2);
[r,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,Rstruc,Fstruc);
w=T*Null
[Q,R]=qr(Null); R
subplot(312)
plot(r)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L)])
%pause

[r,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,Rstruc,Fstruc,1);
w=T*Null
[Q,R]=qr(Null); 
disp('QR factorization of null space')
R
subplot(313)
plot(r)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L),' and minimum order filter'])


disp('Noise and L=5')
L=5;
e=0.001*randn(N,3);
y=y0+e;

z=[y u];
[r,Ordo,Hu,Hd,Hf,Null]=faultdetect(z,nnn,L);
figure
subplot(311)
plot(r)
axis([0 N -1 2])
title(['Unstructured residuals for L = ',num2str(L)])
Fstruc=[f1 f2];
Rstruc=eye(2);
[r,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,Rstruc,Fstruc);
subplot(312)
plot(r)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L)])
[r,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,Rstruc,Fstruc,1);
subplot(313)
plot(r)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L),' and minimum order filter'])
covy=cov(y0)
cove=cov(e)
snr=sum(sum(covy))/sum(sum(cove))
pause

disp('Noise and L=10')
L=10;
e=0.001*randn(N,3);
y=y0+e;
covy=cov(y0)
cove=cov(e)
snr=sum(sum(covy))/sum(sum(cove))

z=[y u];
[r,Ordo,Hu,Hd,Hf,Null]=faultdetect(z,nnn,L);
figure
subplot(311)
plot(r)
axis([0 N -1 2])
title(['Unstructured residuals for L = ',num2str(L)])
Fstruc=[f1 f2];
Rstruc=eye(2);
[r,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,Rstruc,Fstruc);
subplot(312)
plot(r)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L)])
[r,Ordo,Hu,Hd,Hf,Null,T]=faultdetect(z,nnn,L,Rstruc,Fstruc,1);
subplot(313)
plot(r)
axis([0 N -1 2])
title(['Structured residuals for L = ',num2str(L),' and minimum order filter'])


end


if strcmp(arg,'ex5.1')
% Steepest descent
close all
randn('state',1)
disp('Minimization of x1^2+x1*x2+x2^2')
phi=(0:0.01:2*pi);
x=[sin(phi); cos(phi)];
x=[1 -0.5;-0.5 1]*x;  % 
s=1:4;
figure(1)
plot(x(1,:)'*s,x(2,:)'*s,'b:')
title('Steepest descent minimization of f(x)=x_1^2+x_1x_2+x_2^2')
hold on
figure(2)
plot(x(1,:)'*s,x(2,:)'*s,'b:')
title('Stochastic steepest descent minimization of f(x)=x_1^2+x_1x_2+x_2^2')
hold on
N=100;

figure(1)
xhat(:,1)=[4;4];
mu=0.03;
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*fprime;
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')
plot(xhat(1,1:10:N)',xhat(2,1:10:N),'o')

xhat(:,1)=[4;1];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*fprime;
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')
plot(xhat(1,1:10:N)',xhat(2,1:10:N),'o')

xhat(:,1)=[4;-1];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*fprime;
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')
plot(xhat(1,1:10:N)',xhat(2,1:10:N),'o')

xhat(:,1)=[4;-4];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*fprime;
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')
plot(xhat(1,1:10:N)',xhat(2,1:10:N),'o')
hold off
pause

figure(2)
e=3*randn(2,N);
xhat(:,1)=[4;4];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*(fprime+e(:,i));
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')

xhat(:,1)=[4;1];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*(fprime+e(:,i));
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')

xhat(:,1)=[4;-1];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*(fprime+e(:,i));
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')

xhat(:,1)=[4;-4];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*(fprime+e(:,i));
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')
hold off
end




if strcmp(arg,'ex5.2')
% Gauss-Newton
close all
randn('state',1)
disp('Minimize x1^2+x1*x2+x2^2')
phi=(0:0.01:2*pi);
x=[sin(phi); cos(phi)];
x=[1 -0.5;-0.5 1]*x;  % 
s=1:4;
figure(1)
plot(x(1,:)'*s,x(2,:)'*s,'b:')
title('Newton-Raphson minimization of f(x)=x_1^2+x_1x_2+x_2^2')
hold on
figure(2)
plot(x(1,:)'*s,x(2,:)'*s,'b:')
title('Stochastic Newton-Raphson minimization of f(x)=x_1^2+x_1x_2+x_2^2')
hold on
N=100;

figure(1)
xhat(:,1)=[4;4];
mu=0.03*inv([2 1; 1 2]);  % mu=-inv(fbis)
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*fprime;
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'-b')
plot(xhat(1,1:10:N)',xhat(2,1:10:N),'o')

xhat(:,1)=[4;1];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*fprime;
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'-b')
plot(xhat(1,1:10:N)',xhat(2,1:10:N),'o')

xhat(:,1)=[4;-1];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*fprime;
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'-b')
plot(xhat(1,1:10:N)',xhat(2,1:10:N),'o')

xhat(:,1)=[4;-4];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*fprime;
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'-b')
plot(xhat(1,1:10:N)',xhat(2,1:10:N),'o')
hold off
pause

figure(2)
e=3*randn(2,N);
xhat(:,1)=[4;4];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*(fprime+e(:,i));
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')

xhat(:,1)=[4;1];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*(fprime+e(:,i));
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')

xhat(:,1)=[4;-1];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*(fprime+e(:,i));
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')

xhat(:,1)=[4;-4];
for i=2:N;
  x1=xhat(1,i-1);
  x2=xhat(2,i-1);
  fprime=[2*x1+x2; x1+2*x2];
  xhat(:,i)=xhat(:,i-1)-mu*(fprime+e(:,i));
end
comet(xhat(1,:)',xhat(2,:),0.1)
plot(xhat(1,:)',xhat(2,:),'b')
hold off
end

if strcmp(arg,'ex5.3')
% Newton-Raphson with local minimum
close all
randn('state',1)

x=0:0.1:4;
f=x.^5-6*x.^4+6*x.^3+20*x.^2-38*x+20;
plot(x,f)
title('f=x^5-6*x^4+6*x^3+20*x^2-38*x+20')

xstart=[0 4];
XI=[];
FI=[];
for k=1:2;
q=8;xi=zeros(1,q); 
xi(1)=xstart(k);
for i=1:q
  x0=xi(i);
  f0=x0^5-6*x0^4+6*x0^3+20*x0^2-38*x0+20;
  fprim=5*x0^4-24*x0^3+18*x0^2+40*x0-38;
  fbis=20*x0^3-72*x0^2+36*x0+40;
  xi(i+1)=xi(i)-.5*fprim/(fbis);
end
fi=xi.^5-6*xi.^4+6*xi.^3+20*xi.^2-38*xi+20;
XI(k,:)=xi;
FI(k,:)=fi;
end;

hold on
for i=1:size(XI,2);
  plot(XI(1,i),FI(1,i),'or')
  pause(1)
end
pause
for i=1:size(XI,2);
  plot(XI(2,i),FI(2,i),'*r')
  pause(1)
end
hold off
title('f=x^5-6*x^4+6*x^3+20*x^2-38*x+20 for x0=0 (o) and x0=4 (x)')

end


if strcmp(arg,'ex5.4')
% ARMA estimation

close all
randn('state',0)
a0=-0.5;
b0=0.5;
b=[1 b0];
a=[1 a0];
y=filter(b,a,randn(200,1));
thi=poly2th([1 0],[],[1 0]);
par=[0 0];
for i=1:10
  % Warning: transpose for th2par required in Matlab R12
  dum=th2par(armax(y,thi,i));
  par(i+1,:)=dum(:)';
end
figure(4)
plot(0:10,par),hold on
plot(0:10,par,'o'), hold off
xlabel('Iteration'),
title('ARMA(1,1), th0=[-0.5; 0.5]')

sep=0.04;
B=-1:sep:1;
A=-1:sep:1;
nA=length(A);
nB=length(B);

for i=1:nA
  for j=1:nB
    e=filter([1 A(i)],[1 B(j)],y);
    V(i,j)=sum(e.*e);
  end
end
for i=1:size(par,1);
    e=filter([1 par(i,1)],[1 par(i,2)],y);
    V2(i)=sum(e.*e);
end

pause
figure(1)
mesh(B(1:1:nB),A(1:1:nA),log(V(1:1:nA,1:1:nB)))
xlabel('b')
ylabel('a')
title('log(V) for ARMA(1,1) model')
hold on
h=plot3(par(:,2),par(:,1),log(V2));
set(h,'Linewidth',3)
%view(150,30)

pause

figure(2)
inda=find(A>a0);
indb=find(B>b0);
inda=inda(1)-5:inda(1)+5;
indb=indb(1)-5:indb(1)+5;
mesh(B(indb),A(inda),log(V(inda,indb)))
xlabel('b')
ylabel('a')
ax=axis;
hold on
h=plot3(par(:,2),par(:,1),log(V2));
set(h,'Linewidth',3)
axis(ax)
title('log(V) for ARMA(1,1) model')

pause

figure(3)
V=log(V);
Vmin=min(min(V));
Vmax=max(max(V));
contour(B,A,V,[logspace(log10(Vmin),log10(1.2*Vmin),10) ])
hold on
plot(0.5,-0.5,'*')
plot(par(:,2),par(:,1))
plot(par(:,2),par(:,1),'o')
hold off
%contour(B,A,V,Vmin:(Vmax-Vmin)/50:Vmax)
xlabel('b')
ylabel('a')
title('log(V) for ARMA(1,1) model')


end


if strcmp(arg,'ex5.5')
% AR estimation using LMS and RLS

close all
randn('state',0)
a1=0.8;
a2=0.16;
N=1000;
b=[1];
a=[1 a1 a2];
MC=5;
mu=0.01;
P0=0.1*eye(2);

y=filter(b,a,randn(N,1));
par=adfilter(y,2,mu,'LMS');
par2=adfilter(y,2,0.99,'RLS',[],[],P0);

for i=2:MC;
  y=filter(b,a,randn(N,1));
  par=par+adfilter(y,2,mu,'LMS');
  par2=par2+adfilter(y,2,0.99,'RLS',[],[],P0);
end
par=par/MC;
par2=par2/MC;

par=[[0;0] par]';
par2=[[0;0] par2]';

figure(1)
plot(0:N,par),hold on
plot([0 0;N N],[a1 a2;a1 a2],':')
axis([0 N -0.2 1])
hold off
xlabel('Time'),
title('LMS with \mu=0.01 on AR(2) model')

pause

figure(2)
plot(0:N,par2),hold on
plot([0 0;N N],[a1 a2;a1 a2],':')
axis([0 N -0.2 1])
hold off
xlabel('Time'),
title('RLS with \lambda=0.99 on AR(2) model')


sep=0.04;
A1=0:sep:1.5;
A2=-0.5:sep:1;
for i=1:length(A1)
  for j=1:length(A2)
    e=filter([1 A1(i) A2(j)],[1],y);
    V(i,j)=sum(e.*e);
  end
end
for i=1:size(par,1);
    e=filter([1 par(i,:)],[1],y);
    V2(i)=sum(e.*e);
end
for i=1:size(par2,1);
    e=filter([1 par2(i,:)],[1],y);
    V3(i)=sum(e.*e);
end

pause

figure(3)
mesh(A2(1:1:length(A2)),A1(1:1:length(A1)),log(V)) %log(V(1:1:end,1:1:end)))
xlabel('a_2')
ylabel('a_1')
title('log(V) for AR(2) model')
hold on
h=plot3(par(:,2),par(:,1),log(V2));
set(h,'Linewidth',2)
h=plot3(par2(:,2),par2(:,1),log(V2));
set(h,'Linewidth',2)
view(150,30)

pause

figure(4)
V=log(V);
Vmin=min(min(V));
Vmax=max(max(V));
contour(A2,A1,V,[logspace(log10(Vmin),log10(1.2*Vmin),10) ])
hold on
plot(a2,a1,'*')
plot(par(:,2),par(:,1))
hold off
%contour(B,A,V,Vmin:(Vmax-Vmin)/50:Vmax)
xlabel('a_2')
ylabel('a_1')
title('log(V) and LMS trajectory with \mu=0.01 on AR(2) model')

pause

figure(5)
contour(A2,A1,V,[logspace(log10(Vmin),log10(1.2*Vmin),10) ])
hold on
plot(a2,a1,'*')
plot(par2(:,2),par2(:,1))
hold off
xlabel('a_2')
ylabel('a_1')
title('log(V) and RLS trajectory with \lambda=0.99 on AR(2) model')


end


if strcmp(arg,'ex5.6')
% Chirp time-frequency analysis
close all
figure
N=5000;
y=sin(2*pi*(1:N)'.^2./N);
plot(y(1:200))
pause
specgram(y)
pause

figure
N=500;
y=sin(2*pi*(1:N)'.^2./N);
[th,lamhat]=adfilter(y,2,20); 
th2tfd(th,lamhat,y,64,[],1); 
end