function nmt900

% Adaptive filtering and change detection benchmark data
%
% NMT900
%
% Sales figures for cellular phones in the standard NMT 900

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $


help nmt900

load nmt900

% Plot signal
  N=length(y);
  t=1:N;
  h1=plot(t,y);
  title('Sales figures for NMT900')
  
% Simulate model
  hold on
  yscale=max(y);
  y=y/yscale;
  th0=[0.0001 0.1 1];
  [t0,y0]=ode23('modelnmtode',t,0,[],th0(1),th0(2),th0(3));
  h0=plot(t0,y0*yscale,'-');

% Estimate model
  opt=[1 0 0 0 0]; % do help foptions
  % opt(1)=display info
  % opt(5)=LevenbargMarquart (0), GN (1)
  opt(14)=10;
  th=th0;
  for i=1:3; %length(fcount);
    th=leastsq('modelnmt',th,opt,[],y)
    [that,yhat]=ode45('modelnmtode',t,0,[],th(1),th(2),th(3));
    h2(i)=plot(that,yhat*yscale,'--');
  end
  set([h1 h2(length(h2))],'LineWidth',2);
  hold off
