function [A,Bu,Bv,Bth,C,Du,Dth,Q,R,P0,x0]=nnn2ss(nnn)

% Converts structure nnn to state space matrices
%
% [A,Bu,Bv,Bth,C,Du,Dth,Q,R,P0,x0]=nnn2ss(nnn)
%
% See also nnn, ss2nnn

if size(nnn,2)<6;
  error('This is not a correct nnn') 
end

  nx=nnn(1,1);
  nu=nnn(1,2);
  nv=nnn(1,3);
  nth=nnn(1,4);
  ny=nnn(1,5);

  A=nnn(2:nx+1,1:nx);
  Bu=nnn(2:nx+1,nx+1:nx+nu);
  Bv=nnn(2:nx+1,nx+nu+1:nx+nu+nv);
  Bth=nnn(2:nx+1,nx+nu+nv+1:nx+nu+nv+nth);
  Q=nnn(2:nv+1,nx+nu+nv+nth+1:nx+nu+nv+nth+nv);
  P0=nnn(2:nx+1,nx+nu+nv+nth+nv+1:nx+nu+nv+nth+nv+nx);
  x0=nnn(2:nx+1,nx+nu+nv+nth+nv+nx+1);

  C=nnn(nx+2:nx+ny+1,1:nx);
  Du=nnn(nx+2:nx+ny+1,nx+1:nx+nu);
  Dth=nnn(nx+2:nx+ny+1,nx+nu+1:nx+nu+nth);
  R=nnn(nx+2:nx+ny+1,nx+nu+nth+1:nx+nu+nth+ny);

