function [out1,out2,out3,out4,out5,out6]=nnnss1(t,x,uinp,flag,option);

% Sampled state space model with x=[x1 x2 v1 v2]'
%
% Syntax of nnn model objects (see also S-functions in Simulink)
%   [n,x0,P0]=nnn(0,0,0,0);
%   xp=nnn(t,x,f,2);
%   y =nnn(t,x,f,3);
%   [A,Bu,Bv,Bth,Q]=nnn(t,x,f,5);
%   [C,Du,Dth,R]=nnn(t,x,f,6);
%

out1=[]; out2=[]; out3=[]; out4=[]; out5=[]; out6=[];

if flag==0;    % Initialization
    nx=2; nu=1; nv=0; nd=1; nth=2; ny=2;
    P0=zeros(nx);
    x0=zeros(nx,1);
    n=[nx nu nv nd nth ny];
    out1=n; out2=x0; out3=P0;
elseif flag==1;
elseif flag==2;
    nx=2; nu=1; nv=0; nd=1; nth=2; ny=2;
    [A,Bu,Bv,Bd,Bf,Q]=feval('nnnss1',0,x,0,5);
    u=uinp(1:nu);
    d=uinp(nu+1:nu+nd);
    f=uinp(nu+nd+1:nu+nd+nth);
    xp=A*x+Bu*u+Bd*d+Bf*f;
    out1=xp;
elseif flag==3;
    nx=2; nu=1; nv=0; nd=1; nth=2; ny=2;
    [C,Du,Df,R]=feval('nnnss1',0,x,0,6);
    u=uinp(1:nu);
    d=uinp(nu+1:nu+nd);
    f=uinp(nu+nd+1:nu+nd+nth);
    y=C*x+Du*u+Df*f;
    out1=y;
elseif flag==4;
elseif flag==5;
  A=[0 -1; 0.5 -1];
  Bu=[1;0];
%  Bd=[1;2];
  Bd=[0;0];
  Bf=eye(2);
  Q=[];
  out1=A; out2=Bu; out4=Bd; out5=Bf; out6=Q;
elseif flag==6;  % Output equation matrices
  C=eye(2);
  Du=[0;0];
%  Dd=[0;0];
  Df=zeros(2);
  R=[];
  out1=C;
  out2=Du;
  out3=Df;
  out4=R;
end







