function guidemo(action,arg1,arg2)

global cddemostate
if nargin>0;
  if strcmp(action,'fuel')
    cddemostate=[1 0];
    action='update';
  elseif strcmp(action,'fricest')
    cddemostate=[2 0];
    action='update';
  elseif strcmp(action,'navigation')
    cddemostate=[3 0];
    action='update';
  elseif strcmp(action,'tracking')
    cddemostate=[4 0];
    action='update';
  end
else
   action='none';
   cddemostate(1)=0;
   if length(cddemostate)==1; cddemostate(2)=1; end
   if cddemostate(2)>4, cddemostate(2)=1; end
   if cddemostate(2)<1, cddemostate(2)=4; end
   text=['\l\b   Application demonstrations \n',...
         '\W1. Fuel consumption \n',...
         '\W2. Friction estimation \n',...
         '\W3. Navigation \n',...
         '\W4. Tracking \n '];
   ind=find(text=='W');
   text(ind(cddemostate(2)))='R';
   cddisp(text,'demo')
   h=findobj('Tag','de');
         uicontrol(h,'Style','PushButton',...
               'Units','pixels',...
               'Position',[165 100 70 30],...
	       'String','OK',...
	       'CallBack','guidemo(''ok'')',...
	       'BackGroundColor','w');

end

if strcmp(action,'ok')
   if cddemostate(2)==1;
      guidemo('fuel')
   elseif cddemostate(2)==2;
      guidemo('fricest')
   elseif cddemostate(2)==3;
      guidemo('navigation')
   elseif cddemostate(2)==4;
      guidemo('tracking')
   end
   
end   
   
if strcmp(action,'next')
   cddemostate=cddemostate+[0 1];
   if cddemostate(1)>0
      guidemo('update')
   else
      guidemo
   end
end
if strcmp(action,'back')
  if cddemostate(2)>0;
    cddemostate=cddemostate-[0 1];
  end
    if cddemostate(1)>0
      guidemo('update')
   else
      guidemo
   end
end

if strcmp(action,'update')
  
if cddemostate==[1 0];
randn('seed',1);
text=['\l\b     Surveillance of fuel consumption\n',...
'Surveillance problems consist in monitoring levels, flows,\n',...
'temparatures and so on in industrial processes. In many cases,\n',...
'the level itself is measured but noise corrupted, and one is\n',...
'interested in getting an accurate value while at the same time\n',...
'being able to track slow and fast variations. In this example,\n',...
'a fuel consumption signal taken from a Volvo 850 GLT will be\n',...
'examined. '];

cddisp(text,'demo');
end

if cddemostate==[1 1];

text=[...
'\b1. \t Load the data file \b\R fuel \W\t. This can be done either\n',...
'by choosing  \R Real Data/fuel \W in the menu or by\n',...
'opening  \R Data Generation \W and choosing \R Data From File\W\n',...
'and typing \R fuel \W in the edit field.\n',...
'To load the data, press the block now called \R Data From File.\W \n '];

cddisp(text,'demo');

guidetect('datafuel|loaddata')

end

if cddemostate==[1 2];


text=[...
'\b2. \t Take a look at the signal by pressing the signal\R y \W.  \n',...
'The measured instantaneous fuel consumption is noisy and \n',...
'needs filtering.'];

cddisp(text,'demo');

guidetect('blocksigplot',1) 

end

if cddemostate==[1 3];


text=[...
      '\b3. \t Open the \R Design Parameters \W window and choose the \n',...
      'detection model  \R mean change \W  which means that the\n',...
'filter will try to estimate the mean level of the signal\n',...
'adaptively. Check that \R adaptive filter \W is the current\n',...
'structure in the upper right corner. Click at \R Filter \W.\n',...
'The filtered signal is computed and can be looked at by\n',...
'pushing \R th \W.\n',...
'Compare the result with the original signal.'];

cddisp(text,'demo');

guidetect('setmodel',2);
guidetect('setdetector',1);
guidetect('blockplot')
guidetect('startclock|startdetect|stopclock')
guidetect('blocksigplot',2) 
guidetect('blocksigplot',1) 

end

if cddemostate==[1 4];


text=[...
'\b4. \t Open the \R Design Parameters \W. Try to tune the design\n',...
'parameter in RLS to get good performance. Try for instance \n',...
'\R 0.92 \W. Try also other adaptive filters from this sub-menu.\n '];

cddisp(text,'demo');

guidetect('changedesign')
figsimdeshandle=findobj(0,'Tag','figsimdes');
handle=findobj(figsimdeshandle,'Tag','adg');
set(handle,'String','0.92');
guidetect('designedit|startclock|startdetect|stopclock')

end

if cddemostate==[1 5];


text=[...
'\b5. \t Choose \R RLS \W again and close the design parameter \n',...
'menu. Open the  \R Adaptive Tool \W. Here a number of \n',...
'norms are presented, of which only two are available for the\n',...
'current setting. You can save the current result to a table \n',...
'by clicking \R Table \W. You can now\n',...
'choose another adaptive filter and optimize it for this signal\n',...
'and update the table.  '];

cddisp(text,'demo');

guidetect('closechangedesign')
mainhandle=findobj('Tag','block');
onhandle=findobj(mainhandle,'Tag','adaptivetool');
set(onhandle,'Value',1);
guidetect('adaptivetool')
adtoolhandle=findobj(0,'Tag','figadaptivetool');
handle=findobj(adtoolhandle,'Tag','4');
set(handle,'Value',1);
guidetect('setadaptivetool|tabadaptivetool')

end

if cddemostate==[1 6];


text=[...
'\b6. \t Linear filters do not give the desired combined accuracy and\n',...
'tracking ability. Try the default \R one-model \W structure \n',...
'in the upper right corner and then choose the \R CUSUM test. \W\n   '];
cddisp(text,'demo');

guidetect('setdetector',2)
guidetect('blockplot')
guidetect('startclock|startdetect|stopclock|updateadaptivetool')
guidetect('blocksigplot',2)

end

if cddemostate==[1 7];


text=[...
      '\b7. \t Look at the test statistics in the CUSUM test \n',...
      'by pressing the signal \R g \W. \n',...
      'Save the result to the \R Table. \W \n '];
cddisp(text,'demo');

guidetect('blocksigplot',3)
guidetect('tabadaptivetool')

end


if cddemostate==[1 8];


text=[...
'\b8. \tPress the signal \R y \W to see the estimated change times \n',...
'in the original signal.'];
cddisp(text,'demo');

guidetect('blocksigplot',3)
guidetect('blocksigplot',1)
  
end


if cddemostate==[1 9];


text=[...
'\b9. \tTry the default \R two-model \W and\n',...
'\R multi-model \W change detection algorithms, and save the results\n',...
'of each to the table. When you are finished you can get a\n',...
'latex version of the table by pressing \R latex \W in the table.\n '];

cddisp(text,'demo');

close(findobj(0,'Tag','addesignplot'));
guidetect('setdetector',4)
guidetect('blockplot')
guidetect('startclock|startdetect|stopclock|updateadaptivetool')
guidetect('tabadaptivetool')

end

if cddemostate==[1 10];
   text=[...
         'This is the end of the demo. One conclusion is that the\n',...
         '\idetect1 \r  detector which as a change detector performs bad\n',...
         'gives much better tracking compared to a linear filter.\n',...
         'This is also achieved with a negligible computational increase.\n',...
         'Best performance is obtained by the \i detectM \r detector.\n\n',...
         'The performance shown in the demo can be improved by tuning \n',...
         'and using the design tools.',...
      ];
      
cddisp(text,'demo');
end

if cddemostate==[1 11];
   
guidetect('cleanup')
guidemo

end

if cddemostate==[2 0];
randn('seed',1);
  
text=['\l\b Friction estimation \n\n',...
      'This application illustrates the need of a combined adaptive filter\n',...
'and change detector. The task is to estimate the friction between\n',...
'tire and road on-line in a car. We have a model involving two \n',...
'measurements:\n',...
' \n',...
'\o    s(t) = mu(t) theta(1,t) + theta(2,t) + e(t) \n',...
' \n',...
'Here s(t) is the so called wheel slip and mu(t) a normalized traction force.'];

cddisp(text,'demo');

end

if cddemostate==[2 1];
  text=[...
' The model assumption is that these are related by an \n',...
'affine transformation and that the slope theta(1,t) is \n',...
'proportional to the friction. The other parameter is changing \n',...
'rather slowly compared to theta(1,t). '];

cddisp(text,'demo');

end

if cddemostate==[2 2];


  
text=[...
' The driver wants the following information:\n',...
' \n',...
'     Continuous monitoring of the friction.\n',...
'     That is, theta(1,t) is estimated by an adaptive filter.\n',...
' \n',...
'     Alarm when the friction suddenly decreases.\n',...
'     That is, detect sudden parameter changes.\n',...
' \n',...
'In this demo, we will design an appropriate adaptive filter and \n',...
'change detector.'];

cddisp(text,'demo');

end

if cddemostate==[2 3];



text=[...
'\b1.\t Load the signal \R fricest \W This can be done either\n',...
'by choosing \R Real Data/friction estimation \W in the menu or by\n',...
'opening \R Data Generation \W and choosing \R Data From File \W\n',...
'and typing \R fricest \W in the edit field.\n',...
'To load the data, press the block called \R Load Data.\W\n\n ',...
'We will run in simulation mode to be able to compare parameter\n',...
'estimates with true values and to run Monte Carlo simulations.\n',...
'After loading data, open \R Data Generation \W and \nchoose \R Simulate Data \W.\n ',...
];

cddisp(text,'demo');

guidetect('datafricest|loaddata')
guidetect('mainsim')
guidetect('setdatatype',2)


end

if cddemostate==[2 4];

text=[...
'\b2.\t To simulate the data, press the block now called\R Simulation.\W\n ',...
'Look at the data by pressing the signal \R y \W\n .'];

cddisp(text,'demo');

guidetect('closemainsim')
guidetect('startclock|startsim|stopclock')
guidetect('blocksigplot',1)

end

if cddemostate==[2 5];

text=[...
      '\b3.\t Assure that the model structure in \R Design Parameters\n\',...
      '\W is \R Regression \W\n',...
      'This is set automatically when you load the data from the menu.'];

cddisp(text,'demo');

guidetect('setmodel',3);
guidetect('blockplot')

end

if cddemostate==[2 6];

text=[...
      '\b4.\t Choose \R Adaptive filter \W (again default). \n',...
      'set the design parameters to\n',...
      '\R RLS \W and \R lam=0.9 \W. Click at the \R Filter \W.\n',...
      'Check the parameter estimates by pressing \R th \W.\n',...
'Resize the axis with \R axis([0 313 0 0.05]) \W.\n '];
cddisp(text,'demo');

guidetect('setdetector',1);
guidetect('blockplot')
global designpar
designpar(1,:)=[0.9,1,0,0,0,0];
guidetect('changedesign')

guidetect('startclock|startdetect|stopclock|updateadaptivetool')
guidetect('blocksigplot',1)
guidetect('blocksigplot',2)
axis([0 313 0 0.05])
disp('axis([0 313 0 0.05])')

end

if cddemostate==[2 7];


text=[...
'\b5.\t The estimates are too noisy. Increase the forgetting factor in\n',...
'RLS to \R lam=0.97 \W (Press \R Filter model \W) and click at the \n',...
'at the \R filter \W again. Since this\n',...
'data set were obtained by simulation using a true signal mu(t),\n',...
'the true parameter values are available and shown in the parameter plot.\n',...
'There is less noise in the estimates now, but \n',...
'there is almost no adaptation to the true value of theta(1) after \n',...
'the change.'];

cddisp(text,'demo');

guidetect('changedesign')
figsimdeshandle=findobj(0,'Tag','figsimdes');
handle=findobj(figsimdeshandle,'Tag','adg');
set(handle,'String','0.97');
guidetect('designedit|startclock|startdetect|stopclock|updateadaptivetool')
guidetect('blocksigplot',2)
axis([0 313 0 0.05])
disp('axis([0 313 0 0.05])')

end

if cddemostate==[2 8];


text=[...
'\b6. \t For later reference, press \R Adaptive Tool \W and \R Table \W. \n',...
'Now the performance is saved into the table.  \n\n',...
'Previous items in the table can be cleared by \R Quit \W\n',...
'and then \R Table \W again.\n '];

cddisp(text,'demo');

mainhandle=findobj('Tag','block');
onhandle=findobj(mainhandle,'Tag','adaptivetool');
set(onhandle,'Value',1);
guidetect('adaptivetool')
%adtoolhandle=findobj(0,'Tag','figadaptivetool');
%handle=findobj(adtoolhandle,'Tag','4');
%set(handle,'Value',1);
%guidetect('setadaptivetool|tabadaptivetool')
guidetect('tabadaptivetool')

end

if cddemostate==[2 9];


text=[...
'\b7.\t Press the fourth button \R Loss function \W and then \R Optimize \W. \n',...
'The GUI now computes the forgetting factor that minimizes this loss\n',...
'function. Do \R Help \W to find out the definition of this. \n',...
' \n',...
'Press \R Table \W in the\R Design Tool \Wfor later reference.\n '];

cddisp(text,'demo');

mainhandle=findobj('Tag','block');
onhandle=findobj(mainhandle,'Tag','adaptivetool');
set(onhandle,'Value',1);
guidetect('adaptivetool')
adtoolhandle=findobj(0,'Tag','figadaptivetool');
handle=findobj(adtoolhandle,'Tag','4');
set(handle,'Value',1);
guidetect('setadaptivetool|startoptdesign|tabadaptivetool')

end

if cddemostate==[2 10];


text=[...
'\b8.\t  A more intelligent adaptive filter is a Kalman filter where only\n',...
'the first parameter is assumed to be time variable.\R Design \Wthe\n',...
'filter by choosing Kalman filter ("KF") with\R Adaptation gain \Wto \n',...
'"[0.5 0;0 0]". Press\R OK \Wand\R Start \Wthe filter. This time the \n',...
'parameter estimate starts to adapt shortly after the change. '];

cddisp(text,'demo');

handle=findobj('Tag','addesignplot');
close(handle)

figsimdeshandle=findobj(0,'Tag','figsimdes');
handle=findobj(figsimdeshandle,'Tag','adm');
set(handle,'Value',5);
handle=findobj(figsimdeshandle,'Tag','adg');
set(handle,'String','[0.5 0;0 0]');
guidetect('designedit|startclock|startdetect|stopclock|updateadaptivetool')
axis([0 313 0 0.05])
disp('axis([0 313 0 0.05])')

end

if cddemostate==[2 11];


text=[...
'\b9.\t Press\R Table \Win the\R Design Tool \Wfor later reference. \n '];

cddisp(text,'demo');

guidetect('tabadaptivetool')

end

if cddemostate==[2 12];


text=[...
'\b10.\t Still the estimation delay after the change is too large, 40\n',...
'samples correspond to 8 seconds. Choose the    \R Onemodel   \W approach \n',...
'to change detection. Default design parameters should be the \n',...
'two-sided CUSUM test with threshold h=0.003 and drift nu=0.0005.\n',...
'Press\R Start". Look at the\R Parameter estimate \W and \n',...
'\R Test statistics \W(a good check of the design parameters) and \n',...
'\RVisual inspection \Wto see when the alarm comes. Save the \n',...
'performance in the \R Table \Wof the\R Design Tool\W.\n '];


cddisp(text,'demo');

guidetect('setdetector',2)
guidetect('blockplot')

designpar(2,6)=1;

guidetect('startclock|startdetect|stopclock|updateadaptivetool')
axis([0 313 0 0.05])
disp('axis([0 313 0 0.05])')

end

if cddemostate==[2 13];


text=[...
'\b11.\t Press\R Table \Win the \R Design Tool \W.\n '];

cddisp(text,'demo');

guidetect('tabadaptivetool')

end

if cddemostate==[2 14];



text=[...
'\b12.\t A somewhat better performance is achieved with the\n',...
'multi-model approaches. Test the \R Segm \W and \R GLR \W methods.\n '];

cddisp(text,'demo');

guidetect('setdetector',4)
guidetect('blockplot')
guidetect('startclock|startdetect|stopclock|updateadaptivetool')
axis([0 313 0 0.05])
disp('axis([0 313 0 0.05])')


end

if cddemostate==[2 15];



text=[...
'\b13.\t Save to the \R Table \W. \n',...
'Compare with the CUSUM test. Note that the delay for \n',...
'detection decreased but the computational time increased.\n',...
' \n',...
'The combination of the KF and CUSUM test designed above has been \n',...
'implemented and tested in real-time with good result.'];

cddisp(text,'demo');

guidetect('tabadaptivetool')


end

if cddemostate==[2 16];



text=[...
'\b14.\t To see where the alarm comes in the average, make a Monte Carlo\n',...
'simulation by pressing \R Change Tool \W, choosing the number of\n',...
'simulations and then press \R Monte Carlo simulations \W.\n',...
'When the simulations are finished, you get histograms\n',...
'over the alarm times and some statistics. The delay \n',...
'for detection is about 15 samples (3 seconds).'];

cddisp(text,'demo');

mainhandle=findobj('Tag','block');
onhandle=findobj(mainhandle,'Tag','adaptivetool');
set(onhandle,'Value',0);
guidetect('adaptivetool')

onhandle=findobj(mainhandle,'Tag','plottool');
set(onhandle,'Value',0);
guidetect('adaptivetool')

guidetect('setdetector',2)
guidetect('blockplot')

onhandle=findobj(mainhandle,'Tag','changetool');
set(onhandle,'Value',1);
guidetect('changetool')

guidetect('startMC')

%axis([0 313 0 0.05])
%disp('axis([0 313 0 0.05])')

end

if cddemostate==[2 17];

guidetect('cleanup')
guidemo

end
 

if cddemostate==[3 0];
randn('seed',1);

 
  text=[...
        '\l\b      Fault detection in a navigation system \n',...
        'Integration of GPS with the standard Inertial Navigation System (INS)\n',...
'is a hot topic in airborne navigation. Since the integrity of GPS is\n',...
'not satisfactory for the safety demand in this application, there must\n',...
'be a support of a fault detection algorithm. Here we will investigate\n',...
'a model of one channel of such a system, which is represented in state\n',...
'space form. '];

cddisp(text,'demo');
end

if cddemostate==[3 1];



text=[...
'1. Choose\R State space \Was detection model, and choose the file\n',...
'"insgps \Was an m-file that creates the system parameters. Do the same\n',...
'thing for the data generation model (or choose\R Same as detection\n',...
'model"). Instead of typing all parameters in the\R Simulation setup",\n',...
'run the script insgpssetup and check \n',...
'the result.\n',...
'"Simulate \Wthe model and take a\R Look \Wat the input and output.'];

cddisp(text,'demo');
end

if cddemostate==[3 2];



text=[...
'2. Choose \R Adaptive filter \W and Kalman filter (\R KF \W) \n',...
'in the \R filter model \W design dialog box. Start the filter \n',...
'by clicking at the \R Adaptive Filter \W block.',...
];

cddisp(text,'demo');
end

if cddemostate==[3 3];


text=[...
'3. Test the \R detect1 \W CUSUM test.'];

cddisp(text,'demo');
end

if cddemostate==[3 4];


text=[...
'4. Test the auto-tuning function in the \R Change Tool \W. First simulate\n',...
'data without any fault and apply the CUSUM test as fault\n',...
'detector. '];

cddisp(text,'demo');
end

if cddemostate==[3 5];


guidetect('cleanup')
guidemo('guidemo')

end

if cddemostate==[4 0];
randn('seed',0);


text=[...
'\l\b       Multi-model approach to target tracking \n',...
'In this simulation study, a radar is used to track an object\n',...
'moving in 2D according to so called coordinated turns, which\n',...
'means that it is following straight lines and circular segments.\n',...
' '];
    
cddisp(text,'demo');

end

if cddemostate==[4 1];


text=[...
'1. Set the simulation model to state space and choose the \R From m-file\W\n',...
'option with file name \R simairplane \W. This m-file generates a \n',...
'physical trajectory.'];

cddisp(text,'demo');

guidetect('setmodel',6);
guidetect('setdetector',1);
guidetect('simmodel',6);
guidetect('blockplot')
mainhandle=findobj('Tag','main');

global datafilename
datafilename='simairplane';
end

if cddemostate==[4 2];
text=[...
'2.Run the script \R jumpsairplane \W to \n',...
'set the abrupt changes in this simulation. Check the settings in \n',...
'\R Data Generator \W.\n '];

cddisp(text,'demo');

jumpsairplane
guidetect('closemainsim')
guidetect('mainsim')
end

if cddemostate==[4 3];



text=[...
'3. Start the simulation. '];

cddisp(text,'demo');

guidetect('startclock|startsim|stopclock')
global th0
th0(5,:)=[];   % Detection model has only four states

guidetect('blocksigplot',1)

end

if cddemostate==[4 4];



text=[...
'4. Start the \R Plot Tool \W. The script \R radarplot \W\n',...
'will in the sequel be used as a user specified plot to illustrate\n',...
'the true and estimated\n',...
'position for this quite typical inflight. Check the simulated trajectory\n',...
'There is one manouver \n',...
'after sampel 15 and one after sampel 25.'];


global threc z
threc=zeros(size(z)-[0 1]);

%guidetect('startclock|startdetect|stopclock')
guidetect('blocksigplot',1)

mainhandle=findobj('Tag','block');
fighandle=findobj(mainhandle,'Tag','plottool');
set(fighandle,'Value',1);
guidetect('plottool')
fighandle=findobj(0,'Tag','figplottool');
namehandle=findobj(fighandle,'Tag','usernm');
set(namehandle,'String','radarplot');
onhandle=findobj(fighandle,'Tag','valusr');
set(onhandle,'Value',1);
guidetect('validuser')



cddisp(text,'demo');
end

if cddemostate==[4 5];



text=[...
'5. Set the filter model to \R State space \W and choose \n',...
'\R airplane \W as the m-file defining the time-varying state \n',...
'space model. Now everything is ready for estimation.'];

guidemo('disp',text);

guidetect('setmodel',6);
guidetect('blockplot')
guidetect('detectpar')
fighandle=findobj('Tag',['ABCDdetect']);
handle=findobj(fighandle,'Tag','sstype');
set(handle,'Value',2);
handle=findobj(fighandle,'Tag','ssname');
set(handle,'String','airplane');
guidetect('ssorder',fighandle)

end

if cddemostate==[4 6];



text=[...
      '6. Choose \R Adaptive filter \W as \R Filter Structure \W \n',...
      'and then Kalman filter \R KF \W in the \R Filter model \W\n',...
'menu.\R Start \W estimation and choose \R radarplot \W in the plot tool to\n',...
'illustrate the result.\n',...
'You can tune the adaptation gain to trade off speed by estimation\n',...
'accuracy.'];

cddisp(text,'demo');

fighandle=findobj('Tag',['ABCDdetect']);
set(fighandle,'Visible','Off');
guidetect('setdetector',1)
guidetect('blockplot')

guidetect('changedesign')
figsimdeshandle=findobj(0,'Tag','figsimdes');
handle=findobj(figsimdeshandle,'Tag','adm');
set(handle,'Value',5);
handle=findobj(figsimdeshandle,'Tag','adg');
set(handle,'String','[0.1 0;0 0.1]');
guidetect('designedit|startclock|startdetect|stopclock|updateadaptivetool')

end

if cddemostate==[4 7];



text=[...
'Look at the \R RMS error \W in the state estimate.\n',...
'There is a transient error and an error due to the maneouvre.'];
    
cddisp(text,'demo');

fighandle=findobj(0,'Tag','figplottool');
onhandle=findobj(fighandle,'Tag','valrms');
set(onhandle,'Value',1);
guidetect('validrmsplot')

end

if cddemostate==[4 8];



text=[...
'8. Increase the state noise in the Kalman filter, that is, \n',...
'increase the adaptivity.'];

cddisp(text,'demo');


figsimdeshandle=findobj(0,'Tag','figsimdes');
handle=findobj(figsimdeshandle,'Tag','adm');
set(handle,'Value',5);
handle=findobj(figsimdeshandle,'Tag','adg');
set(handle,'String','[100 0;0 100]');
guidetect('designedit|startclock|startdetect|stopclock|updateadaptivetool')

end

if cddemostate==[4 9];

guidetect('cleanup')
guidemo('guidemo')
end


end  % update

if strcmp(action,'closeguidemo')
  h=findobj('Tag','demo');
  if ~isempty(h);
    close(h);
  end
end

	 
