function guidemo1(gotoin,action)
global goto
gotostring=['0.1 ';'1.1 ';'1.2 ';'1.3 ';'1.4 ';'1.5 ';'1.6 ';'1.7 ';'1.8 ';'1.9 ';...
      '1.10';'1.11';'1.12';'1.13';'1.14';'1.15';'1.16';'1.17';'1.18';...
      '2.1 ';'2.2 ';'2.3 ';'3.1 ';'3.2 ';'3.3 ';'3.4 ';'3.5 ';'3.6 ';

       ];
p1=5; % overview pause
p2=5; % standard pause
if nargin==0;
   goto='all';   % goto='1.1' - '5.3'
elseif ~isempty(gotoin)
   goto=gotoin;
end
if nargin<2;
   action='none';
end

   
text=['\n\l\b                                                  A MATLAB TOOLBOX FOR\n',...
      '\h                CHANGE DETECTION AND ADAPTIVE FILTERING \n\n\n',...
      '\W\l\bUsing the GUI.\n',...
      '\l\b1. Fundamental example:  \t  change in the mean in random variable \n',...
      '\W\l   How to simulate signals:\i built-in simulator, simulink, the LTI object \n',...
      '\W\l   Adaptive filter design: \i tuning, Monte Carlo, auto-tuning  \n',...
      '\W\l   Concepts of whiteness change detection: \i test statistic, threshold \n',...
      '\W\l   Performance of change detectors: \i false alarms, delay for detection \n',...
      '\W\l   Concepts of the two-filter approach: \i sliding window, threshold \n',...
      '\W\l   Concepts of bank of matched filters. \n',...
      '\W\l\b 2. ARX example:   \t    tracking and change detection in dynamical systems.\n',...
      '\W\l\b 3. Airborne application:   \t tracking and manoeuver detection using radar   .\n',...
   ];
%      '\W\l\b 3. Automotive application:   \t tracking of fuel consumption   .\n',...
%      '\W\l\b 3. Automotive application:   \t tracking and detection of tire-road friction   .\n',...

colorind=[];
for i=1:length(text)-1;
   if strcmp(text(i:i+1),'\W')
      colorind=[colorind i];
   end
end

guihandle=findobj('Tag','block');

if strcmp(action,'next')
   for i=1:length(gotostring)
      gotoi=gotostring(i,:);
      gotoi=gotoi(find(gotoi~=' '));
      if strcmp(goto,gotoi)
         k=i;
      end
   end
   if k==length(gotostring); k=k-1; end
   goto=gotostring(k+1,:);
   goto=goto(find(goto~=' '));
   guidemo1(goto)
end   
   
if strcmp(action,'prev')
   for i=1:length(gotostring)
      gotoi=gotostring(i,:);
      gotoi=gotoi(find(gotoi~=' '))
      if strcmp(goto,gotoi)
         k=i;
      end
   end
   if k==1; k=k+1; end
   goto=gotostring(k-1,:);
   goto=goto(find(goto~=' '));
   guidemo1(goto)
end   
   
if strcmp(action,'ui')
h=findobj('Tag','he');
pos=get(h,'Position');
uicontrol(h,'Position',[pos(3)-80 pos(4)*0.75 60 30],...
   'Style','Pushbutton',...
   'String','Next',...
   'CallBack','guidemo1([],''next'')');
uicontrol(h,'Position',[pos(3)-80 pos(4)*0.4 60 30],...
   'Style','Pushbutton',...
   'String','Previous',...
   'CallBack','guidemo1([],''prev'')');
uicontrol(h,'Position',[pos(3)-80 pos(4)*0.05 60 30],...
   'Style','Pushbutton',...
   'String','Quit',...
   'CallBack','close(gcf),close(findobj(''Tag'',''al'')),guidetect(''cleanup'')');
end

if strcmp(action,'allui')
h=findobj('Tag','al');
pos=get(h,'Position');
uicontrol(h,'Position',[pos(3)-80 pos(4)*0.95 60 30],...
   'Style','Pushbutton',...
   'String','OK',...
   'CallBack','guidemo1([],''ok'')');
end

if strcmp(action,'ok')  
    guidemo1(goto)
end

if strcmp(action,'none')  % begin the demo
   
if strcmp(goto,'0.1') | strcmp(goto,'all')
text(colorind(1)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(1)+1)='W';  
cddisp(' ','header');
headtext=['\h\b USING THE GUI \n',...
      '\hGUI is focused on block diagrams. \n',...
      '\h \n \h \n \h \n \h \n \h \n \h \n',...
      '\hClick on blocks to simulate and filter. \n',...
      '\hClick on signal buttons to look at the signals. \n',...
      '\hClick on Filter Structure to switch block diagram. \n',...
      '\hClick on upper row buttons to setup the simulation/filter\n',...      
      ];
cddisp(headtext,'all')
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);
if strcmp(goto,'all'), pause(p2), end

end


if strcmp(goto,'1.1') | strcmp(goto,'all')
text(colorind(2)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(2)+1)='W';  
cddisp(' ','header');
headtext=['\h FIRST EXAMPLE: CHANGE IN THE MEAN \n',...
      '\lSetup and default design parameters loaded. ',...
      ];
   cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('exM') 
guidetect('cleanup') 

guidetect('setdetector',1) 
guidetect('closechangedesign')
guidetect('blockplot') 
guidetect('disp','Default values for mean change model loaded. ') 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.2') | strcmp(goto,'all')
headtext=['\h SIMULATION OF DATA \n',...
      '\lThe toolbox can simulate arbitrary linear systems with abrupt changes. See the setup window.\n',...
      '\lReal data, user defined simulators, simulink blocks or LTI objects can also be specified. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('mainsim')
if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.3') | strcmp(goto,'all')

headtext=['\h SIMULATION OF DATA \n',...
      '\lThe \ichange in mean \r model is chosen. The other design parameters are self explained by\n',...
      '\lstarting a simulation (click at Simulation) and look at the data (click at y). ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('startclock') 
guidetect('startsim') 
guidetect('stopclock') 
guidetect('blocksigplot',1) 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.4') | strcmp(goto,'all')

headtext=['\h SIMULATION OF DATA \n',...
      '\lNow, close these windows and go on with filter design.\n',...
      '\l',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('cleanup')
if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.5') | strcmp(goto,'all')

text(colorind(3)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(3)+1)='W';  
cddisp(' ','header');
headtext=['\h ADAPTIVE FILTER DESIGN \n',...
      '\lThe filter is started by a click on Adaptive Filter. \n',...
      '\lClick on the signal block \b th \t to see the result. ',...
      ];
 cddisp(headtext,'header')
guidemo1([],'ui')
 figure(guihandle);



guidetect('startclock') 
guidetect('startdetect') 
guidetect('stopclock') 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.6') | strcmp(goto,'all')

headtext=['\h ADAPTIVE FILTER DESIGN \n',...
      '\l Look at the estimated mean (click at th). ',...
      ];
guidemo1([],'ui')
 figure(guihandle);


guidetect('blocksigplot',2) 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.7') | strcmp(goto,'all')

headtext=['\h A FIRST FILTER APPLIED \n',...
      '\lThis is the response of RLS for a certain forgetting factor. \n',...
      '\lThere are many alternatives to RLS in the toolbox. '];
cddisp(headtext,'header')
guidemo1([],'ui')
 figure(guihandle);

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.8') | strcmp(goto,'all')

headtext=['\h AUTO-TUNING \n',...
      '\lWhich is the best forgetting factor to use? \n',...
      '\lIt is computed automatically by the \i Adaptive Tool. '];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);


guidetect('adaptivetool',1) 
guidetect('setadaptivetool',5)
drawnow
guidetect('closemaindetector') 
guidetect('startoptdesign') 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.9') | strcmp(goto,'all')

headtext=['\h MONTE CARLO SIMULATIONS \n',...
      '\lEvaluate the performance during repeated simulations. \n',...
      '\lThe mean parameter estimate is displayed when finished. '];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);


fighandle=findobj('Tag','figadaptivetool');
MChandle=findobj(fighandle,'Tag','MCiter');
set(MChandle,'String','10');

guidetect('adtoolMC') 
guidetect('validthplot') 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.10') | strcmp(goto,'all')

headtext=['\h TABLE GENERATION \n',...
      '\lSave the results in a table for later reference. \n',...
      '\l '];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);


guidetect('tabadaptivetool') 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.11') | strcmp(goto,'all')

guidetect('closeadaptivetool') 

text(colorind(4)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(4)+1)='W';  


headtext=['\h WHITENESS TEST CHANGE DETECTION \n',...
      '\lThe simplest form of change detection is based on \n',...
      '\ltesting the whiteness of the residuals from an adaptive filter. '];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);



guidetect('maindetector') 
guidetect('setdetector',2) 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.12') | strcmp(goto,'all')

headtext=['\h TEST STATISTICS \n',...
      '\lThe detector forms a test statistic which is compared to \n',...
      '\la threshold. Here we get one alarm, and the adaptive filter speeds up. '];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('closemaindetector') 
guidetect('startclock') 
guidetect('startdetect') 
guidetect('stopclock') 
guidetect('blocksigplot',3) 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.13') | strcmp(goto,'all')

headtext=['\h TABLE COMPARISON \n',...
      '\lThe table in the Adaptive Tool shows much better \n',...
      '\lperformance in all aspects. '];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('adaptivetool',1) 
guidetect('tabadaptivetool') 

if strcmp(goto,'all'), pause(p2), end
end

if strcmp(goto,'1.14') | strcmp(goto,'all')
   
close(findobj('Tag','figtabdesign'));
guidetect('closeadaptivetool') 


guidetect('cleanup')

end

if strcmp(goto,'1.15') | strcmp(goto,'all')
text(colorind(5)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(5)+1)='W';  
cddisp(' ','header');
headtext=['\h CHANGE DETECTION PERFORMANCE \n',...
      '\l\bChange Tool \t enables Monte Carlo based evaluation measures:\n ',...
      '\lFalse alarm rate, Delay for detection, histograms etc. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('changetool',1) 
handle=findobj('Tag','figchangetool');
MCNhandle=findobj(handle,'Tag','MCN');
set(MCNhandle,'String','20');
guidetect('startMC')

end

if strcmp(goto,'1.16') | strcmp(goto,'all')
headtext=['\h CHANGE DETECTION PERFORMANCE \n',...
      '\lA change detection table summarizes the performance for later reference. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('tabchangetool') 
end

if strcmp(goto,'1.17') | strcmp(goto,'all')
text(colorind(6)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(6)+1)='W';  
cddisp(' ','header');
headtext=['\h CONCEPTS OF TWO-MODEL CHANGE DETECTION \n',...
      '\lSignificant for this approach is that one slow and one fast filter competes.  \n ',...
      '\lThe one with the smallest residuals in some norm wins. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

close(findobj('Tag','figMCtab'));
guidetect('closechangetool') 
guidetect('maindetector') 
guidetect('setdetector',3) 

end

if strcmp(goto,'1.18') | strcmp(goto,'all')
text(colorind(7)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(7)+1)='W';  
cddisp(' ','header');
headtext=['\h CONCEPTS OF BANK OF MATCHED FILTERS \n',...
      '\lA number of methods is based on a bank of filters, each one matched to certain \n ',...
      '\lassumptions on the change times. The norm on the residual varies with the method. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('maindetector') 
guidetect('setdetector',4) 

end

if strcmp(goto,'2.1') | strcmp(goto,'all')
text(colorind(8)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(8)+1)='W';  
cddisp(' ','header');
headtext=['\h AN ARX EXAMPLE \n',...
      '\lThis example is setup from the utilities menu. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('cleanup')
guidetect('exARX')
end


if strcmp(goto,'2.2') | strcmp(goto,'all')
headtext=['\h AN ARX EXAMPLE \n',...
      '\lSimulate data and look at the singal \o y . ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);


guidetect('startclock')
guidetect('startsim')
guidetect('stopclock')
guidetect('blocksigplot',1)
end


if strcmp(goto,'2.3') | strcmp(goto,'all')
headtext=['\h AN ARX EXAMPLE \n',...
      '\lRun the filter and detector and look at the estimated parameters \o th .\n ',...
      '\lNote how quickly the abrupt change is tracked due to the detector. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);


guidetect('blocksigplot',1)
guidetect('startdetect')
guidetect('blocksigplot',2)
h=findobj('Tag','figvalpar');
if ~isempty(h), figure(h),a=axis; axis([a(1) a(2) -1.5 2]), end

end


if strcmp(goto,'3.1') | strcmp(goto,'all')
text(colorind(9)+1)='R';  % highlight
cddisp(text,'all'), pause(p1), cddisp(' ','all')
text(colorind(9)+1)='W';  
cddisp(' ','header');
headtext=['\h AN APPLICATION \n',...
      '\lRadar tracking of airplanes. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('cleanup')
guidetect('datatracking')
end

if strcmp(goto,'3.2') | strcmp(goto,'all')
cddisp(' ','header');
headtext=['\h AN APPLICATION \n',...
      '\lA simulation is done using a realistic non-linear model.\n',...
      '\lThe usual plot of states is not informtive. Use a customized plot. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('startclock')
guidetect('startsim')
guidetect('stopclock')
guidetect('blocksigplot',1)


end

if strcmp(goto,'3.3') | strcmp(goto,'all')
cddisp(' ','header');
headtext=['\h AN APPLICATION \n',...
      '\lThe customized plot shows the position in 2D.',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('plottool')
set(findobj('Tag','usernm'),'String','radarplot')
set(findobj('Tag','valusr'),'Value',1)
guidetect('validuser')


end

if strcmp(goto,'3.4') | strcmp(goto,'all')
cddisp(' ','header');
headtext=['\h AN APPLICATION \n',...
      '\lThe customized plot is updated with the Kalman filter estimate.\n',...
      '\lThis is bad design because of slow tracking. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);
guidetect('startclock')
guidetect('startdetect')
guidetect('stopclock')
guidetect('blocksigplot',1)


end

if strcmp(goto,'3.5') | strcmp(goto,'all')
cddisp(' ','header');
headtext=['\h AN APPLICATION \n',...
      '\lUse the design tool to auto-tune the adaptation gain.\n',...
      '\lMuch better performance, but norm plot shows no minima yet. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('adaptivetool',1) 
guidetect('setadaptivetool',4)
drawnow
guidetect('startoptdesign') 
end


if strcmp(goto,'3.6') | strcmp(goto,'all')
cddisp(' ','header');
headtext=['\h AN APPLICATION \n',...
      '\lAnother optimization with better initialization gives local minimum.\n',...
      '\lThis is the best performance with a Kalman filter. ',...
      ];
cddisp(headtext,'header')
guidemo1([],'ui')
figure(guihandle);

guidetect('startoptdesign') 
guidetect('startoptdesign') 

if strcmp(goto,'all'), guidemo1('all'), end   % Start all over again

end




%close(findobj('Tag','header'))
%close(findobj('Tag','all'))

end