function [TH,jumptimes,N]=par2segm(thseg);

% Converts a full th matrix to the compact TH format
%
% [TH,jumptimes,N]=par2segm(thseg);
%
% jumptimes The segmentation
% TH        The parameters vectors in each segment.
% N         Total number of data
% thseg     Parameter vectors expanded to a dxN matrix.
%
% See also segm2par
%
% Fredrik Gustafsson


[d,N]=size(thseg);

jumptimes=find(diff(thseg(1,:))~=0);
ind=[0 jumptimes];
TH=thseg(:,ind+1);

