function h=radarplot(zin,xin,jhat)

% Plots a trajectory and draws a radar at the origin
%
% zin  Measured position
% xin  Estimated position
% jhat Estimated manoeuvre times (optional)
%


global z threc  % For GUI call
if nargin>0
  z=zin;
  threc=xin;
end


% Illustration
Y=z(:,1:2)';
Xhat=threc(1:2,:);

c='bgrcmyk';

h1=plot(Y(1,:),Y(2,:),'o-b');
hold('on')
%plot(Y(1,:),Y(2,:),'ob')

r=3000;
plot([0 0],[-1.5*r 0])
t=-pi/2:.01:0;
plot(r*cos(t(length(t)/2))-r*cos(t),-r*sin(t(length(t)/2))+r*sin(t))
%axis([-5000 35000 -5000 25000])
axis('equal')

h2=plot(Xhat(1,:),Xhat(2,:),'*--r');
%plot(Xhat(1,:),Xhat(2,:),'*r')

if nargin>2
  h3=plot(Y(1,jhat),Y(2,jhat),'dk');
  set(h3,'MarkerSize',20);
  legend([h1 h2 h3],'Measured position','Estimated position','Estimated change times',4)
else
  legend([h1 h2],'Measured position','Estimated position',4)
end

hold('off')
drawnow
h=[h1 h2];
