function reference(arg,saveplots)
 
% Includes all examples in the reference section of the manual
%
% arg is the name of one function.
% arg=all runs all reference examples (benchmark test!)
% saveplots=1 used for saving plots by the author

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $

if nargin<2, saveplots=0; end
if strcmp(arg,'all')
  pause off
  echo off
  more off
  t000=clock;
end


%if strcmp(arg,'all') | strcmp(arg,'adfilter')
if strcmp(arg,'adfilter')
u=randn(100,1);
e=randn(100,1);
jumptimes=[40 70];
TH=[1.5 .8 2 0.5;...
    1.5 .8 2 1;...
    1.5 .6 2 1]';
nnn=[2 2 1];
y=simchange([0.1*e u],nnn,jumptimes,TH);
z=[y u];
thRLS=adfilter(z,nnn,0.9);
thplot(thRLS,segm2par(TH,jumptimes,100));
%thplot(thRLS,TH,jumptimes);
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/adfilter1.eps, end
figure
nnn='nnnssex';
jumptime=50;
TH=[10 10]';
u=randn(100,1);
[y,X]=simchange([u],nnn,jumptime,TH);
[xhat,lamhat,epsi]=adfilter([y u],nnn);
subplot(211)
thplot(X,xhat)
subplot(212)
plot(epsi)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/adfilter2.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'cpe')
% H0 signal:
y0=[1*ones(50,1);1*ones(50,1)]+.1*randn(100,1);
% H1 signal:
y1=[1*ones(50,1);2*ones(50,1)]+.1*randn(100,1);
% Use a unknown mean model (required in cpe)
nnn=-1;
% Bayesian approach
[jh,ths,GT01,U01]=cpe(y0,nnn,1);
[jh,ths,GT11,U11]=cpe(y1,nnn,1);
% Maximum likelihood approach
[jh,ths,GT02,U12]=cpe(y0,nnn,2);
[jh,ths,GT12,U12]=cpe(y1,nnn,2);
% Non-parametric approach I
[jh,ths,GT03,U13]=cpe(y0,nnn,3);
[jh,ths,GT13,U13]=cpe(y1,nnn,3);
% Non-parametric approach II
[jh,ths,GT04,U14]=cpe(y0,nnn,4);
[jh,ths,GT14,U14]=cpe(y1,nnn,4);
subplot(221), plot([GT01,GT11]), title('Bayes')
subplot(222), plot([GT02,GT12]), title('Maximum Likelihood')
subplot(223), plot([GT03,GT13]), title('Non-parametric I')
subplot(224), plot([GT04,GT14]), title('Non-parametric II')
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/cpe.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'cusumarl')
h=3;
nu=1;
th=1;
mu=th-nu/2;
[ta0,N0] = cusumarl(h,-mu);  % H0
[ta1,N0] = cusumarl(h,+mu);  % H1
[ta0siegmund] = cusumarl(h,-mu,0.5,-1);
[ta1siegmund] = cusumarl(h,+mu,0.5,-1);
[ta0wald] = cusumarl(h,-mu,0.5,-2);
[ta1wald] = cusumarl(h,+mu,0.5,-2);
L0=cusumMC(h,-mu,500);
L1=cusumMC(h,mu,500);
disp([ta0 ta0wald ta0siegmund mean(L0);...
      ta1 ta1wald ta1siegmund mean(L1)])


end

if strcmp(arg,'all') | strcmp(arg,'cusumdesign')
hmax=10;
th=0.4;
L0=10;
h=cusumdesign(L0,th/2,hmax);
[ta0]=cusumarl(h,th/2);
disp([ta0,L0])
end

if strcmp(arg,'all') | strcmp(arg,'cusumMC')
h=3;
mu=0.5;
ta1 = cusumarl(h,+mu)
L1=cusumMC(h,mu,500);
mean(L1)
end


if strcmp(arg,'all') | strcmp(arg,'detect1')
u=randn(100,1);
e=randn(100,1);
jumptimes=[40 70];
TH=[1.5 0.8 2 0.5;...
    1.5 0.8 2 1;...
    1.5 0.6 2 1]';
nnn=[2 2 1];
y=simchange([0.1*e u],nnn,jumptimes,TH);
z=[y u];
[threc,jhat,thseg,gt,ta]=detect1(z,nnn,2,[1 10 5],0.01);
thplot(threc,TH,jumptimes);
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/detect1.eps, end
end
 
if strcmp(arg,'all') | strcmp(arg,'detect2')
close all
randn('state',1)
u=randn(100,1);
e=randn(100,1);
jumptimes=[40 70];
TH=[1.5 .8 2 0.5;1.5 .8 2 1;1.5 .6 2 1]';
nnn=[2 2 1];
y=simchange([0.1*e u],nnn,jumptimes,TH);
z=[y u];
[threc,jhat,thseg,gt,ta]=detect2(z,nnn,1,[1 0.5 0.3],10,-1);
figure(1),thplot(threc,TH,jumptimes);
%figure(2), plot(gt)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/detect2.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'detectM')
close all
randn('state',0)
u=randn(100,1);
e=randn(100,1);
jumptimes=[40 70];
TH=[1.5 .8 2 0.5;1.5 .8 2 1;1.5 .6 2 1]';
nnn=[2 2 1];
y=simchange([0.1*e u],nnn,jumptimes,TH);
z=[y u];
[threc,jhat,thseg,lamhat]=detectM(z,nnn);
thplot(thseg,TH,jumptimes,threc);
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/detectM.eps, end
end


if strcmp(arg,'all') | strcmp(arg,'faultdetect')
nnn='nnnDCm1';
N=80;
f1=[1;0];
f2=[0;1];
TH=[f1 -f1 f2 -f2];
jumps=[3*N/8 4*N/8 5*N/8 6*N/8];
u=randn(N,1);
d=[zeros(N/8,1); randn(N/8,1); zeros(6*N/8,1)];
[y,x0]=simchange([u d],nnn,jumps,TH,1);

L=2;
z=[y u];
r1=faultdetect(z,nnn,L);
F=eye(2);
R=eye(2);
r2=faultdetect(z,nnn,L,R,F);
figure
subplot(211)
plot(r1(:,1),'-'), hold on, plot(r1(:,2),'--'), hold off, 
title(['Unstructured residuals for L = ',num2str(L)])
subplot(212)
plot(r2(:,1),'-'), hold on, plot(r2(:,2),'--'), hold off, 
title(['Structured residuals for L = ',num2str(L)])
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/faultdetect.eps, end
end

%if strcmp(arg,'all') | strcmp(arg,'gibbs')
if strcmp(arg,'gibbs')
   close all
   rand('state',1)
   randn('state',3)
   N=30;
   TH=[1 4 8];
   jump=[N/3 2*N/3];
   y=simchange(randn(N,1),-1,jump,TH);
   figure(1)
   book('plotfix')
   p=thplot(y,TH,jump);
   set(p,'LineWidth',2)
   if saveplots==1, print -deps /home/rt/fredrik/books/manual/figures/gibbs1.eps, end
   figure(1)
   [threc,kn]=gibbs(y,-1,[1 1],0.5,[2 500 0],[0 1 1],[5 10]);
   figure(2)
   if saveplots==1, print -deps /home/rt/fredrik/books/manual/figures/gibbs2.eps, end
   figure(3)
   if saveplots==1, print -deps /home/rt/fredrik/books/manual/figures/gibbs3.eps, end
end


%if strcmp(arg,'all') | strcmp(arg,'glr')
if strcmp(arg,'glr')
randn('seed',0)
u=randn(100,1);
[a,b,c,d]=tf2ss([0 1 -1],[1 -1 0.8]);
Q=0.0001*eye(2);
R=0.01;
nnn=ss2nnn(a,b,c,d,Q,R);
jumptime=50;
TH=[10 10]';
[y,x]=simchange(u,nnn,jumptime,TH);
[xhat,jhat,nuhat,lr]=glr([y u],nnn);
thplot(x,xhat)
jhat,nuhat,jhat
figure(2),plot(lr)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/glr.eps, end
end


%if strcmp(arg,'all') | strcmp(arg,'glr2')
if strcmp(arg,'glr2')
randn('seed',0)
N=100;
d=2;
u=randn(N,1);
A=[1 1;0 1]; B=[0.5;1]; C=[1 0]; D=0; R1=.01*eye(2); R2=0.1; P0=1*eye(2);
nnn=ss2nnn(A,B,C,D,R1,R2,P0);
th0=[1;...
     2];
y=simchange([u],nnn,N/2,th0);
M=10;  % size of sliding window, batch test here
Xhatkf=adfilter([y u],nnn);
flops(0)
[Xhat,jhatglr,nuhatglr,taglr,lrglr]=glr([y u],nnn,M,30);
flopsglr=flops;
flops(0)
[jhatmlr,lrmlr]=mlr([y u],nnn,1);
flopsmlr=flops;
jhatglr,jhatmlr
nuhatglr
plot([y-(C*Xhat)' y-(C*Xhatkf)'])
title('Prediction error from Kalman and GLR')
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/glr.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'hypplot')
randn('seed',1);
close all
jumps=[10 20];
TH=[0 5 8];
[y,th0]=simchange(randn(30,1),-1,jumps,TH);     
M=6;
[threc,jumphat,thseg,lamseg,Alfa,hist]=detectM(y,-1,[1 1],0.5,M,0);
cdfigure(1);
hypplot(hist,jumphat) 
title(['Local search with M=',num2str(M)])
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/hypplot.eps, end
end


%if strcmp(arg,'all') | strcmp(arg,'mlr')
if strcmp(arg,'mlr')
randn('seed',0)
u=randn(100,1);
[a,b,c,d]=tf2ss([0 1 -1],[1 -1 0.8]);
Q=0.0001*eye(2);
R=0.01;
nnn=ss2nnn(a,b,c,d,Q,R);
jumptime=50;
TH=[10 10]';
[y,x]=simchange(u,nnn,jumptime,TH);
[jhat,lr]=mlr([y u],nnn);
jhat
figure(2),plot(lr)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/mlr.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'multihyp')
randn('seed',0)
TH=[1.6 .64; -1.6 .64; -1.6 .64; -1.6 .64; 1.6 .64;]';
Lam=[1 1 10 1 1];
jumptimes=[50;100;150;200];
N=250;
nnn=[0 2 1];  % FIR model
L=10;         % Size of sliding window
e=randn(N,1);
u=randn(N,1);
y=simchange([e u],nnn,jumptimes,TH,Lam);
[jhat,jtype,thseg,lamseg]=multihyp([y u],nnn,L);
disp([jhat;jtype])
%if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/multihyp.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'simchannel')
N=1000;
nb=2;
alphabet=[-1 1];
[y,u,b]=simchannel(alphabet,nb,N);
plot(b')
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/simchannel1.eps, end

N=100;
b=[3 2 1   6 5 4];
nb=[3;3];
[y,u,b]=simchannel(alphabet,nb,N,b);
subplot(211)
plot(u)
title('Input u')
axis([ 0 N -1.2 1.2])
subplot(212)
plot(y)
title('Output y')
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/simchannel1.eps, end

nb=2; ny=2; nu=2;
[y,u,th]=simchannel(alphabet,nb*ones(ny,nu),N,[]);

%G_{11}=1+0.9q^{-1} 
%G_{12}=0.8+0.7q^{-1} 
%G_{21}=0.6+0.5q^{-1}
%G_{22}=0.4+0.3q^{-1}

th=[1 0.9   0.8 0.7    0.6 0.5   0.4 0.3];
nb=2; ny=2; nu=2;
[y,u]=simchannel(alphabet,nb*ones(ny,nu),N,th);

end


if strcmp(arg,'all') | strcmp(arg,'blindeq')
N=1000;
randn('seed',1);
b=[0.3 1 0.3];   % Channel dynamics
nb=length(b);
alphabet=[-1 1]; % Binary channel
[y,u]=simchannel(alphabet,nb,N,b); % Simulate channel input and output
y=y+0.1*randn(N,1);  % Add noise

nc=5;   % equalizer order for blindeq
c0=[0 -0.1 1 -0.1 0]';  % Initial equalizer
[theq1,uhat1,epsi1]=blindeq(y,nc,0.01,1,c0);
m1=openeye(b,theq1); % m1=1 is a perfect equalizer, m1>0 gives perfect 
                     % reconstruction in the noise free case
plot(m1)
title('Open eye condition')
conv(b,theq1(:,N))'  % Impulse response of combined channel and equalizer
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/blindeq.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'blindeqM')
N=100;
randn('seed',1);
rand('seed',1);
b=[0.5 1 0.7];  % Channel dynamics
nb=length(b);
alphabet=[-1 1]; % Binary channel
[y,u]=simchannel(alphabet,nb,N,b); % Simulate channel input and output
y=y+0.1*randn(N,1);  % Add noise
nb=3;     % channel order for blindeqM
[thhat,uhat]=blindeqM([y u],nb,[-1 1],0.001,16,0.1,10,0);
ber=u2ber(u,uhat)
cdfigure(1);
plot(thhat')
hold on
plot(ones(N,1)*b,'--')
hold off
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/blindeqM.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'openeye')
b=[0.3 1 0.3];          % channel
b1=[0 -0.1 1 -0.1 0]';  % equalizer
m1=openeye(b,b0)
b2=[0 1 1 1 0]';  % equalizer
m2=openeye(b,b0)
end

if strcmp(arg,'all') | strcmp(arg,'viterbi')
randn('seed',1);
N=100;
b=[1 1 1];        % True channel
u=sign(randn(N,1));
y=filter(b,1,u)+sqrt(0.1)*randn(N,1);
bhat=[1 0.7 1.3]; %  Channel ''estimate''
uhat=viterbi(y,bhat,[-1 1],0.1);
ber=u2ber(u,uhat)
% BER when using a short training sequence
[uhat,thhat]=viterbi(y,3,[-1 1],0.1,u(1:5));
thhat'
ber=u2ber(u,uhat)
end


if strcmp(arg,'all') | strcmp(arg,'th2tfd')
cdfigure(1);
N=5000;
y=sin(2*pi*(1:N)'.^2./N);
specgram(y)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/th2tfd1.eps, end
cdfigure(2,1);
N=500;
y=sin(2*pi*(1:N)'.^2./N);
[th,lamhat]=adfilter(y,2,20); 
th2tfd(th,lamhat,y,64,[],1); 
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/th2tfd2.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'th2poles')
cdfigure(1);
N=5000;
y=sin(2*pi*(1:N)'.^2./N);
specgram(y)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/th2poles1.eps, end
cdfigure(2,1);
N=500;
y=sin(2*pi*(1:N)'.^2./N);
[th,lamhat]=adfilter(y,2,20); 
th2poles(th);
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/th2poles2.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'optseg')
y=[ones(25,1);2*ones(25,1)]+0.1*randn(50,1);
z=[y ones(50,1)];
nn=[0 1 0];
lambda=0.01;
q=0.5;
[jhat,thseg,V,likelihood,modnum]=optseg(z,nn,lambda,q,0.01);
jhat
%[jhat,thseg]=detectM(y,-1,[1 lambda],q,50);
[threc,jhat,thseg]=detectM(y,-1);
jhat
plot(modnum)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/optseg.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'radfilter')
N=100;
u=randn(N,1);
e=randn(N,1);
th0=[0.5 1.5;0.8 1.8]';
d=2;
lam=0.1;
nnn=[1 1 1];
y=simchange([lam*e u],nnn,N/2,th0);
TH=[];

[Xfilt]=radfilter([NaN NaN],nnn);
for t=1:N;
  [thhat,lamhat,epsi,S,Xfilt]=radfilter([y(t) u(t)],nnn,0.95,'RLS',Xfilt);
  TH=[TH thhat];
end
plot(TH')
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/radfilter.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'rdetect1')
randn('seed',0)
lambda=0.25;
y=[zeros(50,1);ones(50,1)] + sqrt(lambda)*randn(100,1);
dm=2;
h=5;
nu=.5;
sr=[1 h nu];
GT1=[];
alarmtimes=[];

[Xone]=rdetect1([],[],dm,sr,-1);
for t=1:100;
  [alarm,Xone]=rdetect1(y(t),Xone);
  GT1=[GT1;Xone(1)]; 
  if alarm~=0; 
    Xone(1:2)=[0 0]; % Reset
    alarmtimes=[alarmtimes t];
  end;
end
segplot(GT1,alarmtimes)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/rdetect1.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'rdetect2')
randn('seed',0)
lambda=0.25;
y=[zeros(50,1);ones(50,1)] + sqrt(lambda)*randn(100,1);
nnn=-1;
GT2=[];
alarmtimes=[];

[X0]=radfilter([],nnn,1,'RLS');
[X1]=radfilter([],nnn,0.8,'RLS');
dm=2;
h=10;
nu=1;
sr=[1 h nu];
[Xdet]=rdetect2([],[],[],[],[],dm,sr);
for t=1:100;
  [thhat0,lam0,epsi0,S0,X0]=radfilter([y(t)],nnn,1,'RLS',X0);
  [thhat1,lam1,epsi1,S1,X1]=radfilter([y(t)],nnn,0.8,'RLS',X1);
  [alarm,Xdet]=rdetect2(epsi0/sqrt(S0),epsi1/sqrt(S1),lam0,lam1,Xdet);
  GT2=[GT2;Xdet(1)]; 
  if alarm~=0; 
    X0=X1; % Let the slow filter overtake the fast filter state
    alarmtimes=[alarmtimes t];
  end;
end
segplot(GT2,alarmtimes)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/rdetect2.eps, end
end

%if strcmp(arg,'all') | strcmp(arg,'rglr')
if strcmp(arg,'rglr')
N=100;
d=2;
u=randn(N,1);
A=[1 1;0 1]; B=[0.5;1]; C=[1 0]; D=0; R1=.01*eye(2); R2=0.1; P0=1*eye(2);
nnn=ss2nnn(A,B,C,D,R1,R2,P0);
th0=[1;...
     2];
y=simchange([u],nnn,N/2,th0);

[Xfilt]=radfilter([NaN NaN],nnn);
h=72;
M=10;
[Xglr]=rglr([],[],[],nnn,[],M,h);
GT1=[];
alarmtimes=[];

for t=1:N;
  [thhat,lamhat,epsi,S,Xfilt,K]=radfilter([y(t) u(t)],nnn,1,'RLS',Xfilt);
  [alarm,Xglr,nuhat,jhat,lrmax,P]=rglr(epsi,S,K,nnn,Xglr);
  GT1=[GT1;lrmax]; 
  if alarm~=0; 
    alarmtimes=[alarmtimes t]; 
    Xfilt(:,6:5+d)=100*Xfilt(:,6:5+d);   % Increase P in the Kalman filter
  end;
end;
segplot([GT1],alarmtimes)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/rglr.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'segm2par')
jumptimes=[40 70];
TH=[1.5 0.8 2 0.5;...
    1.5 0.8 2 1;...
    1.5 0.6 2 1]';
nnn=[2 2 1];
th=segm2par(TH,jumptimes,100);
plot(th')
axis([0 100 0 2.5])
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/segm2par.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'par2segm')
t=(1:100)'/100;
y=sin(t*2*pi);
[threc,jhat,thseg]=detectM([y ones(size(t)) t t.^2],-2,[1 0.001]);
subplot(211)
plot(thseg')
title('Parameter estimate')
subplot(212)
segplot(y,jhat)
par2segm(thseg)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/par2segm.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'simchange')
close all
e=randn(100,1);
jumptimes=[20 60];
TH=[0 1 3];
nnn=[-1];
[y,th0]=simchange(e,nnn,jumptimes,TH);
[y,th1]=simchange(e,nnn,jumptimes,TH,1,'lc',[10 1]);
[y,th2]=simchange(e,nnn,jumptimes,TH,1,'lc',[10 3]);
%segplot(y,jumptimes)
plot(th0),      hold on
plot(th1,'--')
plot(th2,'-.'), hold off
title('Simulation with different interpolations')
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/simchange.eps, end
end

%if strcmp(arg,'all') | strcmp(arg,'simadfilter')
if strcmp(arg,'simadfilter')
close all
randn('seed',0);
u=randn(100,1);
e=0.1*randn(100,1);
nnn=[1 3 1];
%[y,th]=simadfilter([e u],nnn,0.1*eye(4),'KF');
adg0=0.1;
adm='RLS';
[y,th]=simadfilter([e u],nnn,adg0,adm);
%figure
%th2poles(th);
%pause
subplot(311),plot(th')
subplot(312),plot(y)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/simadfilter.eps, end

adg=logspace(-2,-0.3,10)
for i=1:length(adg); 
  [thhat,lamhat,epsi]=adfilter(y,nnn,adg(i),adm);
  V(i)=epsi(30:end)'*epsi(30:end)/(100-30);
end
subplot(313)
plot(adg,V)


end

if strcmp(arg,'all') | strcmp(arg,'simresid')
randn('seed',0);
u=randn(100,1);
e=0.1*randn(100,1);
nnn=[2 2 1];
jumptimes=[40 70];
TH=[1.5 .8 2 0.5;...
    1.5 .8 2 1;...
    1.5 .6 2 1]';
y=simchange([e u],nnn,jumptimes,TH);
th=segm2par(TH,jumptimes,100);
[epsi,epsif]=simresid([y u],nnn,th);
plot([epsif-e])

if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/simresid.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'power2')
nb=30;
lambda=0.1;
N=50;
alpha0=0.99;                    % confidence level 99%
Calpha=erfinv(2*(alpha0)-1);    % Assuming AsN of test statistics
i=sqrt(-1);
% The "Astrom system", pole in 0.8376*exp(i*0.4592)
th0=filter(.2/1.5*[0 1 .5],[1 -1.5 0.7],[1;zeros(nb-1,1)]);
r=0.8376*exp(i*0.4);                     
% Move the phase angle from 0.46 to 0.4
th1=filter(.2/1.5*[0 1 .5],[1 -real(r+r') real(r*r')],[1;zeros(nb-1,1)]);

for m=1:nb;
  beta0(m)=power2(th0(1:m),th1(1:m),eye(m),lambda,N,alpha0);
end;
plot(beta0)
xlabel('FIR order'), ylabel('Power of model validation test')
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/power2.eps, end
end

if strcmp(arg,'all') | strcmp(arg,'segplot')
u=randn(100,1);
e=randn(100,1);
jumptimes=[40 70];
TH=[1.5 0.8 2 0.5;...
    1.5 0.8 2 1;...
    1.5 0.6 2 1]';
nnn=[2 2 1];
y=simchange([0.1*e u],nnn,jumptimes,TH);
segplot(y,jumptimes)
if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/segplot.eps, end
end

%if strcmp(arg,'all') | strcmp(arg,'')
%if saveplots==1, print -depsc /home/rt/fredrik/books/manual/figures/.eps, end
%end


if strcmp(arg,'all')
  t1=etime(clock,t000);
  disp(['Elapsed time: ',num2str(t1)])
end
