function thseg=segm2par(TH,jumptimes,N);

% Converts the compact TH format to a full th matrix
%
% thseg=segm2par(TH,jumptimes,N);
%
% jumptimes The segmentation
% TH        The parameters vectors in each segment.
% N         Total number of data
% thseg     Parameter vectors expanded to a dxN matrix.
%
% See also par2segm
%
% Fredrik Gustafsson

[d,n]=size(TH);
thseg=zeros(d,N);
jumptimes=[0;jumptimes(:);N];
for k=2:length(jumptimes);
  thseg(:,jumptimes(k-1)+1:jumptimes(k))=TH(:,k-1)*ones(1,jumptimes(k)-jumptimes(k-1));
end;
