%load /home/rt/fredrik/DALTM/data/ceram32.par

vf=1./ceram32(:,1);
vb=1./ceram32(:,3);
ind=(191:270);
slip=1000*(vf(ind)./vb(ind)-1);
plot(0.2*(1:80),slip)
ylabel('Slip [per mille]')
xlabel('Time [s]')
if saveplots==1;
  print ../figures/slip.eps
else
  pause
end;

lambda=0.9;
slipf=filter(1-lambda,[1 -lambda],slip);
plot(0.2*(1:80),slipf,'y-',0.2*(1:80),slip,'g:')
ylabel('Slip [per mille]')
xlabel('Time [s]')
if saveplots==1;
  print ../figures/slipf.eps
else
  pause
end;

load /home/rt/fredrik/matlab/data/segm/taldata
N=length(tal1);
plot((1:N)/8000,tal1)
axis([0 N/8000 -5000 4000])
ylabel('Amplitude')
xlabel('Time [s]')
if saveplots==1;
  print ../figures/speech.eps
else
  pause
end;


load /home/rt/fredrik/tex/papers/segm/mypath3
log1=logpar(1:450,:);
homedir=pwd;
cd /home/rt/fredrik/DALTM/oz
[X,Y,V]=tracker(log1,.9985);
eval(['cd ',homedir])
ind=(1:2:450);
x=X(ind);
y=Y(ind);
v=V(ind);
N=length(x);

plot(x,y)
drawnow
axis('equal')
xlabel('Meter')
ylabel('Meter')
title('Path')
text(x(1),y(1)-50,'t=0 s')
text(x(N)+50,y(N)+50,'t=225 s')
if saveplots==1;
  print ../figures/path.eps
else
  pause
end;


