echo on
clc
%          Skid detection using wheel slip
%         =================================


load slip.par

vf=1./slip(:,1);
vb=1./slip(:,3);
ind=(191:270);
slip=1000*(vf(ind)./vb(ind)-1);

h1=cdfigure(1);
plot(0.2*(1:80),slip)
ylabel('Slip [per mille]')
xlabel('Time [s]')

lambda=0.9;
slipf=filter(1-lambda,[1 -lambda],slip);

h2=cdfigure(2,1);
plot(0.2*(1:80),slipf,'y-',0.2*(1:80),slip,'g:')
ylabel('Slip [per mille]')
xlabel('Time [s]')

pause
close([h1 h2])
clear slip


