function nnn=ss2nnn(A,Bu,Bv,Bth,C,Du,Dth,Q,R,P0,x0)

% Converts a state space model to model structure nnn
%
% nnn=ss2nnn(A,Bu,Bv,Bth,C,Du,Dth,Q,R,P0,x0)
%
% See also nnn, nnn2ss

nx=size(A,1);
nu=size(Bu,2);
nv=size(Bv,2);
nth=size(Bth,2);
if nth~=size(Dth,2); error('Bth and Dth must have the same number of columns'), end
if nu~=size(Du,2);   error('Bu and Du must have the same number of columns'), end
ny=size(C,1);

if nargin<11; x0=zeros(nx,1); end;
if nargin<10; P0=1000*eye(nx); end;
if nargin<9;  R=eye(ny);   end;
if nargin<8;  Q=zeros(nv,nv); end;

nnn0=[nx nu nv nth ny];
nnn1=[A Bu Bv Bth [Q;zeros(nx-nv,nv)] x0 P0];
nnn2=[C Du Dth R];
ncol1=size(nnn1,2);
ncol1=size(nnn1,2);
ncol=max([5,ncol1,ncol2]);

nnn=[nnn0 zeros(1,ncol-5);...
     nnn1 zeros(nx,ncol-ncol1);...
     nnn2 zeros(ny,ncol-ncol2)];

