% global detectnnn threc z
detectnnn=[1 2 0];
na=detectnnn(1);
nb=detectnnn(2);

load percy
N=50000;
u=y(1:N);
b0=[1 0];
a0=[1 0];
[b1,a1]=butter(1,[0.2],'low');
[b2,a2]=butter(1,[0.7],'high');
jumps=[N/5 2*N/5 3*N/5 4*N/5];
TH=[a0(2:end) b0;...
    a1(2:end) b1;...
    a0(2:end) b0;...
    a2(2:end) b2;...
    a0(2:end) b0]';
%y=simchange([u zeros(size(u))],detectnnn,jumps,TH);
decfactor=50;
th0=segm2par(TH,jumps/decfactor,N/decfactor);
plot(th0')
title('True channel parameters')
text(200,1.2,'Lowpass-filter')
text(600,1.2,'Highpass-filter')
axis([1 1000 -1 1.5])
pause

jumpsdum=[1 jumps N+1];
y=[];
x=zeros(1,1);
for i=1:length(jumpsdum)-1;
  b=TH(na+1:end,i)';
  a=[1;TH(1:na,i)]';
  [ydum,x]=filter(b,a,u(jumpsdum(i):jumpsdum(i+1)-1),x);
  y=[y;ydum(:)];
end

disp(' ')
disp('Listen to u')
disp(' ')
sound(u)
pause
disp(' ')
disp('Listen to y')
disp(' ')
sound(y)
pause

adg=0.05;
th=adfilter([y u],detectnnn,adg,'NLMS',1,decfactor);
plot(th')
hold on
plot(th0','--')
hold off
axis([1 1000 -1 1.5])
title(['NLMS with step size ',num2str(adg)])
pause


adg=0.1;
th=adfilter([y u],detectnnn,adg,'NLMS',1,decfactor);
plot(th')
hold on
plot(th0','--')
hold off
axis([1 1000 -1 1.5])
title(['NLMS with step size ',num2str(adg)])
pause


adg=0.5;
th=adfilter([y u],detectnnn,adg,'NLMS',1,decfactor);
plot(th')
hold on
plot(th0','--')
hold off
axis([1 1000 -1 1.5])
title(['NLMS with step size ',num2str(adg)])
pause

adg=0.9;
th=adfilter([y u],detectnnn,adg,'RLS',1,decfactor);
plot(th')
hold on
plot(th0','--')
hold off
axis([1 1000 -1 1.5])
title(['RLS with forgetting factor ',num2str(adg)])
pause

adg=0.98;
th=adfilter([y u],detectnnn,adg,'RLS',1,decfactor);
plot(th')
hold on
plot(th0','--')
hold off
axis([1 1000 -1 1.5])
title(['RLS with forgetting factor ',num2str(adg)])
pause

adg=0.95;
th=adfilter([y u],detectnnn,0.98,'RLS',1,decfactor);
plot(th')
hold on
plot(th0','--')
hold off
axis([1 1000 -1 1.5])
title(['RLS with forgetting factor ',num2str(adg)])
pause


disp(' ')
disp('Computing residual ')
disp(' ')
thhat=kron(th,ones(1,decfactor));
e=simresid([y u],detectnnn,thhat);
uhat=y-e;

disp(' ')
disp('Listen to residual y-yhat')
disp(' ')
sound(e)

%uhat=[];
%x=zeros(1,1);
%for i=2:N/decfactor;
%  b=th(na+1:end,i)';
%  a=[1;th(1:na,i)]';
%  if b(1)~=0;
%    b=b/b(1);
%    a=a/b(1);
%  else
%    b=[1 0]; a=[1 0];
%  end
%  [uhatdum,x]=filter(a,b,u((i-1)*decfactor+1:i*decfactor),x);
%  uhat=[uhat;uhatdum(:)];
%end
