function [absP,argP]=th2poles(thm);

% th2poles(thm);
%
% Plots the absolute value and argument of the poles of the 
% recursively estimated AR parameters in thm.


thm=thm';
[N,d]=size(thm);
p=zeros(N,d);
absP=zeros(N,d);
argP=zeros(N,d);

for i=1:N;
  p(i,:)=roots([1 thm(i,:)])';
  absP(i,:)=abs(p(i,:));
  argP(i,:)=phase(p(i,:));
end;
argP=argP(:,1:d/2);
absP=absP(:,1:d/2);
argP=rem(argP+4*pi,2*pi);
argP=pi-abs(argP-pi);
if nargout==0;
  subplot(211)
  plot(absP);
  title('Magnitude of the poles'); 
  subplot(212)
  plot(argP);
  axis([0 N 0 pi])
  title('Argument of the poles'); 
end