function p=thplot(th,TH,jumptimes,threc);

% Plots the estimated parameters and true parameters
%
% function p=thplot(th,TH,jumptimes,threc);
% 
% th     parameters plotted with solid line (smoothed estimate)
% TH     parameters plotted with dotted line (true values)
% threc  parameters plotted with dashed line (recursive values) 
%
% Note:  th and threc are a given for each time instant, but
%        TH for each segment only
% jumptimes illustrated with vertical bars

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $

[dum,N]=size(th);
if dum>N; th=th'; N=dum; end;

if length(TH)==N;  % New syntax   thplot(th0,threc,thseg)
  h1=plot(th','r');
  hold on
  h2=plot(TH','b--');
  if nargin>2;
    h3=plot(jumptimes','b:');
  else
    h3=[];
  end 
  hold off
else

[n,m]=size(jumptimes);
if n==1; jumptimes=jumptimes'; n=m; end;

jumptimes=[0;jumptimes;N];
th0=[];
for i=2:length(jumptimes);
  th0=[th0 TH(:,i-1)*ones(1,jumptimes(i)-jumptimes(i-1))];
end
hold off
h1=plot(th','-');
hold on
h2=plot(th0',':');
if nargin==4;
  h3=plot(threc','--');
  title('Estimated (solid=smoothed, dashed=recursive) and real (dotted) parameters')
else
  title('Estimated (solid) and real (dotted) parameters')
  h3=[];
end
hold off
xlabel('Sampel number')
end

if nargout>0
  p=[h1 h2 h3];
end



