% Lager en "glattet" versjon av QoM (gjennomsnitt). 
%
% Lager et vindu som forflytter seg en sampel for hver iterajon mens
% gjennomsnittsverien Qmean til QoM innenfor vinduet kalkuleres.
% Kan legge inn grense for amplitude som kanskje kan gjenspeile FM
% (Qmean > g) -> FM? 
%
% g: egendefinert grense QoM niv med FM.
% k1: inneholder all skjringspunktene mellom g og Qmean.
%
% Laget av Stian F. Olsen (2010).
%
%

g = 0.45;   

window = 30; %width(2)/10;  
Qmean = zeros(1,width(2)-window);
sizeQmean = size(Qmean);


for k = 1:width(2)-window
    Qmean(k)= mean(QoM(k:window+k));
end
 
k1 = intersections(1:sizeQmean(2),ones(1,sizeQmean(2))*g,1:sizeQmean(2),Qmean);

%k1(k1 == 0) = [];   % Fjerner element med verdi 0 fra vektor k1

figure(5)
segmentplot(Qmean,k1),hline(g);
title('Gjennomsnittsverdi (Qmean) for QoM med skjringspunkter');