% Funksjon som regner ut sentroiden til et bilde.
%
% Funksjon som har tar bilde eller matrise/vektor som argument. Regner ut
% sentroiden (tyngdepunkte) og viser X og Y koordinatene til punktet. 
%%
%
% EKSEMPEL
% 
%   bilde = imread('test.jpg');
%   [x,y] = centroid(bilde);
%   x
%   y
%   imshow(bilde); impixelinfo
%
%%

function [meanx,meany] = centroid(bilde)

% Sjekker om bildet er RGB (farger) eller grtone. Dersom RGB, konverterer til grtt.    
[x,y,z] = size(bilde);           
                               
if(z==1)
    ;
else
    bilde = rgb2gray(bilde);
end


im = bilde;
[rows,cols] = size(im);
x = ones(rows,1)*[1:cols];    % Lager matrise hvor hver pixel fr en x verdi
y = [1:rows]'*ones(1,cols);   %   "     "     "    "    "    "   "   y    "

area = sum(sum(im));
meanx = sum(sum(double(im).*x))/area;
meany = sum(sum(double(im).*y))/area;
