% Beregne sentroiden til motiongram.
%
% Sentroidene kalkuleres med utgangspunkt i pikselverdier som starter 
% fra toppen av bildet og ker i verdi nedover. Dette frer til at 
% sentroidekurven C er en representasjon av sentrum for bevegelsen i 
% motiongramet speilvent om horisontalplanet. Dette er rettet her ved 
% bruke 1-C (ved bruk av pikselverdi og ikke 0-1 -> hight(1)-C).
%
% width: bredden til motiongram (antall piksler per rad).
% hight: hyden til motiongram (antall piksler per kolonne).
% c: sentroidekurve.
%
% Laget av Stian F. Olsen (2010).
%
%
%%

width = size(mGram(1,:));
hight = size(mGram(:,1));
C = zeros(1,width(2));

%%

for j = 1:width(2)
        [t,C(j)] = centroid(mGram(:,j));
end

c = 1-C/hight(1);
%%

figure(3)
plot(c);
title('Sentroide til motiongram');



