% Lage testsett.
%
% Her lages testsett som skal segmenteres. Kalkulerer variabelverdier for
% hele settet hvor resultatene lagres i en matrise med tre kolonner (en for
% hver variabel).
%
% startSegment: bestemmer hvilket bevegelsesbilde som markerer starten til 
% et segment.
% endSegment: bestemmer hvilket bevegelsesbilde som markerer slutten til et
% segment.
% window: bestemmer lengden p vindu (antall bevegelsesbilder behandlet ved
% hver iterasjon av for-lkken).
% Qmean: gjennomsnitt av QoM.
% QSD: QoM standardavvik.
% CSD: Sentroide standardavvik:
%
% Laget av Stian F. Olsen (2010).
%
%


clear test_sett

for i = 1:sizeFrames(3)
    QoM(i) = sum(sum(mImages(:,:,i)))/(sizeFrames(1)*sizeFrames(2));
end
    
startSegment = 1;
endSegment = length(X);
window = 175;

for k = startSegment:window:endSegment
    if k == startSegment
        a = k;
        b = k+window;
    elseif k+window-1 <= endSegment
        a = k-1;
        b = k+window-1;
    elseif k+window-1 >= endSegment && k+window-1 < endSegment+window
        a = endSegment-window;
        b = endSegment;
    end
    
    CSD = std([X(a:b) Y(a:b)]);
    
    Qmean = sum(QoM(a:b))/window;
   
    QSD = std(QoM(a:b));
    
    test_sett(k,:) = [CSD, Qmean, QSD];
    
end

B = sum(test_sett,2); 
C = B > 0; 
test_sett_8 = test_sett(C,:);