% Her kan det lages treningsett med og uten FM.
%
% Variabelverdier for segmenter med og uten FM lagres i hvert sitt
% treningssett. Hvilke segmenter hvis noen som inneholder FM m kjennes p
% forhnd. Treningssettene er matrise med tre kolonner (en for hver
% variabel).
% startSegment: bestemmer hvilket bevegelsesbilde som markerer starten til 
% et segment.
% endSegment: bestemmer hvilket bevegelsesbilde som markerer slutten til et
% segment.
% window: bestemmer lengden p vindu (antall bevegelsesbilder behandlet ved
% hver iterasjon av for-lkken).
% Qmean: gjennomsnitt av QoM.
% QSD: QoM standardavvik.
% CSD: Sentroide standardavvik:
%
% Laget av Stian F. Olsen (2010).
%
%


clear trening_sett_FM
clear trening_sett_ikkeFM

% Kalkulerer QoM.

for i = 1:sizeFrames(3)
    QoM(i) = sum(sum(mImages(:,:,i)))/(sizeFrames(1)*sizeFrames(2));
end
  
% Lage treningssett med FM

startSegment = 1000;
endSegment = 5022;
window = 175;

for k = startSegment:window:endSegment
    if k == startSegment
        a = k;
        b = k+window;
    elseif k+window-1 <= endSegment
        a = k-1;
        b = k+window-1;
    elseif k+window-1 >= endSegment && k+window-1 < endSegment+window
        a = endSegment-window;
        b = endSegment;
    end
    
    CSD = std([X(a:b) Y(a:b)]);
    
    Qmean = sum(QoM(a:b))/window;
   
    QSD = std(QoM(a:b));
    
    trening_sett_FM(k,:) = [CSD, Qmean, QSD];
    
end

B = sum(trening_sett_FM,2); 
C = B > 0; 
trening_sett_FM_1 = trening_sett_FM(C,:);


% Lage treningssett uten FM

startSegment = 1;
endSegment = 1000;
window = 175;

for k = startSegment:window:endSegment
    if k == startSegment
        a = k;
        b = k+window;
    elseif k+window-1 <= endSegment
        a = k-1;
        b = k+window-1;
    elseif k+window-1 >= endSegment && k+window-1 < endSegment+window
        a = endSegment-window;
        b = endSegment;
    end
    
    CSD = std([X(a:b) Y(a:b)]);
    
    Qmean = sum(QoM(a:b))/window;
   
    QSD = std(QoM(a:b));
    
    trening_sett_ikkeFM(k,:) = [CSD, Qmean, QSD];
    
end

B = sum(trening_sett_ikkeFM,2); 
C = find(B > 0); 
trening_sett_ikkeFM_8 = trening_sett_ikkeFM(C,:);
    
    

