% Generering av bevegelsesbilder (eng: motion image).
%
% Tar inn og behandler to og to frames som danner et bevegelsesbilde.
% Resultatet blir en 3D matrise bestende av bevegelsesbilder hvor antallet
% er n mindre enn antall frames.
%
% mImages: 3D matrise med genererte bevegelsesbilder.
%
% Laget av Stian F. Olsen (2010).
%
%



for i = 1:sizeFrames(3)-1
    
    frame1 = frames(:,:,i);               
    frame2 = frames(:,:,i+1);             
    
    doubleFrame1 = im2double(frame1);
    doubleFrame2 = im2double(frame2);
    
    % kontrast forandring, normalisering, kun 2-D gr
    %dData = imadjust(dData);               
    
    % subtraherer frame(i) med frame(i+1).
    mImage = abs(doubleFrame1 - doubleFrame2);                     
    
    % setter alle verdiene til 'd' som er over 0.04 til 1. Resten blir 0.
    mImage = mImage > 0.04;   
    
    % filtrering, fjerner enslige piksler
    for k = 1:sizeFrames(1)
        for l = 2:sizeFrames(2)-1
            if mImage(k,l) == 1 && (mImage(k,l+1)== 1 || mImage(k,l-1)== 1)
                ;
            else mImage(k,l) = 0;
            end
        end
    end
    mImages(:,:,i) = mImage;
end 
    

