% Her kan standardavvik til sentroidene og QoM for bevegelsesbilder finnes.
%
% Det er her mulig  studere sammensetningen av de kalkulerte variablene 
% ved  plotte dem i 2D eller 3D scatter-plot. Variabelverdiene regnes ut
% for en spesifisert vinduslengde og mellom valgte start- og sluttpunkt.
%
% startSegment: bestemmer hvilket bevegelsesbilde som markerer starten til 
% et segment.
% endSegment: bestemmer hvilket bevegelsesbilde som markerer slutten til et
% segment.
% window: bestemmer lengden p vindu (antall bevegelsesbilder behandlet ved
% hver iterasjon av for-lkken).
% Qmean: gjennomsnitt av QoM.
% QSD: QoM standardavvik.
% CSD: Sentroide standardavvik:
% Cv: Sentroide varians.
%
% Laget av Stian F. Olsen (2010).
%
%


% Regne ut bevegelsesmengden (QoM) til bevegelsesbilder.
for i = 1:sizeFrames(3)
    QoM(i) = sum(sum(mImages(:,:,i)))/(sizeFrames(1)*sizeFrames(2));
end
    
startSegment = 1;
endSegment = 1000;
window = 50;
    
for k = startSegment:window:endSegment
    if k == startSegment
        a = k;
        b = k+window;
    elseif k+window-1 <= endSegment
        a = k-1;
        b = k+window-1;
    elseif k+window-1 >= endSegment && k+window-1 < endSegment+window
        a = endSegment-window;
        b = endSegment;
    end
    
    %CSD = std([X(a:b) Y(a:b)]);
    CSD(k) = std([X(a:b) Y(a:b)]);
    CSD(CSD==0) = [];
    %Cv = var([X(a:b) Y(a:b)]);
    %Cv(k) = var([X(a:b) Y(a:b)]);
    %Cv(Cv==0) = []; 
    %Qmean = sum(Q(a:b))/window;
    Qmean(k) = sum(QoM(a:b))/window;
    Qmean(Qmean==0) = [];
    %QSD = std(Q(a:b));
    QSD(k) = std(QoM(a:b));
    QSD(QSD==0) = [];
end

%scatter(Qmean, CSD,'o','MarkerEdgeColor','k','MarkerFaceColor','k');
%title('P093-T03'),xlabel('Q_m_e_a_n'),ylabel('C_S_D');
%hold on;
    
%scatter3(QSD,Qmean, CSD,'o','MarkerEdgeColor','k','MarkerFaceColor','k');
%title('P093-T03'),xlabel('Q_S_D'),ylabel('Q_m_e_a_n'),zlabel('C_S_D');
%hold on;

