% Lage motiongram ved  sette sammen "gjennomsnittskolonnene" fra alle
% bevegelsesbildene.
%
% Her omgjres ett og ett bevegelsesbilde fra en MxN matrise til en Mx1
% matrise som tilsvarer en kolonnevektor hvor verdien til hvert element er
% gjennomsnittet til den respektive raden i den opprinnelige matrisen.
% Kolonnenen settes s sammen og danner selve bevegelseskurven. Alle
% bokstav-variablene i for-lkkene er kun midlertidige og er derfor ikke
% gitt noe betydningsfult navn.
%
% motiongramH: horisontalt motiongram.
% motiongramV: vertikalt motiongram.
% mImages: 3D matrise med bevegelsesbilder.
%
% Laget av Stian F. Olsen (2010).
%
%

% Forhndsreservering av minne.
motiongramH = zeros(sizeFrames(1),1);
motiongramV = zeros(1,sizeFrames(2));

%Lage horisontale motiongram
for s = 1:sizeFrames(3)-1
    d = mImages(:,:,s);
    for t = 1:sizeFrames(1)
        b(t) = sum(d(t,1:sizeFrames(2)))/sizeFrames(2);
    end
    f = b'*5;
    motiongramH = [motiongramH f];
end

% fjerner den frste kolonnen som kun inneholder 0
motiongramH(:,1) = [];


%Lage vertikale motiongram
for v = 1:sizeFrames(3)-1
    e = mImages(:,:,v);
    for u = 1:sizeFrames(2)
        c(u) = sum(e(1:sizeFrames(1),u))/sizeFrames(1);
    end
    g = c*5;
    motiongramV = [motiongramV; g];
end

% fjerner den frste raden som kun inneholder 0
motiongramV(1,:) = [];