% Her kan man rekursivt estimere modellparametre
% Stian F. Olsen (2009).
%
%
%%
s = 3;                      % Struktnummer (ROI) til data. abnormal 1-48, normal 1-198.
sensorSignal = 1;           % Sensorsignal nummer, 1-7, se data_info.txt for beskrivelse. 
sensorNr = 4;               % Nummer p sensor, 1-6, se data_info.txt for beskrivelse.
p = 4;                      % Orden til modell.
metode = 'ff';              % Valg av metode:  'ff' (glemmefaktor), 'ng' (normalisert gradient),
                            % 'ug' (unormalisert gradient), 'kf' (Kalman filter).
lambda = 0.996;             % Glemmefaktor ved bruk av metode 'ff'.
%fFaktor = 1;                % Forsterkningsfaktor ved bruk av 'ng' eller 'ug'.
%kMatrise = R1;              % Kovariansmatrise ved bruka av 'kf', samme dim som p.                            

%%
metodeVariabel = lambda;    % Justeringsvariabel avhengig av valgt metode.
sigType = abnormal;         % Valg av type signal, abnormal eller normal. 

%%
signal = sigType(s).tab(:,sensorSignal,sensorNr); % Signalet som skal brukes.
thm1 = rarx(signal,p,metode,metodeVariabel); % RARX funksjon.

%%
% Plot av resultatet. Originalt signal og estimerte parametre. Kan plotte 
% hver parameter individuelt ved  bruke: thm(:,1) for theta 1.

figure(1)
subplot(211), plot(signal),title('Sensordata'),xlabel('Sampel'),ylabel('Posisjon 1D signal');
subplot(212), plot(thm1),title('Estimerte parametre'),xlabel('Sampel'),ylabel('Posisjon 1D signal');
legend('theta 1','theta 2','theta 3','theta 4')