
function ms = sec2ms(secs) 

% Konverterer antall sekunder til en minutt-sekund string.
% 
% Denne funksjonen tar inn antall sekunder og konvertere dem til riktig
% kombinasjon av minutter og sekunder. Benytter funksjonen 'rem' som
% er en substrasjonsfunksjon hvor resultatet alltid har samme fortegn som
% det frste argumentet. 'floor' er en funksjon som alltid runder
% desimaltall mot minus uendelig (runder ned).
%
% secs: antall sekunder som skal konverteres.
% s: sekunder.
% m: minutter.
% ms: resultat variabel p formen 00m00s.
%
% Laget av Stian F. Olsen (2010).
%
%

secs = round(secs); 
s = rem(secs, 60); 
m = rem(floor(secs / 60), 60); 
ms = sprintf('%02dm%02ds', m, s); 
