% Omgjr resultatene fra LDA til relevante segmenter.
%
% Tar inn kolonnevektoren Klasse og gjr den om slik at hver rad
% konverteres til sitt respektive bevegelsesbilde og tidspunkt. Den
% modifiserte vektoren lagres som variabelen Segments og denne brukes til 
% presentere segmenterigsresultatene.
%
% Klasse: vektor med rasultatene fra klassifiseringen basert p LDA.
% Segments: modifisert versjon av Klasse som brukes til  representere
% reultater.
%
% Laget av Stian F. Olsen (2010).
%
%

sizeKlasse = size(Klasse);

% Gjr om Klasse dersom kolonnevektor.
if sizeKlasse(1)>=sizeKlasse(2)
    Klasse = Klasse';
else
    ;
end

% Forandrer verdiene som representerer FM (1) til sine respektive
% bevegelsesbilder.
for j = 1:length(Klasse)
    if Klasse(j)==1
        Klasse(j)=j;
    else
        ;
    end
end

% Klasse inneholder n kun segmentnr. som har FM.
Klasse(Klasse==0)=[];

Segments=[];
window = 175;
for j = 1:length(Klasse)
    if Klasse(j)==1
        Segments =[Segments window*j+1-window window*j+1];
    %elseif j==max(Klasse)
        %Segments =[Segments window*j-window window*j];
    else
        Segments =[Segments window*Klasse(j)-window window*Klasse(j)];
    end
end

% Sl sammen nabosegmenter i Segments vektoren. 
for j = 1:length(Segments)-1
    if Segments(j)==Segments(j+1) || Segments(j)>=Segments(j+1)
        Segments(j)=0;
        Segments(j+1)=0;
    else
        ;
    end
end
Segments(Segments==0)=[];


% Skriver hvilke segmenter som inneholder FM til skjerm.

if isempty(Segments);
    segmentsWithFM = sprintf('Fant ingen segmenter med FM!\r');
    disp(segmentsWithFM);
elseif length(Segments)== 2
    segmentsWithFM = sprintf('\rFant 1 segment som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)',Segments(1),Segments(2),sec2ms(Segments(1)/25),sec2ms(Segments(2)/25));
    disp(segmentsWithFM);
elseif length(Segments)== 4
    segmentsWithFM = sprintf('\rFant 2 segmenter som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)\rSegment 2:\t%d - %d\t(%s - %s)',Segments(1),Segments(2),sec2ms(Segments(1)/25),sec2ms(Segments(2)/25),Segments(3),Segments(4),sec2ms(Segments(3)/25),sec2ms(Segments(4)/25));
    disp(segmentsWithFM);
elseif length(Segments)== 6
    segmentsWithFM = sprintf('\rFant 3 segmenter som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)\rSegment 2:\t%d - %d\t(%s - %s)\rSegment 3:\t%d - %d\t(%s - %s)',Segments(1),Segments(2),sec2ms(Segments(1)/25),sec2ms(Segments(2)/25),Segments(3),Segments(4),sec2ms(Segments(3)/25),sec2ms(Segments(4)/25),Segments(5),Segments(6),sec2ms(Segments(5)/25),sec2ms(Segments(6)/25));
    disp(segmentsWithFM);
elseif length(Segments)== 8
    segmentsWithFM = sprintf('\rFant 4 segmenter som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)\rSegment 2:\t%d - %d\t(%s - %s)\rSegment 3:\t%d - %d\t(%s - %s)\rSegment 4:\t%d - %d\t(%s - %s)',Segments(1),Segments(2),sec2ms(Segments(1)/25),sec2ms(Segments(2)/25),Segments(3),Segments(4),sec2ms(Segments(3)/25),sec2ms(Segments(4)/25),Segments(5),Segments(6),sec2ms(Segments(5)/25),sec2ms(Segments(6)/25),Segments(7),Segments(8),sec2ms(Segments(7)/25),sec2ms(Segments(8)/25));
    disp(segmentsWithFM);
elseif length(Segments)== 10
    segmentsWithFM = sprintf('\rFant 5 segmenter som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)\rSegment 2:\t%d - %d\t(%s - %s)\rSegment 3:\t%d - %d\t(%s - %s)\rSegment 4:\t%d - %d\t(%s - %s)\rSegment 5:\t%d - %d\t(%s - %s)',Segments(1),Segments(2),sec2ms(Segments(1)/25),sec2ms(Segments(2)/25),Segments(3),Segments(4),sec2ms(Segments(3)/25),sec2ms(Segments(4)/25),Segments(5),Segments(6),sec2ms(Segments(5)/25),sec2ms(Segments(6)/25),Segments(7),Segments(8),sec2ms(Segments(7)/25),sec2ms(Segments(8)/25),Segments(9),Segments(10),sec2ms(Segments(9)/25),sec2ms(Segments(10)/25));
    disp(segmentsWithFM);
else
    segmentsWithFM = sprintf('\rDet er funnet %d segmenter med FM!\r', length(Segments)/2);
    disp(segmentsWithFM);
end