% Her klassifiseres segmenter til  inneholde FM eller ikke ut i fra
% variabelverdiene Qmean, QSD og CSD. Bruker ikke Cv da dette bare er
% kvadratet av CSD.
%
% Qmean: gjennomsnitt av QoM.
% QSD: QoM standardavvik.
% CSD: Sentroide standardavvik:
% FM: vektor med start- og sluttpunkt for segmenter med FM.
% nonFM: vektor med start- og sluttpunkt for segmenter uten FM.
% window: bestemmer antall bevegelsesbilder som inngr i utregningen av
% variabelverdiene for runde i for-lkken.
%
% Laget av Stian F. Olsen (2010).
%
%

% Regne ut bevegelsesmengden (QoM) til bevegelsesbilder.

for i = 1:sizeFrames(3)
    QoM(i) = sum(sum(mImages(:,:,i)))/(sizeFrames(1)*sizeFrames(2));
end
    
startSegment = 1;
endSegment = length(X);
window = 175;
FM = [];
nonFM = [];
    
for k = startSegment:window:endSegment
    if k == startSegment
        a = k;
        b = k+window;
    elseif k+window-1 <= endSegment
        a = k-1;
        b = k+window-1;
    elseif k+window-1 >= endSegment && k+window-1 < endSegment+window
        a = endSegment-window;
        b = endSegment;
    end
    
    CSD = std([X(a:b) Y(a:b)]);
    
    Qmean = sum(QoM(a:b))/window;
   
    QSD = std(QoM(a:b));
   
    
    if Qmean >= 0.03 && CSD <= 0.1 && QSD >= 0.015
        FM = [FM a b];
    else
        nonFM = [nonFM a b];
    end  
end

% Sl sammen nabosegmenter i FM vektoren. Tar hyde for overlapp mellom
% segment og slr dem sammen. 
sizeFM = size(FM);
for j = 1:sizeFM(2)-1
    if FM(j)==FM(j+1) || FM(j)>=FM(j+1)
        FM(j)=0;
        FM(j+1)=0;
    else
        ;
    end
end
FM(FM==0)=[];

% Sl sammen nabosegmenter i nonFM vektoren.
sizeNonFM = size(nonFM);
for j = 1:sizeNonFM(2)-1
    if nonFM(j)==nonFM(j+1) || nonFM(j)>=nonFM(j+1)
        nonFM(j)=0;
        nonFM(j+1)=0;
    else
        ;
    end
end
nonFM(nonFM==0)=[];


% Skriver hvilke segmenter som inneholder FM til skjerm (resultater).
sizeNewFM = size(FM);

if sizeNewFM(2)== 0;
    segmentsWithFM = sprintf('Fant ingen segmenter med FM!\r');
    disp(segmentsWithFM);
elseif sizeNewFM(2)== 2
    segmentsWithFM = sprintf('\rFant 1 segment som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)',FM(1),FM(2),sec2ms(FM(1)/25),sec2ms(FM(2)/25));
    disp(segmentsWithFM);
elseif sizeNewFM(2)== 4
    segmentsWithFM = sprintf('\rFant 2 segmenter som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)\rSegment 2:\t%d - %d\t(%s - %s)',FM(1),FM(2),sec2ms(FM(1)/25),sec2ms(FM(2)/25),FM(3),FM(4),sec2ms(FM(3)/25),sec2ms(FM(4)/25));
    disp(segmentsWithFM);
elseif sizeNewFM(2)== 6
    segmentsWithFM = sprintf('\rFant 3 segmenter som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)\rSegment 2:\t%d - %d\t(%s - %s)\rSegment 3:\t%d - %d\t(%s - %s)',FM(1),FM(2),sec2ms(FM(1)/25),sec2ms(FM(2)/25),FM(3),FM(4),sec2ms(FM(3)/25),sec2ms(FM(4)/25),FM(5),FM(6),sec2ms(FM(5)/25),sec2ms(FM(6)/25));
    disp(segmentsWithFM);
elseif sizeNewFM(2)== 8
    segmentsWithFM = sprintf('\rFant 4 segmenter som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)\rSegment 2:\t%d - %d\t(%s - %s)\rSegment 3:\t%d - %d\t(%s - %s)\rSegment 4:\t%d - %d\t(%s - %s)',FM(1),FM(2),sec2ms(FM(1)/25),sec2ms(FM(2)/25),FM(3),FM(4),sec2ms(FM(3)/25),sec2ms(FM(4)/25),FM(5),FM(6),sec2ms(FM(5)/25),sec2ms(FM(6)/25),FM(7),FM(8),sec2ms(FM(7)/25),sec2ms(FM(8)/25));
    disp(segmentsWithFM);
elseif sizeNewFM(2)== 10
    segmentsWithFM = sprintf('\rFant 5 segmenter som inneholder FM!\r\rSegment 1:\t%d - %d\t(%s - %s)\rSegment 2:\t%d - %d\t(%s - %s)\rSegment 3:\t%d - %d\t(%s - %s)\rSegment 4:\t%d - %d\t(%s - %s)\rSegment 5:\t%d - %d\t(%s - %s)',FM(1),FM(2),sec2ms(FM(1)/25),sec2ms(FM(2)/25),FM(3),FM(4),sec2ms(FM(3)/25),sec2ms(FM(4)/25),FM(5),FM(6),sec2ms(FM(5)/25),sec2ms(FM(6)/25),FM(7),FM(8),sec2ms(FM(7)/25),sec2ms(FM(8)/25),FM(9),FM(10),sec2ms(FM(9)/25),sec2ms(FM(10)/25));
    disp(segmentsWithFM);
else
    segmentsWithFM = sprintf('\rDet er funnet %d segmenter med FM!\r', sizeNewFM(2)/2);
    disp(segmentsWithFM);
end


    
    
% scatter(Qmean, CSD,'o','MarkerEdgeColor','k','MarkerFaceColor','k');
% title('P093-T03'),xlabel('Q_m_e_a_n'),ylabel('C_S_D');
% hold on;
%     
% scatter3(QSD,Qmean, CSD,'o','MarkerEdgeColor','k','MarkerFaceColor','k');
% title('P093-T03'),xlabel('Q_S_D'),ylabel('Q_m_e_a_n'),zlabel('C_S_D');
% hold on;

