function h=segmentplot(signal,segpkt)

% Plotter aktuelt signal med segmenteringslinjer.
%
% segmentplot(signal,segpkt);
%
% h1: plot av aktuelt signal.
% h2: plot av segmenteringslinjer.
% signal: aktuelt signal.
% segpkt: segmenteringspunkter.
%
% Laget av Stian F. Olsen (2010).
%
%

segpkt=segpkt(:);
hold off
h1=plot(signal,'k');
hold on
dum=axis;
h2=plot([segpkt segpkt]',[dum(3)*ones(size(segpkt)) dum(4)*ones(size(segpkt))]','r-','LineWidth',1);
hold off
title('Signal med segmentering')
xlabel('Sampel nummer')
if isempty(h2); 
  h=h1;
else
  h=[h1(:);h2(1)];
end

