% Segmenter funnet av segm_LDA markeres p QoM-plot eller i motiongram. 
% 
% QoM: bevegelsesmengden til motiongram (mGram).
% Segments: liste med hvert segmenteringspunkt.
% newMgram: motiongram som markeres med segmenteringslinjer.
%
% Laget av Stian F. Olsen (2010).
%
%


% Gjr om det siste segmentet dersom det overskrider lengden til bildet.
sizeSegments = size(Segments);
if max(Segments)>= length(mGram)
    Segments(sizeSegments(2))=length(mGram);
end

% Genererer QoM til det aktuelle motiongramet.
length = size(mGram(1,:));
hight = size(mGram(:,1));
QoM = zeros(1,length(2));

for i = 1:length(2)
        QoM(i) = sum(mGram(:,i))/hight(1);
end

% Markerer segmenteringsgrenser p motiongram.
figure(1)
newMgram = mGram;
for f = 1:sizeSegments(2)
    newMgram(:,Segments(f):Segments(f)+5) = 1;
end

imshow(newMgram);

% Plotter QoM sammen med segmenteringsgrenser.
figure(2)
segmentplot(QoM,Segments);
title('Signal med segmenteringslinjer (LDA)');
ylabel('QoM'),xlabel('Sampel nummer');