function out1=guidetect(action,arg1,arg2,arg3)

% Graphical user interface

% Copyright Fredrik Gustafsson, Sigmoid AB
% $  Revision: 1.0, 07-Aug-2003  $

%#
%#  
  
global CDHchangedesign
global FILTER SIM RESULT
global history z jhat thhat thseg threc th0 datatype gt ta options
global detectnnn simmodel simnnn simN simjhat simthhat simlamhat 
global MCN simu simPhi gt
global MSrec MSseg Vseg Vrec
global figpos comptime 
global designpar simmodel detectmodeltype 
global detecttype olddetecttype datatype datafilename userplotname
global simssmodel simsstype filtssmodel filtsstype
global guirec guirecfile

if nargin==0; guirec=0; options=[0 0 0]; action='init|blockplot'; end;

% Colors from book
%      [cover,covermap]=imread('coverpart.jpg');
%      image(cover), colormap(covermap);
%      pause
fgdarkblue=[0*16+7 0*16+0 3*16+1]/256;     %07 06 31
fgblue=[2*16+10 6*16+1 10*16+3]/256;       %2a 61 a3
fglightblue=[7*16+9 12*16+5 13*16+14]/256; %79 c5 de
fgred=[15*16+15 10*16+10 10*16+10]/256;        %ff aa aa

grey=0.83*[1 1 1];
darkgrey=0.75*[1 1 1];
white=[1 1 1];
blue=[.8 .8 1];
blue=[.6 .6 1];
lightblue=[.8 .8 1];
mycol=[0.9 1 1];
framecolor=grey;
maincolor=darkgrey;
execcolor=blue;
uicolor=grey;

%===== nested calls ========
ind=find('|'==action);   
if isempty(ind) & ( options(3) | guirec );  % save single calls only
   if nargout==0;
      outargstring=[];
   else
      outargstring='out1=';
   end
   inargstring=[];
   if nargin>1;
      if ischar(arg1)
         inargstring=[inargstring,',''',arg1,''''];
      else
         inargstring=[inargstring,',',cdnum2str(arg1)];
      end
   end
   if nargin>2;
      if ischar(arg2)
         inargstring=[inargstring,',''',arg2,''''];
      else
         inargstring=[inargstring,',',cdnum2str(arg2)];
      end
   end
   if nargin>3;
      if ischar(arg3)
         inargstring=[inargstring,',''',arg3,''''];
      else
         inargstring=[inargstring,',',cdnum2str(arg3)];
      end
   end
   call=[outargstring,'guidetect(''',action,'''',inargstring,')'];
   if options(3)
      disp(call)
   end
   if guirec
      disp(call)
      fprintf(guirec,[call,' \n']);
   end
   
end

if ~isempty(ind);
  ind=[0 ind length(action)+1];
  for i=1:length(ind)-1;
    guidetect(action(ind(i)+1:ind(i+1)-1))
  end;
  action='none';  % Finished
end;

ind=find(' '==action);  % remove spaces
if ~isempty(ind);
  action=action(1:ind(1)-1);
end;

if ~isempty(options);
  if options(2)==1;
    disp(action)
  end
end


%====== Set up main window ==============
if strcmp(action,'blockplot')

  guidetect('blockdiagram');

end;   % blockplot

if strcmp(action,'blockclose') 
  options(3)=0;
  guidetect('blockplot')
end

if strcmp(action,'blocksimu') 
  % First test version
  designpar;
%  [sizes,xsimu]=ssimu([],[],[],0,simnnn);
%  [sizes,xfilt]=sfilt([],[],[],0,detectnnn);
%  [sizes,xdetect]=sdetect1([],[],[],designpar(2,:));
  GT=zeros(1,simN);
  threc=zeros(d,simN);
  ta=[];
  
  for t=1:simN;
 
%   xsimu=ssimu(t,xsimu,simu,2);
%    y=ssimu(t,xsimu,simu,3);
%    xfilt=sfilt(t,xfilt,u,2,detectnnn)
%    xdetect=sdetect1(t,xdetect,epsi/sqrt(S),2);
%    alarm=sdetect1(t,xdetect,epsi/sqrt(S),3);

    GT(t)=xdetect(1); 
    threc(:,t)=xhat;
    if alarm~=0; 
      ta=[ta t]; 
      xfilt(:,5:4+d)=10*Xfilt(:,5:4+d);
    end;
  end
  
end;



if strcmp(action,'mainsim') 
global CDHmainsim
%xxx2
   %arg1=1/0

  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','mainsim');
  onhandle=onhandle(1);
  fighandle=findobj(0,'Tag','figmainsim');
  if nargin>1;
     set(onhandle,'Value',arg1);
  end
      
  if get(onhandle,'Value');
    if isempty(fighandle);
      fighandle=figure(...
       'Units','pixels',...
       'Position',[figpos(28,1:4)],...
       'Units','normalized',...
       'Color',maincolor,...
       'Name','Data Generation',...
       'NumberTitle','off',...
       'MenuBar','none',...
       'BackingStore','off',...
       'Visible','on',...
       'HandleVisibility','on',...
       'Tag','figmainsim');

      Pos=[...
	     10  330 130 20;...
	     150 330 130 20;...
	     10  300 130 20;...
	     10  260 130 20;...
	     150 260 130 20;...
	     10 240  250 20;...
	     10 225  250 20;...
	     10 205 100 20;...
	     10 205 100 20;...
	     10 205 100 20;...
	     120 205  20 20;...
	     140 205  30 20;...
	     180 205  20 20;...
	     200 205  30 20;...
	     240 205  20 20;...
	     260 205  30 20;...
	     120 205 100 20;...
	     10  180 70 20;...
	     10  180 90 20;...
	     100  180 120 20;...
	     235 180 45 20;...
	     10  140 130 20;...
	     150 140 130 20;...
	     10  110 130 20;...
	     150 110 130 20;...
	     10   80 130 20;...
	     150  80 130 20;...
	     10   50 130 20;...
	     150  50 130 20;...
	     ];
      LastPos=[...
  	      45  10  60 20;...
	     115  10  60 20;...
	     185  10  60 20;...
      ];

      FramePos=[...
               5 45 290 120;...
               5 175 290 110;...
               5 295 290 60];

      for i=1:3
        uicontrol(gcf,'Style','Frame',...
          'Units','pixels',...
          'Backgroundcolor',darkgrey,...
          'Position',FramePos(i,:),...
          'Units','normalized');
      end

      uicontrol(gcf,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',LastPos(1,:),...
               'Units','normalized',...
	       'String','OK',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''OKmainsim'')');

      uicontrol(gcf,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',LastPos(2,:),...
               'Units','normalized',...
	       'String','Help',...
	       'BackGroundColor',grey,...
       	       'Callback','guihelp(''mainsim'')');

      uicontrol(gcf,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',LastPos(3,:),...
               'Units','normalized',...
	       'String','Close',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''closemainsim'')');


  Strings=str2mat('Data from File:',' ',...
       'Simulated Data');

  Strings=str2mat(Strings,...
       'Model structure',...
       'Variance change|Mean Change|Regression|AR|ARX|State Space',' ',' ');
      Strings=str2mat(Strings,...
       'AR order:','ARX orders:','State space m-file','na',' ','nb',' ','nk',' ',' ');
      Strings=str2mat(Strings,...
       'Input u(t):','Regressor phi(t):','From workspace|Noise with variance',' ');
      Strings=str2mat(Strings,...
       'Number of data:',...
       ' ','Change times:',' ','Parameter vectors:',...
       ' ','Noise variance(s):',' ');


      Styles=str2mat('RadioButton','Edit','RadioButton',...
     'Text','PopUp','Text','Text','Text','Text','Text');
      Styles=str2mat(Styles,...
          'Text','Edit','Text','Edit','Text','Edit','Edit');

      Styles=str2mat(Styles,'Text','Text','PopUp','Edit');
      Styles=str2mat(Styles,'Text','Edit','Text','Edit','Text','Edit','Text','Edit');


      Tags=str2mat('loaddata','datafile','simudata');
      Tags=str2mat(Tags,...
         ' ','ms','cm1','cm2');
      Tags=str2mat(Tags,...
         ' ',' ',' ',' ','na',' ','nb',' ','nk','nnnfile');
      Tags=str2mat(Tags,...
         ' ',' ','utype','u');
      Tags=str2mat(Tags,' ','simN',' ','simjhat',' ','simthhat',' ','simlamhat');
      Tags=str2mat(Tags,' ',' ',' ',' ',' ');

      m=29;
      ind=[1 3 5 20 30];
      for i=1:length(ind);
        Callbacks(ind(i),:)=['guidetect(''getmainsim'',',num2str(i),')'];
      end


      Colors=ones(m,1)*darkgrey;
      ind=find(Styles(:,1)=='E');
      Colors(ind,:)=ones(length(ind),1)*[1 1 1];
      ind=find(Styles(:,1)=='P');
      Colors(ind,:)=ones(length(ind),1)*grey;

% size(Strings),size(Styles),size(Callbacks),size(Tags),size(Strings),size(Colors),size(Pos),
m1=1; m2=m;
ss=setstr(32*ones(m2-m1+1,2));
%[num2str((m1:m2)'),ss,Styles(m1:m2,:),ss,Strings(m1:m2,1:25),ss,Callbacks(m1:m2,1:end),ss,Tags(m1:m2,:),ss,num2str(Pos(m1:m2,:))]

      for i=1:m;
        ind=findstr('  ',Strings(i,:));
        if ~isempty(ind); 
          text=Strings(i,1:ind(1)-1); 
        else
          text=Strings(i,:);
        end;
        ind=findstr(' ',Tags(i,:));
        if ~isempty(ind); 
          tag=Tags(i,1:ind(1)-1);
        else
          tag=Tags(i,:);
        end;
        CDHmainsim(i)=uicontrol(gcf,'Style',Styles(i,:),...
                'Units','pixels',...
                'Position',Pos(i,:),...
                'Units','normalized',...
   	        'String',text,...
   	        'Tag',tag,...
	        'CallBack',Callbacks(i,:),...
                'HorizontalAlignment','Left',...
	        'BackGroundColor',Colors(i,:));
      end;
      guidetect('updatemainsim')
    else
      figure(fighandle);
      set(fighandle,'Visible','on');
    end;
  elseif fighandle~=0
    set(fighandle,'Visible','off')
    mainhandle=findobj('Tag','block');
    onhandle=findobj(mainhandle,'Tag','mainsim');
    set(onhandle,'Value',0);
  end;
end     % action=mainsim

if strcmp(action,'closemainsim') 
  fighandle=findobj('Tag','figmainsim');
  set(fighandle,'Visible','off');
  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','mainsim');
  onhandle=onhandle(1);
  set(onhandle,'Value',0);
end

if strcmp(action,'getmainsim') 
  % arg1=1 (load) or 2 (simulate)
  fighandle=findobj('Tag','figmainsim');
  if arg1==1
    h1=findobj(fighandle,'Tag','loaddata');
    h2=findobj(fighandle,'Tag','simudata');
    h3=findobj(fighandle,'Tag','datafile');
    set(h1,'Value',1);
    set(h2,'Value',0);
    SIM.datatype=arg1;
    SIM.nnn.datafile=get(h3,'String');
 elseif arg1==2
    h1=findobj(fighandle,'Tag','loaddata');
    h2=findobj(fighandle,'Tag','simudata');
    set(h1,'Value',0);
    set(h2,'Value',1);
    SIM.datatype=arg1;
  elseif arg1==3
    handle=findobj(fighandle,'Tag','ms');
    SIM.modeltype=get(handle,'Value');
  elseif arg1==4
    handle=findobj(fighandle,'Tag','utype');
    SIM.nnn.utype=get(handle,'Value');
  end

  guidetect('updatemainsim')
  guidetect('blockplot');
end

if strcmp(action,'updatemainsim')
global CDHmainsim

  mainhandle=findobj('Tag','block');
  fighandle=findobj(0,'Tag','figmainsim');
  if ~isempty(fighandle);
    set(fighandle,'HandleVisibility','on');

    handle=findobj(fighandle,'Tag','ms');
    set(handle,'Value',SIM.modeltype);
    h1=findobj(fighandle,'Tag','loaddata');
    h2=findobj(fighandle,'Tag','simudata');
    if SIM.datatype==1;
      set(h1,'Value',1);
      set(h2,'Value',0);
      set(CDHmainsim([4:29]),'Visible','off');
    elseif SIM.datatype==2;
      set(h1,'Value',0);
      set(h2,'Value',1);
      set(CDHmainsim([4:29]),'Visible','on');
    end

    handle=findobj(fighandle,'Tag','cm1');
    set(handle,'String',SIM.nnn.title1(SIM.modeltype,:));
    handle=findobj(fighandle,'Tag','cm2');
    set(handle,'String',SIM.nnn.title2(SIM.modeltype,:));


    set(CDHmainsim([8:21]),'Visible','off');
    if SIM.datatype==2;
      if SIM.modeltype==1;
        simNstring=cdnum2str(SIM.m(1).N);
        simthhatstring=cdnum2str(SIM.m(1).thhat);
        simlamhatstring=cdnum2str(SIM.m(1).lamhat);
        simjhatstring=cdnum2str(SIM.m(1).jhat);
      elseif SIM.modeltype==2;
        simNstring=cdnum2str(SIM.m(2).N);
        simthhatstring=cdnum2str(SIM.m(2).thhat);
        simlamhatstring=cdnum2str(SIM.m(2).lamhat);
        simjhatstring=cdnum2str(SIM.m(2).jhat);
      elseif SIM.modeltype==3;
        simNstring=cdnum2str(SIM.m(3).N);
        simthhatstring=cdnum2str(SIM.m(3).thhat);
        simlamhatstring=cdnum2str(SIM.m(3).lamhat);
        simjhatstring=cdnum2str(SIM.m(3).jhat);
        set(CDHmainsim([19 20 21]),'Visible','on');
        handle=findobj(fighandle,'Tag','utype');
        set(handle,'Value',SIM.nnn.utype);
        handle=findobj(fighandle,'Tag','u');
        set(handle,'String',SIM.nnn.u{SIM.nnn.utype});
      elseif SIM.modeltype==4;
        simNstring=cdnum2str(SIM.m(4).N);
        simthhatstring=cdnum2str(SIM.m(4).thhat);
        simlamhatstring=cdnum2str(SIM.m(4).lamhat);
        simjhatstring=cdnum2str(SIM.m(4).jhat);
        set(CDHmainsim([8 11 12]),'Visible','on');
        handle=findobj(fighandle,'Tag','na');
        set(handle,'String',SIM.nnn.ar);
      elseif SIM.modeltype==5;
        simNstring=cdnum2str(SIM.m(5).N);
        simthhatstring=cdnum2str(SIM.m(5).thhat);
        simlamhatstring=cdnum2str(SIM.m(5).lamhat);
        simjhatstring=cdnum2str(SIM.m(5).jhat);
        set(CDHmainsim([9 11:16]),'Visible','on');
        handle=findobj(fighandle,'Tag','na');
        set(handle,'String',SIM.nnn.arx(1));
        handle=findobj(fighandle,'Tag','nb');
        set(handle,'String',SIM.nnn.arx(2));
        handle=findobj(fighandle,'Tag','nk');
        set(handle,'String',SIM.nnn.arx(3));
        set(CDHmainsim([18 20 21]),'Visible','on');
        handle=findobj(fighandle,'Tag','utype');
        set(handle,'Value',SIM.nnn.utype);
        handle=findobj(fighandle,'Tag','u');
        set(handle,'String',SIM.nnn.u{SIM.nnn.utype});
      elseif SIM.modeltype==6;
        simNstring=cdnum2str(SIM.m(6).N);
        simthhatstring=cdnum2str(SIM.m(6).thhat);
        simlamhatstring=cdnum2str(SIM.m(6).lamhat);
        simjhatstring=cdnum2str(SIM.m(6).jhat);
        set(CDHmainsim([10 17]),'Visible','on');
        handle=findobj(fighandle,'Tag','nnnfile');
        set(handle,'String',SIM.nnn.ss);
        set(CDHmainsim([18 20 21]),'Visible','on');
        handle=findobj(fighandle,'Tag','utype');
        set(handle,'Value',SIM.nnn.utype);
        handle=findobj(fighandle,'Tag','u');
        set(handle,'String',SIM.nnn.u{SIM.nnn.utype});
      end
      handle=findobj(fighandle,'Tag','simN');
      set(handle,'String',simNstring);
      handle=findobj(fighandle,'Tag','simjhat');
      set(handle,'String',simjhatstring);
      handle=findobj(fighandle,'Tag','simthhat');
      set(handle,'String',simthhatstring);
      handle=findobj(fighandle,'Tag','simlamhat');
      set(handle,'String',simlamhatstring);
    else
      handle=findobj(fighandle,'Tag','datafile');
      set(handle,'String',SIM.nnn.datafile);
    end
    set(gcf,'HandleVisibility','Callback');
  end
end

if strcmp(action,'OKmainsim')
  fighandle=findobj('Tag','figmainsim');

  if SIM.datatype==2;
    if SIM.modeltype==1;
      handle=findobj(fighandle,'Tag','simN');
      SIM.m(1).N=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simjhat');
      SIM.m(1).jhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simthhat');
      SIM.m(1).thhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simlamhat');
      SIM.m(1).lamhat=str2num(get(handle,'String'));

    elseif SIM.modeltype==2;
      handle=findobj(fighandle,'Tag','simN');
      SIM.m(2).N=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simjhat');
      SIM.m(2).jhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simthhat');
      SIM.m(2).thhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simlamhat');
      SIM.m(2).lamhat=str2num(get(handle,'String'));
    elseif SIM.modeltype==3;
      handle=findobj(fighandle,'Tag','simN');
      SIM.m(3).N=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simjhat');
      SIM.m(3).jhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simthhat');
      SIM.m(3).thhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simlamhat');
      SIM.m(3).lamhat=str2num(get(handle,'String'));

      handle=findobj(fighandle,'Tag','u');
      SIM.nnn.u{SIM.nnn.utype}=get(handle,'String');
    elseif SIM.modeltype==4;
      handle=findobj(fighandle,'Tag','simN');
      SIM.m(4).N=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simjhat');
      SIM.m(4).jhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simthhat');
      SIM.m(4).thhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simlamhat');
      SIM.m(4).lamhat=str2num(get(handle,'String'));

      handle=findobj(fighandle,'Tag','na');
      SIM.nnn.ar=str2num(get(handle,'String'));
    elseif SIM.modeltype==5;
      handle=findobj(fighandle,'Tag','simN');
      SIM.m(5).N=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simjhat');
      SIM.m(5).jhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simthhat');
      SIM.m(5).thhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simlamhat');
      SIM.m(5).lamhat=str2num(get(handle,'String'));

      handle=findobj(fighandle,'Tag','na');
      SIM.nnn.arx(1)=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','nb');
      SIM.nnn.arx(2)=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','nk');
      SIM.nnn.arx(3)=str2num(get(handle,'String'));
    elseif SIM.modeltype==6;
      handle=findobj(fighandle,'Tag','simN');
      SIM.m(6).N=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simjhat');
      SIM.m(6).jhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simthhat');
      SIM.m(6).thhat=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','simlamhat');
      SIM.m(6).lamhat=str2num(get(handle,'String'));

      handle=findobj(fighandle,'Tag','nnnfile');
      SIM.nnn.ss=get(handle,'String'); 
    end
    handle=findobj(fighandle,'Tag','simN');
    SIM.N=str2num(get(handle,'String'));
    handle=findobj(fighandle,'Tag','simjhat');
    SIM.jhat=str2num(get(handle,'String'));
    handle=findobj(fighandle,'Tag','simthhat');
    SIM.thhat=str2num(get(handle,'String'));
    handle=findobj(fighandle,'Tag','simlamhat');
    SIM.lamhat=str2num(get(handle,'String'));
    handle=findobj(fighandle,'Tag','u');
    SIM.nnn.u{SIM.nnn.utype}=get(handle,'String');
  else
    handle=findobj(fighandle,'Tag','datafile');
    SIM.nnn.datafile=get(handle,'String');
  end
end

	   
if strcmp(action,'SIMview')
  disp('Matlab object SIM')
  disp('Do global SIM in workspace to get the variables')
  SIM.m(SIM.modeltype)
  SIM.nnn
end

if strcmp(action,'SIMinit')
  SIM=[];
  SIM.modeltype=2;
  SIM.datatype=2;
  SIM.m(1).N=100;
  SIM.m(1).jhat=50;
  SIM.m(1).thhat=[1 4];
  SIM.m(1).lamhat=[1 1];
  SIM.m(2).N=100;
  SIM.m(2).jhat=50;
  SIM.m(2).thhat=[1 4];
  SIM.m(2).lamhat=[1 1];
  SIM.m(3).N=100;
  SIM.m(3).jhat=50;
  SIM.m(3).thhat=[1 4];
  SIM.m(3).lamhat=[1 1];
  SIM.m(4).N=100;
  SIM.m(4).jhat=50;
  SIM.m(4).thhat=[1.6 0.4; 0.64 0.04];
  SIM.m(4).lamhat=[1 1];
  SIM.m(5).N=100;
  SIM.m(5).jhat=50;
  SIM.m(5).thhat=[1.6 .4; 0.64 0.04; 1 1; 0.5 0.5];
  SIM.m(5).lamhat=[1 1];
  SIM.m(6).N=100;
  SIM.m(6).jhat=50;
  SIM.m(6).thhat=[5;10];
  SIM.m(6).lamhat=[1 1];

  SIM.nnn.datafile='fuel';
  SIM.nnn.ar=2;
  SIM.nnn.arx=[2 2 1];
  SIM.nnn.ss='nnnDCm0';
  SIM.nnn.utype=2;
  SIM.nnn.u={'usim','1'};

  SIM.nnn.title1=str2mat('y(t) = e(t)','y(t) = theta(t) + e(t)','y(t) = phi^T(t) theta(t) + e(t)','A(q,theta(t)) y(t) = e(t)','A(q,theta(t)) y(t) = B(q,theta(t)) u(t) + e(t)','x(t+1) = A x(t) + B u(t) + v(t) + delta(t-k) theta');
  SIM.nnn.title2=str2mat('E e^2(t) piecewise constant','theta(t) piecewise constant','theta(t) piecewise constant','theta(t) piecewise constant','theta(t) piecewise constant','y(t) = C x(t) + e(t)');

end


if strcmp(action,'mainmodel') 

  fighandle=findobj(0,'Tag','figmainmodel');
  if ~isempty(fighandle);
    close(fighandle)
  end 
  fighandle=figure('Position',[figpos(29,1:2) 220 300],...
       'Color',maincolor,...
       'Name','Residual Generation Model',...
       'NumberTitle','off',...
       'Visible','on',...
       'MenuBar','none',...
       'BackingStore','off',...
       'HandleVisibility','on',...
       'Tag','figmainmodel');

  Pos=[...
	     10  270 200 25;...
	     10  230 200 25;...
	     10  200 200 25;...
	     10  170 200 25;...
	     10  140 200 25;...
	     10  110 200 25;...
	     10  80  200 25;...
	     10   50 200 25;...
	     40  10  60 25;...
	     120  10  60 25;...
	     ];

	   

Tags=str2mat('detmod','detmod1','detmod2','detmod3','detmod4','detmod5','detmod6','detmod7',' ',' ');
    
Styles=str2mat('Text','RadioButton','RadioButton','RadioButton','RadioButton','RadioButton','RadioButton','RadioButton','PushButton','PushButton');

Strings=str2mat('Model Structure','lambda change','Mean change','Linear regression','AR','ARX','State space','General Filter','Help','Close');

Callbacks=str2mat(' ',...
'guidetect(''setmodel'',1)',...
'guidetect(''setmodel'',2)',...
'guidetect(''setmodel'',3)',...
'guidetect(''setmodel'',4)',...
'guidetect(''setmodel'',5)',...
'guidetect(''setmodel'',6)',...
'guidetect(''setmodel'',7)',...
'guihelp(''detmod'')',...
'guidetect(''closemainmodel'')');

[m,n]=size(Callbacks);
Colors=ones(m,1)*uicolor;

for i=1:-m;
  [cdnum2str(Pos(i,:)), Styles(i,:),Strings(i,1:8),Callbacks(i,1:8),Tags(i,:), cdnum2str(Colors(i,:))]
end


for i=1:m;
  ind=findstr('  ',Strings(i,:));
  if ~isempty(ind); 
    text=Strings(i,1:ind(1)-1); 
  else
    text=Strings(i,:);
  end;
  ind=findstr(' ',Tags(i,:));
  if ~isempty(ind); 
    tag=Tags(i,1:ind(1)-1); 
  else
    tag=Tags(i,:);
  end;
  uicontrol(gcf,'Style',Styles(i,:),...
                'Units','pixels',...
                'Position',Pos(i,:),...
   	        'String',text,...
   	        'Tag',tag,...
	        'CallBack',Callbacks(i,:),...
	        'BackGroundColor',Colors(i,:));
     end;



  detectmodeltype=modeltype(detectnnn)+1;
  guidetect('setmodel',detectmodeltype)
%  guidetect('adfilterpar')
  guidetect('changedesign')
end

if strcmp(action,'adfilterpar');
   fighandle=findobj(0,'Tag','figmainmodel');
   figure(fighandle);
   pos=get(gcf,'Position');
   set(gcf,'Position',[pos(1) pos(2) 640 pos(4)]);
   set(gcf,'Name','Adaptive filter design')
   
   menupos=[230 40 200 200;... 		% Frame 2
	     240 200 180 20;...
	     240 175 180 20;...
	     240 150 180 20;...
	     240 125 180 20;...
	     240 100 180 20;...
	     240  75 180 20;...
	     240  50 180 20;...
	     340  10 50 20;...
	     405  10 50 20;...
	     370  10 50 20;...
	     ];
     
     menupos2=[430 40 200 200;... 		% Frame 3
	     440 200 180 20;...
	     440 125 80 20;...
	     530 125 90 20;...
	     440 100 80 20;...
	     530 100 90 20;...
	     440  75 80 20;...
	     530  75 90 20;...
	     440  50 80 20;...
	     530  50 90 20;...
	     ];


    uicontrol(gcf,'Style','Frame',...
               'Units','pixels',...
               'Position',menupos(1,:),...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2,:),...
	       'String','ADAPTATION METHOD',...
	       'BackGroundColor',grey);

       
    uicontrol(gcf,'Style','Frame',...
               'Units','pixels',...
               'Position',menupos2(1,:),...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(2,:),...
	       'String','ADAPTATION GAIN',...
	       'BackGroundColor',grey);
	   
    adg=designpar(1,1);
    if any(designpar(1,3:size(designpar,2)));  % Q is a matrix
       [dum,d]=z2phi(z,0,detectnnn);
       if size(designpar,2)>1+d*d
         Q=zeros(d,d);
         Q(:)=designpar(1,3:2+d*d)';
         adg=Q;
       end
    end
    adg=cdnum2str(adg);
    
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Adaptation method',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','PopUp',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String','RLS|WLS|LMS|NLMS|KF',...
	       'Tag','adm',...
	       'Value',abs(designpar(1,2)),...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(3,:),...
	       'String',['Adaptation gain'],...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
	       'String',adg,...
               'Position',menupos2(4,:),...
	       'Tag','adg',...
	       'BackGroundColor','w');
end
    
    
if strcmp(action,'detect1par');
   fighandle=findobj(0,'Tag','figmainmodel');
   figure(fighandle);
   pos=get(gcf,'Position');
   set(gcf,'Position',[pos(1) pos(2) 640 pos(4)]);
   menupos=[230 40 200 200;... 		% Frame 2
	     240 200 180 20;...
	     240 175 180 20;...
	     240 150 180 20;...
	     240 125 180 20;...
	     240 100 180 20;...
	     240  75 180 20;...
	     240  50 180 20;...
	     340  10 50 20;...
	     405  10 50 20;...
	     370  10 50 20;...
	     ];
     
     menupos2=[430 40 200 200;... 		% Frame 3
	     440 200 180 20;...
	     440 125 80 20;...
	     530 125 90 20;...
	     440 100 80 20;...
	     530 100 90 20;...
	     440  75 80 20;...
	     530  75 90 20;...
	     440  50 80 20;...
	     530  50 90 20;...
	     ];

  
   
          set(gcf,'Name','One-model design')
	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Distance measure',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','PopUp',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String','Residual|Squared residual',...
	       'Tag','dm',...
	       'Value',abs(designpar(2,1)),...
	       'BackGroundColor',grey);
	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(5,:),...
	       'String','Stopping rule',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','PopUp',...
               'Units','pixels',...
               'Position',menupos(6,:),...
	       'String','CUSUM, one-sided|CUSUM, two-sided|GMA, one-sided|GMA, two-sided',...
	       'BackGroundColor',grey,...
	       'Tag','sr',...
	       'Value',abs(designpar(2,2)));
     dm=designpar(detecttype,1);
     sr=designpar(detecttype,2);
       
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(3,:),...
	       'String',['Threshold'],...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(4,:),...
	       'String',num2str(designpar(detecttype,3)),...
	       'Tag','h',...
	       'BackGroundColor','w');
	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(5,:),...
	       'String','Drift/forgetting',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(6,:),...
	       'String',num2str(designpar(detecttype,4)),...
	       'Tag','nuorgam',...
	       'BackGroundColor','w');
	     
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(7,:),...
	       'String','Noise scaling',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(8,:),...
	       'String',num2str(designpar(detecttype,6)),...
	       'Tag','lam',...
	       'BackGroundColor','w');
	     

end
    
if strcmp(action,'detect2par');
   fighandle=findobj(0,'Tag','figmainmodel');
   figure(fighandle);
   pos=get(gcf,'Position');
   set(gcf,'Position',[pos(1) pos(2) 640 pos(4)]);
   
   set(gcf,'Name','Two model design')
	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Distance measure',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','PopUp',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String','Brandt''s GLR|Divergence test|Mean',...
	       'Tag','dm',...
	       'Value',abs(designpar(3,1)),...
	       'BackGroundColor',grey);

	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(5,:),...
	       'String','Stopping rule',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','PopUp',...
               'Units','pixels',...
               'Position',menupos(6,:),...
	       'String','CUSUM, one-sided|CUSUM, two-sided|GMA, one-sided|GMA, two-sided|Bayes',...
	       'Tag','sr',...
	       'Value',abs(designpar(3,2)),...
	       'BackGroundColor',grey);

	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(7,:),...
	       'String',['Size of sliding window'],...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos(8,:),...
	       'Tag','L',...
	       'String',num2str(designpar(3,5)),...
          'BackGroundColor','w');
       
       
     dm=designpar(detecttype,1);
     sr=designpar(detecttype,2);
       
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(3,:),...
	       'String',['Threshold'],...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(4,:),...
	       'String',num2str(designpar(detecttype,3)),...
	       'Tag','h',...
	       'BackGroundColor','w');
	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(5,:),...
	       'String','Drift/forgetting',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(6,:),...
	       'String',num2str(designpar(detecttype,4)),...
	       'Tag','nuorgam',...
	       'BackGroundColor','w');
	     
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(7,:),...
	       'String','Noise scaling',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(8,:),...
	       'String',num2str(designpar(detecttype,6)),...
	       'Tag','lam',...
	       'BackGroundColor','w');
	     
       
end
    
if strcmp(action,'segmpar');
   fighandle=findobj(0,'Tag','figmainmodel');
   figure(fighandle);
   pos=get(gcf,'Position');
   set(gcf,'Position',[pos(1) pos(2) 640 pos(4)]);
   menupos=[230 40 200 200;... 		% Frame 2
	     240 200 180 20;...
	     240 175 180 20;...
	     240 150 180 20;...
	     240 125 180 20;...
	     240 100 180 20;...
	     240  75 180 20;...
	     240  50 180 20;...
	     340  10 50 20;...
	     405  10 50 20;...
	     370  10 50 20;...
	     ];
     
     menupos2=[430 40 200 200;... 		% Frame 3
	     440 200 180 20;...
	     440 125 80 20;...
	     530 125 90 20;...
	     440 100 80 20;...
	     530 100 90 20;...
	     440  75 80 20;...
	     530  75 90 20;...
	     440  50 80 20;...
	     530  50 90 20;...
	     ];

   
      set(gcf,'Name','Multi-model design of SEGM')
      
      uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Distance measure',...
	       'BackGroundColor',grey);

      uicontrol(gcf,'Style','PopUp',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String','MAP, known noise var|MAP, unknown noise var|MDL/BIC|AIC',...
	       'Tag','dm',...
	       'Value',abs(designpar(4,1)),...
	       'BackGroundColor',grey);
	   
     uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(3,:),...
	       'String',['lambda'],...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(4,:),...
	       'String',num2str(designpar(detecttype,2)),...
	       'Tag','lam',...
	       'BackGroundColor','w');
	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(5,:),...
	       'String','Jump probability',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(6,:),...
	       'String',num2str(designpar(detecttype,3)),...
	       'Tag','q',...
	       'BackGroundColor','w');
	     
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(7,:),...
	       'String','Number of filters',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(8,:),...
	       'String',num2str(designpar(detecttype,4)),...
	       'Tag','M',...
	       'BackGroundColor','w');
	     
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(9,:),...
	       'String','Life length',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(10,:),...
	       'String',num2str(designpar(detecttype,5)),...
	       'Tag','ll',...
	       'BackGroundColor','w');
	 
end
    

if strcmp(action,'glrpar');
   fighandle=findobj(0,'Tag','figmainmodel');
   figure(fighandle);
   pos=get(gcf,'Position');
   set(gcf,'Position',[pos(1) pos(2) 640 pos(4)]);
   menupos=[230 40 200 200;... 		% Frame 2
	     240 200 180 20;...
	     240 175 180 20;...
	     240 150 180 20;...
	     240 125 180 20;...
	     240 100 180 20;...
	     240  75 180 20;...
	     240  50 180 20;...
	     340  10 50 20;...
	     405  10 50 20;...
	     370  10 50 20;...
	     ];
     
     menupos2=[430 40 200 200;... 		% Frame 3
	     440 200 180 20;...
	     440 125 80 20;...
	     530 125 90 20;...
	     440 100 80 20;...
	     530 100 90 20;...
	     440  75 80 20;...
	     530  75 90 20;...
	     440  50 80 20;...
	     530  50 90 20;...
	     ];



   set(gcf,'Name','Multi-model design of GLR')
      
      uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Mode',...
	       'BackGroundColor',grey);

      uicontrol(gcf,'Style','PopUp',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String','Exact GLR|Approximate GLR|Gaussian prior',...
	       'Tag','mode',...
	       'Value',abs(designpar(5,1)),...
	       'BackGroundColor',grey);
	   
     uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(3,:),...
	       'String',['Window (mode 2)'],...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(4,:),...
	       'String',num2str(designpar(5,2)),...
	       'Tag','L',...
	       'BackGroundColor','w');
	   
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(5,:),...
	       'String','Threshold',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(6,:),...
	       'String',num2str(designpar(5,3)),...
	       'Tag','h',...
	       'BackGroundColor','w');
	     
    uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(7,:),...
	       'String','Scaling (mode 3)',...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(8,:),...
	       'String',num2str(designpar(5,4)),...
	       'Tag','pnu',...
	       'BackGroundColor','w');
	     
    end
    
if strcmp(action,'mlrpar');
   fighandle=findobj(0,'Tag','figmainmodel');
   figure(fighandle);
   pos=get(gcf,'Position');
   set(gcf,'Position',[pos(1) pos(2) 640 pos(4)]);
   menupos=[230 40 200 200;... 		% Frame 2
	     240 200 180 20;...
	     240 175 180 20;...
	     240 150 180 20;...
	     240 125 180 20;...
	     240 100 180 20;...
	     240  75 180 20;...
	     240  50 180 20;...
	     340  10 50 20;...
	     405  10 50 20;...
	     370  10 50 20;...
	     ];
     
     menupos2=[430 40 200 200;... 		% Frame 3
	     440 200 180 20;...
	     440 125 80 20;...
	     530 125 90 20;...
	     440 100 80 20;...
	     530 100 90 20;...
	     440  75 80 20;...
	     530  75 90 20;...
	     440  50 80 20;...
	     530  50 90 20;...
	     ];


      set(gcf,'Name','Multi-model design of MLR')
      
      uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Noise assumption',...
	       'BackGroundColor',grey);

      uicontrol(gcf,'Style','PopUp',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String','Known noise level|Unknown constant noise level|Unknown changing noise level',...
	       'Tag','lf',...
	       'Value',abs(designpar(6,1)),...
	       'BackGroundColor',grey);
	   
     uicontrol(gcf,'Style','Text',...
               'Units','pixels',...
               'Position',menupos2(3,:),...
	       'String',['Known noise'],...
	       'BackGroundColor',grey);

    uicontrol(gcf,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos2(4,:),...
	       'String',num2str(designpar(6,2)),...
	       'Tag','lam',...
	       'BackGroundColor','w');
end	   
	   


if strcmp(action,'closemainmodel') 
  fighandle=findobj('Tag','figmainmodel');
  set(fighandle,'Visible','off');
end


if strcmp(action,'setmodel');
  % arg1=modeltype
  Nmodelchoices=7;
  if nargin<2; arg1=1; end;   % obsolete
  detectmodeltype=arg1;
  if detectmodeltype==7;
    guidetect('disp','Not yet implemented');
  end
  mainhandle=findobj('Tag','figmainmodel');
  if ~isempty(mainhandle);
    for i=1:Nmodelchoices,
      handle(i)=findobj(mainhandle,'Tag',['detmod',num2str(i)]);
      set(handle(i),'Value',0);
    end
    set(handle(detectmodeltype),'Value',1),
  end
  handle=findobj('Tag','arorder');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','simarxorder');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','detectarxorder');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','ABCDsim');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','ABCDdetect');
  if ~isempty(handle); close(handle); end;
  guidetect('blocksigupdate');
  guidetect('detectpar');
end

	   
if strcmp(action,'maindetector') 
   %arg1=1/0

  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','maindetector');
  fighandle=findobj(0,'Tag','figmaindetector');
  if nargin>1;
     set(onhandle,'Value',arg1);
  else
    FILTER.detecttype=get(onhandle,'Value');
  end
  guidetect('blockplot');   %update block diagram
%  guidetect('blocksigupdate');  
  guidetect('updatechangedesign');  
  FILTER.olddetecttype=FILTER.detecttype;
end

if strcmp(action,'maindetectorold') 
   %arg1=1/0

  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','maindetector');
  fighandle=findobj(0,'Tag','figmaindetector');
  if nargin>1;
     set(onhandle,'Value',arg1);
  end
      
  if get(onhandle,'Value');
    if isempty(fighandle);
      fighandle=figure('Position',[figpos(30,1:2) 220 280],...
       'Color',maincolor,...
       'Name','Block diagram',...
       'NumberTitle','off',...
       'Visible','on',...
       'MenuBar','none',...
       'BackingStore','off',...
       'IntegerHandle','off',...
       'HandleVisibility','on',...
       'Tag','figmaindetector');

  Pos=[...
	     10  240 200 25;...
	     10  200 200 25;...
	     10  170 200 25;...
	     10  140 200 25;...
	     10  110 200 25;...
	     10  80  200 25;...
	     10   50 200 25;...
	     40  10  60 25;...
	     120  10  60 25;...
	     ];


Tags=str2mat(...
  'detect','detect1','detect2','detect3','detect4','detect5','detect6',' ',' ');
    
Styles=str2mat(...
'Text','Radiobutton','Radiobutton','Radiobutton','Radiobutton','Radiobutton','Radiobutton','Pushbutton','Pushbutton');

Strings=str2mat(...
'Choose structure on block diagram','Adaptive filter','One-model','Two-model','SEGM','GLR','MLR','Help','Close');

Callbacks=str2mat(' ',...
'guidetect(''setdetector'',1)',...
'guidetect(''setdetector'',2)',...
'guidetect(''setdetector'',3)',...
'guidetect(''setdetector'',4)',...
'guidetect(''setdetector'',5)',...
'guidetect(''setdetector'',6)',...
'guihelp(''detector'')',...
'guidetect(''closemaindetector'')');

[m,n]=size(Callbacks);
Colors=ones(m,1)*darkgrey;

for i=1:m;
  ind=findstr('  ',Strings(i,:));
  if ~isempty(ind); 
    text=Strings(i,1:ind(1)-1); 
  else
    text=Strings(i,:);
  end;
  ind=findstr(' ',Tags(i,:));
  if ~isempty(ind); 
    tag=Tags(i,1:ind(1)-1); 
  else
    tag=Tags(i,:);
  end;
  uicontrol(gcf,'Style','Frame',...
                'Units','pixels',...
                'Position',Pos(i,:)+[-1 -1 2 2],...
	       'BackGroundColor',darkgrey);
  uicontrol(gcf,'Style',Styles(i,:),...
                'Units','pixels',...
                'Position',Pos(i,:),...
   	        'String',text,...
   	        'Tag',tag,...
	        'CallBack',Callbacks(i,:),...
	        'BackGroundColor',Colors(i,:));
end;
set(gcf,'HandleVisibility','Callback');

    else
      figure(fighandle);
      set(fighandle,'Visible','on');
    end;
  elseif fighandle~=0
    set(fighandle,'Visible','off')
    mainhandle=findobj('Tag','block');
    onhandle=findobj(mainhandle,'Tag','adaptivetool');
    set(onhandle,'Value',0);
  end;
guidetect('setdetector',detecttype)
end     % action=maindetector
	   
if strcmp(action,'closemaindetector')
  fighandle=findobj(0,'Tag','figmaindetector');
  set(fighandle,'Visible','off')
  fighandle=findobj(0,'Tag','block');
  handle=findobj(0,'Tag','maindetector');
  set(handle,'Value',0);
end;

if strcmp(action,'setdetector');
  % arg1=detecttype
  Ndetectchoices=6;
  if nargin<2; arg1=1; end;   % obsolete
  FILTER.detecttype=arg1;
  mainhandle=findobj('Tag','figmaindetector');
  if ~isempty(mainhandle);
    for i=1:Ndetectchoices,
      handle(i)=findobj(mainhandle,'Tag',['detect',num2str(i)]);
      set(handle(i),'Value',0);
    end
    set(handle(FILTER.detecttype),'Value',1),
  end
  if FILTER.detecttype~=FILTER.olddetecttype;
    guidetect('blockplot');   %update block diagram
    guidetect('blocksigupdate');  
 end
  FILTER.olddetecttype=FILTER.detecttype;
end





if strcmp(action,'figpos')
  % arg1 = 0 values for 600*800 pixel resolution
  % arg1 = 1 default position values
  % arg1 = 2 load position values from cdfigpos.mat
  % arg1 = 3 save position values as cdfigpos.mat

  if ~exist('arg1')
    if exist('cdfigpos')
      arg1=2;
    else
      arg1=1;
    end
  end
  s=get(0,'ScreenSize');
  maxx=s(3);
  maxy=s(4);
  if arg1==1;  
    figpos=[0.01 .3 .6 .35;...  % 1 main not used anymore
        10 maxy-260 700 200;...   % 2 block diagram
        0.1   0.1   0.4 0.4;...   % 3 figlook
        400 500 0 0        ;...   % 4 figzoom
        10 450 500 270;...   % 5 figsimdes
        10 20 0 0       ;...   % 6 figplottool
        maxx-420 maxy-350 400 300;...   % 7 figvalvis
        maxx-420 350 400 300;...   % 8 figvalusr
        maxx-420 350 400 300;...   % 9 figvalpar
        maxx-420 250 400 300;...   % 10 figvalrms
        maxx-420 50 400 300;...   % 11 figvaltes
        0.05 0.1 0.35 0.22;...   % 12 figsimsetup
        200 500 0 0       ;...   % 13 figarorder
        220 520 0 0       ;...   % 14 figarxorder
        240 540 0 0       ;...   % 15 ABCDsim/detect
        10 maxy-260-460 0 0        ;...   % 16 figchangetool
        400 50 0 0        ;...   % 17 figautotuning
        20 40 730 350;...   % 18 figMCtab
        240 maxy-260-320 0 0         ;...   % 19 figadaptivetool
        50 40 800 350;...   % 20 figtabdesign
        0.55  0.1    0.4  0.4  ;...   % 21 figaddesign
        0.05 0.65   0.3  0.3  ;...   % 22 figmc1
        0.35 0.65   0.3  0.3  ;...   % 23 figmc2
        0.65 0.65   0.3  0.3  ;...   % 24 figmc3
        300 50 0 0            ;...   % 25 figmcdata
        0.65  0.65   0.3 0.3 ;...   % 26 GUI demo
        0.65   0.3   0.3 0.3 ;...   % 27 GUI help
        10  50   300 360 ;...   % 28 mainsim
        300  50   0.0 0.0 ;...   % 29 mainmodel
        200  50   0.5 0.3 ;...   % 30 maindetect
	];
      handle=findobj('Tag','block');
      if ~isempty(handle);
	set(handle,'Position',figpos(2,:));
      end
  end
  if arg1==0;     % 800x600
    figpos=[0.01 .05 .7 .45;...  % 1 main
        0.01   0.55 0.75 .35;...   % 2 block
        0.01   0.01   0.5 0.5;...   % 3 figlook
        0.11   0.3 0.25 0.25;...   % 4 figzoom
        0.03 0.45 0.6 0.4;...   % 5 figsimdes
        10 10 0 0;...   % 6 figplottool
        400 50 400 300;...   % 7 figvalvis
        350 50 400 300;...   % 8 figvalusr
        200 50 400 300;...   % 9 figvalpar
        250 50 400 300;...   % 10 figvalrms
        200 50 400 300;...   % 11 figvaltes
        0.05 0.4 0.5 0.4;...   % 12 figsimsetup
        0.05 0.56 0.25 0.17;...   % 13 figarorder
        0.07 0.46 0.25 0.24;...   % 14 figarxorder
        0.09 0.44 0.4 0.3;...   % 15 ABCDsim/detect
        0.1 0.04 0.3 0.42;...   % 16 figchangetool
        0.4 0.04 0.35 0.25;...   % 17 figautotuning
        0.25 0.04 0.75 0.6;...   % 18 figMCtab
        0.07 0.04 0.5 0.5;...   % 19 figadaptivetool
        0.25 0.04 0.75 0.55;...   % 20 figtabdesign
        0.01    0.6   0.35  0.35  ;...   % 21 figaddesign
        0.05 0.6   0.3  0.3  ;...   % 22 figmc1
        0.35 0.6   0.3  0.3  ;...   % 23 figmc2
        0.65 0.6   0.3  0.3  ;...   % 24 figmc3
        0.4  0.12   0.35 0.25 ;...   % 25 figmcdata
        0.58  0.52   0.4 0.4 ;...   % 26 GUI demo
        0.58  0.25   0.4 0.4 ;...   % 27 GUI help
        100  200   0.0 0.0 ;...   % 28 mainsim
        300  200   0.0 0.0 ;...   % 29 mainmodel
        500  200   0.5 0.3 ;...   % 30 maindetect
	];
      handle=findobj('Tag','main');
      set(handle,'Position',figpos(1,:));
      handle=findobj('Tag','block');
      if ~isempty(handle);
	set(handle,'Position',figpos(2,:));
      end
  end
  if arg1==2;
    load cdfigpos.mat
  end
  if arg1==3;
    h=findobj('Tag','main');
    if ~isempty(h);
      figpos(1,:)=get(h(1),'Position');
    end
    h=findobj('Tag','block');
    if ~isempty(h);
      figpos(2,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figlook');
    if ~isempty(h);
      figpos(3,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figzoom');
    if ~isempty(h);
      figpos(4,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figsimdes');
    if ~isempty(h);
      figpos(5,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figplottool');
    if ~isempty(h);
      figpos(6,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figvalvis');
    if ~isempty(h);
      figpos(7,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figvalusr');
    if ~isempty(h);
      figpos(8,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figvalpar');
    if ~isempty(h);
      figpos(9,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figvalrms');
    if ~isempty(h);
      figpos(10,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figvaltes');
    if ~isempty(h);
      figpos(11,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figsimsetup');
    if ~isempty(h);
      figpos(12,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figarorder');
    if ~isempty(h);
      figpos(13,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figarxorder');
    if ~isempty(h);
      figpos(14,:)=get(h(1),'Position');
    end
    h=findobj('Tag','ABCDsim');
    if ~isempty(h);
      figpos(14,:)=get(h(1),'Position');
    end
    h=findobj('Tag','ABCDdetect');
    if ~isempty(h);
      figpos(15,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figchangetool');
    if ~isempty(h);
      figpos(16,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figautotuning');
    if ~isempty(h);
      figpos(17,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figMCtab');
    if ~isempty(h);
      figpos(18,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figadaptivetool');
    if ~isempty(h);
      figpos(19,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figtabdesign');
    if ~isempty(h);
      figpos(20,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figaddesign');
    if ~isempty(h);
      figpos(21,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figmc1');
    if ~isempty(h);
      figpos(22,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figmc2');
    if ~isempty(h);
      figpos(23,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figmc3');
    if ~isempty(h);
      figpos(24,:)=get(h(1),'Position');
    end
    h=findobj('Tag','figmcdata');
    if ~isempty(h);
      figpos(25,:)=get(h(1),'Position');
    end
    save cdfigpos figpos
  end;
end

if strcmp(action,'changeoptions')
  options(arg1)=xor(options(arg1),1)';
end;

if strcmp(action,'simmodel') 
  % arg1=simmodel
  if nargin<2;
    mainhandle=findobj('Tag','figmainsim');
    handle=findobj(mainhandle,'Tag','simmodel');
    simmodel=get(handle,'Value');
    guidetect('simmodel',simmodel);   % For logging
  else
    simmodel=arg1;

  if simmodel==1;
    simnnn=0;
  elseif simmodel==2;
    simnnn=-1;
  elseif simmodel==3;
    simnnn=-2;
    guidetect('phi','sim');
  elseif simmodel==4;
    guidetect('simarorder','sim')
  elseif simmodel==5;
    guidetect('simarxorder','sim')
    guidetect('u');
  elseif simmodel==6;
    guidetect('simABCD','sim')
    guidetect('u');
  elseif simmodel==7;
    simmodel=detectmodeltype;
    simnnn=detectnnn;
  end;
  end
  guidetect('blocksigupdate');
end;

if strcmp(action,'datalook')
  mainhandle=findobj(0,'Tag','figplottool');
  handle=findobj(mainhandle,'Tag','look');
  fighandle=findobj(0,'Tag','figlook');
  if get(handle,'Value');
    if isempty(z)
       guidetect('disp','Warning: No data to show!','r')
       return
    end

    if isempty(fighandle);
      fighandle=figure('Tag','figlook',...
        'Units','normalized',...
        'Position',figpos(3,:),...
        'Name','Data',...
        'MenuBar','none',...
        'HandleVisibility','on',...
        'NumberTitle','off');
      handle=uimenu(gcf,'Label','Signals');
      uimenu(handle,'Label','All',...
                   'Callback','guidetect(''datalook'',0)');
      for i=1:size(z,2);     
        uimenu(handle,'Label',['Signal ',num2str(i)],...
        'Callback',['guidetect(''datalook'',',num2str(i),')']);
      end
    else
      figure(fighandle);
    end;

    [N,nz]=size(z);
    
    if ~exist('arg1')    % First call
      arg1=0;
    end
    if arg1==0;
      zind=1:nz;    % plot all signals by default
    else
      zind=arg1;
    end
	   
    zoomhandle=findobj('Tag','figzoom');
    if ~isempty(zoomhandle);
      handle1=findobj(zoomhandle(1),'Tag','slizoom1');
      handle2=findobj(zoomhandle(1),'Tag','slizoom2');
      sli_zoom1=get(handle1(1),'Value');
      sli_zoom2=get(handle2(1),'Value');
      start=sli_zoom1*N;
      stop=sli_zoom2*N;
      zoomvalue=[start stop];
    else
      zoomvalue=[1 N];
    end
      
    if 1==1;   %nz==1; 
%      segplot(z(:,zind),zoomvalue)
      figure(fighandle);
      if length(zind)>1;
	plot(z(:,zind))
      else
        c='bgrcmyb';
	plot(z(:,zind),c(rem(zind-1,length(c))+1))   % Same color as before
      end
      hold on
      dum=axis;
      zoomvalue=zoomvalue(:);
      plot([zoomvalue zoomvalue]',...
	[dum(3)*ones(size(zoomvalue)) dum(4)*ones(size(zoomvalue))]','b-')
      hold off
      title(['Signal number ',cdnum2str(zind)])
      fcn=['plot(z(:,',cdnum2str(zind),'))'];
    else
      subplot(211)
      segplot(z(:,1),zoomvalue)
      title('Data output')
      subplot(212)
      segplot(z(:,2:nz),zoomvalue)
      title('Data input')
      fcn='subplot(211), plot(z(:,1)), subplot(212), plot(z(:,2:nz))';
    end
    if options(1)==1; disp(fcn); end
    [nr,nc]=size(history);
    history=[history;fcn setstr(32*ones(1,nc-length(fcn)))];
  else
    if ~isempty(fighandle);
      close(fighandle)
    end
  end
end

if strcmp(action,'datazoom')
  mainhandle=findobj('Tag','figplottool');
  onhandle=findobj(mainhandle,'Tag','look');
  fighandle=findobj(0,'Tag','figzoom');
if get(onhandle,'Value');
  if isempty(fighandle);
    fighandle=figure('Tag','figzoom',...
      'Units','pixels',...
      'Position',[figpos(4,1:2) 200 150],...
      'Name','Data Zoom',...
      'MenuBar','none',...
      'HandleVisibility','on',...
      'NumberTitle','off');
  else
    figure(fighandle);
  end;
  menupos=[  0    0 200 150;... 		% Frame 2
	     10  130 180 20;...
	     10  110 180 20;...
	     10   90 180 20;...
	     10   70 180 20;...
	     10   50 180 20;...
	     10  10  50 20;...
	     75  10  50 20;...
	     140  10  50 20;...
	     ];

  uicontrol(fighandle,'Style','Frame',...
               'Units','pixels',...
               'Position',menupos(1,:),...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2,:),...
	       'String','Data Zoom',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Starting point',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Slider',...
               'Units','pixels',...
               'Tag','slizoom1',...
	       'Position',menupos(4,:),...
	       'Value',0,...
	       'Callback','guidetect(''datalook'')');

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(5,:),...
	       'String','Ending point',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Slider',...
               'Units','pixels',...
               'Tag','slizoom2',...
               'Position',menupos(6,:),...
	       'Value',1,...
	       'Callback','guidetect(''datalook'')');

  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(7,:),...
	       'String','OK',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''datacut'');');

  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(8,:),...
	       'String','Help',...
	       'BackGroundColor',grey,...
       	       'Callback','guihelp(''zoom'');');

  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(9,:),...
	       'String','Close',...
	       'BackGroundColor',grey,...
          'Callback','guidetect(''closezoom'')');
  else
    if ~isempty(fighandle);
      close(fighandle)
    end
  end
end

if strcmp(action,'closezoom')
  fighandle=findobj(0,'Tag','figzoom');
  close(fighandle)
end

if strcmp(action,'datacut')
    mainhandle=findobj('Tag','main');
    zoomhandle=findobj('Tag','figzoom');
    [N,nz]=size(z);
    if ~isempty(zoomhandle);
      handle1=findobj(zoomhandle(1),'Tag','slizoom1');
      handle2=findobj(zoomhandle(1),'Tag','slizoom2');
      sli_zoom1=get(handle1(1),'Value');
      sli_zoom2=get(handle2(1),'Value');
      start=sli_zoom1*N;
      stop=sli_zoom2*N;
    else
      start=1;
      stop=N;
    end
    z=z(max([round(start) 1]):round(stop),:);
    guidetect('datazoom')
    guidetect('datalook')
end
  
if strcmp(action,'loaddata'),
  %datatype=1;
  %mainhandle=findobj('Tag','figmainsim');
  %handle=findobj(mainhandle,'Tag','nnnfile');
  %file=get(handle,'String');
  if exist([SIM.nnn.datafile,'.mat'])
    file=SIM.nnn.datafile;
    fcn=['load ',file];
    if options(1)==1; disp(fcn); end
    global z
    feval('load',file);
    RESULT.z=z;
    [nr,nc]=size(history);
    history=[history;fcn setstr(32*ones(1,nc-length(fcn)))];
    th0=zeros(1,length(z));
    threc=th0; thseg=th0;
    guidetect('disp',['Data loaded from ''',file,'.mat''']);
 else
    guidetect('disp',['Warning: File ',datafilename,' not found!'],'r');
 end
 
    
 end;


if strcmp(action,'startdetect'),
  if isempty(z);
    guidetect('disp','There are no data! Simulate or load data first','r'), return
  end
  if FILTER.modeltype==1;
    nnn=0;
  elseif FILTER.modeltype==2;
    nnn=-1;
  elseif FILTER.modeltype==3;
    nnn=-2;
  elseif FILTER.modeltype==4;
    nnn=FILTER.nnn.ar;
  elseif FILTER.modeltype==5;
    nnn=FILTER.nnn.arx;
  elseif FILTER.modeltype==6;
    nnn=FILTER.nnn.ss;
  end
  if isstr(nnn)
    nnnstring=nnn;
  else
    nnnstring=cdnum2str(nnn);
  end

  if FILTER.detecttype==1;
    m=FILTER.adfilter.adm;
    if m==1;
      adm='RLS';
    elseif m==2;
      adm='WLS';
    elseif m==3;
      adm='LMS';
    elseif m==4;
      adm='NLMS';
    elseif m==5;
      adm='KF';
    end
    adg=FILTER.adfilter.adg(FILTER.adfilter.adm);

    fcn=['threc=adfilter(z,',nnnstring,...
       ',',cdnum2str(adg),',''',adm,'''); jhat=[]; ta=[];'];

    threc=adfilter(z,nnn,adg,adm);
    thseg=zeros(size(threc));
 
    RESULT.threc=threc;
    RESULT.thseg=thseg;

  elseif FILTER.detecttype==2;
    dm=FILTER.detect1.dm;
    sr=FILTER.detect1.sr;
    h=FILTER.detect1.h;
    nuorgam=FILTER.detect1.nuorgam;
    lam=FILTER.detect1.lam;

    [threc,jhat,thseg,gt,ta]=detect1(z,nnn,dm,[sr h nuorgam],lam);
    fcn=['[threc,jhat,thseg,gt,ta]=detect1(z,',nnnstring,',',num2str(dm),',[',num2str(sr),' ',num2str(h),' ',num2str(nuorgam),'],',num2str(lam),');'];

    RESULT.threc=threc;
    RESULT.thseg=thseg;
    RESULT.jhat=jhat;
    RESULT.gt=gt;
    RESULT.ta=ta;

  elseif FILTER.detecttype==3;
    dm=FILTER.detect2.dm;
    sr=FILTER.detect2.sr;
    h=FILTER.detect2.h;
    nuorgam=FILTER.detect2.nuorgam;
    lam=FILTER.detect2.lam;
    L=FILTER.detect2.L;

    [threc,jhat,thseg,gt,ta]=detect2(z,nnn,dm,[sr h nuorgam],L,lam);
    fcn=['[threc,jhat,thseg,gt,ta]=detect2(z,',nnnstring,',',num2str(dm),',[',num2str(sr),' ',num2str(h),' ',num2str(nuorgam),'],',num2str(L),',',num2str(lam),');'];
    RESULT.threc=threc;
    RESULT.thseg=thseg;
    RESULT.jhat=jhat;
    RESULT.gt=gt;
    RESULT.ta=ta;

  elseif FILTER.detecttype==4;
      lf=FILTER.detectM.lf;
      lam=FILTER.detectM.lambda;
      q=FILTER.detectM.q;
      M=FILTER.detectM.M;
      lifelength=FILTER.detectM.lifelength;
      minseg=FILTER.detectM.minseg;
      if M<0; [dum,d]=z2phi(z,0,detectnnn); M=8+d; end;
      [threc,jhat,thseg,lamhat,alpha]=detectM(z,nnn,[lf lam],q,[M lifelength minseg]);
      gt=exp(-abs(alpha)); 
      ta=[jhat]+M;
      fcn=['[threc,jhat,thseg,lamhat,alpha]=detectM(z,',nnnstring,',',cdnum2str([lf lam]),',',num2str(q),',',cdnum2str([M lifelength minseg]),');'];

    RESULT.threc=threc;
    RESULT.thseg=thseg;
    RESULT.jhat=jhat;
    RESULT.gt=gt;
    RESULT.ta=ta;

  elseif FILTER.detecttype==5;
      mode=designpar(5,1);
      M=designpar(5,2);
      h=designpar(5,3);
      pnu=designpar(5,4);
      if mode==1;
	M=-1;
      end
      fcn=['[Xhat,jhat,ta,lr,nuhat]=glr(z,',nnnstring,',',num2str(M),',',num2str(h),',',num2str(pnu),');'];
      [Xhat,jhat,ta,lr,nuhat]=glr(z,nnn,M,h,pnu);
      gt=lr; ta=ta; jhat=jhat; threc=Xhat; thseg=zeros(size(threc)); 
      nuhat;

    RESULT.threc=threc;
    RESULT.thseg=thseg;
    RESULT.jhat=jhat;
    RESULT.gt=gt;
    RESULT.ta=ta;

  elseif FILTER.detecttype==6;
    lf=designpar(5,1:2);
    fcn=['[jhat,lr]=mlr(z,',nnnstring,',[',num2str(lf(1)),' ',num2str(lf(2)),']);'];
    [jhat]=mlr(z,nnn,lf);
    gt=lr; ta=[jhat]; threc=[]; thseg=[];
    RESULT.threc=threc;
    RESULT.thseg=thseg;
    RESULT.jhat=jhat;
    RESULT.gt=gt;
    RESULT.ta=ta;
  end;

  if options(1)==1; disp(fcn); end
  [nr,nc]=size(history);
  history=[history;fcn setstr(32*ones(1,nc-length(fcn)))];

  % Compute some norms
  if size(th0)==size(threc);
    MSrec=(th0-threc).^2;
    sqrt(sum(sum(MSrec))/length(z));
    MSseg=(th0-thseg).^2;
  else
    MSrec=0;
    MSseg=0;
  end
  epsiseg=simresid(z,nnn,thseg);
  epsirec=simresid(z,nnn,threc);
  [t0,d]=z2phi(z,0,nnn);
  N=length(z);
  Vseg=sum(sum(epsiseg(t0+d+1:N).^2))/(N-t0-d);
  Vrec=sum(sum(epsirec(t0+d+1:N).^2))/(N-t0-d);

  RESULT.mc.MSrec=MSrec;
  RESULT.mc.MSseg=MSseg;
  RESULT.mc.Vrec=Vrec;
  RESULT.mc.Vseg=Vseg;
 
  guidetect('disp','Data filtered')
  guidetect('plottool')
end;


%  Filter object
if strcmp(action,'FILTERview')
  disp('Matlab object FILTER')
  disp('Do global FILTER in workspace to get the variables')
  FILTER
  FILTER.nnn
  FILTER.adfilter
  FILTER.detect1
  FILTER.detect2
end

if strcmp(action,'FILTERinit')
  FILTER=[];
  FILTER.detecttype=1;
  FILTER.olddetecttype=1;
  FILTER.modeltype=2;
  FILTER.structure='Adaptive filter';
  FILTER.nnn.ar=2;
  FILTER.nnn.arx=[2 2 1];
  FILTER.nnn.ss='nnnDCm0';

  FILTER.adfilter.adg=[0.95 10 0.05 0.05 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=1;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=10;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=1;
  FILTER.detect2.sr=1;
  FILTER.detect2.h=10;
  FILTER.detect2.nuorgam=1;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;
  FILTER.detectM.q=0.5;
  FILTER.detectM.M=10; 
  FILTER.detectM.lf=2;
  FILTER.detectM.minseg=0;
  FILTER.detectM.lifelength=6;
  FILTER.detectM.lambda=1;

  FILTER.adfilter.title='Adaptive filter';

  FILTER.detect1.title='One-model change detector';
  FILTER.detect1.htext='Threshold h';
  FILTER.detect1.lamtext='Noise scaling lambda';
  FILTER.detect1.nutext=str2mat('Drift nu','Drift nu','Forgetting factor','Forgetting factor');
  FILTER.detect2.title='Two-model change detector';
  FILTER.detect2.htext='Threshold h';
  FILTER.detect2.lamtext='Noise scaling lambda';
  FILTER.detect2.nutext=str2mat('Drift nu','Drift nu','Forgetting factor','Forgetting factor');


  FILTER.nnn.title1=str2mat('y(t) = e(t)','y(t) = theta(t) + e(t)','y(t) = phi^T(t) theta(t) + e(t)','A(q,theta(t)) y(t) = e(t)','A(q,theta(t)) y(t) = B(q,theta(t)) u(t) + e(t)','x(t+1) = A x(t) + B u(t) + v(t) + delta(t-k) theta');
  FILTER.nnn.title2=str2mat('E e^2(t) piecewise constant','theta(t) piecewise constant','theta(t) piecewise constant','theta(t) piecewise constant','theta(t) piecewise constant','y(t) = C x(t) + e(t)');


end


%  Result object
if strcmp(action,'RESULTview')
  disp('Matlab object RESULT')
  disp('Do global RESULT in workspace to get the variables')
  RESULT
end

if strcmp(action,'RESULTinit')
  RESULT.z=[];
  RESULT.threc=[];
  RESULT.thseg=[];
  RESULT.jhat=[];
  RESULT.gt=[];
  RESULT.ta=[];
  RESULT.lamhat=[];
  RESULT.comptime=0;
  RESULT.mc.N=[];
  RESULT.mc.MSrec=[];
  RESULT.mc.MSseg=[];
  RESULT.mc.Vrec=[];
  RESULT.mc.Vseg=[];
  RESULT.mc.FA=[];
  RESULT.mc.TA=[];
  RESULT.mc.dfd=[];
end

if strcmp(action,'updatechangedesign')
global CDHchangedesign
%CDHchangedesign

  mainhandle=findobj('Tag','block');
  fighandle=findobj('Tag','figsimdes');
  if ~isempty(CDHchangedesign);
  if ~isempty(fighandle);
    handle=findobj(fighandle,'Tag','cm1');
    set(handle,'String',FILTER.nnn.title1(FILTER.modeltype,:));
    handle=findobj(fighandle,'Tag','cm2');
    set(handle,'String',FILTER.nnn.title2(FILTER.modeltype,:));

    if FILTER.detecttype==1;
      set(fighandle,'Name','Adaptive filter design parameters')
      ind=(1:length(CDHchangedesign));
      set(CDHchangedesign(ind),'Visible','off');
      ind=[1 2 3 4 5 16 17 19 20];
      set(CDHchangedesign(ind),'Visible','on');

      handle=findobj(fighandle,'Tag','ms');
      set(handle,'Value',FILTER.modeltype);
      handle=findobj(fighandle,'Tag','adg');
      set(handle,'String',num2str(FILTER.adfilter.adg(FILTER.adfilter.adm)));
      handle=findobj(fighandle,'Tag','adm');
      set(handle,'Value',FILTER.adfilter.adm);

      adgmat=str2mat('Forgetting factor',...
            'Sliding window size',...
            'Step size',...
            'Step size',...
            'State covariance');
      handle=findobj(fighandle,'Tag','adgstring');
      set(handle,'String',adgmat(FILTER.adfilter.adm,:));

    elseif FILTER.detecttype==2;
      set(fighandle,'Name','One-model design parameters')
      ind=(1:length(CDHchangedesign));
      set(CDHchangedesign(ind),'Visible','off');
      ind=[1 2 3 4 5 16 18 19 21 24:36];
      set(CDHchangedesign(ind),'Visible','on');


      handle=findobj(fighandle,'Tag','ms');
      set(handle,'Value',FILTER.modeltype);
      handle=findobj(fighandle,'Tag','dm');
      set(handle,'Value',FILTER.detect1.dm);
      handle=findobj(fighandle,'Tag','sr');
      set(handle,'Value',FILTER.detect1.sr);
      handle=findobj(fighandle,'Tag','h');
      set(handle,'String',num2str(FILTER.detect1.h));
      handle=findobj(fighandle,'Tag','nuorgam');
      set(handle,'String',num2str(FILTER.detect1.nuorgam));
      handle=findobj(fighandle,'Tag','lam');
      set(handle,'String',num2str(FILTER.detect1.lam));


      handle=findobj(fighandle,'Tag','htext');
      set(handle,'String',FILTER.detect1.htext);
      handle=findobj(fighandle,'Tag','nutext');
      set(handle,'String',FILTER.detect1.nutext(FILTER.detect1.sr,:));
      handle=findobj(fighandle,'Tag','lamtext');
      set(handle,'String',FILTER.detect1.lamtext);

    elseif FILTER.detecttype==3;
      set(fighandle,'Name','Two-model design parameters')
      ind=(1:length(CDHchangedesign));
      set(CDHchangedesign(ind),'Visible','off');
      ind=[1 2 3 4 5 16 18 19 21 22:36];
      set(CDHchangedesign(ind),'Visible','on');

      handle=findobj(fighandle,'Tag','ms');
      set(handle,'Value',FILTER.modeltype);
      handle=findobj(fighandle,'Tag','dm');
      set(handle,'Value',FILTER.detect2.dm);
      handle=findobj(fighandle,'Tag','sr');
      set(handle,'Value',FILTER.detect2.sr);
      handle=findobj(fighandle,'Tag','h');
      set(handle,'String',num2str(FILTER.detect2.h));
      handle=findobj(fighandle,'Tag','L');
      set(handle,'String',num2str(FILTER.detect2.L));
      handle=findobj(fighandle,'Tag','nuorgam');
      set(handle,'String',num2str(FILTER.detect2.nuorgam));
      handle=findobj(fighandle,'Tag','lam');
      set(handle,'String',num2str(FILTER.detect2.lam));

      handle=findobj(fighandle,'Tag','htext');
      set(handle,'String',FILTER.detect2.htext);
      handle=findobj(fighandle,'Tag','nutext');
      set(handle,'String',FILTER.detect2.nutext(FILTER.detect2.sr,:));
      handle=findobj(fighandle,'Tag','lamtext');
      set(handle,'String',FILTER.detect2.lamtext);

    elseif FILTER.detecttype==4;  % detectM
      set(fighandle,'Name','Multi-model design parameters')
      ind=(1:length(CDHchangedesign));
      set(CDHchangedesign(ind),'Visible','off');
      ind=[1 2 3 4 5 16 18 19 21 37:46];
      set(CDHchangedesign(ind),'Visible','on');


      handle=findobj(fighandle,'Tag','ms');
      set(handle,'Value',FILTER.modeltype);
      handle=findobj(fighandle,'Tag','lf');
      set(handle,'Value',FILTER.detectM.lf);
      handle=findobj(fighandle,'Tag','M');
      set(handle,'Value',FILTER.detectM.M); 
      handle=findobj(fighandle,'Tag','q');
      set(handle,'String',num2str(FILTER.detectM.q));
      handle=findobj(fighandle,'Tag','ll');
      set(handle,'String',num2str(FILTER.detectM.lifelength));
      handle=findobj(fighandle,'Tag','minseg');
      set(handle,'String',num2str(FILTER.detectM.minseg));
      handle=findobj(fighandle,'Tag','lambda');
      set(handle,'String',num2str(FILTER.detectM.lambda));
    elseif FILTER.detecttype==5;  % GLR
    elseif FILTER.detecttype==6;  % MLR

    end

    if FILTER.modeltype==4;
      set(CDHchangedesign([6 9 10]),'Visible','on');
      handle=findobj(fighandle,'Tag','na');
      set(handle,'String',FILTER.nnn.ar);
    elseif FILTER.modeltype==5;
      set(CDHchangedesign([7 9 10 11 12 13 14]),'Visible','on');
      handle=findobj(fighandle,'Tag','na');
      set(handle,'String',FILTER.nnn.arx(1));
      handle=findobj(fighandle,'Tag','nb');
      set(handle,'String',FILTER.nnn.arx(2));
      handle=findobj(fighandle,'Tag','nk');
      set(handle,'String',FILTER.nnn.arx(3));
    elseif FILTER.modeltype==6;
      set(CDHchangedesign([8 15]),'Visible','on');
      set(CDHchangedesign([16 17]),'Visible','off');
      handle=findobj(fighandle,'Tag','ss');
      set(handle,'String',FILTER.nnn.ss);
    end

  end
  end
end

if strcmp(action,'OKchangedesign')

  mainhandle=findobj('Tag','block');
  fighandle=findobj(0,'Tag','figsimdes');
  if ~isempty(fighandle);
    if FILTER.detecttype==1;
      handle=findobj(fighandle,'Tag','adg');
      FILTER.adfilter.adg(FILTER.adfilter.adm)=str2num(get(handle,'String'));
    elseif FILTER.detecttype==2;
      handle=findobj(fighandle,'Tag','h');
      FILTER.detect1.h=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','nuorgam');
      FILTER.detect1.nuorgam=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','lam');
      FILTER.detect1.lam=str2num(get(handle,'String'));
    elseif FILTER.detecttype==3;
      handle=findobj(fighandle,'Tag','h');
      FILTER.detect2.h=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','nuorgam');
      FILTER.detect2.nuorgam=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','lam');
      FILTER.detect2.lam=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','L');
      FILTER.detect2.L=str2num(get(handle,'String'));

    elseif FILTER.detecttype==4;  % detectM
      handle=findobj(fighandle,'Tag','lf');
      FILTER.detectM.lf=get(handle,'Value');
      handle=findobj(fighandle,'Tag','M');
      FILTER.detectM.M=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','q');
      FILTER.detectM.q=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','ll');
      FILTER.detectM.lifelength=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','minseg');
      FILTER.detectM.minseg=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','lambda');
      FILTER.detectM.lambda=str2num(get(handle,'String'));

    elseif FILTER.detecttype==5;  % GLR

    elseif FILTER.detecttype==6;  % MLR

    end

    if FILTER.modeltype==4;
      handle=findobj(fighandle,'Tag','na');
      FILTER.nnn.ar=str2num(get(handle,'String'));
    elseif FILTER.modeltype==5;
      handle=findobj(fighandle,'Tag','na');
      FILTER.nnn.arx(1)=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','nb');
      FILTER.nnn.arx(2)=str2num(get(handle,'String'));
      handle=findobj(fighandle,'Tag','nk');
      FILTER.nnn.arx(3)=str2num(get(handle,'String'));
    elseif FILTER.modeltype==6;
      handle=findobj(fighandle,'Tag','ss');
      FILTER.nnn.ss=get(handle,'String');
    end
  end
end

if strcmp(action,'getchangedesign')
% arg1
  mainhandle=findobj('Tag','block');
  fighandle=findobj(0,'Tag','figsimdes');
  if arg1==1
    handle=findobj(fighandle,'Tag','ms');
    FILTER.modeltype=get(handle,'Value');
  elseif arg1==2
    handle=findobj(fighandle,'Tag','adm');
    FILTER.adfilter.adm=get(handle,'Value');
  elseif arg1==3
    handle=findobj(fighandle,'Tag','dm');
    if FILTER.detecttype==2;
      FILTER.detect1.dm=get(handle,'Value');
    elseif FILTER.detecttype==3;
      FILTER.detect2.dm=get(handle,'Value');
    end
  elseif arg1==4
    handle=findobj(fighandle,'Tag','sr');
    if FILTER.detecttype==2;
      FILTER.detect1.sr=get(handle,'Value');
    elseif FILTER.detecttype==3;
      FILTER.detect2.sr=get(handle,'Value');
    end
  end
  guidetect('updatechangedesign')
end


if strcmp(action,'changedesign')
   %arg1=1/0
  global CDHchangedesign % Local handles

%  guidetect('filterobject')
  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','changedesign');
  onhandle=onhandle(1);
  fighandle=findobj('Tag','figsimdes');
  if nargin>1;
     set(onhandle,'Value',arg1);
  end
      
      Framepos=[5 40 240 230;... 		% Frame 1
                255 40 240 230]; 		% Frame 2
      LastPos=[210  10 50 20;...
	       275  10 50 20;...
	       340  10 50 20;...
	       ];
%xxx1

  if get(onhandle,'Value');
    if isempty(fighandle);
      fighandle=figure('Tag','figsimdes',...
        'Color',darkgrey,...
        'Units','pixels',...
        'Position',figpos(5,:),...
        'Units','normalized',...
        'MenuBar','none',...
        'HandleVisibility','on',...
        'NumberTitle','off');

      uicontrol(gcf,'Style','Frame','Position',Framepos(1,:),'Backgroundcolor',darkgrey);
      uicontrol(gcf,'Style','Frame','Position',Framepos(2,:),'Backgroundcolor',darkgrey);

      uicontrol(gcf,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',LastPos(1,:),...
	       'String','OK',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''OKchangedesign'')');

      uicontrol(gcf,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',LastPos(2,:),...
	       'String','Help',...
	       'BackGroundColor',grey,...
       	       'Callback','guihelp(''design'')');

      uicontrol(gcf,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',LastPos(3,:),...
	       'String','Close',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''closechangedesign'')');


      Pos=[  20 270 230 20;...
	     10 240 100 20;...
	     120 240 110 20;...  % 991013 120 from 100
	     10 210 230 20;...
	     10 190 230 20;...
	     10 160 230 20;...
	     10 160 230 20;...
	     10 160 230 20;...
	     20 140  20 20;...
	     40 140  30 20;...
	     80 140  20 20;...
	     100 140  30 20;...
	     140 140  20 20;...
	     160 140  30 20;...
	     10 140 130 20;...
	     10  110 150 20;...
	     160 110 80 20;...
	     160 110 80 20;...
	     10  80 150 20;...
	     160 80 80 20;...
	     160 80 80 20;...
	     10  50 100 20;...
	     160  50 80 20;...
	     260 270 230 20;...
	     260 240 230 20;...
	     260 210 100 20;...
	     360 210 130 20;...
	     260 180 100 20;...
	     360 180 130 20;...
	     260 150 230 20;...
	     260 120 150 20;...
	     410 120 80 20;...
	     260 90 150 20;...
	     410 90  80 20;...
	     260 60 150 20;...
	     410 60  80 20;...
	     260 210 100 20;...  % detectM
	     360 210 130 20;...
	     260 180 100 20;...
	     360 180 130 20;...
	     260 135 100 20;...
	     410 135 80 20;...
	     260 110 100 20;...
	     410 110  80 20;...
	     260 85 100 20;...
	     410 85  80 20;...
	     260 60 100 20;...
	     410 60  80 20];


      Strings=str2mat('FILTER DESIGN','Model structure',...
       'Variance change|Mean Change|Regression|AR|ARX|State Space',' ',' ');
      Strings=str2mat(Strings,...
       'AR order','ARX order','State space m-file','na',' ','nb',' ','nk',' ',' ');
      Strings=str2mat(Strings,...
       'Adaptation method','RLS|WLS|LMS|NLMS|KF','RLS',...
       'Adaptation gain',' ','1 (fixed)',...
       'Sliding window size L',' ');

      Styles=str2mat('Text','Text','PopUp','Text','Text');
      Styles=str2mat(Styles,...
          'Text','Text','Text');
      Styles=str2mat(Styles,...
          'Text','Edit','Text','Edit','Text','Edit','Edit');
      Styles=str2mat(Styles,...
          'Text','PopUp','Text','Text','Edit','Text','Text','Edit');

      Tags=str2mat(' ',' ','ms','cm1','cm2');
      Tags=str2mat(Tags,...
           ' ',' ',' ',' ','na',' ','nb',' ','nk','ss');
      Tags=str2mat(Tags,...
           '','adm',' ','adgstring','adg',' ',' ','L');

      ind=[3 17 27 29 37 49]; %49 dummy
      for i=1:6;
        Callbacks(ind(i),:)=['guidetect(''getchangedesign'',',num2str(i),')'];
      end

      Strings=str2mat(Strings,...
       'DETECTOR DESIGN','DISCRETE PARAMETERS','Distance measure',...
       'Residual|Squared residual','Stopping rule',...
       'CUSUM, one-sided|CUSUM, two-sided|GMA, one-sided|GMA, two-sided',...
       'CONTINUOUS PARAMETERS');
      Strings=str2mat(Strings,' ',' ',' ',' ',' ',' ');

      Styles=str2mat(Styles,'Text','Text','Text','PopUp','Text','PopUp','Text','Text','Edit','Text','Edit','Text','Edit','Text');

      Tags=str2mat(Tags,...
          ' ',' ',' ','dm',' ','sr');
      Tags=str2mat(Tags,...
          ' ','htext','h','nutext','nuorgam','lamtext','lam');
 
      % detectM
      Strings=str2mat(Strings,'Loss function','MAP, known lambda|MAP|AIC|BIC/MDL','Parallel filters #',' ','Jump prob. (0<q<1)',' ','Life length',' ','Minimum segments',' ','Noise var. (for MAP)',' ');
      Tags=str2mat(Tags,...
          ' ','lf',' ','M',' ','q',' ','ll',' ','minseg',' ','lambda');
      Styles=str2mat(Styles,'PopUp','Text','Edit','Text','Edit','Text','Edit','Text','Edit','Text','Edit');

      [m,n]=size(Strings);
      Colors=ones(m,1)*darkgrey;
      ind=find(Styles(:,1)=='E');
      Colors(ind,:)=ones(length(ind),1)*[1 1 1];

%size(Strings),size(Styles),size(Callbacks),size(Tags),size(Strings),size(Colors),size(Pos),
m=48;
m1=1; m2=48;
ss=setstr(32*ones(m2-m1+1,2));
%[num2str((m1:m2)'),ss,Styles(m1:m2,:),ss,Strings(m1:m2,1:25),ss,Callbacks(m1:m2,1:end),ss,Tags(m1:m2,:),ss,num2str(Pos(m1:m2,:))]

    for i=1:m;
      ind=findstr('  ',Strings(i,:));
      if ~isempty(ind); 
        text=Strings(i,1:ind(1)-1); 
      else
        text=Strings(i,:);
      end;
      ind=findstr(' ',Tags(i,:));
      if ~isempty(ind); 
        tag=Tags(i,1:ind(1)-1);
      else
        tag=Tags(i,:);
      end;
      CDHchangedesign(i)=uicontrol(gcf,'Style',Styles(i,:),...
                'Units','pixels',...
                'Position',Pos(i,:),...
   	        'String',text,...
   	        'Tag',tag,...
                'HorizontalAlignment','Left',...
	        'CallBack',Callbacks(i,:),...
	        'BackGroundColor',Colors(i,:));
      end
    else
      figure(fighandle);
      set(fighandle,'Visible','on');
      set(fighandle,'HandleVisibility','on');
    end;

    set(gcf,'HandleVisibility','Callback');
    guidetect('updatechangedesign')


  elseif fighandle~=0
    set(fighandle,'Visible','off')
    mainhandle=findobj('Tag','block');
    onhandle=findobj(mainhandle,'Tag','changedesign');
    set(onhandle,'Value',0);
  end;
end


if strcmp(action,'closechangedesign')
  handle=findobj(0,'Tag','figsimdes');
  set(handle,'Visible','off');
  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','changedesign');
  onhandle=onhandle(1);
  set(onhandle,'Value',0);
end

if strcmp(action,'designedit')
  figsimdeshandle=findobj(0,'Tag','figsimdes');
  detecttype=FILTER.detecttype;
  
  if detecttype==1;
    handle=findobj(figsimdeshandle,'Tag','adm');
    adm=get(handle(1),'Value');
    designpar(1,2)=[adm];
    handle=findobj(figsimdeshandle,'Tag','adg');
    adg=str2num(get(handle(1),'String'));
    if length(adg)==1;
      designpar(1,1)=[adg];
      designpar(1,3)=0;
    else   % Kalman filter Q
      Q=adg(:);
      d2=length(Q);
     designpar=[designpar(1:6,1:6) zeros(6,d2+2-6)];
     designpar(1,3:d2+2)=Q';
     
  end
      
  end
  if detecttype==2;
    handle=findobj(figsimdeshandle,'Tag','dm');
    dm=get(handle,'Value');
    handle=findobj(figsimdeshandle,'Tag','sr');
    sr=get(handle,'Value');
    handle=findobj(figsimdeshandle,'Tag','nuorgam');
    nu=str2num(get(handle,'String'));
    handle=findobj(figsimdeshandle,'Tag','lam');
    lam=str2num(get(handle,'String'));
    handle=findobj(figsimdeshandle,'Tag','h');
    h=str2num(get(handle,'String'));
    designpar(2,1:4)=[dm sr h nu];
    designpar(2,6)=lam;
  end
  if detecttype==3;
    handle=findobj(figsimdeshandle,'Tag','dm');
    dm=get(handle(1),'Value');
    handle=findobj(figsimdeshandle,'Tag','sr');
    sr=get(handle,'Value');
    handle=findobj(figsimdeshandle,'Tag','nuorgam');
    nu=str2num(get(handle,'String'));
    handle=findobj(figsimdeshandle,'Tag','lam');
    lam=str2num(get(handle,'String'));
    handle=findobj(figsimdeshandle,'Tag','h');
    h=str2num(get(handle,'String'));
    handle=findobj(figsimdeshandle,'Tag','L');
    L=str2num(get(handle,'String'));
    designpar(3,1:6)=[dm sr h nu round(L) lam];
  end
  if detecttype==4;
      handle=findobj(figsimdeshandle,'Tag','dm');
      lf=get(handle,'Value');
      handle=findobj(figsimdeshandle,'Tag','lam');
      lam=str2num(get(handle,'String'));
      handle=findobj(figsimdeshandle,'Tag','q');
      q=str2num(get(handle,'String'));
      handle=findobj(figsimdeshandle,'Tag','M');
      M=str2num(get(handle,'String'));
      handle=findobj(figsimdeshandle,'Tag','ll');
      ll=str2num(get(handle,'String'));
      designpar(4,1:5)=[lf lam q M ll];
  elseif detecttype==5;
      handle=findobj(figsimdeshandle,'Tag','mode');
      mode=get(handle,'Value');
      handle=findobj(figsimdeshandle,'Tag','L');
      L=str2num(get(handle,'String'));
      handle=findobj(figsimdeshandle,'Tag','h');
      h=str2num(get(handle,'String'));
      handle=findobj(figsimdeshandle,'Tag','pnu');
      pnu=str2num(get(handle,'String'));
      designpar(5,1:4)=[mode L h pnu];
  elseif detecttype==6;
      handle=findobj(figsimdeshandle,'Tag','lf');
      lf=get(handle,'Value');
      handle=findobj(figsimdeshandle,'Tag','lam');
      lam=str2num(get(handle,'String'));
      designpar(6,1:2)=[lf lam];
  end
  guidetect('xxx')
end

%======== Plot tool ================


if strcmp(action,'plottool')  
  mainhandle=findobj('Tag','block');
  fighandle=findobj(0,'Tag','figplottool');

    if isempty(fighandle);
      fighandle=figure('Tag','figplottool',...
        'Units','pixels',...
	'Position',[figpos(6,1:2) 240 330 ],...
	'Name','Plot Tool',...
        'MenuBar','none',...
	'NumberTitle','off',...
        'IntegerHandle','off',...
        'Visible','off',...
        'HandleVisibility','on',...
	'Color',darkgrey);
    
	  
      menupos=[...
         10 295 140 25;...
         160 295 70 25;...
         10 260 220 25;...
	 10 225 220 25;...
	 10 190 220 25;...
         40 155 160 25;...
         10 120 220 25;...
         40 85  160 25;...
         40 50  160 25;...
         50  10  60 20;...
        130  10  60 20;...
	 ];
	   

      Strings=str2mat('Data Preview.','Zoom.','Data segmentation.','Test statistic.',...
	  'User specified below.',userplotname,...
	  'Recursive estimates|Smoothed estimates|Both recursive and smoothed.',...
	  'Parameter plot.','RMS error plot.');
      CallBacks=str2mat('datalook','datazoom','validsegplot','validteststat',...
	  'validuser',' ',...
	  'validthplot|validrmsplot',...
	  'validthplot','validrmsplot');
      Tags=str2mat('look','zoom','valvis','valtes','valusr','usernm','segrec','valpar','valrms');
      Styles=str2mat('CheckBox','PushButton','CheckBox','CheckBox','CheckBox','Edit',...
	  'PopUp','CheckBox','CheckBox');
    
      for i=1:size(Strings,1);
        ind=findstr(' ',Tags(i,:));
        if ~isempty(ind); 
          tag=Tags(i,1:ind(1)-1); 
        else
          tag=Tags(i,:);
        end;
        ind=findstr('.',Strings(i,:));
        if ~isempty(ind); 
          string=Strings(i,1:ind(1)-1); 
        else
          string=Strings(i,:);
        end;

        if ~strcmp(Styles(i,1:4),'Edit');
          uicontrol(gcf,'Style',Styles(i,:),...
               'Units','pixels',...
               'Position',menupos(i,:),...
	       'String',string,...
	       'Tag',tag,...
	       'Callback',['guidetect(''',CallBacks(i,:),''');'],...
	       'BackGroundColor',grey);
        else
          uicontrol(gcf,'Style',Styles(i,:),...
               'Units','pixels',...
               'Position',menupos(i,:),...
	       'String','userplot',...
	       'Tag',Tags(i,:),...
	       'Callback',['guidetect(''',CallBacks(i,:),''');'],...
	       'BackGroundColor','w');
	end
     end  
     uicontrol(gcf,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(i+1,:),...
	       'String','Help',...
	       'BackGroundColor',grey,...
       	       'Callback','guihelp(''plottool'');');

     uicontrol(gcf,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(i+2,:),...
	       'String','Close',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''closeplottool'')');
    set(gcf,'HandleVisibility','Callback');

  end    
  onhandle=findobj(mainhandle,'Tag','plottool');
  if get(onhandle,'Value');
    figure(fighandle);
    set(fighandle,'Visible','on');
  elseif fighandle~=0
    figure(fighandle);
    set(fighandle,'Visible','off');
%    guidetect('closeplottool')
  end;
    guidetect('datazoom')
    guidetect('datalook')
    guidetect('validsegplot')
    guidetect('validthplot')
    guidetect('validrmsplot')
    guidetect('validteststat')
    guidetect('validuser')
end

if strcmp(action,'closeplottool')
  % Close plot tool window
  fighandle=findobj(0,'Tag','figplottool');
  set(fighandle,'Visible','off');
  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','plottool');
  set(onhandle,'Value',0);
  
  % Close all plot windows
  onhandle=findobj(fighandle,'Tag','look');
  set(onhandle,'Value',0);
  onhandle=findobj(fighandle,'Tag','zoom');
  set(onhandle,'Value',0);

  onhandle=findobj(fighandle,'Tag','valpar');
  set(onhandle,'Value',0);
  onhandle=findobj(fighandle,'Tag','valvis');
  set(onhandle,'Value',0);
  onhandle=findobj(fighandle,'Tag','valtes');
  set(onhandle,'Value',0);
  onhandle=findobj(fighandle,'Tag','valrms');
  set(onhandle,'Value',0);
  onhandle=findobj(fighandle,'Tag','valusr');
  set(onhandle,'Value',0);

  guidetect('datazoom')
  guidetect('datalook')
  guidetect('validsegplot')
  guidetect('validthplot')
  guidetect('validrmsplot')
  guidetect('validteststat')
  guidetect('validuser')
end;


if strcmp(action,'validsegplot')
  plottoolhandle=findobj(0,'Tag','figplottool');
  onhandle=findobj(plottoolhandle,'Tag','valvis');
  fighandle=findobj(0,'Tag','figvalvis');

  z=RESULT.z;
  jhat=RESULT.jhat;
  detecttype=FILTER.detecttype;
  simjhat=SIM.m(SIM.modeltype).jhat;

  if ~isempty(onhandle); if get(onhandle,'Value');
    if isempty(fighandle);
      figure('Tag','figvalvis',...
         'Units','pixels',...
	      'Position',[figpos(7,1:4)],...
         'Name','Visual inspection',...
         'MenuBar','none',...
      	'NumberTitle','off')
      handle=uimenu(gcf,'Label','Signals');
      uimenu(handle,'Label','All',...
                   'Callback','guidetect(''validsegplot'',0)');
      for i=1:size(z,2);     
        uimenu(handle,'Label',['Signal ',num2str(i)],...
        'Callback',['guidetect(''validsegplot'',',num2str(i),')']);
      end
    else
      figure(fighandle);
    end;


    [N,nz]=size(z);
    
    if ~exist('arg1')    % First call
      arg1=0;
    end
    if arg1==0;
      zind=1:nz;    % plot all signals by default
    else
      zind=arg1;
    end
	   
    if length(zind)>1;
      plot(z(:,zind))
    else
      c='bgrcmyb';
      plot(z(:,zind),c(rem(zind-1,length(c))+1))   % Same color as before
    end
    hold on
    dum=axis;
    if detecttype>1;   % detection
      jhat=jhat(:);
      h1=plot([jhat jhat]',...
        [dum(3)*ones(size(jhat)) dum(4)*ones(size(jhat))]','b-');
      if SIM.datatype==2; % simulation
         simjhat=simjhat(:);
         h2=plot([simjhat simjhat]',...
         [dum(3)*ones(size(simjhat)) dum(4)*ones(size(simjhat))]','r-');
         if ~isempty(jhat) & ~isempty(simjhat)
            legend([h1(1) h2(1)],'Estimated jump times','Simulated jump times',2)
         elseif ~isempty(jhat)
            legend([h1(1)],'Estimated jump times',2)
         elseif ~isempty(simjhat)
            legend([h2(1)],'Simulated jump times',2)
         end
      else
         if ~isempty(jhat)
            legend([h1(1)],'Estimated jump times',2)
         end
      end
    end
    hold off
    title(['Signal number ',cdnum2str(zind)])
    fcn=['plot(z(:,',cdnum2str(zind),'))'];
      
    if options(1)==1; disp(fcn); end
    [nr,nc]=size(history);
    history=[history;fcn setstr(32*ones(1,nc-length(fcn)))];
  elseif fighandle~=0
    close(fighandle);
  end; end;
end

if strcmp(action,'validuser')
  plottoolhandle=findobj(0,'Tag','figplottool');
  namehandle=findobj(plottoolhandle,'Tag','usernm');
  fcn=get(namehandle,'String');
  userplotname=fcn;    
  onhandle=findobj(plottoolhandle,'Tag','valusr');
  fighandle=findobj(0,'Tag','figvalusr');
  if ~isempty(onhandle); if get(onhandle,'Value');
   if ~exist(fcn)
     guidetect('disp',['The function ',fcn,' not found'],'r')
     return
   end
   if isempty(fighandle);
      figure('Tag','figvalusr',...
        'Units','pixels',...
      'MenuBar','none',...
	'Position',figpos(8,:),...
	'Name',['User specified plot: ',userplotname],...
	'NumberTitle','off')
    else
      figure(fighandle);
    end;

    z=RESULT.z;
    jhat=RESULT.jhat;
    threc=RESULT.threc;
    thseg=RESULT.thseg;
    th0=RESULT.th0;
    simjhat=SIM.m(SIM.modeltype).jhat;
    
    if options(1)==1; disp(fcn); end
    feval(fcn,z,threc,thseg,th0,jhat,simjhat)
    [nr,nc]=size(history);
    history=[history;fcn setstr(32*ones(1,nc-length(fcn)))];
  elseif fighandle~=0
    close(fighandle);
  end; end;
end

if strcmp(action,'validthplot')
  plottoolhandle=findobj(0,'Tag','figplottool');
  onhandle=findobj(plottoolhandle,'Tag','valpar');
  fighandle=findobj(0,'Tag','figvalpar');
  
  if ~isempty(onhandle); if get(onhandle,'Value');
    z=RESULT.z;
    th0=RESULT.th0;
    threc=RESULT.threc;
    thseg=RESULT.thseg;
    if isempty(th0)
       guidetect('disp','Warning: no data available!','r')
       return
    end
    if isempty(threc)
       guidetect('disp','Warning: no filter has been applied!','r')
%       return
    end

    if isempty(fighandle);
      figure('Tag','figvalpar',...
         'Units','pixels',...
         'Position',[figpos(9,:)],...
         'Name','Parameter plot',...
         'MenuBar','none',...
       	 'NumberTitle','off')
      handle=uimenu(gcf,'Label','Parameter/state');
      uimenu(handle,'Label','All',...
                   'Callback','guidetect(''validthplot'',0)');
      for i=1:size(th0,2);     
        uimenu(handle,'Label',['Signal ',num2str(i)],...
        'Callback',['guidetect(''validthplot'',',num2str(i),')']);
      end

    else
      figure(fighandle);
    end;


    [N,nz]=size(z);
    
    if ~exist('arg1')    % Not call from uimenu, then plot all signals
      arg1=0;
    end
    if arg1==0;
      n=min([size(th0,1) size(threc,1)]);
      zind=1:n;    % plot all signals by default
    else
      zind=arg1;
    end
	   
    
    segrechandle=findobj(plottoolhandle,'Tag','segrec');
    segrec=get(segrechandle,'Value');
    
    if length(zind)==1;
      c='bgrcmyb';
      c=c(rem(zind-1,length(c))+1);    % Same color as before
    else
      c=[];
    end
    h=[];
    leg=[];
    if SIM.datatype==2;
      hdum=plot(th0(zind,:)',[c,':']);
      h=[h hdum(1)];
      leg=str2mat(leg,'True values');
      hold on
    end
    fcn='plot([threc thseg])';
    if segrec==1 | segrec==3;
%      zind,size(threc)
      hdum=plot(threc(zind,:)',[c,'-']);
      hold on
      h=[h hdum(1)];
      leg=str2mat(leg,'Recursive estimates');
    end
    if segrec==2 | segrec==3;
      hdum=plot(thseg(zind,:)',[c,'--']);
      h=[h hdum(1)];
      leg=str2mat(leg,'Smoothed estimates');
    end
    leg(1,:)=[];
    leg;
    legend(h,leg,0);
    hold off
          
    if options(1)==1; disp(fcn); end
    [nr,nc]=size(history);
    history=[history;fcn setstr(32*ones(size(fcn,1),nc-size(fcn,2)))];
    
  elseif ~isempty(fighandle)
    close(fighandle);
  end; end
end

if strcmp(action,'validrmsplot')
  plottoolhandle=findobj(0,'Tag','figplottool');
  onhandle=findobj(plottoolhandle,'Tag','valrms');
  fighandle=findobj(0,'Tag','figvalrms');
  
  if ~isempty(onhandle); if get(onhandle,'Value');
    if isempty(MSrec)
       guidetect('disp','Warning: Run the filter first!','r')
       return
    end
   
    % RMS plot
    if datatype==2;   
      if isempty(fighandle);
        figure('Tag','figvalrms',...
        'Units','pixels',...
	'Position',figpos(10,:),...
      'MenuBar','none',...
	'Name','RMS plot',...
	'NumberTitle','off')
      else
        figure(fighandle);
      end;
      segrechandle=findobj(plottoolhandle,'Tag','segrec');
      segrec=get(segrechandle,'Value');
      mtype=modeltype(detectnnn);
      if size(MSrec,1)>1;
        RMSrec=sqrt(mean(MSrec));
      else
        RMSrec=sqrt(MSrec);
      end
      if size(MSseg,1)>1;
        RMSseg=sqrt(mean(MSseg));
      else
        RMSseg=sqrt(MSseg);
      end
      if segrec==1;
        plot(RMSrec)
      elseif segrec==2;
        plot(RMSseg)
      elseif segrec==3;
	Np=length(RMSrec);   %ver5
        plot(1:Np,RMSrec,'-',1:Np,RMSseg,'--')
      end
    else
      guidetect('disp','Warning: Cannot compute RMS for real data!','r')
    end;
    
  elseif ~isempty(fighandle)
    close(fighandle);
  end; end
end

if strcmp(action,'validteststat')
  plottoolhandle=findobj(0,'Tag','figplottool');
  onhandle=findobj(plottoolhandle,'Tag','valtes');
  fighandle=findobj(0,'Tag','figvaltes');
  if ~isempty(onhandle); if get(onhandle,'Value');

    gt=RESULT.gt;
    simN=SIM.m(SIM.modeltype).N;

    if isempty(gt)
       guidetect('disp','Warning: Run a detector first!','r')
       return
    end
    if isempty(fighandle);
      figure('Tag','figvaltes',...
        'Units','pixels',...
	'Position',figpos(11,:),...
      'MenuBar','none',...
	'Name','Test statistics',...
	'NumberTitle','off')
    else
      figure(fighandle);
    end;
    plot(gt)
    if FILTER.detecttype==2;
      h=FILTER.detect1.h;
    elseif FILTER.detecttype==3;
      h=FILTER.detect2.h;
    else
      h=0;
    end
    hold on, plot([1 length(gt)],h*[1 1],'r--'); hold off
    a=axis;
    axis([a(1),a(2),a(3),max([a(4),1.1*h])])  
    fcn='plot(gt)';
    if options(1)==1; disp(fcn); end
    [nr,nc]=size(history);
    history=[history;fcn setstr(32*ones(1,nc-length(fcn)))];
  elseif fighandle~=0
    close(fighandle);
  end; end;
end



%====== Change Tool ============================

if strcmp(action,'changetool')
  %arg1=0/1
  mainhandle=findobj('Tag','block');
  fighandle=findobj(0,'Tag','figchangetool');
  onhandle=findobj(mainhandle,'Tag','changetool');
  if nargin>1;
     set(onhandle,'Value',arg1);
  end

  if get(onhandle,'Value');
  if isempty(fighandle);
    fighandle=figure('Tag','figchangetool',...
      'Units','pixels',...
      'Position',[figpos(16,1:2) 220 460],...
      'Units','normalized',...
      'Name','Change Tool',...
      'Color',darkgrey,...
      'MenuBar','none',...
      'HandleVisibility','on',...
      'IntegerHandle','off',...
      'NumberTitle','off');

  MCN=10;
  FAR=0.01;
  menupos=[...
	     10  130 200 320;... 	% Frame 1
	     10  40 200 80;... 		% Frame 2
	     20  415 180 25;...
	     20  380 50 25;...
	     80  380 50 25;...  
             % reserve rows  205, 240, 275, 310, 345 for info
	     20  135 85 25;...
	     115 135 85 25;...
	     20  170 180 25;...
	     20  85 180 25;...
	     20  50 180 25;...
	     150 50 50 25;...
	     40  10  60 20;...
	     120 10  60 20;...
	     ];

  uicontrol(fighandle,'Style','Frame',...
               'Units','pixels',...
               'Position',menupos(1,:),...
	       'BackGroundColor',grey);
  uicontrol(fighandle,'Style','Frame',...
               'Units','pixels',...
               'Position',menupos(2,:),...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Monte Carlo simulation',...
       	       'Callback','guidetect(''startMC'',''cd'');',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String','MC iter = ',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos(5,:),...
	       'String',num2str(MCN),...
	       'Tag','MCN',...
	       'BackGroundColor','w');



     uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(6,:),...
	       'String','Add to Table',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''tabchangetool'');');

     uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(7,:),...
	       'String','Help statistics',...
	       'BackGroundColor',grey,...
       	       'Callback','guihelp(''MCtable'');');

    uicontrol(fighandle,'Style','Frame',...
               'Units','pixels',...
               'Position',menupos(8,:),...
	       'BackGroundColor',grey);

    uicontrol(fighandle,'Style','CheckBox',...
               'Units','pixels',...
               'Position',menupos(8,:)+[2 2 -4 -4],...
	       'String','Histograms',...
	       'Tag','changehist',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''changehist'')');

   uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',menupos(9,:),...
	       'String','Auto-Tuning of Threshold',...
       	       'Callback','guidetect(''autotuning'');',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(10,:),...
	       'String','False alarm rate = ',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos(11,:),...
	       'String',num2str(FAR),...
	       'Tag','FAR',...
	       'BackGroundColor','w');

  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(12,:),...
	       'String','Help',...
	       'BackGroundColor',grey,...
       	       'Callback','guihelp(''MC'');');

  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(13,:),...
	       'String','Close',...
	       'BackGroundColor',grey,...
       	       'Callback','guidetect(''closechangetool'');');


  set(gcf,'HandleVisibility','Callback');

    else
      figure(fighandle);
      set(fighandle,'Visible','on');
    end;
  elseif fighandle~=0
    guidetect('closechangetool')
  end;
end

if strcmp(action,'closechangetool')
  % Close plot tool window
  fighandle=findobj(0,'Tag','figchangetool');
  set(fighandle,'Visible','off')
  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','changetool');
  set(onhandle,'Value',0);
  % Close histograms and statistics
  handle=findobj(0,'Tag','figchangetool');
  close(findobj('Tag','figmc1'));
  close(findobj('Tag','figmc2'));
  close(findobj('Tag','figmc3'));
  close(findobj('Tag','figmcdata'));
  close(findobj('Tag','figautotuning'));
  close(findobj('Tag','autotuningplot'));
  close(findobj('Tag','autotuninghist'));
  close(handle);
end

if strcmp(action,'autotuning')  
  fighandle=findobj(0,'Tag','figautotuning');
  if isempty(fighandle);
    fighandle=figure('Tag','figautotuning',...
      'Units','pixels',...
      'Position',[figpos(17,1:2) 320 240],...
      'Name','Change Tool',...
      'Color',grey,...
      'MenuBar','none',...
      'HandleVisibility','on',...
      'NumberTitle','off');
  else
    figure(fighandle);
  end;
  simN=SIM.m(SIM.modeltype).N;
  simjhat=SIM.m(SIM.modeltype).jhat;
  jhat=RESULT.jhat;
  z=RESULT.z;
  threc=RESULT.threc;


  menupos=[...
	     10  155 300 80;... 		% Frame 1
	     10  40 300 105;... 		% Frame 2
	     20  205 280 25;...
	     20  170 280 25;...
	     20  115 280 25;...
	     20  80 280 25;...
	     20  45 280 25;...
	     90  10  60 20;...
	     170 10  60 20];
	   
  uicontrol(fighandle,'Style','Frame',...
               'Units','pixels',...
               'Position',menupos(1,:),...
	       'BackGroundColor',grey);
  uicontrol(fighandle,'Style','Frame',...
               'Units','pixels',...
               'Position',menupos(2,:),...
	       'BackGroundColor',grey);
	   
  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(8,:),...
	       'String','Help',...
	       'BackGroundColor',grey,...
       	       'Callback','guihelp(''MCautotuning'');');

  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(9,:),...
	       'String','Close',...
	       'BackGroundColor',grey,...
       	       'Callback',['close(gcf);',...
		          'h=findobj(''Tag'',''autotuningplot'');',...
                'if ~isempty(h); close(h); end,',...
                'h=findobj(''Tag'',''autotuninghist'');',...
			       'if ~isempty(h); close(h); end,']);

  if ~isempty(jhat);

    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Jumps detected in the current simulation.',...
	       'BackGroundColor',grey);
    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String','Redo the detection with larger threshold!',...
	       'BackGroundColor',grey);
  elseif ~isempty(simjhat);

    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Simulate data with no jumps!',...
	       'BackGroundColor',grey);
  elseif simN~=length(z);
    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Simulate data!',...
	       'BackGroundColor',grey);
  elseif simN~=length(threc);
    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Start the detection filter!',...
	       'BackGroundColor',grey);
	   
  else
    fighandle=findobj(0,'Tag','figchangetool');
    FARhandle=findobj(fighandle,'Tag','FAR');
    FAR=str2num(get(FARhandle,'String'));
    gtsort=sort(gt(:));
    N=length(gtsort);
    indl=floor(N*FAR);
    indu=ceil(N*FAR);
    if indl==indu;
      indl=indl-1; indu=indu+1; 
    end
    
    hl=gtsort(N-indu);
    hu=gtsort(N-indl);
    
    alpha=0.8;
    gt80=gtsort(alpha*N:N);    % Take the 80% percentile
    [fhat,xd]=hist(gt80,(1-alpha)*N/10);
    fhat=fhat/sum(fhat);

    
    a0=mean(gt80);
    Indata=[xd;fhat];
    OPTIONS=[1 0 0 0 1];
    save matlab Indata OPTIONS a0
    %    [a,OPTIONS]=leastsq('expdist',a0,OPTIONS,[],Indata,a0);
    if exist('leastsq')==2
       [a,OPTIONS]=leastsq('guidetect',a0,OPTIONS,[],'expmodel',Indata,a0);
    else
       guidetect('This function requires ''Optimization Toolbox''','r'),return
    end
    alpha2=length(gt80)/length(gt);
    alpha1=1-alpha2;
    hhat=gt80(1)-a*log(FAR/alpha2);
    hhat0=gt80(1)-a0*log(FAR/alpha2);

    f0=1/a0*exp(-xd/a0);
    f0=f0/sum(f0);
    f=1/a*exp(-xd/a);
    f=f/sum(f);

    fighandle=findobj(0,'Tag','figautotuning');

    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String','Non-parametric Method',...
	       'BackGroundColor',grey);
    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String',['Threshold between ',...
  	        num2str(hl),' and ',num2str(hu)],... 
	       'BackGroundColor',grey);
    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(5,:),...
	       'String','Parametric Method',...
	       'BackGroundColor',grey);
    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(6,:),...
	       'String',['Optimized threshold ',...
  	        num2str(hhat)],... 
	       'BackGroundColor',grey);
    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(7,:),...
	       'String',['Non-optimized threshold ',...
  	        num2str(hhat0)],... 
	       'BackGroundColor',grey);
    
    figure
    set(gcf,'Tag','autotuningplot',...
        'Units','normalized',...
	'Position',figpos(21,:),...
	'Name','Autotuning of threshold',...
	'NumberTitle','off',...
	'Color',grey,...
   'UserData',[]);
    h=semilogy(xd,f0,'--',xd,f0,'x',xd,f,'-',xd,f,'x',xd,fhat,'x',xd,fhat,':'); 
   title('Non-parametric and parametric distributions')
   legend(h([6 1 3]),'Non-parametric','Non-optimized parametric',...
       'Optimized Parametric')
    %title(['Non-parameric (dotted) and parametric distribution',...
	 % '(solid-optimized, dashed-nonoptimized)'])
      
    figure; 
    set(gcf,'Tag','autotuninghist',...
        'Units','normalized',...
	'Position',[0.5 0.5 0.3 0.2],...
	'Name','Histogram over test statistics',...
	'NumberTitle','off',...
	'Color',grey,...
   'UserData',[]);

   hist(gt(:)), 
   title('Histogram over test statistics')   
   drawnow 
    
   end	   
end

if nargin>1
  if strcmp(arg1,'expmodel')
    % function V=expdist(a,indata,a0);
    % V=out1
    a=action;       % I can't help the least squares syntax!
    indata=arg2;
    a0=arg3;

    xd=indata(1,:);
    fobs=indata(2,:);

    % Evaluate the parametric distribution
    fpar=1/a*exp(-xd/a);
    fpar=fpar/sum(fpar);
    f0=1/a0*exp(-xd/a0);
    f0=f0/sum(f0);

    % Compute relative error 
    V=(fobs-fpar)./f0;
    out1=V;
  end
end  
  
if strcmp(action,'startMC')
% arg1 = 'ad' or 'cd'
%zzz

  guidetect('disp','Monte Carlo simulations in progress.','r')

  menupos=[140 380 50 25;...   %change tool
           350 40 50 20;...    %adaptive tool
	     ];

  figadhandle=findobj('Tag','figadaptivetool');
  figcdhandle=findobj('Tag','figchangetool');

  MCNcdhandle=findobj(figcdhandle,'Tag','MCN');
  MCNadhandle=findobj(figadhandle,'Tag','MCiter');

  if arg1=='cd'
    MCN=str2num(get(MCNcdhandle,'String'));
    set(MCNadhandle,'String',num2str(MCN));
  elseif arg1=='ad'
    MCN=str2num(get(MCNadhandle,'String'));
    set(MCNcdhandle,'String',num2str(MCN));
  end

  simN=SIM.m(SIM.modeltype).N;
  simthhat=SIM.m(SIM.modeltype).thhat;
  simjhat=SIM.m(SIM.modeltype).jhat;
  simlamhat=SIM.m(SIM.modeltype).lamhat;

  tc0=[simjhat(:); simN]; 
  [d,dum]=size(simthhat);
  dfd=[];
  missedalarms=0;
  FA=[];
  TA=[];
  JHAT=[];
  TH0=zeros(d,simN);
  THREC=zeros(d,simN);
  THSEG=zeros(d,simN);
  MSREC=zeros(d,simN);
  MSSEG=zeros(d,simN);
  VREC=0;
  VSEG=0;
  GT=[];
  guidetect('startclock')
  red=[1 0.5 0.5];
  
  for i=1:MCN;
    if ~isempty(figcdhandle)
      uicontrol(figcdhandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(1,:),...
	       'String',['# ',num2str(i)],...
	       'BackGroundColor',red);
    end
    if ~isempty(figadhandle)
      uicontrol(figadhandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2,:),...
	       'String',['# ',num2str(i)],...
	       'BackGroundColor',red);
    end
    drawnow
    randn('seed',i);
    guidetect('startsim')
    guidetect('startdetect')
    ta=ta(:);
    JHAT=[JHAT;jhat(:)];
    TA=[TA;ta];
    TH0=TH0+th0;
    THREC=THREC+threc;
    THSEG=THSEG+thseg;
    MSREC=MSREC+(th0-threc).^2;
    MSSEG=MSSEG+(th0-thseg).^2;
    VREC=VREC+Vrec;
    VSEG=VSEG+Vseg;
    GT=[GT gt];
    ind=find(ta<tc0(1));
    if length(ind)>0; FA=[FA;ta(ind)]; end;
    
    for i=1:length(tc0)-1;
      ind=find(ta>=tc0(i) & ta<tc0(i+1));
      dum=length(ind);
      if dum<1; missedalarms=missedalarms+1; end;
      if dum>1; FA=[FA;ta(ind(2:dum))]; end;
      if dum>0; dfd=[dfd;ta(ind(1))-tc0(i)]; end;
    end;
  end;
  % Iterations ended
  guidetect('MChist')
  if ~isempty(figcdhandle)
    uicontrol(figcdhandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(1,:),...
	       'String',['    '],...
	       'BackGroundColor',grey);
  end
  if ~isempty(figadhandle)
    uicontrol(figadhandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2,:),...
	       'String',['    '],...
	       'BackGroundColor',grey);
  end
  th0=TH0/MCN;
  threc=THREC/MCN;
  thseg=THSEG/MCN;
  MSrec=MSREC/MCN;
  MSseg=MSSEG/MCN;
  Vrec=VREC/MCN;
  Vseg=VSEG/MCN;
  % gt=GT/MCN; % matrix currently
  gt=GT;
  simN=SIM.m(SIM.modeltype).N;
  Values=[MCN length(JHAT) length(FA)/(MCN*simN) missedalarms/(MCN*simN)];
  if isempty(dfd)
    Values(5)=0;
  else
    Values(5)=mean(dfd);
  end

  RESULT.threc=threc;
  RESULT.thseg=thseg;
  RESULT.jhat=jhat;
  RESULT.gt=GT;
%  RESULT.ta=ta;
%  RESULT.lamhat=lamhat;
  RESULT.mc.Values=Values;
  RESULT.mc.N=MCN;
  RESULT.mc.MSrec=MSrec;
  RESULT.mc.MSseg=MSseg;
  RESULT.mc.Vrec=Vrec;
  RESULT.mc.Vseg=Vseg;
  RESULT.mc.FA=FA;
  RESULT.mc.TA=TA;
  RESULT.mc.dfd=dfd;
  RESULT.mc.JHAT=dfd;

  guidetect('stopclock')
  guidetect('plottool')
  guidetect('updateadaptivetool')
  guidetect('updatechangetool')
  guidetect('disp','Ready. Mean values displayed in all plots.')
end


if strcmp(action,'updatechangetool')
  % Display some info
   
  fighandle=findobj('Tag','figchangetool');
  if ~isempty(fighandle)
  set(gcf,'HandleVisibility','On');

  Values=RESULT.mc.Values;
  % Values=[MCN length(JHAT) length(FA)/(MCN*simN) missedalarms/(MCN*simN) mean(dfd)];

  adm=guidetect('getdetectpar',3);
  adgpar=guidetect('getdetectpar',4);
  texta=['MC STATISTICS'];
  textb=[adm,' with design par:'];
  textc=[adgpar];
  text1=['Total number of det.: ',num2str(Values(2))];
  text2=['False alarm rate (FAR): ',num2str(Values(3))];
  text3=['Missed det. rate (MDR): ',num2str(Values(4))];
  text4=['Mean time to det. (MTD): ',num2str(Values(5))];
  
  MCNhandle=findobj(fighandle,'Tag','MCN');
  set(MCNhandle,'String',num2str(MCN));

  menupos=[...
	     20  340 180 20;...
	     20  310 180 20;...
	     20  290 180 20;...
	     20  270 180 20;...
	     20  250 180 20;...
	     20  230 180 20;...
	     20  210 180 20;...
	     ];


  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(1,:),...
	       'String',texta,...
               'HorizontalAlignment','Center',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2,:),...
	       'String',textb,...
               'HorizontalAlignment','Left',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(3,:),...
	       'String',textc,...
               'HorizontalAlignment','Left',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(4,:),...
	       'String',text1,...
               'HorizontalAlignment','Left',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(5,:),...
	       'String',text2,...
               'HorizontalAlignment','Left',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(6,:),...
	       'String',text3,...
               'HorizontalAlignment','Left',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(7,:),...
	       'String',text4,...
               'HorizontalAlignment','Left',...
	       'BackGroundColor',grey);

  set(gcf,'HandleVisibility','CallBack');
  guidetect('changehist')

  end
end;

if strcmp(action,'changehist')

  fighandle=findobj('Tag','figchangetool');
  handle=findobj(fighandle,'Tag','changehist');
  onvalue=get(handle,'Value');
  if ~onvalue
    h=findobj('Tag','figmc1');
    if ~isempty(h); close(h), end
    h=findobj('Tag','figmc2');
    if ~isempty(h); close(h), end
    h=findobj('Tag','figmc3');
    if ~isempty(h); close(h), end
  else
  FA=RESULT.mc.FA;
  dfd=RESULT.mc.dfd;
  TA=RESULT.mc.TA;

%  Histogram over false alarms
  handle=findobj('Tag','figmc1');
  if length(FA)>0 & ~isempty(find(diff(FA)~=0));  % Hist bugg in matlab 5.1 
    if isempty(handle);
      figure('Tag','figmc1',...
        'Units','normalized',...
        'Position',figpos(22,:),...
        'Name','Histogram over false alarms',...
        'MenuBar','none',...
        'NumberTitle','off')
    else 
      figure(handle);
    end;
    hist(FA); 
  else
    if ~isempty(handle);
      close(handle)
    end
  end

  
%  Histogram over alarm times
  handle=findobj('Tag','figmc2');
  if length(TA)>0 & ~isempty(find(diff(TA)~=0));  % Hist bugg in matlab 5.1 
    if isempty(handle);
      figure('Tag','figmc2',...
        'Units','normalized',...
        'Position',figpos(23,:),...
        'Name','Histogram over alarm times',...
        'MenuBar','none',...
        'NumberTitle','off')
    else 
      figure(handle);
    end;
    hist(TA); 
  else
    if ~isempty(handle);
      close(handle)
    end
  end

%  Histogram over delay for detections
  handle=findobj('Tag','figmc3');
  if length(dfd)>0 & ~isempty(find(diff(dfd)~=0));  % Hist bugg in matlab 5.1 
    if isempty(handle);
      figure('Tag','figmc3',...
        'Units','normalized',...
        'Position',figpos(24,:),...
        'Name','Histogram over delay for detection',...
        'MenuBar','none',...
        'NumberTitle','off')
    else 
      figure(handle);
    end;
    hist(dfd); 
  else
    if ~isempty(handle);
      close(handle)
    end
  end
  end
end
  
if strcmp(action,'tabchangetool')
  Values=RESULT.mc.Values;
  mainhandle=findobj('Tag','main');
  fighandle=findobj(0,'Tag','figMCtab');
  if isempty(fighandle);
      fighandle=figure('Tag','figMCtab',...
        'Units','pixels',...
	'Position',figpos(18,:),...
        'Units','normalized',...
	'Name','Change Tool Table',...
	'NumberTitle','off',...
	'Color',grey,...
        'MenuBar','none',...
        'HandleVisibility','on',...
	'UserData',[]);
        %------ File menu-----------

        test_menu=uimenu(gcf,'Label','Latex');
        uimenu(test_menu,'Label','Table',...
                 'Callback','guidetect(''latexMCtab'',1)');
        uimenu(test_menu,'Label','Document',...
                 'Callback','guidetect(''latexMCtab'',2)');
        uimenu(test_menu,'Label','Preview',...
                 'Callback','guidetect(''latexMCtab'',3)');
        uimenu(test_menu,'Label','Print',...
                 'Callback','guidetect(''latexMCtab'',4)');

  else
      figure(fighandle);
      set(fighandle,'Visible','on');
  end;
  tabmat=get(fighandle,'UserData');
  Nentries=size(tabmat,1);
  sep=60;  % column separation
  ncol=6;     % Number of columns in table
  for i=1:11;
    for j=1:ncol;
      if j==1;
        menupos(i*ncol-ncol+j,:)=[10 320-i*20 6*sep 20];
%      elseif j==2;
%        menupos(i*ncol-ncol+j,:)=[10+(j-1)*3*sep 320-i*20 4*sep 20];
      else
        menupos(i*ncol-ncol+j,:)=[10+1.1*(j+4)*sep 320-i*20 sep 20];
      end
    end
  end

  if Nentries<1;
    Nentries=1;
    Titles=str2mat('Method (push to re-load)','Nsim','Nr det.','FAR','MDR','MTD');
    latexTitles=str2mat('Method with design parameters','Nsim','Nr det.','FAR','MDR','MTD');
    for i=1:ncol;
      ind=findstr('  ',Titles(i,:));
      if ~isempty(ind); 
        text=Titles(i,1:ind(1)-1); 
      else
        text=Titles(i,:);
      end;
      uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(i,:)+[0 10 0 0],...
	       'String',text,...
	       'BackGroundColor',grey);
      tabmat=[tabmat,latexTitles(i,:),' & '];
    end;
    n=length(tabmat);
    tabmat(n-2:n)='   ';
    tabmat=[tabmat,' \\\\ \\hline \\hline'];
  end
  Nentriesmod10=rem(Nentries-1,10)+1;   % Shift out first value in
                                    % Matlab table, but keep in latex

  % Make strings with detector information
  adm=guidetect('getdetectpar',3);
  adgpar=guidetect('getdetectpar',4);

  OBJECTS=[];	
  OBJECTS.filter=FILTER;
  OBJECTS.result=RESULT;
  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',menupos(Nentriesmod10*ncol+1,:),...
	       'String',[adm,'    ',adgpar],...
	       'Tag',['detector',num2str(Nentries)],...
       'CallBack',['guidetect(''getdetector'',',num2str(Nentries),')'],...
               'UserData',OBJECTS,...
	       'BackGroundColor',grey);
  newline=[adm,' ',adgpar];
  for i=1:ncol-1;    
    newline=[newline,' & ',num2str(Values(i))];
    if Values(i)>0;
      uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(Nentriesmod10*ncol+i+1,:),...
	       'String',num2str(Values(i)),...
	       'BackGroundColor',grey);
    else
      uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(Nentriesmod10*ncol+i+2,:),...
	       'String','-',...
	       'BackGroundColor',grey);
    end
  end
  tabmat=str2mat(tabmat,[newline,' \\\\ \\hline']);
  set(fighandle,'UserData',tabmat);
  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',[165 10 60 20],...
	       'String','Help',...
	       'CallBack','guihelp(''MCtable'')',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',[235 10 60 20],...
	       'String','Close',...
	       'CallBack','set(gcf,''Visible'',''off'')',...
	       'BackGroundColor',grey);

	   
  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',[305 10 60 20],...
	       'String','Latex',...
	       'CallBack','guidetect(''latexMCtab'')',...
	       'BackGroundColor',grey);
	   
  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',[375 10 60 20],...
	       'String','Quit',...
	       'CallBack','close(gcf)',...
	       'BackGroundColor',grey);
end;

if strcmp(action,'getdetector')
% arg1 table item

  fighandle=findobj(0,'Tag','figMCtab');
  handle=findobj(fighandle,'Tag',['detector',num2str(arg1)]);
  OBJECTS=get(handle,'UserData');
  FILTER=OBJECTS.filter;
  RESULT=OBJECTS.result;
  guidetect('plottool')
  guidetect('updatemainsim')
  guidetect('updatechangedesign')
  guidetect('updatechangetool')
  guidetect('updateadaptivetool')
end

if strcmp(action,'latexMCtab')
  % arg1=1   latex table
  % arg1=2   latex document
  % arg1=3   latex document with preview
  % arg1=4   print latex document
  if ~exist('arg1'); arg1=3; end;
  mainhandle=findobj('Tag','main');
  fighandle=findobj(0,'Tag','figMCtab');
  tabmat=get(fighandle,'UserData');
  Nentries=size(tabmat,1)-1;
  ncol=length(find(tabmat(1,:)=='&'));
  tabarg='|l|';
  for i=1:ncol;
    tabarg=[tabarg,'c|'];
  end;
  intro=str2mat('\\documentclass[12pt,landscape]{article}',...
                '\\textwidth 18cm ',...
		'\\textheight 24cm ',...
		'\\begin{document}',...
		'\\centerline{ ',...
		'\\begin{tabular}{',tabarg,'} ',...
		'\\hline ');
  conc=str2mat('\\end{tabular}',...
	       '} ',...
	       '\\end{document}');
  nrows=size(tabmat,1);
  
  fid=fopen('MCtab.tex','wt');
  if arg1>1;
    for i=1:size(intro,1);
      fprintf(fid,[intro(i,:),' \n']);
    end;
  end
  for i=1:size(tabmat,1);
    fprintf(fid,[tabmat(i,:),' \n']);
  end;
  if arg1>1;
    for i=1:size(conc,1);
      fprintf(fid,[conc(i,:),' \n']);
    end;
  end
  fclose(fid);   
  if arg1>2;
    !latex MCtab
  end
  if arg1==3;
    !xdvi MCtab &
  elseif arg1==4
    !dvips -t landscape MCtab
  end
end


%======== Adaptive tool =====================


if strcmp(action,'adaptivetool')  
   %arg1=1/0

  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','adaptivetool');
  fighandle=findobj(0,'Tag','figadaptivetool');
  if nargin>1;
     set(onhandle,'Value',arg1);
  end
        
  if get(onhandle,'Value');
    if isempty(fighandle);
      fighandle=figure('Tag','figadaptivetool',...
        'Units','pixels',...
	'Position',[figpos(19,1:2) 420 320],...
        'Units','normalized',...
	'Name','Adaptive Filtering Design Tool',...
	'NumberTitle','off',...
        'IntegerHandle','off',...
        'MenuBar','none',...
        'HandleVisibility','on',...
	'Color',darkgrey);
%	'NextPlot','new',...
   
      Frames=[10 215 400  90;...
              10 115 400  90;...
        	  ];
      for i=1:size(Frames,1);
        uicontrol(fighandle,'Style','Frame',...
               'Units','pixels',...
               'Position',Frames(i,:),...
	       'BackGroundColor',grey);
      end
    
	  
           menupos=[... 		
	     20   280 320 20;...
	     300 280 90 20;...
	      50 260 220 20;...
	     300 260 90 20;...
	      50 240 220 20;...
	     300 240 90 20;...
	      50 220 220 20;...
	     300 220 90 20;...
	     20  180 320 20;...
	     300 180 90 20;...
	      50 160 320 20;...
	     300 160 90 20;...
	      50 140 320 20;...
	     300 140 90 20;...
	      50 120 320 20;...
	     300 120 90 20;...
	      50 90 320 20;...
	     300 90 90 20;...
	      50 60 320 20;...
	     300 60 90 20;...
	      50 40 320 20;...
	     300 40 40 20;...
	      40  10  60 20;...
	     110  10  60 20;...
	     180  10  60 20;...
	     250  10  60 20;...
	     320  10  60 20;...
	     ];

pbpos=[30 260 20 20;...
         30 240 20 20;...
         30 220 20 20;...
         30 160 20 20;...
         30 140 20 20;...
         30 120 20 20;...
	 ];
	   


 Strings=str2mat('NORMS FOR SMOOTHED ESTIMATES           Current value','   Loss function (V):',...
    '   MDL:','   RMS parameter error:','NORMS FOR RECURSIVE ESTIMATES          Current value','   Loss function (V):','   MDL:',...
    '   RMS parameter error (PE):','Computation time');

 Colors=[grey;grey;grey;grey;grey;grey;grey;grey;darkgrey;darkgrey;darkgrey];
 
      for i=1:size(Strings,1);
        uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2*i-1,:),...
	       'String',Strings(i,:),...
               'HorizontalAlignment','Left',...
	       'BackGroundColor',Colors(i,:));
      end
  
      Tags=str2mat('1','2','3','4','5','6');
      Callbacks='setadaptivetool';
      for i=1:size(pbpos,1);
        uicontrol(fighandle,'Style','RadioButton',...
               'Units','pixels',...
               'Position',pbpos(i,:),...
	       'String',' ',...
	       'Tag',Tags(i,:),...
               'CallBack',['guidetect(''',Callbacks,''');'],...
	       'BackGroundColor',darkgrey);
      end
      if SIM.datatype==2;  
        uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(21,:),...
	       'String','Monte Carlo iterations:',...
	       'BackGroundColor',darkgrey);
      end
      uicontrol(fighandle,'Style','Edit',...
               'Units','pixels',...
               'Position',menupos(22,:),...
	       'String',num2str(1),...
	       'Tag','MCiter',...
	       'BackGroundColor','w');

      uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(23,:),...
	       'String','MC',...
	       'BackGroundColor',darkgrey,...
       	       'Callback','guidetect(''startMC'',''ad'');');

      uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(24,:),...
	       'String','AutoTune',...
	       'BackGroundColor',darkgrey,...
       	       'Callback','guidetect(''startoptdesign'');');

     uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(25,:),...
	       'String','Table',...
	       'BackGroundColor',darkgrey,...
       	       'Callback','guidetect(''tabadaptivetool'');');

     uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(26,:),...
	       'String','Help',...
	       'BackGroundColor',darkgrey,...
       	       'Callback','guihelp(''adaptivetool'');');

     uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',menupos(27,:),...
	       'String','Close',...
	       'BackGroundColor',darkgrey,...
       	       'Callback','guidetect(''closeadaptivetool'')');
    set(fighandle,'HandleVisibility','Callback');
    else
      figure(fighandle);
      set(fighandle,'Visible','on');
    end;
    guidetect('setadaptivetool');
    guidetect('updateadaptivetool');
  elseif fighandle~=0
    set(fighandle,'Visible','off')
    mainhandle=findobj('Tag','block');
    onhandle=findobj(mainhandle,'Tag','adaptivetool');
    set(onhandle,'Value',0);
  end;
end

if strcmp(action,'closeadaptivetool')
  fighandle=findobj(0,'Tag','figadaptivetool');
  set(fighandle,'Visible','off')
  fighandle=findobj(0,'Tag','block');
  handle=findobj(0,'Tag','adaptivetool');
  set(handle,'Value',0)
  fighandle=findobj(0,'Tag','addesignplot');
  if ~isempty(fighandle)
     close(fighandle)
  end
  
end;

if strcmp(action,'setadaptivetool');
  % arg1 = choice of norm
  Noptchoices=6;
  fighandle=findobj('Tag','figadaptivetool');
  oldstatus=get(fighandle,'UserData');
  if isempty(oldstatus); 
    oldstatus=zeros(1,Noptchoices); 
%    oldstatus(4,1)=1;  % Default
  end   
  status=oldstatus;
  for i=1:Noptchoices,
    handle(i)=findobj(fighandle,'Tag',[num2str(i)]);
    if get(handle(i),'Value')==1;
      status(i)=1;
    else
      status(i)=0;
    end
  end
  status=xor(status,oldstatus);   % 	case: try to unlock or two locked
  if nargin>1;
     status=zeros(1,Noptchoices); 
     status(arg1)=1;
  end
  ind=find(oldstatus==1);
  set(handle(ind),'Value',0),
  ind=find(status==1);
  set(handle(ind),'Value',1),
  set(fighandle,'UserData',status);
end


if strcmp(action,'Vadaptivetool')

   % Global Vrec Vseg MSrec MSseg z jhat detectnnn comptime detecttype

   datatype=SIM.datatype;
   z=RESULT.z;
   threc=RESULT.threc;
   thseg=RESULT.thseg;
   jhat=RESULT.jhat;
   comptime=RESULT.comptime;
   MSrec=RESULT.mc.MSrec;
   MSseg=RESULT.mc.MSseg;
   Vrec=RESULT.mc.Vrec;
   Vseg=RESULT.mc.Vseg;
   detectnnn=FILTER.nnn;
   detecttype=FILTER.detecttype;
   detectnnn=guidetect('getdetectpar',1);
   N=length(z);
    if N>0;
      [t0,d]=z2phi(z,0,detectnnn);
      deltath=diff([zeros(1,d); threc']);
      MDLrec=Vrec+1/(N-t0-d)*sum(sum(deltath(t0+d+1:N,:).^2));
      k=length(jhat)+2;
      MDLseg=Vseg+d*k*log(N-t0-d)/(N-t0-d);
      thnormrec=sqrt(sum(sum(MSrec))/N);
      thnormseg=sqrt(sum(sum(MSseg))/N);
%      Vrec, MDLrec, thnormrec
    

      Values=[0 Vseg MDLseg  thnormseg 0 Vrec MDLrec thnormrec comptime];
      if detecttype==1; 
        Values(2:4)=-ones(1,3);
      end
      if datatype==1; 
        Values([4 8])=-ones(1,2);
      end
    else
      Values=-ones(1,8);
    end
    out1=Values;
    RESULT.mc.Values=Values;
end;

if strcmp(action,'adtoolMC')
%zzz
  guidetect('disp','Monte Carlo simulations in progress.','r')

  mcinfohandle=figure('Tag','MCinfo',...
        'Units','pixels',...
	'Position',[300 300 220 40],...
	'Name','MC info',...
	'NumberTitle','off',...
	'Color',darkgrey,...
        'MenuBar','none',...
        'HandleVisibility','on',...
	'UserData',[]);
  menupos=[  20 10 180 20;...
	     ];
  red=[1 0.5 0.5];
  fighandle=findobj('Tag','figadaptivetool');
  MChandle=findobj(fighandle,'Tag','MCiter');
  dum=get(MChandle,'String');
  if isstr(dum);
    MCN=str2num(dum);
  else 
    MCN=1;
  end

  [d,dum]=size(simthhat);
  dfd=[];
  missedalarms=0;
  FA=[];
  TA=[];
  JHAT=[];
  TH0=zeros(d,simN);
  THREC=zeros(d,simN);
  THSEG=zeros(d,simN);
  MSREC=zeros(d,simN);
  MSSEG=zeros(d,simN);
  VREC=0;
  VSEG=0;
  GT=0;
  guidetect('startclock')
  for i=1:MCN;

    uicontrol(mcinfohandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(1,:),...
	       'String',['Running iteration: ',num2str(i)],...
	       'BackGroundColor',red);
    drawnow
    randn('seed',i);
    guidetect('startsim')
    guidetect('startdetect')
    TH0=TH0+th0;
    THREC=THREC+threc;
    THSEG=THSEG+thseg;
    MSREC=MSREC+(th0-threc).^2;
    MSSEG=MSSEG+(th0-thseg).^2;
    VREC=VREC+Vrec;
    VSEG=VSEG+Vseg;
    GT=GT+gt;
    
  end;


  th0=TH0/MCN;
  threc=THREC/MCN;
  thseg=THSEG/MCN;
  MSrec=MSREC/MCN;
  MSseg=MSSEG/MCN;
  Vrec=VREC/MCN;
  Vseg=VSEG/MCN;
  gt=GT/MCN;
  
  guidetect('stopclock')
  guidetect('plottool')
  guidetect('updateadaptivetool')
  guidetect('disp','Ready. Mean values displayed in all plots.')
  close(mcinfohandle)

end


if strcmp(action,'getdetectpar')
% arg1=1  nnn
% arg2=1  nnnstring
% arg3=1  adm
% arg4=1  adgstring

  if FILTER.modeltype==1;
    nnn=0;
  elseif FILTER.modeltype==2;
    nnn=-1;
  elseif FILTER.modeltype==3;
    nnn=-2;
  elseif FILTER.modeltype==4;
    nnn=FILTER.nnn.ar;
  elseif FILTER.modeltype==5;
    nnn=FILTER.nnn.arx;
  elseif FILTER.modeltype==6;
    nnn=FILTER.nnn.ss;
  end
  if isstr(nnn)
    nnnstring=nnn;
  else
    nnnstring=cdnum2str(nnn);
  end

  if FILTER.detecttype==1;
    m=FILTER.adfilter.adm;
    if m==1;
      adm='RLS';
      adgstring='Forgetting factor';
    elseif m==2;
      adm='WLS';
      adgstring='Sliding window size';
    elseif m==3;
      adm='LMS';
      adgstring='Step size';
    elseif m==4;
      adm='NLMS';
      adgstring='Step size';
    elseif m==5;
      adm='KF';
      adgstring='State covariance';
    end
    adg=FILTER.adfilter.adg(FILTER.adfilter.adm);
    adgstring=[adgstring,' ',cdnum2str(adg)];


  elseif FILTER.detecttype==2;
    adm='Whiteness test';
    dm=FILTER.detect1.dm;
    sr=FILTER.detect1.sr;
    h=FILTER.detect1.h;
    nuorgam=FILTER.detect1.nuorgam;
    lam=FILTER.detect1.lam;
    if sr<3;
      dum='nu';
    else
      dum='gamma';
    end
    adgstring=['dm=',num2str(dm),', sr=',num2str(sr),', h=',num2str(h),...
    ', ',dum,'=',num2str(nuorgam),', lam=',num2str(lam)];

  elseif FILTER.detecttype==3;
    adm='Parallel filters';
    dm=FILTER.detect2.dm;
    sr=FILTER.detect2.sr;
    h=FILTER.detect2.h;
    nuorgam=FILTER.detect2.nuorgam;
    lam=FILTER.detect2.lam;
    L=FILTER.detect2.L;
    if sr<3;
      dum='nu';
    else
      dum='gamma';
    end
    adgstring=['dm=',num2str(dm),', sr=',num2str(sr),', h=',num2str(h),...
    ', ',dum,'=',num2str(nuorgam),', lam=',num2str(lam),', L=',num2str(L)];

  elseif FILTER.detecttype==4;
    adm='Filter bank';
    lf=FILTER.detectM.lf;
    q=FILTER.detectM.q;  
    minseg=FILTER.detectM.minseg;
    lifelength=FILTER.detectM.lifelength;
    lambda=FILTER.detectM.lambda;
    M=FILTER.detectM.M;
    adgstring=['lf=',num2str(lf),', q=',num2str(q),', ss=',...
	       cdnum2str([M lifelength minseg]),'M=',num2str(M)];

  elseif FILTER.detecttype==5;
    %error('Not prepared for state space models')

  elseif FILTER.detecttype==6;

  end;

  if arg1==1 
    out1=nnn;
  elseif arg1==2;
    out1=nnnstring;
  elseif arg1==3;
    out1=adm;
  elseif arg1==4;
    out1=adgstring;
  end

end

if strcmp(action,'updateadaptivetool')
  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','adaptivetool');
  fighandle=findobj(0,'Tag','figadaptivetool');

  if get(onhandle,'Value');
           menupos=[... 		
	     20   280 320 20;...
	     300 280 90 20;...
	      50 260 220 20;...
	     300 260 90 20;...
	      50 240 220 20;...
	     300 240 90 20;...
	      50 220 220 20;...
	     300 220 90 20;...
	     20  180 320 20;...
	     300 180 90 20;...
	      50 160 320 20;...
	     300 160 90 20;...
	      50 140 320 20;...
	     300 140 90 20;...
	      50 120 320 20;...
	     300 120 90 20;...
	      50 90 320 20;...
	     300 90 90 20;...
	      20 60 350 20;...
	     300 60 90 20;...
	      50 40 320 20;...
	     300 40 90 20;...
	      40  10  60 20;...
	     110  10  60 20;...
	     180  10  60 20;...
	     250  10  60 20;...
	     320  10  60 20;...
	     ];
    
  Values=guidetect('Vadaptivetool');
  % ----- set adm and adgpar -----------------
  adm=guidetect('getdetectpar',3);
  adgpar=guidetect('getdetectpar',4);
	
    optstring=['Algorithm: ',adm,' with ',adgpar];
    %subpos=menupos();
    Colors=[grey;grey;grey;grey;grey;grey;grey;grey;darkgrey;darkgrey;darkgrey];
    for i=1:length(Values);
      if Values(i)>0;
        uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2*i,:),...
	       'String',num2str(Values(i)),...
	       'BackGroundColor',Colors(i,:));
      elseif Values(i)<0 & i~=1 & i~=5
        uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2*i,:),...
	       'String','N.A.',...
	       'BackGroundColor',Colors(i,:));
      end
    end
    uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(19,:),...
	       'String',optstring,...
               'HorizontalAlignment','Center',...
	       'BackGroundColor',darkgrey);
    
  end
end;

if strcmp(action,'tabadaptivetool')
  mainhandle=findobj('Tag','block');
  fighandle=findobj(0,'Tag','figtabdesign');
  if isempty(fighandle);
      fighandle=figure('Tag','figtabdesign',...
        'Units','pixels',...
	'Position',figpos(20,:),...
        'Units','normalized',...
	'Name','Design Table',...
	'NumberTitle','off',...
   'MenuBar','none',...
	'Color',grey,...
      'HandleVisibility','on',...
	'UserData',[]);
        %------ File menu-----------

        test_menu=uimenu(fighandle,'Label','Latex');
        uimenu(test_menu,'Label','Table',...
                 'Callback','guidetect(''latexadtab'',1)');
        uimenu(test_menu,'Label','Document',...
                 'Callback','guidetect(''latexadtab'',2)');
        uimenu(test_menu,'Label','Preview',...
                 'Callback','guidetect(''latexadtab'',3)');
        uimenu(test_menu,'Label','Print',...
                 'Callback','guidetect(''latexadtab'',4)');

  else
      figure(fighandle);
      set(fighandle,'Visible','on');
  end;
  tabmat=get(fighandle,'UserData');
  Nentries=size(tabmat,1);
  sep=60;  % column separation
  ncol=7;     % Number of columns in table
  for i=1:11;
    for j=1:ncol;
      if j==1;
        menupos(i*ncol-ncol+j,:)=[10 320-i*20 5*sep 20];
%      elseif j==2;
%        menupos(i*8-8+j,:)=[10+(j-1)*3*sep 320-i*20 4*sep 20];
      else
        menupos(i*ncol-ncol+j,:)=[10+1.1*(j+3)*sep 320-i*20 sep 20];
      end
    end
  end

  if Nentries<1;
    Nentries=1;
    Titles=str2mat('Method (push to re-load)','V(seg)','MDL(seg)','PE(seg)','V(rec)','MDL(rec)','PE(rec)');
    latexTitles=str2mat('Method with design parameters','V(seg)','MDL(seg)','PE(seg)','V(rec)','MDL(rec)','PE(rec)');

%               'Position',menupos(Nentries*8+i+2,:),...
    for i=1:ncol;
      ind=findstr('  ',Titles(i,:));
      if ~isempty(ind); 
        text=Titles(i,1:ind(1)-1); 
      else
        text=Titles(i,:);
      end;
      uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(i,:)+[0 10 0 0],...
               'Units','normalized',...
	       'String',text,...
	       'BackGroundColor',grey);
      tabmat=[tabmat,latexTitles(i,:),' & '];
    end;
    n=length(tabmat);
    tabmat(n-2:n)='   ';
    tabmat=[tabmat,' \\\\ \\hline \\hline'];
  end
  Nentriesmod10=rem(Nentries-1,10)+1;   % Shift out first value in
                                    % Matlab table, but keep in latex
  Values=guidetect('Vadaptivetool');
  Vind=[2 3 4 6 7 8];
  Values=Values(Vind);

  adm=guidetect('getdetectpar',3);
  adgpar=guidetect('getdetectpar',4);
  OBJECTS=[];	
  OBJECTS.filter=FILTER;
  OBJECTS.result=RESULT;
  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',menupos(Nentriesmod10*ncol+1,:),...
               'Units','normalized',...
	       'String',[adm,'    ',adgpar],...
	       'Tag',['adfilter',num2str(Nentries)],...
       'CallBack',['guidetect(''getadfilter'',',num2str(Nentries),')'],...
               'UserData',OBJECTS,...
	       'BackGroundColor',grey);
  newline=[adm,'  ',adgpar];
  for i=1:ncol-1;    
    newline=[newline,' & ',num2str(Values(i))];
    if Values(i)>0;
      uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(Nentriesmod10*ncol+i+1,:),...
               'Units','normalized',...
	       'String',num2str(Values(i)),...
	       'BackGroundColor',grey);
    else
      uicontrol(fighandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(Nentriesmod10*ncol+i+1,:),...
               'Units','normalized',...
	       'String','-',...
	       'BackGroundColor',grey);
    end
  end
  tabmat=str2mat(tabmat,[newline,' \\\\ \\hline']);
  set(fighandle,'UserData',tabmat);
  uicontrol(fighandle,'Style','Pushbutton',...
               'Units','pixels',...
               'Position',[165 10 60 20],...
               'Units','normalized',...
	       'String','Help',...
	       'CallBack','guihelp(''designtable'')',...
	       'BackGroundColor',grey);

  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',[235 10 60 20],...
               'Units','normalized',...
	       'String','Close',...
	       'CallBack','set(gcf,''Visible'',''off'')',...
	       'BackGroundColor',grey);

	   
  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',[305 10 60 20],...
               'Units','normalized',...
	       'String','Latex',...
	       'CallBack','guidetect(''latexadtab'',3)',...
	       'BackGroundColor',grey);
	   
  uicontrol(fighandle,'Style','PushButton',...
               'Units','pixels',...
               'Position',[375 10 60 20],...
               'Units','normalized',...
	       'String','Quit',...
	       'CallBack','close(gcf)',...
	       'BackGroundColor',grey);
end;

if strcmp(action,'getadfilter')
% arg1 table item

  fighandle=findobj(0,'Tag','figtabdesign');
  handle=findobj(fighandle,'Tag',['adfilter',num2str(arg1)]);
  OBJECTS=get(handle,'UserData');
  FILTER=OBJECTS.filter;
  RESULT=OBJECTS.result;
  guidetect('plottool')
  guidetect('updatemainsim')
  guidetect('updatechangedesign')
  guidetect('updatechangetool')
  guidetect('updateadaptivetool')
end

if strcmp(action,'latexadtab')
  % arg1=1   latex table
  % arg1=2   latex document
  % arg1=3   latex document with preview
  % arg1=4   print latex document
  if ~exist('arg1'); arg1=3; end;
  mainhandle=findobj('Tag','main');
  fighandle=findobj(0,'Tag','figtabdesign');
  tabmat=get(fighandle,'UserData');
  Nentries=size(tabmat,1)-1;
  ncol=length(find(tabmat(1,:)=='&'));
  tabarg='|l|';
  for i=1:ncol;
    tabarg=[tabarg,'c|'];
  end;
  intro=str2mat('\\documentclass[12pt,landscape]{article}',...
                '\\textwidth 18cm ',...
		'\\textheight 24cm ',...
		'\\begin{document}',...
		'\\centerline{ ',...
		'\\begin{tabular}{',tabarg,'} ',...
		'\\hline ');
  conc=str2mat('\\end{tabular}',...
	       '} ',...
	       '\\end{document}');
  nrows=size(tabmat,1);
  
  fid=fopen('designtab.tex','wt');
  if arg1>1;
    for i=1:size(intro,1);
      fprintf(fid,[intro(i,:),' \n']);
    end;
  end
  for i=1:size(tabmat,1);
    fprintf(fid,[tabmat(i,:),' \n']);
  end;
  if arg1>1;
    for i=1:size(conc,1);
      fprintf(fid,[conc(i,:),' \n']);
    end;
  end
  fclose(fid);   
  if arg1>2;
    !latex designtab
  end
  if arg1==3;
    !xdvi  -paper a4r designtab &
  elseif arg1==4
    !dvips -t landscape designtab
  end
end

if strcmp(action,'startoptdesign')

  guidetect('disp','Design parameter optimization in progress.')
%zzz tag


  menupos=[  20 30 180 20;...
             20 10 180 20;...
	     ];
  red=[1 0.5 0.5];

 
  statushandle=findobj('Tag','figadaptivetool');
  status=get(statushandle,'UserData');
  optm=find(status==1);
  fighandle=findobj('Tag','figadaptivetool');
  MChandle=findobj(fighandle,'Tag','MCiter');
  dum=get(MChandle,'String');
  if isstr(dum);
    MCiter=str2num(dum);
  else 
    MCiter=1;
  end
  if MCiter>1
      mcinfohandle=figure('Tag','MCinfo',...
        'Units','pixels',...
	'Position',[300 300 220 60],...
	'Name','MC info',...
	'NumberTitle','off',...
	'Color',grey,...
        'MenuBar','none',...
        'HandleVisibility','on',...
	'UserData',[]);
  end
  
  Values=guidetect('Vadaptivetool');
  indV=[2 3 4 6 7 8];
  Values=Values(indV);

  if Values(optm)<0 & ~isempty(thhat);
     guidetect('disp','Not a computable norm for this setting'), 
     if MCiter>1, close(mcinfohandle), end
     return
  elseif isempty(optm);
     guidetect('disp','Choose a norm!','r'), 
     if MCiter>1, close(mcinfohandle), end
     return
  else
    n=10;
    adm=guidetect('getdetectpar',3);
    %adgpar=guidetect('getdetectpar',4);
    if FILTER.detecttype==1;
      m=FILTER.adfilter.adm;  % RLS, WLS,...
      adg=FILTER.adfilter.adg(m);  % adaption gain
      if m==1;
	adm='RLS'; adg=1-(1-adg)*logspace(-0.5,0.5,n);
	ind=find(adg<0); adg(ind)=zeros(size(ind));
	ind=find(adg>1); adg(ind)=ones(size(ind)); 
      elseif m==2;
	adm='WLS'; adg=round(adg*logspace(-1,1,n));
      elseif m==3;
	adm='LMS'; adg=adg*logspace(-1,1,n);
      elseif m==4;
	adm='NLMS'; adg=adg*logspace(-1,1,n);
      elseif m==5;
	adm='KF';  adg=adg*logspace(-1,1,n);
      end;
      parnr=1;
    elseif FILTER.detecttype==2;
      if FILTER.detect1.sr<3;
	adm='CUSUM';
      elseif FILTER.detect1.sr>2;
	adm='GMA';
      end
      adg=FILTER.detect1.nuorgam*logspace(-1,1,n);
      parnr=3;
    elseif FILTER.detecttype==3;
      if FILTER.detect2.sr==1 |FILTER.detect2.sr==2;
	adm='CUSUM';
      elseif FILTER.detect2.sr==3 |FILTER.detect2.sr==4;
	adm='GMA';
      else
	adm='Bayes';
      end
      adg=FILTER.detect2.nuorgam*logspace(-1,1,n);
      parnr=3;
    else
      guidetect('disp','Not yet implemented')
    end;
    if exist('adm');  
%      guidetect('startclock')  % does not work because of Vadaptivetool

      for j=1:n  % search loop
        if FILTER.detecttype==1;
          FILTER.adfilter.adg(m)=adg(j);  % adaption gain
        elseif FILTER.detecttype==2;
          FILTER.detect1.nuorgam=adg(j);
        elseif FILTER.detecttype==3;
          FILTER.detect2.nuorgam=adg(j);
        end
	
        if datatype==1 & MCiter>1;
	  randn('seed',1);
	  for i=1:MCiter;
            uicontrol(mcinfohandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(1,:),...
               'Units','normalized',...
	       'String',['Running iteration: ',num2str(i)],...
	       'BackGroundColor',red);
            uicontrol(mcinfohandle,'Style','Text',...
               'Units','pixels',...
               'Position',menupos(2,:),...
               'Units','normalized',...
	       'String',['for design parameter: ',num2str(adg(j))],...
	       'BackGroundColor',red);
            drawnow
	    guidetect('startsim|startdetect')
	    Values=guidetect('Vadaptivetool');
	    Values=Values(indV);
	    Vsim(i)=Values(optm);
	  end;
	  V(j)=mean(Vsim);
	else
	  guidetect('startdetect')
          Values=guidetect('Vadaptivetool');
          Values=RESULT.mc.Values;
          Values=Values(indV);
	  V(j)=Values(optm);
          guidetect('updateadaptivetool')
	end;
      end
%      guidetect('stopclock')
      [Vmin,minind]=min(V);
      adgopt=adg(minind);
      guidetect('disp',['Vmin = ',num2str(Vmin),' for adg = ',num2str(adgopt)])

      if FILTER.detecttype==1;
        m=FILTER.adfilter.adm;  % RLS, WLS,...
        FILTER.adfilter.adg(m)=adgopt;  % adaption gain
      elseif FILTER.detecttype==2;
        FILTER.detect1.nuorgam=adgopt;
      elseif FILTER.detecttype==3;
        FILTER.detect2.nuorgam=adgopt;
      end	
      
      guidetect('startdetect')
      guidetect('updateadaptivetool')
      figure
      set(gcf,'Tag','addesignplot',...
        'Units','normalized',...
	'Position',figpos(21,:),...
	'Name','Optimization result',...
	'NumberTitle','off',...
	'Color',grey,...
	'UserData',[]);
      plot(adg,V)
      xlabel('Adaptation gain')
      ylabel('Optimization criterion (V or PE or MDL)')
      title(['Optimal adaptation gain for ',adm,' is ',...
	    num2str(adg(minind))])
    end
  end
  guidetect('disp','Ready. Mean values at optimum displayed in all plots.')
  close(mcinfohandle)
end  
  
if strcmp(action,'startsim')
  %datatype=2;
%xxx
  simN=SIM.m(SIM.modeltype).N;
  simthhat=SIM.m(SIM.modeltype).thhat;
  simjhat=SIM.m(SIM.modeltype).jhat;
  simlamhat=SIM.m(SIM.modeltype).lamhat;
  simu=SIM.nnn.u{1};
  lamu=SIM.nnn.u{2};
  fcn1=[];
  if SIM.modeltype==1;
    z=randn(simN,1);
    fcn1='z=randn(simN,1);';
  elseif SIM.modeltype==2;
    z=randn(simN,1);
    fcn1='z=randn(simN,1);';
  elseif SIM.modeltype==4;
    z=randn(simN,1);
    fcn1='z=randn(simN,1);';
  elseif SIM.modeltype==[3] | SIM.modeltype==[5] 
   if SIM.nnn.utype==2;  % simulated u
     u=sqrt(lamu)*randn(simN,1);
     z=[randn(simN,1) u];
     fcn1=['z=[randn(simN,1) sqrt(lamu)*randn(simN,1)'];
   elseif SIM.nnn.utype==1;  % u from file
    eval(['global ',simu])
    if exist('simu') 
      eval(['u=',simu,';'])
      if length(u)~=simN
        guidetect('disp',[simu,' is not of length ',num2str(simN),'!'],'r'),return
      end
    else
       guidetect('disp',[simu,' is not found as a global!'],'r'),return
    end;
    z=[randn(simN,1) u];
    fcn1=['z=[randn(simN,1) ',simu,'];'];
   end
  elseif SIM.modeltype==[6] 
    SIM.nnn.utype
    if SIM.nnn.utype==1;
      eval(['global ',simu])
      if exist('simu') 
        eval(['u=',simu,';'])
        if length(u)~=simN
          guidetect('disp',[simu,' is not of length ',num2str(simN),'!'],'r'),return
        end
      else
        guidetect('disp',[simu,' is not found as a global!'],'r'),return
      end;
      eval(['simu=',simu,';'])
      z=[u];
      fcn1=['z=[',simu,'];'];
    else
      u=sqrt(lamu)*randn(simN,1);
      z=[randn(simN,1) u];
      fcn1=['z=[randn(simN,1) sqrt(lamu)*randn(simN,1)'];
      z=simN;
    end
  end;

  if SIM.modeltype==1;
    simnnn=0;
  elseif SIM.modeltype==2;
    simnnn=-1;
  elseif SIM.modeltype==3;
    simnnn=-2;
  elseif SIM.modeltype==4;
    simnnn=SIM.nnn.ar;
  elseif SIM.modeltype==5;
    simnnn=SIM.nnn.arx;
  elseif SIM.modeltype==6;
    simnnn=SIM.nnn.ss;
  end

  if isstr(simnnn)
    nnnstring=simnnn;
  else
    nnnstring=cdnum2str(simnnn);
  end
  fcn2=['y=simchange(z,',nnnstring,...
       ',',cdnum2str(simjhat),',',cdnum2str(simthhat),',',...
       cdnum2str(simlamhat),');'];

  [y,th0]=simchange(z,simnnn,simjhat,simthhat,simlamhat);


  if SIM.modeltype==1;
    z=y;
    fcn3='z=y;';
  elseif SIM.modeltype==2;
    z=y;
    fcn3='z=y;';
  elseif SIM.modeltype==3;
    z=[y u];
    fcn3=['z=[randn(simN,1) simu];'];
  elseif SIM.modeltype==4;
    z=y;
    fcn3='z=y;';
  elseif SIM.modeltype==5;
    z=[y u];
    fcn3=['z=[randn(simN,1) simu];'];
  elseif SIM.modeltype==6;
    z=[y u];
    fcn3=['z=[randn(simN,1) simu];'];
  end;

  RESULT.z=z;
  RESULT.th0=th0;
  RESULT.N=simN;

  if size(th0,2)~=size(z,1);
    th0=zeros(1,size(z,1));
    threc=th0; thseg=th0;
    RESULT.threc=threc;
    RESULT.thseg=thseg;
  end  

  if options(1)==1;
    disp(fcn1)
    disp(fcn2)
    disp(fcn3)
  end
  [nr,nc]=size(history);
  history=[history;fcn1 setstr(32*ones(1,nc-length(fcn1)))];
  history=[history;fcn2 setstr(32*ones(1,nc-length(fcn2)))];
  history=[history;fcn3 setstr(32*ones(1,nc-length(fcn3)))];
  guidetect('plottool')
  guidetect('disp','Data Simulated');
end;

if strcmp(action,'startclock')
  red=[1 0.5 0.5];
  guidetect('cpudisp','CPU working',red);
  drawnow
  RESULT.starttime=clock;
end;

if strcmp(action,'stopclock')
  RESULT.comptime=etime(clock,RESULT.starttime);
  guidetect('cpudisp',['CPU idle. Time: ',num2str(RESULT.comptime)]);
end;



if strcmp(action,'cleanup')
  handle=findobj(0,'Tag','figtabdesign');
  if ~isempty(handle); set(handle,'Visible','off'); end;
  handle=findobj('Tag','figzoom');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figlook');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figsimsetup');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figsimdes');
  if ~isempty(handle); guidetect('closechangedesign'); end;
  handle=findobj('Tag','figdetdes');
  if ~isempty(handle); close(handle); end;

  handle=findobj(0,'Tag','figplottool');
  if ~isempty(handle); guidetect('closeplottool'); end;
  handle=findobj(0,'Tag','figplottool');
  if ~isempty(handle); close(handle); end;

  handle=findobj(0,'Tag','figadaptivetool');
  if ~isempty(handle); guidetect('adaptivetool'); end;
  handle=findobj(0,'Tag','figadaptivetool');
  if ~isempty(handle); close(handle); end;

  handle=findobj(0,'Tag','figchangetool');
  if ~isempty(handle); guidetect('closechangetool'); end;
  handle=findobj(0,'Tag','figchangetool');
  if ~isempty(handle); close(handle); end;

  handle=findobj('Tag','figmainsim');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figmainmodel');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figmaindetector');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figarorder');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figarxorder');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figABCDsim');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figABCDdetect');
  if ~isempty(handle); close(handle); end;
  handle=findobj('Tag','figguirec');
  if ~isempty(handle); close(handle); end;

end
  
if strcmp(action,'exit')
  guidetect('figpos',3)  % save figure positions
  guidetect('cleanup')
  handle=findobj('Tag','block');
  close(handle);
end

if strcmp(action,'guirec')  
   fighandle=findobj(0,'Tag','figguirec');
   if isempty(fighandle);
      fighandle=figure('Tag','figguirec',...
        'Units','pixels',...
	'Position',[figpos(6,1:2) 240 200 ],...
	'Name','GUI recording',...
      'HandleVisibility','on',...
   'NumberTitle','off',...
   'MenuBar','none',...
	'Color',darkgrey);

	  
      menupos=[...
         10 155 220 25;...
         10 120 220 25;...
         10 85 220 25;...
         10 50 70 25;...
         90 50 140 25;...
         50 20 60 25;...
         130 20 60 25;...
 	 ];
	   

 Strings=str2mat('Start Recording.','Stop Recording.','Play Recording.',...
    'Filename.',[guirecfile,'.'],'Help.','Close.');
 CallBacks=str2mat('guidetect(''guirecstart'')','guidetect(''guirecstop'')','guidetect(''guirecplay'')',' ',' ',...
     'guihelp(''guirec'')','guidetect(''guirecclose'')');
      Styles=str2mat('PushButton','PushButton','PushButton','Text','Edit',...
         'PushButton','PushButton');
      c=[grey;grey;grey;darkgrey;white;grey;grey];
      for i=1:size(Strings,1);
        ind=findstr('.',Strings(i,:));
        if ~isempty(ind); 
          string=Strings(i,1:ind(1)-1); 
        else
          string=Strings(i,:);
        end;
       uicontrol(gcf,'Style',Styles(i,:),...
          'Units','pixels',...
          'Position',menupos(i,:),...
	       'String',string,...
	       'Tag','edit',...
	       'Callback',CallBacks(i,:),...
	       'BackGroundColor',c(i,:));
     end
  else
      figure(fighandle);
      set(fighandle,'Visible','on');
   end;
end
if strcmp(action,'guirecclose')
   fighandle=findobj(0,'Tag','figguirec');
   if ~isempty(fighandle);
      close(fighandle)
   end
end
if strcmp(action,'guirecstart')
   fighandle=findobj(0,'Tag','figguirec');
   handle=findobj(fighandle,'Tag','edit');
   guirecfile=get(handle,'String');
   guirec=fopen(guirecfile,'wt')
   if guirec==-1;
      guirec=0;
      guidetect('disp',['Cannot open file: ',guirecfile],'r')
   else
      guidetect('disp',['Saving session as: ',guirecfile])
   end
end
if strcmp(action,'guirecstop')
   if guirec>2
      fclose(guirec)
   end
   guirec=0
   guidetect('disp',['Closing session: ',guirecfile])
end
if strcmp(action,'guirecplay')
   fighandle=findobj(0,'Tag','figguirec');
   handle=findobj(fighandle,'Tag','edit');
   guirecfile=get(handle,'String');
   guidetect('disp',['Opening session: ',guirecfile])
   guirec=fopen(guirecfile,'rt')
   F = fread(guirec);
   s = setstr(F')
   fclose(guirec);
   guirec=0;
end

if strcmp(action,'demo')
  demodetect
end

if strcmp(action,'guidemo')
  guidemo
end

if strcmp(action,'dum')
  guidetect('disp','Stop pushing me!')
end

if strcmp(action,'disp')
  % arg1=string to be displayed
  c=grey;
  if nargin>2; c=arg2; end;
  mainhandle=findobj('Tag','block');
  handle=findobj(mainhandle,'Tag','info');
%  disp(['Message from DetectTB GUI: ',arg1])
  set(handle,'String',arg1,...
	       'BackGroundColor',c);
end

if strcmp(action,'cpudisp')
  % arg1=string to be displayed
  c=grey;
  if nargin>2; c=arg2; end;
  mainhandle=findobj('Tag','block');
  handle=findobj(mainhandle,'Tag','cpu');
%  disp(['Message from DetectTB GUI: ',arg1])
  set(handle,'String',arg1,...
	       'BackGroundColor',c);
end


if strcmp(action,'init');
  global CDH CDHchangedesign
  CDH=[];
  CDHchangedesign=[];
  guidetect('cleanup')
  close all hidden  % 991013
  guidetect('figpos',1);   % setup figure positions


  guirec=0;
  guirecfile='myguirecording';
  options=[0 0 0];	      
  history=setstr(32*ones(1,80));

  guidetect('SIMinit')
  guidetect('RESULTinit')
  guidetect('FILTERinit')
end;

if strcmp(action,'exM1');
  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.detecttype=1;
  FILTER.modeltype=2;
  FILTER.structure='Adaptive filter';

  FILTER.adfilter.adg=[0.9 10 0.05 0.05 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=2;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=2;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=3;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  SIM.modeltype=2;
  SIM.datatype=2;
  SIM.m(2).N=100;
  SIM.m(2).jhat=50;
  SIM.m(2).thhat=[1 4];
  SIM.m(2).lamhat=[1 1];

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for mean change model loaded. ')
  guihelp('exM1')
end;

if strcmp(action,'exM2');
  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.detecttype=1;
  FILTER.modeltype=2;
  FILTER.structure='Adaptive filter';

  FILTER.adfilter.adg=[0.85 10 0.05 0.05 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=2;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=2;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=3;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  SIM.modeltype=2;
  SIM.datatype=2;
  SIM.m(2).N=100;
  SIM.m(2).jhat=[25 50 75];
  SIM.m(2).thhat=[1 2 4 8];
  SIM.m(2).lamhat=[1 1 1 1];

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for mean change model loaded. ')
  guihelp('exM2')
end;

if strcmp(action,'exAR');

  SIM.modeltype=4;
  SIM.datatype=2;
  SIM.m(4).N=100;
  SIM.m(4).jhat=50;
  SIM.m(4).thhat=[1.6 0.4; 0.64 0.04];
  SIM.m(4).lamhat=[1 1];

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=4;
  FILTER.detecttype=1;
  FILTER.nnn.ar=2;
  FILTER.adfilter.adg=[0.9 10 0.05 0.05 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=2;
  FILTER.detect1.sr=1;
  FILTER.detect1.h=10;
  FILTER.detect1.nuorgam=2;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=2;
  FILTER.detect2.sr=1;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=2;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  FILTER.detectM.M=10;
  FILTER.detectM.lf=2;
  FILTER.detectM.lifelength=6;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for AR model loaded. ')
  guihelp('exar')
end

if strcmp(action,'exARX');
  SIM.modeltype=5;
  SIM.datatype=2;
  SIM.nnn.utype=2;
  SIM.nnn.u={'usim','1'};
  SIM.m(5).N=100;
  SIM.m(5).jhat=50;
  SIM.m(5).thhat=[1.6 .4; 0.64 0.04; 1 1; 0.5 0.5];
  SIM.m(5).lamhat=[1 1];

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=5;
  FILTER.detecttype=1;
  FILTER.nnn.arx=[2 2 1];
  FILTER.adfilter.adg=[0.98 10 0.05 0.05 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=2;
  FILTER.detect1.sr=1;
  FILTER.detect1.h=10;
  FILTER.detect1.nuorgam=2;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=2;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=3;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for ARX model loaded. ')
  guihelp('exarx')
end

if strcmp(action,'exSS');
  SIM.modeltype=6;
  SIM.datatype=2;
  SIM.m(6).N=100;
  SIM.m(6).jhat=50;
  SIM.m(6).thhat=[5;10];
  SIM.m(6).lamhat=[1 1];
  SIM.nnn.ss='nnnDCm0';
  SIM.nnn.utype=2;
  SIM.nnn.u={'usim','1'};

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=6;
  FILTER.detecttype=1;
  FILTER.nnn.ss=simnnn;
  FILTER.adfilter.adg=[0.98 10 0.05 0.05 1];
  FILTER.adfilter.adm=5;
  FILTER.detect1.dm=2;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=3;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=2;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=3;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for state space model loaded (displayed in matlab). ')
  guihelp('exss')
end;  


%        Real data
% ========================

if strcmp(action,'datafuel');
  SIM.modeltype=2;
  SIM.datatype=1;
  SIM.nnn.datafile='fuel';

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=2;
  FILTER.detecttype=1;
  FILTER.adfilter.adg=[0.9 10 0.05 0.05 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=1;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=1;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=1;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for ''fuel'' data loaded. ')
  guihelp('fuel')
  
end;

if strcmp(action,'datafricest');
  SIM.modeltype=3;
  SIM.datatype=2;
  SIM.nnn.datafile='fricest';

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=3;
  FILTER.detecttype=1;
  FILTER.adfilter.adg=[0.9 10 0.05 0.05 1];
  FILTER.adfilter.adm=5;
  FILTER.detect1.dm=1;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=0.003;
  FILTER.detect1.nuorgam=0.0005;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=2;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=1e-6;
  FILTER.detect2.nuorgam=5e-7;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for ''fricest'' data loaded. ')
  guihelp('fricest')

end;

if strcmp(action,'datapath');
  SIM.modeltype=3;
  SIM.datatype=1;
  SIM.nnn.datafile='path';

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=3;
  FILTER.detecttype=2;
  FILTER.adfilter.adg=[0.9 10 0.05 0.05 1];
  FILTER.adfilter.adm=5;
  FILTER.detect1.dm=1;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=1;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=1;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for ''path'' data loaded. ')
  guihelp('path')
end;

if strcmp(action,'dataspeech');
  SIM.modeltype=4;
  SIM.datatype=1;
  SIM.nnn.datafile='speech';

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=4;
  FILTER.nnn.ar=1;
  FILTER.detecttype=1;
  FILTER.adfilter.adg=[0.98 30 0.02 0.02 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=1;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=1;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=1;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for ''speech'' data loaded. ')
  guihelp('speech')
end;

if strcmp(action,'dataaltitude');
  SIM.modeltype=1;
  SIM.datatype=1;
  SIM.nnn.datafile='altdata';

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=1;
  FILTER.detecttype=1;
  FILTER.adfilter.adg=[0.98 30 0.02 0.02 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=1;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=1;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=1;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for ''altdata'' data loaded. ')
  guihelp('altdata')
  
end;

if strcmp(action,'dataeeg');
  SIM.modeltype=4;
  SIM.datatype=1;
  SIM.nnn.datafile='eeg';

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=4;
  FILTER.nnn.ar=2;
  FILTER.detecttype=1;
  FILTER.adfilter.adg=[0.98 30 0.02 0.02 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=1;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=1;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=1;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for ''eeg'' data loaded. ')
  guihelp('eeg')
end;

if strcmp(action,'datatracking');
  SIM.modeltype=6;
  SIM.datatype=2;
  SIM.nnn.datafile='None';
  SIM.nnn.ss='nnnplane';
  SIM.nnn.utype=2;
  SIM.nnn.u={'usim','0'};
  
  %nnn='nnnplane';
  global NNNmethod
  NNNmethod=5;
  N=50;
  SIM.m(6).N=N;
  SIM.m(6).jhat=[15 18 35 38];
  SIM.m(6).thhat=[-0.05;0.05;0.075;-0.075]';
  SIM.m(6).lamhat=[1];

  RESULT.z=zeros(N,1);

  FILTER.olddetecttype=FILTER.detecttype;
  FILTER.modeltype=6;
  FILTER.detecttype=1;
  FILTER.adfilter.adg=[0.98 30 0.02 0.02 1];
  FILTER.adfilter.adm=1;
  FILTER.detect1.dm=1;
  FILTER.detect1.sr=2;
  FILTER.detect1.h=5;
  FILTER.detect1.nuorgam=1;
  FILTER.detect1.lam=1;
  FILTER.detect2.dm=1;
  FILTER.detect2.sr=2;
  FILTER.detect2.h=5;
  FILTER.detect2.nuorgam=1;
  FILTER.detect2.lam=1;
  FILTER.detect2.L=10;

  guidetect('RESULTinit')
  guidetect('cleanup')
  guidetect('blockplot')
  guidetect('disp','Default values for tracking application loaded. ')
  guihelp('tracking')
end;


% Change detectors

if strcmp(action,'cdRLS');
  detecttype=1;
  designpar(1,:)=[0.98,1,0,0,0,1];
  guidetect('blockplot')
  guidetect('disp','RLS filter with forgetting 0.98 is now the current filter. ')

end;

if strcmp(action,'cdKF');
  detecttype=1;
  designpar(1,:)=[1,5,0,0,0,1];
  guidetect('blockplot')
  guidetect('disp','Kalman filter is now the current filter. ')
  
end;

if strcmp(action,'cdCUSUM1');
  detectnnn=-1;
  detectmodeltype=modeltype(detectnnn)+1;
  detecttype=2;
  designpar(2,:)=[1,1,5,3,10,1];
  guidetect('blockplot')
  guidetect('disp','CUSUM is now the current detector. ')
  
end;

if strcmp(action,'cdCUSUM2');
  detectnnn=-1;
  detectmodeltype=modeltype(detectnnn)+1;
  detecttype=2;
  designpar(2,:)=[1,2,5,3,10,1];
  guidetect('blockplot')
  guidetect('disp','CUSUM is now the current detector. ')
  
end;

if strcmp(action,'cdGMA1');
  detectnnn=-1;
  detectmodeltype=modeltype(detectnnn)+1;
  detecttype=2;
  designpar(2,:)=[1,3,5,0.1,10,1];
  guidetect('blockplot')
  guidetect('disp','GMA is now the current detector. ')
end;

if strcmp(action,'cdGMA2');
  detectnnn=-1;
  detectmodeltype=modeltype(detectnnn)+1;
  detecttype=2;
  designpar(2,:)=[1,4,5,0.1,10,1];
  guidetect('blockplot')
  guidetect('disp','GMA is now the current detector. ')
end;

if strcmp(action,'cdBGLR');
  detecttype=3;
  designpar(3,:)=[1,1,5,3,10,1];
  guidetect('setdetector',detecttype);
  guidetect('disp','Brandt''s GLR is now the current detector. ')
end;

if strcmp(action,'cddivtest');
  detecttype=3;
  designpar(3,:)=[2,1,5,3,10,1];
  guidetect('blockplot')
  guidetect('disp','Divergence test is now the current detector. ')
end;

if strcmp(action,'cdMAPseg1');
  detecttype=4;
  designpar(4,:)=[1,1,-1,-1,-1,-1];
  guidetect('blockplot')
  guidetect('disp','ML detectM is now the current detector. ')
end;

if strcmp(action,'cdMAPseg2');
  detecttype=4;
  designpar(4,:)=[2,-1,-1,-1,-1,-1];
  guidetect('blockplot')
  guidetect('disp','ML detectM is now the current detector. ')
end;

if strcmp(action,'cdAICseg');
  detecttype=4;
  designpar(4,:)=[3,1,-1,-1,-1,-1];
  guidetect('blockplot')
  guidetect('disp','AIC detectM is now the current detector. ')
end;

if strcmp(action,'cdBICseg');
  detecttype=4;
  designpar(4,:)=[4,-1,-1,-1,-1,-1];
  guidetect('blockplot')
  guidetect('disp','BIC detectM is now the current detector. ')
end;

if strcmp(action,'blocksigupdate');
  if FILTER.detecttype==1;
    n=2; 
    sigdetector=' ';
 elseif FILTER.detecttype==2;
     n=3; 
     sigdetector='g';
  elseif FILTER.detecttype==3;
    n=4; 
    sigdetector='L';
  elseif FILTER.detecttype>3;
     n=3;      
     sigdetector='L';
  end;
  if SIM.modeltype<4
     sigdatagen='y';
  else % ARX or SS
     sigdatagen='y,u';
  end
  
  if FILTER.modeltype<6
     sigfilter='th';
  else % SS
     sigfilter='x';
  end
 
  sigfilter2=' ';
  Callbacks=str2mat('datalook','validth','validteststat','validth');
  Tags=str2mat('y','r','g','2');
  SigStrings=str2mat(sigdatagen,sigfilter,sigdetector,sigfilter2);
 

  fighandle=findobj('Tag','block');
  for i=1:n;
     handle=findobj(fighandle,'Tag',Tags(i,:));
     if ~isempty(handle)
 %       set(handle,'String',SigStrings(i,find(SigStrings(i,:)~=' ')),...
        set(handle,'String',SigStrings(i,:),...
    	                'CallBack',['guidetect(''blocksigplot'',',num2str(i),')']);
     end
  end
 
end

if strcmp(action,'blocksigplot');
   %arg1=which signal
   if arg1==1;
      tag='valvis';
      call='validsegplot';
   elseif arg1==2
      tag='valpar';
      call='validthplot';
  elseif arg1==3
      tag='valtes';
      call='validteststat';
 elseif arg1==4
      tag='valpar';
      call='validthplot';
 end
 
  mainhandle=findobj('Tag','block');
  onhandle=findobj(mainhandle,'Tag','plottool');
%  set(onhandle,'Value',1);
  guidetect('plottool')
  plottoolhandle=findobj(0,'Tag','figplottool');
  onhandle=findobj(plottoolhandle,'Tag',tag);
  if get(onhandle,'Value')==0;
     set(onhandle,'Value',1)
  else
     set(onhandle,'Value',0)
  end
  guidetect(call)
end

if strcmp(action,'blockdiagram');
  global CDH
  blockhandle=findobj('Tag','block');
  if isempty(blockhandle);
    blockhandle=figure;
    set(blockhandle,'Tag','block',...
      'Units','pixels',...
      'Position',figpos(2,:),...
      'Units','normalized',...
      'Name','Block diagram',...
      'NumberTitle','off',...
      'MenuBar','none',...
      'HandleVisibility','on',...
      'Color',fgblue);
%    clf
    guidetect('blockdiagrammenu')
    firsttime=1;
  else
    firsttime=0;
  end

  if ~isempty(CDH)
    ind=find(CDH(FILTER.olddetecttype,:)~=0);
    set(CDH(FILTER.olddetecttype,ind),'Visible','off');
  end
  % Removed because of datatype problem
  if 0 & size(CDH,1)>=FILTER.detecttype & CDH(FILTER.detecttype,1)~=0;  % Blocks exist
    ind=find(CDH(FILTER.detecttype,:)~=0);
    set(CDH(FILTER.detecttype,ind),'Visible','on');
    return
  end
  set(blockhandle,'HandleVisibility','on');
  if SIM.datatype==2; 
    datagen='Simulation';
    call1='startclock|startsim|stopclock|datalook';
  else
    datagen='Data From File';
    call1='loaddata|datalook';
  end;
  filter2=' ';  % ver5
  detector=' ';  % ver5
  if FILTER.detecttype==1;
    filter='Adaptive Filter'; n=2; xs=0.2; y1=0.6; ylow=0.2; nsimu=3;
  elseif FILTER.detecttype==2;
    filter='Adaptive Filter'; n=3; xs=0.05; y1=0.6; ylow=0.2; nsimu=4;
    detector='Change Detector';
  elseif FILTER.detecttype==3;
    filter='Slow filter'; 
    filter2='Fast filter'; 
    n=4; xs=0.05; y1=0.6; ylow=0.2; y2=0.3; nsimu=4;
    detector='Model comparison';
  elseif FILTER.detecttype>3;
    filter='Filter bank'; n=3; xs=0.05; y1=0.6; ylow=0.2; nsimu=4;
    detector='Model comparison';
  end;

  figure(blockhandle);
%  clf
  axis('off')
  axis([0 1 0 1]) 
  set(gca,'Position',[0 0 1 1]);
 

  l=0.18;                % Block length
  w=0.3;                % Block width
  lw=0.01; % line width
  lwh=0.0025; % line width horizontal
  aw=0.03; % arrow width
  al=0.07; % arrow length
  awh=0.008; awv=0.1;
  x=[xs xs+l+al xs+2*(l+al) xs+l+al];   % Block position
  SimuPos=[x(1) 0.8 l w/2;
           x(2) 0.8 l w/2;
           x(3) 0.8 l w/2;
           0.82 0.8 l*0.9 w/2;
           0.82 0.62 l*0.9 w/2;
           0.82 0.44 l*0.9 w/2;
	   0.82 0.26 l*0.9 w/2
	   0.82 0.08 l*0.9 w/2
	   ];

  if n<4;
    Pos=[ x(1) y1-w/2 l w;
          x(2) y1-w/2 l w;
          x(3) y1-w/2 l w
       ];
    SigPos=[x(1)+l+al/4 y1+2*lw al/2 w/3;
            x(2)+l+al/4 y1+2*lw al/2 w/3;
            x(3)+l+al/4 y1+2*lw al/2 w/3
            ];       
  else
    Pos=[ x(1) y1-w/2 l w;
          x(2) y1-w/3 l w*2/3;
          x(3) y1-w/2 l w;
          x(4) y2-w/3 l w*2/3
      ];
    SigPos=[x(1)+l+al/4 y1+2*lw al/2 w/3;
            x(2)+l+al/4 y1+2*lw al/2 w/3;
            x(3)+l+al/4 y1+2*lw al/2 w/3;
            x(4)+l+2*al/4 y2+2*lw al/2 w/3
            ];       
 end;


  CDH(FILTER.detecttype,1)=patch([x(1)+l x(2)-aw x(2)-aw x(1)+l],[y1+lw y1+lw y1-lw y1-lw],'w');
  CDH(FILTER.detecttype,2)=patch([x(2)-aw x(2) x(2)-aw],[y1+aw y1 y1-aw],'w');
  CDH(FILTER.detecttype,3)=patch([x(2)+l x(3)-aw x(3)-aw x(2)+l],[y1+lw y1+lw y1-lw y1-lw],'w');
  CDH(FILTER.detecttype,4)=patch([x(3)-aw x(3) x(3)-aw],[y1+aw y1 y1-aw],'w');
  if n==3;
    CDH(FILTER.detecttype,5)=patch([x(3)+l x(3)+l+al x(3)+l+al x(3)+l],[y1+lw y1+lw y1-lw y1-lw],'w');
    CDH(FILTER.detecttype,6)=patch([x(3)+l+al-aw x(3)+l+al x(3)+l+al-aw],[y1+aw y1 y1-aw],'w');
    CDH(FILTER.detecttype,7)=patch([x(3)+l+al/2+lwh x(3)+l+al/2+lwh x(3)+l+al/2-lwh x(3)+l+al/2-lwh ],[y1-lw ylow-lw ylow-lw y1-lw],'w');
    CDH(FILTER.detecttype,8)=patch([x(3)+l+al/2-lwh x(2)+l/2-lwh x(2)+l/2-lwh x(3)+l+al/2-lwh ],[ylow-lw ylow-lw ylow+lw ylow+lw],'w');
    CDH(FILTER.detecttype,9)=patch([x(2)+l/2-lwh x(2)+l/2-lwh x(2)+l/2+lwh x(2)+l/2+lwh ],[ylow+lw y1-w/2-awv y1-w/2-awv ylow+lw],'w');
    CDH(FILTER.detecttype,10)=patch([x(2)+l/2-awh x(2)+l/2 x(2)+l/2+awh],[y1-w/2-awv y1-w/2 y1-w/2-awv],'w');
  elseif n==4;
    % Down
    CDH(FILTER.detecttype,11)=patch([x(1)+l+al/3-lwh x(1)+l+al/3-lwh x(1)+l+al/3+lwh x(1)+l+al/3+lwh],[y1+lw y2-lw y2-lw y1+lw],'w'); 
    % Forward to fast filter
    CDH(FILTER.detecttype,12)=patch([x(1)+l+al x(1)+l+al/3 x(1)+l+al/3 x(1)+l+al],[y2+lw y2+lw y2-lw y2-lw],'w'); 
    CDH(FILTER.detecttype,13)=patch([x(2)-aw x(2) x(2)-aw],[y2+aw y2 y2-aw],'w');
    % Out from fast filter
    CDH(FILTER.detecttype,14)=patch([x(2)+l x(2)+l+al/3 x(2)+l+al/3 x(2)+l],[y2+lw y2+lw y2-lw y2-lw],'w'); 
    CDH(FILTER.detecttype,15)=patch([x(2)+l+al/3-lwh x(2)+l+al/3-lwh x(2)+l+al/3+lwh x(2)+l+al/3+lwh],[y1+lw-0.1 y2-lw y2-lw y1+lw-0.1],'w'); 
    % arrow
    CDH(FILTER.detecttype,16)=patch([x(2)+l+al/3 x(2)+l+al x(2)+l+al x(2)+l+al/3],[y1+lw-0.1 y1+lw-0.1 y1-lw-0.1 y1-lw-0.1],'w'); 
    
    % Second input to detector
    CDH(FILTER.detecttype,17)=patch([x(3)-aw x(3) x(3)-aw],[y1-0.1+aw y1-0.1 y1-0.1-aw],'w');

    CDH(FILTER.detecttype,18)=patch([x(3)+l x(3)+l+al x(3)+l+al x(3)+l],[y1+lw y1+lw y1-lw y1-lw],'w');
    CDH(FILTER.detecttype,19)=patch([x(3)+l+al-aw x(3)+l+al x(3)+l+al-aw],[y1+aw y1 y1-aw],'w');
    % Feedback
    % down
    CDH(FILTER.detecttype,20)=patch([x(3)+l+al/2+lwh x(3)+l+al/2+lwh x(3)+l+al/2-lwh x(3)+l+al/2-lwh ],[y1-lw ylow-lw ylow-lw y1-lw],'w');
    % back
    CDH(FILTER.detecttype,21)=patch([x(3)+l+al/2-lwh x(2)+l/2-lwh x(2)+l/2-lwh x(3)+l+al/2-lwh ],[ylow-lw ylow-lw ylow+lw ylow+lw],'w');
    CDH(FILTER.detecttype,22)=patch([x(2)+l/2-lwh x(2)+l/2-lwh x(2)+l/2+lwh x(2)+l/2+lwh ],[ylow+lw y1-w/3 y1-w/3 ylow+lw],'w');
%    CDH(FILTER.detecttype,23)=patch([x(2)+l/2-lwh x(2)+l/2-lwh x(2)+l/2+lwh x(2)+l/2+lwh ],[ylow+lw y1-w/2-awv y1-w/2-awv ylow+lw],'w');
    % arrow
    CDH(FILTER.detecttype,24)=patch([x(2)+l/2-awh*0.7 x(2)+l/2 x(2)+l/2+awh*0.7],[y1-w/3-awv*0.7 y1-w/3 y1-w/3-awv*0.7],'w');
    CDH(FILTER.detecttype,25)=patch([x(2)+l/2-awh*0.7 x(2)+l/2 x(2)+l/2+awh*0.7],[y2-w/3-awv*0.7 y2-w/3 y2-w/3-awv*0.7],'w');
  end;

  clockdetect='startclock|startdetect|stopclock|updateadaptivetool';
  Strings=str2mat(datagen,filter,detector,filter2);
  Styles=str2mat('PushButton','PushButton','PushButton','PushButton');
  Callbacks=str2mat([call1],clockdetect,clockdetect,clockdetect);
  Tags=str2mat('blkdata','blkfilt','blkdetect','blkfilt2');
  Colors=[darkgrey;darkgrey;darkgrey;darkgrey];
  SigTags=str2mat('y','r','g','2');
  Tips=str2mat('Open Plot Tool and plot (toggling) the simulated signal(s)',...
    'Open Plot Tool and plot (toggling) the estimates',...
    'Open Plot Tool and plot (toggling) the test statistics',...
    'The output from the fast filter is not available (detect2 is used)');
  Tipssim=str2mat('Load data from file or simulate data from model','Run adaptive filter','Run filter and change detector','Run both filters and change detector','Run filter bank');
  for i=1:n;
    ind=findstr('  ',Strings(i,:));
    if ~isempty(ind); 
      text=Strings(i,1:ind(1)-1); 
    else
      text=Strings(i,:);
    end;
    ind=findstr(' ',Tags(i,:));
    if ~isempty(ind); 
      tag=Tags(i,1:ind(1)-1); 
    else
      tag=Tags(i,:);
    end;
    CDH(FILTER.detecttype,25+2*i-1)=uicontrol(blockhandle,'Style',Styles(i,:),...
                'Units','Normalized',...
                'Position',Pos(i,:),...
   	        'String',text,...
   	        'Tag',tag,...
	        'CallBack',['guidetect(''',Callbacks(i,:),''');'],...
	        'BackGroundColor',Colors(i,:));
%   	        'TooltipString',Tipssim(i,:),...
     CDH(FILTER.detecttype,25+2*i)=uicontrol(blockhandle,'Style','PushButton',...
                'Units','Normalized',...
                'Position',SigPos(i,:),...
   	        'Tag',SigTags(i,:),...
   	        'TooltipString',Tips(i,:),...
	        'BackGroundColor',Colors(i,:));
   
   end;
   guidetect('blocksigupdate')


  if firsttime==1; % Only make these uicontrols once

  %  Upper row of buttons
 
  Strings=str2mat('Data Generation','Design Parameters');
  Callbacks=str2mat('mainsim','changedesign');
  Tags=str2mat('mainsim','changedesign');
  Colors=[darkgrey;darkgrey];
  Styles=str2mat('CheckBox','CheckBox');
  Tips=str2mat('Opens window where file with real data or simulation setup is specified','Opens window where all design parameters in the current block diagram are specified');
  for i=1:2;
    ind=findstr(' ',Tags(i,:));
    if ~isempty(ind); 
      tag=Tags(i,1:ind(1)-1); 
    else
      tag=Tags(i,:);
    end;
    uicontrol(blockhandle,'Style','Frame',...
                'Units','Normalized',...
                'Position',SimuPos(i,:)+[-0.003 -0.01 0.006 0.02],...
	       'BackGroundColor',darkgrey);
    uicontrol(blockhandle,'Style',Styles(i,:),...
                'Units','Normalized',...
                'Position',SimuPos(i,:),...
   	        'Tag',tag,...
   	        'TooltipString',Tips(i,:),...
   	        'String',Strings(i,:),...
	        'CallBack',['guidetect(''',Callbacks(i,:),''');'],...
	        'BackGroundColor',Colors(i,:));

  end  


  %  Lower row of buttons
	  
  uicontrol(gcf,'Style','Text',...
               'Units','normalized',...
               'Position',[0.3 0.03 0.5 0.08] ,...
	       'String','Info',...
   	        'TooltipString','This field displays some information from latest action',...
	       'Tag','info',...
	       'BackGroundColor',fglightblue);

  uicontrol(gcf,'Style','Text',...
               'Units','normalized',...
               'Position',[0.02 0.03 0.23 0.08] ,...
   	        'TooltipString','This field displays some information about the latest computation',...
	       'String','CPU Idle',...
	       'Tag','cpu',...
	       'BackGroundColor',fglightblue);

	  



  %  Right column of buttons

  Strings=str2mat('Adaptive filter|One-model|Two-model|Multi-model|GLR|MLR','Plot Tool','Adaptive Tool','Change Tool','Exit');
  Callbacks=str2mat('maindetector','plottool','adaptivetool','changetool','exit');
  Styles=str2mat('PopUp','CheckBox','CheckBox','CheckBox','PushButton');
  Tags=str2mat('maindetector','plottool','adaptivetool','changetool','exit');
  Colors=[darkgrey;darkgrey;darkgrey;darkgrey;darkgrey];
%  Colors=[lightblue;lightblue;lightblue;lightblue];
  Tips=str2mat('Choose the structure of the block diagram (adaptive filter or change detectors','Open the plot tool, where all available plots can be activated','Open the adaptive filter design tool','Open the change detection design tool','Close all windows and exit');
  for i=1:size(Callbacks,1);
    ind=findstr('  ',Strings(i,:));
    if ~isempty(ind); 
       text=Strings(i,1:ind(1)-1); 
    else
      text=Strings(i,:);
    end;
    ind=findstr(' ',Tags(i,:));
    if ~isempty(ind); 
      tag=Tags(i,1:ind(1)-1); 
    else
      tag=Tags(i,:);
    end;
    uicontrol(blockhandle,'Style','Frame',...
                'Units','Normalized',...
                'Position',SimuPos(3+i,:)+[-0.003 -0.01 0.006 0.02],...
	       'BackGroundColor',darkgrey);
    uicontrol(blockhandle,'Style',Styles(i,:),...
                'Units','normalized',...
                'Position',SimuPos(3+i,:),...
   	        'String',text,...
   	        'Tag',tag,...
	        'CallBack',['guidetect(''',Callbacks(i,:),''');'],...
   	        'TooltipString',Tips(i,:),...
	        'BackGroundColor',Colors(i,:));
  end
  end
  set(blockhandle,'HandleVisibility','Callback');
end

if strcmp(action,'blockdiagrammenu');
	   

  
%------ GUI FILE  menu-----------

h=uimenu(gcf,'Label','File');
  
uimenu(h,'Label','Save or play session',...
   'Callback','guidetect(''guirec'')');

%------ Data  submenu-----------

h1=uimenu(h,'Label','Load Real data');
uimenu(h1,'Label','Fuel consumption',...
                 'Callback','guidetect(''datafuel'')');
uimenu(h1,'Label','Friction detection',...
                 'Callback','guidetect(''datafricest'')');
uimenu(h1,'Label','Tracking of airplane',...
                 'Callback','guidetect(''datatracking'')');
uimenu(h1,'Label','Belching sheep',...
                 'Callback','guidetect(''datasheep'')');
uimenu(h1,'Label','EEG',...
                 'Callback','guidetect(''dataeeg'')');
uimenu(h1,'Label','Baro altitude',...
                 'Callback','guidetect(''dataaltitude'')');
uimenu(h1,'Label','Speech',...
                 'Callback','guidetect(''dataspeech'')');
uimenu(h1,'Label','Driven path',...
                 'Callback','guidetect(''datapath'')');

	     
%------ GUI Utility  menu-----------

h=uimenu(gcf,'Label','Utilities');


%------ GUI DEMO  menu-----------

h1=uimenu(h,'Label','Demo');
h5=uimenu(h1,'Label','Introductory demo');
uimenu(h5,'Label','Autoplay',...
                 'Callback','guidemo1');
uimenu(h5,'Label','Front-end',...
                 'Callback','guidemo1(''0.1'')');
uimenu(h5,'Label','Fundamental example',...
                 'Callback','guidemo1(''1.1'')');
uimenu(h5,'Label','Simulated data',...
                 'Callback','guidemo1(''2.1'')');
uimenu(h5,'Label','Application example',...
                 'Callback','guidemo1(''3.1'')');
uimenu(h1,'Label','Application demos',...
                 'Callback','guidemo');
uimenu(h1,'Label','Command line demos',...
                 'Callback','demodetect');
%uimenu(h1,'Label','Surveillance and fault detection application',...
%                 'Callback','guidemo(''fricest'')');
%uimenu(h1,'Label','Fault detection application',...
%                 'Callback','guidemo(''navigation'')');
%uimenu(h1,'Label','Multi-model tracking',...
%                 'Callback','guidemo(''tracking'')');
    

%------- Exercises----------

h2=uimenu(h,'Label','Exercises');

uimenu(h2,'Label','1. Learning the basics',...
                 'Callback','guiex(''1'')');
uimenu(h2,'Label','2. Working with simulated data',...
                 'Callback','guiex(''2'')');
uimenu(h2,'Label','3. Working with real data',...
                 'Callback','guiex(''3'')');


%------ Examples menu-----------

h3=uimenu(h,'Label','Examples');
uimenu(h3,'Label','Mean change, one jump',...
                 'Callback','guidetect(''exM1'')');
uimenu(h3,'Label','Mean change, several jumps',...
                 'Callback','guidetect(''exM2'')');
uimenu(h3,'Label','AR model',...
                 'Callback','guidetect(''exAR'')');
uimenu(h3,'Label','ARX model',...
                 'Callback','guidetect(''exARX'')');
uimenu(h3,'Label','State space model',...
                 'Callback','guidetect(''exSS'')');
	   
	     
%------ Detectors  menu-----------
if 0
h1=uimenu(h,'Label','Detectors');
uimenu(h1,'Label','RLS',...
                 'Callback','guidetect(''cdRLS'')');
uimenu(h1,'Label','Kalman filter',...
                 'Callback','guidetect(''cdKF'')');
uimenu(h1,'Label','CUSUM',...
                 'Callback','guidetect(''cdCUSUM1'')');
uimenu(h1,'Label','CUSUM, two-sided',...
                 'Callback','guidetect(''cdCUSUM2'')');
uimenu(h1,'Label','GMA',...
                 'Callback','guidetect(''cdGMA1'')');
uimenu(h1,'Label','GMA, twosided',...
                 'Callback','guidetect(''cdGMA2'')');
uimenu(h1,'Label','Brandt''s GLR',...
                 'Callback','guidetect(''cdBGLR'')');
uimenu(h1,'Label','Divergence test',...
                 'Callback','guidetect(''cddivtest'')');
uimenu(h1,'Label','MAP segmentation',...
                 'Callback','guidetect(''cdMAPseg1'')');
uimenu(h1,'Label','MAP segmentation, unknown noise',...
                 'Callback','guidetect(''cdMAPseg2'')');
uimenu(h1,'Label','AIC segmentation',...
                 'Callback','guidetect(''cdAICseg'')');
uimenu(h1,'Label','BIC segmentation',...
                 'Callback','guidetect(''cdBICseg'')');
end

%------ Options  menu-----------

h=uimenu(gcf,'Label','Options');

uimenu(h,'Label','Echo functions calls',...
                 'Callback','guidetect(''changeoptions'',1)');
uimenu(h,'Label','Echo names of subroutine calls',...
                 'Callback','guidetect(''changeoptions'',2)');
uimenu(h,'Label','Echo complete subroutine calls',...
                 'Callback','guidetect(''changeoptions'',3)');
%uimenu(h,'Label','Block diagram',...
%                 'Callback',['guidetect(''changeoptions'',3),',...
%		            'guidetect(''blockplot'')']);
uimenu(h,'Label','Clean up windows',...
                 'Callback',['guidetect(''cleanup'')']);
uimenu(h,'Label','Figure positions for 800x600',...
                 'Callback',['guidetect(''figpos'',0)']);
uimenu(h,'Label','Figure positions for 1152x900',...
                 'Callback',['guidetect(''figpos'',1)']);
uimenu(h,'Label','Load figure positions',...
                 'Callback',['guidetect(''figpos'',2)']);
uimenu(h,'Label','Save figure positions',...
                 'Callback',['guidetect(''figpos'',3)']);
	       
%------ View  menu-----------

view_menu=uimenu(h,'Label','View struct objects');
uimenu(view_menu,'Label','Simulation object',...
   'Callback','guidetect(''SIMview'')');
uimenu(view_menu,'Label','Filter/detector object',...
   'Callback','guidetect(''FILTERview'')');
uimenu(view_menu,'Label','Result object',...
   'Callback','guidetect(''RESULTview'')');


%------ GUI HELP  menu-----------

h=uimenu(gcf,'Label','Help');
  uimenu(h,'Label','General',...
                   'Callback','guihelp(''block'')');	       
  h1=uimenu(h,'Label','Data Generation');
  uimenu(h1,'Label','Real Data',...
                   'Callback','guihelp(''datagenreal'')');	       
  uimenu(h1,'Label','Simulated Data',...
                   'Callback','guihelp(''datagensim'')');	       
  uimenu(h,'Label','Filter Model',...
                   'Callback','guihelp(''detmod'')');
  h2=uimenu(h,'Label','Filter Structures');
  uimenu(h2,'Label','Adaptive filter',...
                   'Callback','guihelp(''detmet0'')');
  uimenu(h2,'Label','One-model detection',...
                   'Callback','guihelp(''detmet1'')');
  uimenu(h2,'Label','Two-model detection',...
                   'Callback','guihelp(''detmet2'')');
  uimenu(h2,'Label','Multi-model detection',...
                   'Callback','guihelp(''detmetsegm'')');
  uimenu(h2,'Label','GLR',...
                   'Callback','guihelp(''detmetglr'')');
  uimenu(h2,'Label','MLR',...
                   'Callback','guihelp(''detmetmlr'')');
  h3=uimenu(h,'Label','Tools');
  uimenu(h3,'Label','Plot Tool',...
                   'Callback','guihelp(''plottool'')');
  uimenu(h3,'Label','Adaptive Tool',...
                   'Callback','guihelp(''adaptivetool'')');
  h33=uimenu(h3,'Label','Change Tool');
     uimenu(h33,'Label','Monte Carlo',...
                   'Callback','guihelp(''MC'')');
     uimenu(h33,'Label','MC Table',...
                   'Callback','guihelp(''MCtable'')');
     uimenu(h33,'Label','Auto-tuning',...
                   'Callback','guihelp(''MCautotuning'')');
	   
%  h4=uimenu(h,'Label','Utilities');
%  uimenu(h4,'Label','Exercises',...
%                   'Callback','guihelp(''exercise'')');
  h4=uimenu(h,'Label','Examples');
    uimenu(h4,'Label','General info',...
                   'Callback','guihelp(''example'')');
    uimenu(h4,'Label','Mean change, one jump',...
                   'Callback','guihelp(''exM1'')');
    uimenu(h4,'Label','Mean change, several jumps',...
                   'Callback','guihelp(''exM2'')');
    uimenu(h4,'Label','AR model',...
                   'Callback','guihelp(''exar'')');
    uimenu(h4,'Label','ARX model',...
                   'Callback','guihelp(''exarx'')');
    uimenu(h4,'Label','State space model',...
                   'Callback','guihelp(''exss'')');
  h5=uimenu(h,'Label','Applications');
    uimenu(h5,'Label','General info',...
                   'Callback','guihelp(''data'')');
    uimenu(h5,'Label','Fuel consumption',...
                   'Callback','guihelp(''fuel'')');
    uimenu(h5,'Label','Friction estimation',...
                   'Callback','guihelp(''fricest'')');
    uimenu(h5,'Label','Path segmentation',...
                   'Callback','guihelp(''path'')');
    uimenu(h5,'Label','EEG',...
                   'Callback','guihelp(''eeg'')');
    uimenu(h5,'Label','Speech segmentation',...
                   'Callback','guihelp(''speech'')');
    uimenu(h5,'Label','Target tracking',...
                   'Callback','guihelp(''tracking'')');
    uimenu(h5,'Label','DC motor',...
                   'Callback','guihelp(''dcmotor'')');

  uimenu(h,'Label','Close',...
                   'Callback','guihelp(''helpclose'')');
                

end


